"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
//////////////////////////// Guards //////////////////////////////////
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//////////////////////////// Catalogos ////////////////////////////////
var categorias_articulos_manager_1 = require("./catalogs/categorias-articulos.manager");
var categorias_articulos_editor_1 = require("./catalogs/categorias-articulos.editor");
var categorias_unidades_medida_manager_1 = require("./catalogs/categorias-unidades-medida.manager");
var categorias_unidades_medida_editor_1 = require("./catalogs/categorias-unidades-medida.editor");
var divisas_manager_1 = require("./catalogs/divisas.manager");
var divisas_editor_1 = require("./catalogs/divisas.editor");
var pacs_manager_1 = require("./catalogs/pacs.manager");
var pacs_editor_1 = require("./catalogs/pacs.editor");
var contribuyentes_manager_1 = require("./catalogs/contribuyentes.manager");
var contribuyentes_editor_1 = require("./catalogs/contribuyentes.editor");
var empresas_manager_1 = require("./catalogs/empresas.manager");
var empresas_editor_1 = require("./catalogs/empresas.editor");
var sucursales_manager_1 = require("./catalogs/sucursales.manager");
var sucursales_editor_1 = require("./catalogs/sucursales.editor");
var cuentas_manager_1 = require("./catalogs/cuentas.manager");
var flujo_manager_1 = require("./catalogs/flujo.manager");
var impuestos_manager_1 = require("./catalogs/impuestos.manager");
var impuestos_editor_1 = require("./catalogs/impuestos.editor");
var retenciones_manager_1 = require("./catalogs/retenciones.manager");
var retenciones_editor_1 = require("./catalogs/retenciones.editor");
var cfdcertificados_manager_1 = require("./catalogs/cfdcertificados.manager");
var cfdcertificados_editor_1 = require("./catalogs/cfdcertificados.editor");
var cfdseries_manager_1 = require("./catalogs/cfdseries.manager");
var cfdseries_editor_1 = require("./catalogs/cfdseries.editor");
var metodos_pago_manager_1 = require("./catalogs/metodos-pago.manager");
var metodos_pago_editor_1 = require("./catalogs/metodos-pago.editor");
var segmentos_negocio_editor_1 = require("./catalogs/segmentos-negocio.editor");
var segmentos_negocio_manager_1 = require("./catalogs/segmentos-negocio.manager");
var notas_conceptos_editor_1 = require("./catalogs/notas-conceptos.editor");
var notas_conceptos_manager_1 = require("./catalogs/notas-conceptos.manager");
var bancos_manager_1 = require("./catalogs/bancos.manager");
var bancos_editor_1 = require("./catalogs/bancos.editor");
var addendas_editor_1 = require("./catalogs/addendas.editor");
var addendas_manager_1 = require("./catalogs/addendas.manager");
//////////////////////////// Mantenimientos ////////////////////////////////
var comprobante_maintenance_1 = require("./maintenances/comprobante.maintenance");
///////////////////////////// Documentos /////////////////////////////////
var polizas_editor_1 = require("./documents/polizas.editor");
var polizas_manager_1 = require("./documents/polizas.manager");
var polizas_by_lote_editor_1 = require("./documents/parts/polizas-by-lote.editor");
var comprobantes_manager_1 = require("./documents/comprobantes.manager");
var notas_manager_1 = require("./documents/notas.manager");
var notas_editor_1 = require("./documents/notas.editor");
var fichas_manager_1 = require("./documents/fichas.manager");
var fichas_editor_1 = require("./documents/fichas.editor");
var ejercicios_manager_1 = require("./documents/ejercicios.manager");
var ejercicios_editor_1 = require("./documents/ejercicios.editor");
var periodos_editor_1 = require("./documents/periodos.editor");
///////////////////////////// Componentes /////////////////////////////////
var tipos_cambio_component_1 = require("./components/tipos-cambio.component");
var tipos_cambio_editor_component_1 = require("./components/tipos-cambio-editor.component");
var envio_comprobantes_fiscales_component_1 = require("./components/envio-comprobantes-fiscales.component");
var routes = [
    {
        path: '',
        canActivateChild: [core_2.AuthGuard],
        children: [
            { path: 'articulos-fiscales/:proceso', component: categorias_articulos_manager_1.CategoriasArticulosManager },
            { path: 'articulos-fiscales/:proceso/:id', component: categorias_articulos_editor_1.CategoriasArticulosEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'unidades-fiscales/:proceso', component: categorias_unidades_medida_manager_1.CategoriasUnidadesMedidaManager },
            { path: 'unidades-fiscales/:proceso/:id', component: categorias_unidades_medida_editor_1.CategoriasUnidadesMedidaEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'contribuyentes/:proceso', component: contribuyentes_manager_1.ContribuyentesManager },
            { path: 'contribuyentes/:proceso/:id', component: contribuyentes_editor_1.ContribuyentesEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'empresas-contabilidad/:proceso', component: empresas_manager_1.EmpresasManager },
            { path: 'empresas-contabilidad/:proceso/:id', component: empresas_editor_1.EmpresasEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'sucursales-contabilidad/:proceso', component: sucursales_manager_1.SucursalesManager },
            { path: 'sucursales-contabilidad/:proceso/:idEmpresa/:id', component: sucursales_editor_1.SucursalesEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'cuentas/:proceso', component: cuentas_manager_1.CuentasManager },
            { path: 'flujo/:proceso', component: flujo_manager_1.FlujoManager },
            { path: 'divisas/:proceso', component: divisas_manager_1.DivisasManager },
            { path: 'divisas/:proceso/:id', component: divisas_editor_1.DivisasEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'pacs/:proceso', component: pacs_manager_1.PACsManager },
            { path: 'pacs/:proceso/:id', component: pacs_editor_1.PACsEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'impuestos/:proceso', component: impuestos_manager_1.ImpuestosManager },
            { path: 'impuestos/:proceso/:id', component: impuestos_editor_1.ImpuestosEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'retenciones/:proceso', component: retenciones_manager_1.RetencionesManager },
            { path: 'retenciones/:proceso/:id', component: retenciones_editor_1.RetencionesEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'certificados/:proceso', component: cfdcertificados_manager_1.CFDCertificadosManager },
            { path: 'certificados/:proceso/:id', component: cfdcertificados_editor_1.CFDCertificadosEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'series/:proceso', component: cfdseries_manager_1.CFDSeriesManager },
            { path: 'series/:proceso/:IdCFDCertificado/:id', component: cfdseries_editor_1.CFDSeriesEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'metodosPago/:proceso', component: metodos_pago_manager_1.MetodosPagoManager },
            { path: 'metodosPago/:proceso/:id', component: metodos_pago_editor_1.MetodosPagoEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'banco/:proceso', component: bancos_manager_1.BancosManager },
            { path: 'banco/:proceso/:id', component: bancos_editor_1.BancosEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'notas-conceptos/:proceso', component: notas_conceptos_manager_1.NotasConceptosManager },
            { path: 'notas-conceptos/:proceso/:id', component: notas_conceptos_editor_1.NotasConceptosEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'tipos-cambio/:proceso', component: tipos_cambio_component_1.TipoCambioComponent },
            { path: 'tipos-cambio-editor/:proceso', component: tipos_cambio_editor_component_1.TipoCambioEditorComponent },
            { path: 'addendas/:proceso', component: addendas_manager_1.AddendasManager },
            { path: 'addendas/:proceso/:id', component: addendas_editor_1.AddendasEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'envio-comprobantes-fiscales/:proceso', component: envio_comprobantes_fiscales_component_1.EnvioComprobantesFiscalesComponent },
            //DOCUMENTS
            { path: 'polizas/:proceso', component: polizas_manager_1.PolizasManager },
            { path: 'polizas/:proceso/:id', component: polizas_editor_1.PolizasEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'polizas-by-lote/:proceso', component: polizas_by_lote_editor_1.PolizasByLoteEditor },
            { path: 'comprobantes/:proceso', component: comprobantes_manager_1.ComprobantesManager },
            { path: 'ejercicios/:proceso', component: ejercicios_manager_1.EjerciciosManager },
            { path: 'ejercicios/:proceso/:id', component: ejercicios_editor_1.EjerciciosEditor },
            { path: 'periodosEditor/:proceso/:idEjercicio/:id', component: periodos_editor_1.PeriodosEditor },
            { path: 'segmentosNegocio/:proceso', component: segmentos_negocio_manager_1.SegmentosNegocioManager },
            { path: 'segmentosNegocio/:proceso/:id', component: segmentos_negocio_editor_1.SegmentosNegocioEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'notas/:proceso', component: notas_manager_1.NotasManager },
            { path: 'notas/:proceso/:id', component: notas_editor_1.NotasEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'fichas/:proceso', component: fichas_manager_1.FichasManager },
            { path: 'fichas/:proceso/:id', component: fichas_editor_1.FichasEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'series/:proceso/:idCFDCertificado/:id', component: cfdseries_editor_1.CFDSeriesEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'comprobante/:proceso', component: comprobante_maintenance_1.ComprobanteMaintenance }
        ]
    },
];
var AccountingRoutingModule = /** @class */ (function () {
    function AccountingRoutingModule() {
    }
    AccountingRoutingModule = __decorate([
        core_1.NgModule({
            imports: [
                router_1.RouterModule.forChild(routes)
            ],
            exports: [
                router_1.RouterModule
            ]
        })
    ], AccountingRoutingModule);
    return AccountingRoutingModule;
}());
exports.AccountingRoutingModule = AccountingRoutingModule;
