"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
var search_1 = require("framework3/search");
//Features
var cfd_certificado_service_1 = require("../services/cfd-certificado.service");
var cfd_certificado_1 = require("../models/cfd-certificado");
var serie_fiscal_service_1 = require("../services/serie-fiscal.service");
var wijmo_1 = require("wijmo/wijmo");
var CFDCertificadosEditor = /** @class */ (function (_super) {
    __extends(CFDCertificadosEditor, _super);
    //
    function CFDCertificadosEditor(router, route, formBuilder, changeDetector, context, location, cFDCertificadoService, serieFiscalService) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.router = router;
        _this.route = route;
        _this.formBuilder = formBuilder;
        _this.changeDetector = changeDetector;
        _this.context = context;
        _this.location = location;
        _this.cFDCertificadoService = cFDCertificadoService;
        _this.serieFiscalService = serieFiscalService;
        _this.cfdCertificado = new cfd_certificado_1.CFDCertificadoInfo();
        _this.series = [];
        _this.catalogForm = formBuilder.group({
            'codigo': ['', forms_1.Validators.required],
            'nombre': ['', forms_1.Validators.required],
            'passwordPK': ['', forms_1.Validators.required],
            'certificado': ['', forms_1.Validators.required],
            'llavePrivada': ['', forms_1.Validators.required]
        });
        return _this;
    }
    CFDCertificadosEditor_1 = CFDCertificadosEditor;
    ///////////////////////// METODOS ///////////////////////////////////////
    ///////////////////////// HANDLERS ///////////////////////////////////////
    CFDCertificadosEditor.prototype.onConfigureCatalog = function (options) {
        this.autogeneratedCode = options.codigoAutogenerado;
    };
    CFDCertificadosEditor.prototype.onCreatingItem = function () {
    };
    CFDCertificadosEditor.prototype.onViewingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.cFDCertificadoService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.cfdCertificado = info;
            _this.loadSeries();
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CFDCertificadosEditor.prototype.onCloningItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.cFDCertificadoService.clone(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.cfdCertificado = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CFDCertificadosEditor.prototype.onLoadingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.cFDCertificadoService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.cfdCertificado = info;
            _this.loadSeries();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CFDCertificadosEditor.prototype.onSavingItem = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.cFDCertificadoService.update(this.cfdCertificado)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.cfdCertificado = info;
            _this.reset();
            if (args.closeEditor)
                _this.location.back();
            else
                _this.showAlert('La información ha sido actualizada con éxito', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CFDCertificadosEditor.prototype.onSelectedTab = function (arg) {
        wijmo_1.Control.invalidateAll();
    };
    CFDCertificadosEditor.prototype.loadSeries = function () {
        var _this = this;
        var request = new search_1.SearchRequest();
        request.paged = false;
        //Agregar condición de empresa actual
        //let condicionServidorSMTP: SearchCondition = { field: "IdCFDCertificado", operator: "=", valueType: "int", value: this.cfdCertificado.identity.toString() };
        //request.conditions.push(condicionServidorSMTP);
        //
        this.context.app.showSpinner();
        this.serieFiscalService.search(this.context.app.defaultSite.identity, request)
            .then(function (response) {
            _this.context.app.hideSpinner();
            //
            _this.series = response.rows;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", Array)
    ], CFDCertificadosEditor.prototype, "series", void 0);
    CFDCertificadosEditor = CFDCertificadosEditor_1 = __decorate([
        core_1.Component({
            selector: 'contabilidad-cfdcertificados-editor',
            template: "\n      <form [formGroup]=\"catalogForm\">\n\n          <azteca-catalog-editor #catalogEditor \n                                 [title]=\"'Certificado'\"\n                                 [info]=\"cfdCertificado\"\n                                 [valid]=\"valid\"\n                                 (configureCatalog)=\"onConfigureCatalog($event)\"\n                                 (creatingItem)=\"onCreatingItem()\"\n                                 (viewingItem)=\"onViewingItem($event)\"\n                                 (cloningItem)=\"onCloningItem($event)\"\n                                 (savingItem)=\"onSavingItem($event)\"\n                                 (loadingItem)=\"onLoadingItem($event)\">\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-lg-10\">\n                      <azteca-form-field [label]=\"'C\u00F3digo:'\">\n                          <catalog-code formControlName=\"codigo\" [(ngModel)]=\"cfdCertificado.code\" [automatic]=\"autogeneratedCode\"></catalog-code>\n                      </azteca-form-field>\n\n                      <azteca-form-field [label]=\"'Nombre:'\">\n                          <az-textbox formControlName=\"nombre\" [(ngModel)]=\"cfdCertificado.nombre\"></az-textbox>\n                      </azteca-form-field>\n\n                  </div>\n              </div>\n\n        \n              <div class=\"row\">\n                  <div class=\"col-12 col-lg-10\">\n                      <tabset>\n                          <tab heading=\"Generales\" (select)=\"onSelectedTab($event)\">\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-lg-6\">\n                                      <azteca-form-field [label]=\"'Certificado:'\">\n                                          <azteca-file-box formControlName=\"certificado\" [(ngModel)]=\"cfdCertificado.certificado\"></azteca-file-box>\n                                      </azteca-form-field>\n                                  </div>\n                                  <div class=\"col-12 col-lg-6\">\n                                      <label class=\"form-control-label\">N\u00FAmero de serie:</label>\n                                      <az-textbox [text]=\"cfdCertificado.numeroSerie\" [enabled]=\"false\"></az-textbox>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-lg-6\">\n                                      <azteca-form-field [label]=\"'Llave privada:'\">\n                                          <azteca-file-box formControlName=\"llavePrivada\" [(ngModel)]=\"cfdCertificado.llavePrivada\"></azteca-file-box>\n                                      </azteca-form-field>\n\n                                  </div>\n                                  <div class=\"col-12 col-lg-6\">\n                                      <azteca-form-field [label]=\"'Password:'\">\n                                          <az-password formControlName=\"passwordPK\" [(ngModel)]=\"cfdCertificado.passwordPK\"></az-password>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-lg-6\">\n\n                                      <label class=\"control-label\">Inicio de vigencia:</label>\n                                      <az-label [text]=\"cfdCertificado.validFrom\"></az-label>\n\n                                  </div>\n                                  <div class=\"col-12 col-lg-6\">\n\n                                      <label class=\"control-label\">Fin de vigencia:</label>\n                                      <az-label [text]=\"cfdCertificado.validTo\"></az-label>\n\n                                  </div>\n                              </div>\n\n                          </tab>\n\n                          <tab heading=\"Series\" [disabled]=\"cfdCertificado.identity == 0\" (select)=\"onSelectedTab($event)\">\n                              <div class=\"row\">\n                                  <div class=\"col-12\">\n                                      <contabilidad-cfdseries-manager [name]=\"'series'\"\n                                                      [series]=\"series\"\n                                                      [IdCFDCertificado]=\"cfdCertificado.identity\"\n                                                      (refreshListParent)=\"loadSeries()\">\n                                      </contabilidad-cfdseries-manager>\n                                  </div>\n                              </div>\n                          </tab>\n                      </tabset>\n                  </div>\n              </div>\n            \n\n          </azteca-catalog-editor>\n      </form>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return CFDCertificadosEditor_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: cfd_certificado_service_1.CFDCertificadoService
                }
            ]
        }),
        __metadata("design:paramtypes", [router_1.Router, router_1.ActivatedRoute, forms_1.FormBuilder, core_1.ChangeDetectorRef,
            core_2.Context, common_1.Location, cfd_certificado_service_1.CFDCertificadoService, serie_fiscal_service_1.SerieFiscalService])
    ], CFDCertificadosEditor);
    return CFDCertificadosEditor;
    var CFDCertificadosEditor_1;
}(editors_1.CatalogEditor));
exports.CFDCertificadosEditor = CFDCertificadosEditor;
