"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//Features
var serie_fiscal_service_1 = require("../services/serie-fiscal.service");
var CFDSeriesManager = /** @class */ (function (_super) {
    __extends(CFDSeriesManager, _super);
    //    
    function CFDSeriesManager(router, route, context, serieFiscalService) {
        var _this = _super.call(this, context, router, route) || this;
        _this.router = router;
        _this.route = route;
        _this.context = context;
        _this.serieFiscalService = serieFiscalService;
        _this.series = [];
        _this.refreshListParent = new core_1.EventEmitter();
        return _this;
    }
    CFDSeriesManager_1 = CFDSeriesManager;
    ///////////////////////// METODOS ///////////////////////////////////////
    ///////////////////////// HANDLERS ///////////////////////////////////////
    CFDSeriesManager.prototype.onConfigureCatalog = function (options) {
        //this.manager.serverSide = options.busquedasServidor;
        //this.manager.pageSize = options.tamanioPagina;        
        //this.refreshList();
    };
    CFDSeriesManager.prototype.doSearch = function (request) {
        //this.context.app.showSpinner();
        //this.serieFiscalService.search(this.context.app.defaultSite.identity, request)
        //    .then(response => {
        //        this.context.app.hideSpinner();
        //        //
        //        this.series = response.rows;
        //        this.totalRows = response.totalRows;
        //        this.pageIndex = request.pageIndex;                                
        //    })
        //    .catch(error => this.handleError(error));
    };
    CFDSeriesManager.prototype.onAddingItem = function () {
        this.router.navigate(['accounting/series', this.process.id, this.IdCFDCertificado, 0]);
    };
    CFDSeriesManager.prototype.onViewingItem = function (item) {
        this.router.navigate([item.id, { readonly: true }], { relativeTo: this.route });
    };
    CFDSeriesManager.prototype.onEditingItem = function (item) {
        this.router.navigate(['accounting/series', this.process.id, this.IdCFDCertificado, item.id]);
    };
    CFDSeriesManager.prototype.onDeletingItem = function (item) {
        var _this = this;
        this.serieFiscalService.delete(item.id)
            .then(function (success) {
            _this.refreshList();
            _this.showAlert('El registro ha sido eliminado con éxito.', 'success');
            _this.refreshListParent.emit();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CFDSeriesManager.prototype.onCloningItem = function (item) {
        this.router.navigate([0, { cloneId: item.id }], { relativeTo: this.route });
    };
    CFDSeriesManager.prototype.onChangingItemState = function (item) {
        var _this = this;
        this.serieFiscalService.changeStatus(item.id, !item.activo)
            .then(function (success) {
            _this.refreshList();
            _this.showAlert('El estatus del registro ha sido actualizado con éxito.', 'success');
            _this.refreshListParent.emit();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", Array)
    ], CFDSeriesManager.prototype, "series", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], CFDSeriesManager.prototype, "IdCFDCertificado", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", core_1.EventEmitter)
    ], CFDSeriesManager.prototype, "refreshListParent", void 0);
    CFDSeriesManager = CFDSeriesManager_1 = __decorate([
        core_1.Component({
            selector: 'contabilidad-cfdseries-manager',
            template: "\n      <azteca-catalog-manager (searchRequested)=\"doSearch($event)\"\n                              (addingItem)=\"onAddingItem()\"\n                              (viewingItem)=\"onViewingItem($event)\"\n                              (editingItem)=\"onEditingItem($event)\"\n                              (deletingItem)=\"onDeletingItem($event)\"\n                              (cloningItem)=\"onCloningItem($event)\"\n                              (changingItemState)=\"onChangingItemState($event)\"\n      \t\t\t\t\t\t(configureCatalog)=\"onConfigureCatalog($event)\"\n                              [enabled]=\"enabled\"\n                              [allowNew]=\"allowNew\"\n                              [allowView]=\"allowView\"\n                              [allowEdit]=\"allowEdit\"\n                              [allowDelete]=\"allowDelete\"\n                              [allowClone]=\"allowClone\"\n                              [allowChangeState]=\"allowChangeState\"\n                              [catalogList]=\"series\"\n                              [totalRows]=\"totalRows\"\n                              [pageIndex]=\"pageIndex\"\n                              [standAlone]=\"false\"\n                              [pageSize]=\"15\"\n                              [serverSide]=\"false\">\n\n    \n          <azteca-grid-column [header]=\"'C\u00F3digo'\" [binding]=\"'codigo'\" [width]=\"'10*'\"></azteca-grid-column>\n          <azteca-grid-column [header]=\"'Nombre'\" [binding]=\"'nombre'\" [width]=\"'60*'\"></azteca-grid-column>\n    \n\n      </azteca-catalog-manager>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return CFDSeriesManager_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: serie_fiscal_service_1.SerieFiscalService
                }
            ]
        }),
        __metadata("design:paramtypes", [router_1.Router, router_1.ActivatedRoute, core_2.Context, serie_fiscal_service_1.SerieFiscalService])
    ], CFDSeriesManager);
    return CFDSeriesManager;
    var CFDSeriesManager_1;
}(editors_1.CatalogManager));
exports.CFDSeriesManager = CFDSeriesManager;
