import { ChangeDetectorRef } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { Context } from 'framework3/core';
import { CatalogOptions } from 'framework3/custom';
import { CatalogEditor, EditorEventArgs } from 'framework3/editors';
import { DomicilioInfo } from 'framework3/general';
import { ContribuyenteService } from '../services/contribuyente.service';
import { ContribuyenteInfo, UsoCFDIItem } from '../models/contribuyente';
export declare class ContribuyentesEditor extends CatalogEditor {
    protected router: Router;
    protected route: ActivatedRoute;
    private formBuilder;
    protected changeDetector: ChangeDetectorRef;
    protected context: Context;
    private location;
    private contribuyenteService;
    contribuyente: ContribuyenteInfo;
    usosCFDI: UsoCFDIItem[];
    constructor(router: Router, route: ActivatedRoute, formBuilder: FormBuilder, changeDetector: ChangeDetectorRef, context: Context, location: Location, contribuyenteService: ContribuyenteService);
    onConfigureCatalog(options: CatalogOptions): void;
    onCreatingItem(): void;
    onViewingItem(id: number): void;
    onCloningItem(id: number): void;
    onLoadingItem(id: number): void;
    onSavingItem(args: EditorEventArgs): void;
    loadUsosCFDI(): void;
    domicilioChanged(domicilio: DomicilioInfo): void;
}
