import { Router, ActivatedRoute } from '@angular/router';
import { Context, CatalogItem } from 'framework3/core';
import { CatalogOptions } from 'framework3/custom';
import { CatalogManager } from 'framework3/editors';
import { SearchRequest } from 'framework3/search';
import { ContribuyenteService } from '../services/contribuyente.service';
import { ContribuyenteItem } from '../models/contribuyente';
import { MenuItem } from 'framework3/controls';
export declare class ContribuyentesManager extends CatalogManager {
    protected router: Router;
    protected route: ActivatedRoute;
    protected context: Context;
    private contribuyenteService;
    contribuyentes: ContribuyenteItem[];
    constructor(router: Router, route: ActivatedRoute, context: Context, contribuyenteService: ContribuyenteService);
    onConfigureCatalog(options: CatalogOptions): void;
    doSearch(request: SearchRequest): void;
    onAddingItem(): void;
    onViewingItem(item: CatalogItem): void;
    onEditingItem(item: CatalogItem): void;
    onDeletingItem(item: CatalogItem): void;
    onCloningItem(item: CatalogItem): void;
    onChangingItemState(item: CatalogItem): void;
    onMenuItemClick(item: MenuItem): void;
}
