"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//Features
var divisa_service_1 = require("../services/divisa.service");
var divisa_1 = require("../models/divisa");
var DivisasEditor = /** @class */ (function (_super) {
    __extends(DivisasEditor, _super);
    //
    function DivisasEditor(router, route, formBuilder, changeDetector, context, location, divisaService) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.router = router;
        _this.route = route;
        _this.formBuilder = formBuilder;
        _this.changeDetector = changeDetector;
        _this.context = context;
        _this.location = location;
        _this.divisaService = divisaService;
        _this.divisa = new divisa_1.DivisaInfo();
        _this.catalogForm = formBuilder.group({
            'codigo': ['', forms_1.Validators.required],
            'nombre': ['', forms_1.Validators.required],
            'abreviatura': ['', forms_1.Validators.required],
            'tipo': [''],
            'serieBanxico': ['']
        });
        return _this;
    }
    DivisasEditor_1 = DivisasEditor;
    ///////////////////////// METODOS ///////////////////////////////////////
    ///////////////////////// HANDLERS ///////////////////////////////////////
    DivisasEditor.prototype.onConfigureCatalog = function (options) {
        this.autogeneratedCode = options.codigoAutogenerado;
    };
    DivisasEditor.prototype.onCreatingItem = function () {
    };
    DivisasEditor.prototype.onViewingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.divisaService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.divisa = info;
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    DivisasEditor.prototype.onCloningItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.divisaService.clone(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.divisa = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    DivisasEditor.prototype.onLoadingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.divisaService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.divisa = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    DivisasEditor.prototype.onSavingItem = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.divisaService.update(this.divisa)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.divisa = info;
            _this.reset();
            if (args.closeEditor)
                _this.location.back();
            else
                _this.showAlert('La información ha sido actualizada con éxito', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    DivisasEditor = DivisasEditor_1 = __decorate([
        core_1.Component({
            selector: 'contabilidad-divisas-editor',
            template: "\n      <form [formGroup]=\"catalogForm\">\n\n          <azteca-catalog-editor #catalogEditor \n                                 [title]=\"'Divisa'\"\n                                 [info]=\"divisa\"\n                                 [valid]=\"valid\"\n                                 (configureCatalog)=\"onConfigureCatalog($event)\"\n                                 (creatingItem)=\"onCreatingItem()\"\n                                 (viewingItem)=\"onViewingItem($event)\"\n                                 (cloningItem)=\"onCloningItem($event)\"\n                                 (savingItem)=\"onSavingItem($event)\"\n                                 (loadingItem)=\"onLoadingItem($event)\">\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <azteca-form-field [label]=\"'C\u00F3digo:'\">\n                          <catalog-code formControlName=\"codigo\" [(ngModel)]=\"divisa.code\" [automatic]=\"autogeneratedCode\"></catalog-code>\n                      </azteca-form-field>\n\n                      <azteca-form-field [label]=\"'Nombre:'\">\n                          <az-textbox formControlName=\"nombre\" [(ngModel)]=\"divisa.nombre\"></az-textbox>\n                      </azteca-form-field>\n\n                  </div>\n              </div>\n\n        \n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <tabset>\n                          <tab heading=\"Generales\">\n                              <azteca-form-field [label]=\"'Abreviatura:'\">\n                                  <az-textbox formControlName=\"abreviatura\" [(ngModel)]=\"divisa.abreviatura\"></az-textbox>\n                              </azteca-form-field>\n\n                              <azteca-form-field [label]=\"'Tipo:'\">\n                                  <az-textbox formControlName=\"tipo\" [(ngModel)]=\"divisa.tipo\"></az-textbox>\n                              </azteca-form-field>\n\n                              <azteca-form-field [label]=\"'Serie Banxico:'\">\n                                  <az-textbox formControlName=\"serieBanxico\" [(ngModel)]=\"divisa.serieBanxico\"></az-textbox>\n                              </azteca-form-field>\n                      \n                          </tab>\n                    \n                      </tabset>\n                  </div>\n              </div>\n            \n\n          </azteca-catalog-editor>\n      </form>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return DivisasEditor_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: divisa_service_1.DivisaService
                }
            ]
        }),
        __metadata("design:paramtypes", [router_1.Router, router_1.ActivatedRoute, forms_1.FormBuilder, core_1.ChangeDetectorRef,
            core_2.Context, common_1.Location, divisa_service_1.DivisaService])
    ], DivisasEditor);
    return DivisasEditor;
    var DivisasEditor_1;
}(editors_1.CatalogEditor));
exports.DivisasEditor = DivisasEditor;
