import { ChangeDetectorRef } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { Context } from 'framework3/core';
import { CatalogOptions } from 'framework3/custom';
import { CatalogEditor, EditorEventArgs } from 'framework3/editors';
import { FormatoTipoService, FormatoItem } from 'framework3/general';
import { EmpresaService } from '../services/empresa.service';
import { EmpresaInfo, RegimenFiscalItem } from '../models/empresa';
import { SucursalItem } from '../models/sucursal';
import { SucursalService } from '../services/sucursal.service';
import { DivisaItem } from '../models/divisa';
import { DivisaService } from '../services/divisa.service';
import { PACService } from '../services/pac.service';
import { SerieFiscalService } from '../services/serie-fiscal.service';
import { SerieFiscalItem } from '../models/serie-fiscal';
import { ContribuyenteService } from '../services/contribuyente.service';
import { UsoCFDIItem } from '../models/contribuyente';
import { DomicilioInfo } from 'framework3/general';
export declare class EmpresasEditor extends CatalogEditor {
    protected router: Router;
    protected route: ActivatedRoute;
    private formBuilder;
    protected changeDetector: ChangeDetectorRef;
    protected context: Context;
    private location;
    private empresaService;
    private sucursalService;
    private divisaService;
    private pacService;
    private serieFiscalService;
    private contribuyenteService;
    private formatoService;
    empresa: EmpresaInfo;
    sucursales: SucursalItem[];
    pacs: DivisaItem[];
    series: SerieFiscalItem[];
    formatosCfdi: FormatoItem[];
    regimenesFiscales: RegimenFiscalItem[];
    usosCFDI: UsoCFDIItem[];
    constructor(router: Router, route: ActivatedRoute, formBuilder: FormBuilder, changeDetector: ChangeDetectorRef, context: Context, location: Location, empresaService: EmpresaService, sucursalService: SucursalService, divisaService: DivisaService, pacService: PACService, serieFiscalService: SerieFiscalService, contribuyenteService: ContribuyenteService, formatoService: FormatoTipoService);
    loadFormatosCfdi(): void;
    loadUsosCFDI(): void;
    loadRegimenesFiscales(): void;
    onConfigureCatalog(options: CatalogOptions): void;
    onCreatingItem(): void;
    onViewingItem(id: number): void;
    onCloningItem(id: number): void;
    onLoadingItem(id: number): void;
    onSavingItem(args: EditorEventArgs): void;
    selectSucursalesTab(arg: any): void;
    loadSucursales(): void;
    loadPACs(): void;
    loadSeries(): void;
    onDomicilioFiscalChanged(domicilio: DomicilioInfo): void;
    onDomicilioValidChange(): void;
}
