"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Azteca Kernel
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
var editors_1 = require("framework3/editors");
var search_1 = require("framework3/search");
var general_1 = require("framework3/general");
//Features
var empresa_service_1 = require("../services/empresa.service");
var empresa_1 = require("../models/empresa");
var sucursal_service_1 = require("../services/sucursal.service");
var divisa_service_1 = require("../services/divisa.service");
var pac_service_1 = require("../services/pac.service");
var serie_fiscal_service_1 = require("../services/serie-fiscal.service");
var contribuyente_service_1 = require("../services/contribuyente.service");
var wijmo_1 = require("wijmo/wijmo");
var EmpresasEditor = /** @class */ (function (_super) {
    __extends(EmpresasEditor, _super);
    //
    function EmpresasEditor(router, route, formBuilder, changeDetector, context, location, empresaService, sucursalService, divisaService, pacService, serieFiscalService, contribuyenteService, formatoService) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.router = router;
        _this.route = route;
        _this.formBuilder = formBuilder;
        _this.changeDetector = changeDetector;
        _this.context = context;
        _this.location = location;
        _this.empresaService = empresaService;
        _this.sucursalService = sucursalService;
        _this.divisaService = divisaService;
        _this.pacService = pacService;
        _this.serieFiscalService = serieFiscalService;
        _this.contribuyenteService = contribuyenteService;
        _this.formatoService = formatoService;
        _this.empresa = new empresa_1.EmpresaInfo();
        _this.sucursales = [];
        _this.pacs = [];
        _this.series = [];
        _this.formatosCfdi = [];
        _this.regimenesFiscales = [];
        _this.usosCFDI = [];
        _this.catalogForm = formBuilder.group({
            'logo': [''],
            'codigo': [''],
            'nombre': ['', forms_1.Validators.required],
            'idDivisa': [0, controls_1.AztecaValidators.selected],
            'idPAC': [''],
            'formatoContable': [''],
            'idRegimenFiscal': [0, controls_1.AztecaValidators.selected],
            'idRemitenteCompborantes': [0],
            'domicilio': [''],
            'rfc': ['', forms_1.Validators.required],
            'razonSocial': ['', forms_1.Validators.required],
            'domicilioFiscal': ['', forms_1.Validators.required],
            'idFormatoIngreso': [0],
            'idFormatoEgreso': [0],
            'idFormatoPago': [0],
            'idFormatoReciboNomina': [0],
        });
        return _this;
    }
    EmpresasEditor_1 = EmpresasEditor;
    ///////////////////////// METODOS ///////////////////////////////////////
    EmpresasEditor.prototype.loadFormatosCfdi = function () {
        var _this = this;
        this.formatoService.loadFormatos('ACCOUNTING_CFDI', this.empresa.identity)
            .then(function (formatos) {
            _this.formatosCfdi = formatos;
            _this.formatosCfdi.unshift({ id: 0, nombre: '[NINGUNO]', activo: true, codigo: '' });
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    EmpresasEditor.prototype.loadUsosCFDI = function () {
        var _this = this;
        this.contribuyenteService.loadUsosCFDI(this.context.app.defaultCompany.identity)
            .then(function (usos) { return _this.usosCFDI = usos; })
            .catch(function (error) { return _this.handleError(error); });
    };
    EmpresasEditor.prototype.loadRegimenesFiscales = function () {
        var _this = this;
        this.empresaService.loadRegimenesFiscales(this.context.app.defaultCompany.identity)
            .then(function (regimenes) { return _this.regimenesFiscales = regimenes; })
            .catch(function (error) { return _this.handleError(error); });
    };
    ///////////////////////// HANDLERS ///////////////////////////////////////
    EmpresasEditor.prototype.onConfigureCatalog = function (options) {
        this.autogeneratedCode = options.codigoAutogenerado;
        this.loadPACs();
        this.loadSeries();
        this.loadRegimenesFiscales();
    };
    EmpresasEditor.prototype.onCreatingItem = function () {
    };
    EmpresasEditor.prototype.onViewingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.empresaService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.empresa = info;
            _this.loadSucursales();
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    EmpresasEditor.prototype.onCloningItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.empresaService.clone(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.empresa = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    EmpresasEditor.prototype.onLoadingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.empresaService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.empresa = info;
            _this.loadSucursales();
            _this.loadFormatosCfdi();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    EmpresasEditor.prototype.onSavingItem = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.empresaService.update(this.empresa)
            .then(function (info) {
            _this.context.app.hideSpinner();
            //Si es un elemento nuevo y no se cerrará el editor, navegar a nueva ruta
            _this.reset();
            if (!args.closeEditor && _this.empresa.identity == 0) {
                _this.router.navigate(['../', info.identity], { relativeTo: _this.route });
            }
            else {
                if (args.closeEditor)
                    _this.router.navigate(['../'], { relativeTo: _this.route });
                else
                    _this.showAlert('La información ha sido actualizada con éxito', 'success');
            }
            _this.empresa = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    //Manejo de Estados
    EmpresasEditor.prototype.selectSucursalesTab = function (arg) {
        wijmo_1.Control.invalidateAll();
    };
    EmpresasEditor.prototype.loadSucursales = function () {
        var _this = this;
        var request = new search_1.SearchRequest();
        request.paged = false;
        //Agregar condición de empresa actual
        var condicion = { field: "IdEmpresa", operator: "=", valueType: "int", value: this.empresa.identity.toString() };
        request.conditions.push(condicion);
        //
        this.context.app.showSpinner();
        this.sucursalService.search(this.context.app.defaultSite.identity, request)
            .then(function (response) {
            _this.context.app.hideSpinner();
            //
            _this.sucursales = response.rows;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    EmpresasEditor.prototype.loadPACs = function () {
        var _this = this;
        this.pacService.loadList()
            .then(function (pacs) { return _this.pacs = pacs; })
            .catch(function (error) { return _this.handleError(error); });
    };
    EmpresasEditor.prototype.loadSeries = function () {
        var _this = this;
        this.serieFiscalService.loadList(this.context.app.defaultCompany.identity.toString())
            .then(function (series) { return _this.series = series; })
            .catch(function (error) { return _this.handleError(error); });
    };
    EmpresasEditor.prototype.onDomicilioFiscalChanged = function (domicilio) {
        this.empresa.contribuyente.domicilio = domicilio;
    };
    EmpresasEditor.prototype.onDomicilioValidChange = function () {
        this.changeDetector.detectChanges();
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", Array)
    ], EmpresasEditor.prototype, "sucursales", void 0);
    EmpresasEditor = EmpresasEditor_1 = __decorate([
        core_1.Component({
            selector: 'contabilidad-empresas-editor',
            template: "\n      <form [formGroup]=\"catalogForm\">\n\n          <azteca-catalog-editor #catalogEditor\n                                 [title]=\"'Empresa'\"\n                                 [info]=\"empresa\"\n                                 [valid]=\"valid && domicilioEditor.valid\"\n                                 (configureCatalog)=\"onConfigureCatalog($event)\"\n                                 (creatingItem)=\"onCreatingItem()\"\n                                 (viewingItem)=\"onViewingItem($event)\"\n                                 (cloningItem)=\"onCloningItem($event)\"\n                                 (savingItem)=\"onSavingItem($event)\"\n                                 (loadingItem)=\"onLoadingItem($event)\">\n\n              <div class=\"row\">\n                  <div class=\"col-4 col-lg-2\">\n                      <azteca-form-field>\n                          <azteca-image-box formControlName=\"logo\" [(ngModel)]=\"empresa.empresaBase.logo\"></azteca-image-box>\n                      </azteca-form-field>\n                  </div>\n\n                  <div class=\"col-8 col-lg-8\">\n                      <azteca-form-field [label]=\"'C\u00F3digo:'\">\n                          <catalog-code formControlName=\"codigo\" [(ngModel)]=\"empresa.empresaBase.code\" [automatic]=\"autogeneratedCode\"></catalog-code>\n                      </azteca-form-field>\n\n                      <azteca-form-field [label]=\"'Nombre:'\">\n                          <az-textbox formControlName=\"nombre\" [(ngModel)]=\"empresa.empresaBase.nombre\"></az-textbox>\n                      </azteca-form-field>\n\n                  </div>\n              </div>\n\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-lg-10\">\n                      <tabset>\n                          <!--------------------------- DOMICILIO ------------------------------------------------->\n                          <tab heading=\"Domicilio\">\n                              <general-domicilio-editor #domicilioEditor\n                                                        formControlName=\"domicilio\"\n                                                        [(ngModel)]=\"empresa.empresaBase.domicilio\"\n                                                        [poblacionRequired]=\"true\"\n                                                        [cruceUnoVisible]=\"false\"\n                                                        [cruceDosVisible]=\"false\"\n                                                        (validChange)=\"onDomicilioValidChange($event)\">\n\n                              </general-domicilio-editor>\n\n                          </tab>\n\n                          <tab heading=\"Datos Fiscales\">\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-lg-5\">\n                                      <azteca-form-field [label]=\"'RFC:'\">\n                                          <az-textbox formControlName=\"rfc\" [(ngModel)]=\"empresa.contribuyente.rfc\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-lg-10\">\n                                      <azteca-form-field [label]=\"'Raz\u00F3n Social:'\">\n                                          <az-textbox formControlName=\"razonSocial\" [(ngModel)]=\"empresa.contribuyente.razonSocial\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-lg-10\">\n                                      <general-domicilio-editor formControlName=\"domicilioFiscal\"\n                                                                [(ngModel)]=\"empresa.contribuyente.domicilio\"\n                                                                (valueChanged)=\"onDomicilioFiscalChanged($event)\"\n                                                                [cruceUnoVisible]=\"false\"\n                                                                [cruceDosVisible]=\"false\">\n\n                                      </general-domicilio-editor>\n\n                                  </div>\n                              </div>\n\n                          </tab>\n\n                          <!--------------------------- CONFIGURACION ------------------------------------------------->\n                          <tab heading=\"Configuracion\">\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-lg-5\">\n                                      <azteca-form-field [label]=\"'Divisa:'\">\n                                          <accounting-divisas-selector formControlName=\"idDivisa\" [(ngModel)]=\"empresa.idDivisa\"></accounting-divisas-selector>\n                                      </azteca-form-field>\n                                  </div>\n                                  <div class=\"col-12 col-lg-5\">\n                                      <azteca-form-field [label]=\"'PAC:'\">\n                                          <az-combobox formControlName=\"idPAC\"\n                                                       [(ngModel)]=\"empresa.idPac\"\n                                                       [items]=\"pacs\"\n                                                       [displayMember]=\"'nombre'\"\n                                                       [valueMember]=\"'id'\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-lg-5\">\n                                      <azteca-form-field [label]=\"'Formato Contable:'\">\n                                          <az-textbox formControlName=\"formatoContable\" [(ngModel)]=\"empresa.formatoContable\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                                  <div class=\"col-12 col-lg-5\">\n                                      <azteca-form-field [label]=\"'RegimenFiscal:'\">\n                                          <az-combobox formControlName=\"idRegimenFiscal\"\n                                                       [(ngModel)]=\"empresa.idRegimenFiscal\"\n                                                       [items]=\"regimenesFiscales\"\n                                                       [displayMember]=\"'nombre'\"\n                                                       [valueMember]=\"'id'\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-lg-5\">\n                                      <azteca-form-field [label]=\"'Remitente:'\">\n                                          <notification-remitente-mail-selector formControlName=\"idRemitenteCompborantes\" [(ngModel)]=\"empresa.idRemitenteComprobantes\"></notification-remitente-mail-selector>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                            \n                              </div>\n                        \n                          </tab>\n\n                          <!--------------------------- SUCURSALES ------------------------------------------------->\n                          <tab heading=\"Sucursales\" [disabled]=\"empresa.identity == 0\" (select)=\"selectSucursalesTab($event)\">\n                              <div class=\"row\">\n                                  <div class=\"col-12\">\n\n                                      <contabilidad-sucursales-manager [name]=\"'sucursales'\"\n                                                                       [sucursales]=\"sucursales\"\n                                                                       [idEmpresa]=\"empresa.identity\"\n                                                                       (refreshListParent)=\"loadSucursales()\">\n                                      </contabilidad-sucursales-manager>\n\n                                  </div>\n                              </div>\n                          </tab>\n\n                          <!--------------------------- FORMATOS ------------------------------------------------->\n                          <tab heading=\"Formatos\">\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-lg-5\">\n                                      <azteca-form-field [label]=\"'Formato CFDI de ingresos:'\">\n                                          <az-combobox formControlName=\"idFormatoIngreso\" [(ngModel)]=\"empresa.idFormatoIngreso\" [items]=\"formatosCfdi\" [valueMember]=\"'id'\" [displayMember]=\"'nombre'\"></az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n                                  <div class=\"col-12 col-lg-5\">\n                                      <azteca-form-field [label]=\"'Formato CFDI de egresos:'\">\n                                          <az-combobox formControlName=\"idFormatoEgreso\" [(ngModel)]=\"empresa.idFormatoEgreso\" [items]=\"formatosCfdi\" [valueMember]=\"'id'\" [displayMember]=\"'nombre'\"></az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-lg-5\">\n                                      <azteca-form-field [label]=\"'Formato CFDI de pagos:'\">\n                                          <az-combobox formControlName=\"idFormatoPago\" [(ngModel)]=\"empresa.idFormatoPago\" [items]=\"formatosCfdi\" [valueMember]=\"'id'\" [displayMember]=\"'nombre'\"></az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n                                  <div class=\"col-12 col-lg-5\">\n                                      <azteca-form-field [label]=\"'Formato CFDI de nomina:'\">\n                                          <az-combobox formControlName=\"idFormatoReciboNomina\" [(ngModel)]=\"empresa.idFormatoReciboNomina\" [items]=\"formatosCfdi\" [valueMember]=\"'id'\" [displayMember]=\"'nombre'\"></az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n                          </tab>\n                      </tabset>\n                  </div>\n              </div>\n\n\n          </azteca-catalog-editor>\n      </form>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return EmpresasEditor_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: empresa_service_1.EmpresaService
                }
            ]
        }),
        __metadata("design:paramtypes", [router_1.Router, router_1.ActivatedRoute, forms_1.FormBuilder, core_1.ChangeDetectorRef,
            core_2.Context, common_1.Location, empresa_service_1.EmpresaService, sucursal_service_1.SucursalService,
            divisa_service_1.DivisaService, pac_service_1.PACService, serie_fiscal_service_1.SerieFiscalService, contribuyente_service_1.ContribuyenteService,
            general_1.FormatoTipoService])
    ], EmpresasEditor);
    return EmpresasEditor;
    var EmpresasEditor_1;
}(editors_1.CatalogEditor));
exports.EmpresasEditor = EmpresasEditor;
