"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var router_1 = require("@angular/router");
//
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//
var flujo_1 = require("../models/flujo");
var flujo_service_1 = require("../services/flujo.service");
var FlujoManager = /** @class */ (function (_super) {
    __extends(FlujoManager, _super);
    function FlujoManager(context, changeDetector, formBuilder, flujoService, router, route) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.context = context;
        _this.changeDetector = changeDetector;
        _this.formBuilder = formBuilder;
        _this.flujoService = flujoService;
        _this.router = router;
        _this.route = route;
        _this.flujo = [];
        _this.flujoEdicion = new flujo_1.FlujoInfo();
        _this.nodeForm = formBuilder.group({
            'codigo': ['', forms_1.Validators.required],
            'nombre': ['', forms_1.Validators.required]
        });
        return _this;
    }
    FlujoManager_1 = FlujoManager;
    ////////////////////// METODOS //////////////////////////////////////////////
    FlujoManager.prototype.loadHierarchy = function () {
        var _this = this;
        this.context.app.showSpinner();
        this.flujoService.loadHierarchy(this.context.app.defaultCompany.identity, 0)
            .then(function (nodes) {
            _this.context.app.hideSpinner();
            _this.flujo = nodes;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    //////////////////// HANDLERS //////////////////////////////////////
    FlujoManager.prototype.onConfigureCatalog = function (options) {
        this.autogeneratedCode = options.codigoAutogenerado;
        this.loadHierarchy();
        //Hacer llamadas de carga inicial de datos aquí
    };
    FlujoManager.prototype.onNodesChanged = function (flujo) {
        this.flujo = flujo;
    };
    FlujoManager.prototype.onCurrentNodeChanged = function (node) {
        this.currentNode = node;
    };
    FlujoManager.prototype.onCreatingNode = function (parentNode) {
        this.flujoEdicion = new flujo_1.FlujoInfo(); //Crear nueva instancia para evitar que reset modifique la información del último nodo en edición
        this.nodeForm.reset();
        this.flujoEdicion = new flujo_1.FlujoInfo(); //Se vuelve a crear instancia para evitar valores nulos creados por reset
        //Inicializar valores del nodo
        this.flujoEdicion.idBranch = this.context.app.defaultSite.identity;
        this.flujoEdicion.idCompany = this.context.app.defaultCompany.identity;
        //
        this.currentParent = parentNode;
        this.showEditor();
    };
    FlujoManager.prototype.onEditingNode = function (node) {
        this.flujoEdicion = this.flujoService.copy(node.data);
        this.showEditor();
    };
    FlujoManager.prototype.onSavingNode = function () {
        //Si es un nuevo nodo
        if (this.flujoEdicion.clientID == 0) {
            this.addNode(this.flujoEdicion, this.currentParent);
        }
        else {
            this.updateNode(this.flujoEdicion);
        }
        this.flujoEdicion = new flujo_1.FlujoInfo();
        this.hideEditor();
    };
    FlujoManager.prototype.onDeletingNode = function (node) {
        this.deleteNode(node);
    };
    FlujoManager.prototype.onSavingHierarchy = function (changes) {
        var _this = this;
        this.context.app.showSpinner();
        this.flujoService.saveHierarchy(changes)
            .then(function (flujo) {
            _this.flujo = flujo;
            _this.reset();
            _this.context.app.hideSpinner();
            _this.showAlert('Los cambios han sido guardados con éxito.', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    FlujoManager = FlujoManager_1 = __decorate([
        core_1.Component({
            selector: 'contabilidad-flujo-manager',
            template: "\n      <azteca-hierarchy-manager (configureCatalog)=\"onConfigureCatalog($event)\"\n                                (currentNodeChanged)=\"onCurrentNodeChanged($event)\"\n                                (creatingNode)=\"onCreatingNode($event)\"\n                                (editingNode)=\"onEditingNode($event)\"\n                                (savingNode)=\"onSavingNode()\"\n                                (deletingNode)=\"onDeletingNode($event)\"\n                                (savingHierarchy)=\"onSavingHierarchy($event)\"\n                                (nodesChanged)=\"onNodesChanged($event)\"\n                                [title]=\"'Administraci\u00F3n de flujo'\"\n                                [validForm]=\"nodeForm.valid\"\n                                [currentNode]=\"currentNode\"                          \n                                [nodes]=\"flujo\">\n\n          <!------------------- Menu de acciones adicionales --------------------->\n      \t<!--\n          <azteca-menu-item [name]=\"'OPT1'\" [icon]=\"'glyphicon glyphicon-cog'\" [text]=\"'Opci\u00F3n1'\" [smallText]=\"'descripci\u00F3n de opci\u00F3n'\"></azteca-menu-item>\n      \t-->\n\n          <!------------------- Formulario de edici\u00F3n  --------------------->\n          <form [formGroup]=\"nodeForm\">\n              <div class=\"row\">\n\n                  <div class=\"col-12 col-md-10\">\n                      <azteca-form-field [label]=\"'C\u00F3digo:'\">\n                          <catalog-code formControlName=\"codigo\" [(ngModel)]=\"flujoEdicion.code\" [automatic]=\"autogeneratedCode\"></catalog-code>\n                      </azteca-form-field>\n\n                      <label class=\"control-label\">Ruta:</label>\n                      <az-label [text]=\"flujoEdicion.namedPath\"></az-label>\n\n                      <azteca-form-field [label]=\"'Nombre:'\">\n                          <az-textbox formControlName=\"nombre\" [(ngModel)]=\"flujoEdicion.nombre\"></az-textbox>\n                      </azteca-form-field>\n\n                  </div>\n              </div>\n          </form>\n\n      </azteca-hierarchy-manager>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return FlujoManager_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: flujo_service_1.FlujoService
                }
            ]
        }),
        __metadata("design:paramtypes", [core_2.Context, core_1.ChangeDetectorRef, forms_1.FormBuilder, flujo_service_1.FlujoService, router_1.Router, router_1.ActivatedRoute])
    ], FlujoManager);
    return FlujoManager;
    var FlujoManager_1;
}(editors_1.HierarchyManager));
exports.FlujoManager = FlujoManager;
