"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//Features
var impuesto_service_1 = require("../services/impuesto.service");
var impuesto_1 = require("../models/impuesto");
var ImpuestosEditor = /** @class */ (function (_super) {
    __extends(ImpuestosEditor, _super);
    function ImpuestosEditor(router, route, formBuilder, changeDetector, context, location, impuestoService) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.router = router;
        _this.route = route;
        _this.formBuilder = formBuilder;
        _this.changeDetector = changeDetector;
        _this.context = context;
        _this.location = location;
        _this.impuestoService = impuestoService;
        _this.impuesto = new impuesto_1.ImpuestoInfo();
        //
        _this.impuestosTipo = [];
        _this.catalogForm = formBuilder.group({
            'codigo': ['', forms_1.Validators.required],
            'nombre': ['', forms_1.Validators.required],
            'abreviatura': ['', forms_1.Validators.required],
            'porcentaje': ['', forms_1.Validators.required],
            'variable': [''],
            'local': [''],
            'tipoImpuesto': ['', forms_1.Validators.required]
        });
        return _this;
    }
    ImpuestosEditor_1 = ImpuestosEditor;
    ///////////////////////// METODOS ///////////////////////////////////////
    ///////////////////////// HANDLERS ///////////////////////////////////////
    ImpuestosEditor.prototype.onConfigureCatalog = function (options) {
        this.autogeneratedCode = options.codigoAutogenerado;
        this.loadTipos();
    };
    ImpuestosEditor.prototype.onCreatingItem = function () {
    };
    ImpuestosEditor.prototype.onViewingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.impuestoService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.impuesto = info;
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ImpuestosEditor.prototype.onCloningItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.impuestoService.clone(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.impuesto = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ImpuestosEditor.prototype.onLoadingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.impuestoService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.impuesto = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ImpuestosEditor.prototype.onSavingItem = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.impuestoService.update(this.impuesto)
            .then(function (info) {
            _this.context.app.hideSpinner();
            //Si es un elemento nuevo y no se cerrará el editor, navegar a nueva ruta
            _this.reset();
            if (!args.closeEditor && _this.impuesto.identity == 0) {
                _this.router.navigate(['../', info.identity], { relativeTo: _this.route });
            }
            else {
                if (args.closeEditor)
                    _this.router.navigate(['../'], { relativeTo: _this.route });
                else
                    _this.showAlert('La información ha sido actualizada con éxito', 'success');
            }
            _this.impuesto = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ImpuestosEditor.prototype.loadTipos = function () {
        var _this = this;
        this.impuestoService.loadTipos(this.context.app.defaultCompany.identity.toString())
            .then(function (tipos) { return _this.impuestosTipo = tipos; })
            .catch(function (error) { return _this.handleError(error); });
    };
    ImpuestosEditor = ImpuestosEditor_1 = __decorate([
        core_1.Component({
            selector: 'contabilidad-impuestos-editor',
            template: "\n      <form [formGroup]=\"catalogForm\">\n\n          <azteca-catalog-editor #catalogEditor \n                                 [title]=\"'Impuesto'\"\n                                 [info]=\"impuesto\"\n                                 [valid]=\"valid\"\n                                 (configureCatalog)=\"onConfigureCatalog($event)\"\n                                 (creatingItem)=\"onCreatingItem()\"\n                                 (viewingItem)=\"onViewingItem($event)\"\n                                 (cloningItem)=\"onCloningItem($event)\"\n                                 (savingItem)=\"onSavingItem($event)\"\n                                 (loadingItem)=\"onLoadingItem($event)\">\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <azteca-form-field [label]=\"'C\u00F3digo:'\">\n                          <catalog-code formControlName=\"codigo\" [(ngModel)]=\"impuesto.code\" [automatic]=\"autogeneratedCode\"></catalog-code>\n                      </azteca-form-field>\n\n                      <azteca-form-field [label]=\"'Nombre:'\">\n                          <az-textbox formControlName=\"nombre\" [(ngModel)]=\"impuesto.nombre\"></az-textbox>\n                      </azteca-form-field>\n\n                  </div>\n              </div>\n\n        \n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <tabset>\n                          <tab heading=\"Generales\">\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-10\">\n                                \n                                      <azteca-form-field [label]=\"'Tipo:'\">\n                                          <az-combobox formControlName=\"tipoImpuesto\"\n                                                       [(ngModel)]=\"impuesto.tipoImpuesto\"\n                                                       [items]=\"impuestosTipo\"\n                                                       [displayMember]=\"'nombre'\"\n                                                       [valueMember]=\"'id'\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n\n                                  </div>\n                              </div>\n\n                          </tab>\n                      </tabset>\n                  </div>\n              </div>\n            \n\n          </azteca-catalog-editor>\n      </form>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return ImpuestosEditor_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: impuesto_service_1.ImpuestoService
                }
            ]
        }),
        __metadata("design:paramtypes", [router_1.Router, router_1.ActivatedRoute, forms_1.FormBuilder, core_1.ChangeDetectorRef,
            core_2.Context, common_1.Location, impuesto_service_1.ImpuestoService])
    ], ImpuestosEditor);
    return ImpuestosEditor;
    var ImpuestosEditor_1;
}(editors_1.CatalogEditor));
exports.ImpuestosEditor = ImpuestosEditor;
