import { ChangeDetectorRef } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { Context } from 'framework3/core';
import { CatalogOptions } from 'framework3/custom';
import { CatalogEditor, EditorEventArgs } from 'framework3/editors';
import { MapaDistribucionService } from '../services/mapa-distribucion.service';
import { MapaDistribucionInfo } from '../models/mapa-distribucion';
export declare class MapasDistribucionesEditor extends CatalogEditor {
    protected router: Router;
    protected route: ActivatedRoute;
    private formBuilder;
    protected changeDetector: ChangeDetectorRef;
    protected context: Context;
    private location;
    private mapaDistribucionService;
    mapaDistribucion: MapaDistribucionInfo;
    constructor(router: Router, route: ActivatedRoute, formBuilder: FormBuilder, changeDetector: ChangeDetectorRef, context: Context, location: Location, mapaDistribucionService: MapaDistribucionService);
    onConfigureCatalog(options: CatalogOptions): void;
    onCreatingItem(): void;
    onViewingItem(id: number): void;
    onCloningItem(id: number): void;
    onLoadingItem(id: number): void;
    onSavingItem(args: EditorEventArgs): void;
}
