"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Wijmo
var wijmo_1 = require("wijmo/wijmo");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//Features
var nota_concepto_service_1 = require("../services/nota-concepto.service");
var nota_concepto_1 = require("../models/nota-concepto");
var impuesto_asignacion_editor_1 = require("../components/impuesto-asignacion.editor");
var NotasConceptosEditor = /** @class */ (function (_super) {
    __extends(NotasConceptosEditor, _super);
    function NotasConceptosEditor(router, route, formBuilder, changeDetector, context, location, notaConceptoService) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.router = router;
        _this.route = route;
        _this.formBuilder = formBuilder;
        _this.changeDetector = changeDetector;
        _this.context = context;
        _this.location = location;
        _this.notaConceptoService = notaConceptoService;
        _this.notaConcepto = new nota_concepto_1.NotaConceptoInfo();
        _this.conceptoImpuestos = [];
        _this.conceptoImpCollection = new editors_1.TrackableCollection();
        _this.catalogForm = formBuilder.group({
            'codigo': ['', forms_1.Validators.required],
            'nombre': ['', forms_1.Validators.required],
            'conceptoLibre': [0, forms_1.Validators.required],
            'categoriaArticulo': [0, forms_1.Validators.required],
            'sample_field': ['']
        });
        return _this;
    }
    NotasConceptosEditor_1 = NotasConceptosEditor;
    ///////////////////////// METODOS ///////////////////////////////////////
    ///////////////////////// HANDLERS ///////////////////////////////////////
    NotasConceptosEditor.prototype.onConfigureCatalog = function (options) {
        this.autogeneratedCode = options.codigoAutogenerado;
        this.applyPolicies();
    };
    NotasConceptosEditor.prototype.ngAfterViewChecked = function () {
        this.conceptoImpCollection.sourceCollection = this.notaConcepto.impuestos;
    };
    NotasConceptosEditor.prototype.onCreatingItem = function () {
    };
    NotasConceptosEditor.prototype.onViewingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.notaConceptoService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.notaConcepto = info;
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    NotasConceptosEditor.prototype.onCloningItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.notaConceptoService.clone(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.notaConcepto = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    NotasConceptosEditor.prototype.onLoadingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.notaConceptoService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.notaConcepto = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    NotasConceptosEditor.prototype.onSavingItem = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.notaConceptoService.update(this.notaConcepto)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.reset();
            //Si es un elemento nuevo y no se cerrará el editor, navegar a nueva ruta
            if (!args.closeEditor && _this.notaConcepto.identity == 0) {
                _this.router.navigate(['../', info.identity], { relativeTo: _this.route });
            }
            else {
                if (args.closeEditor)
                    _this.router.navigate(['../'], { relativeTo: _this.route });
                else
                    _this.showAlert('La información ha sido actualizada con éxito', 'success');
            }
            _this.notaConcepto = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    NotasConceptosEditor.prototype.onSelectTab = function (args) {
        if (args.heading) {
            wijmo_1.Control.invalidateAll();
        }
    };
    NotasConceptosEditor.prototype.onToolbarButtonClick = function (button) {
        if (button.name == 'ADD') {
            this.conceptoImpuestosDialog.show();
        }
    };
    NotasConceptosEditor.prototype.onAgregarImpuesto = function (args) {
        var _this = this;
        var impuestoExists = false;
        this.notaConcepto.impuestos.forEach(function (articuloImp) {
            if (articuloImp.idImpuesto == args.idImpuesto) {
                _this.showAlert("El impuesto ya fue agregado", "información");
                impuestoExists = true;
            }
        });
        if (!impuestoExists) {
            this.notaConcepto.impuestos.push(args);
            this.conceptoImpCollection.refresh();
        }
    };
    NotasConceptosEditor.prototype.onRemoveItem = function (item) {
        this.conceptoImpCollection.remove(item);
        this.conceptoImpCollection.refresh();
    };
    __decorate([
        core_1.ViewChild(impuesto_asignacion_editor_1.ImpuestosAsignacionEditor),
        __metadata("design:type", impuesto_asignacion_editor_1.ImpuestosAsignacionEditor)
    ], NotasConceptosEditor.prototype, "conceptoImpuestosDialog", void 0);
    NotasConceptosEditor = NotasConceptosEditor_1 = __decorate([
        core_1.Component({
            selector: 'contabilidad-nota-concepto-editor',
            template: "\n      <form [formGroup]=\"catalogForm\">\n\n          <azteca-catalog-editor #catalogEditor \n                                 [title]=\"'NotaConcepto'\"\n                                 [info]=\"notaConcepto\"\n                                 [valid]=\"valid\"\n                                 (configureCatalog)=\"onConfigureCatalog($event)\"\n                                 (creatingItem)=\"onCreatingItem()\"\n                                 (viewingItem)=\"onViewingItem($event)\"\n                                 (cloningItem)=\"onCloningItem($event)\"\n                                 (savingItem)=\"onSavingItem($event)\"\n                                 (loadingItem)=\"onLoadingItem($event)\">\n\n\n              <!------------------- Menu de acciones adicionales --------------------->\n\n              <!------------------- Controles del editor ----------------------------->\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <azteca-form-field [label]=\"'C\u00F3digo:'\">\n                          <catalog-code formControlName=\"codigo\" [(ngModel)]=\"notaConcepto.code\" [automatic]=\"autogeneratedCode\"></catalog-code>\n                      </azteca-form-field>\n\n                      <azteca-form-field [label]=\"'Nombre:'\">\n                          <az-textbox formControlName=\"nombre\" [(ngModel)]=\"notaConcepto.nombre\"></az-textbox>\n                      </azteca-form-field>\n\n                  </div>\n              </div>\n\n        \n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <tabset>\n                          <tab heading=\"Generales\" (select)=\"onSelectTab($event)\">\n\n                              <div class=\"row\" >\n                                  <div class=\"col-12 col-lg-6\">\n                                      <az-checkbox [label]=\"'Concepto libre'\" formControlName=\"conceptoLibre\" [(ngModel)]=\"notaConcepto.conceptoLibre\"></az-checkbox>\n                                  </div>\n                                  <div class=\"col-12 col-lg-6\">\n                                      <azteca-form-field [label]=\"'Agregar Categoria Fiscal:'\">\n                                          <accounting-articulo-categoria-fiscal-selector formControlName=\"categoriaArticulo\" [(ngModel)]=\"notaConcepto.idCategoriaArticulo\" [showListButton]=\"true\" #selectorCategoria></accounting-articulo-categoria-fiscal-selector>\n                                      </azteca-form-field>\n                                  </div>\n\n                              </div>\n                              <div class=\"row\">\n                              </div>\n                              <div class=\"row\">\n                              </div>\n\n                          </tab>\n                          <tab heading=\"Impuestos\" (select)=\"onSelectTab($event)\">\n                              <az-toolbar (buttonClick)=\"onToolbarButtonClick($event)\">\n                                  <az-toolbar-button [name]=\"'ADD'\" [type]=\"'primary'\" [text]=\"'Agregar Impuesto'\" [icon]=\"'glyphicon glyphicon-plus'\"></az-toolbar-button>\n                              </az-toolbar>\n\n                              <wj-flex-grid #gridConceptoImpuestos style=\"height:550px\"\n                                            [itemsSource]=\"conceptoImpCollection\">\n\n                                  <wj-flex-grid-column [width]=\"55\" [isReadOnly]=\"true\">\n                                      <ng-template wjFlexGridCellTemplate [cellType]=\"'Cell'\" let-cell=\"cell\">\n                                          <button type=\"button\" class=\"btn btn-default\" (click)=\"onRemoveItem(cell.item)\">\n                                              <span class=\"glyphicon glyphicon-trash\"></span>\n                                          </button>\n                                      </ng-template>\n                                  </wj-flex-grid-column>\n\n                                  <wj-flex-grid-column [header]=\"'C\u00F3digo'\" [binding]=\"'impuesto.code'\" [width]=\"'20*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'Impuesto'\" [binding]=\"'impuesto.nombre'\" [width]=\"'30*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'Tasa \u00F3 cuota'\" [binding]=\"'tasaOCuota'\" [width]=\"'30*'\" [isReadOnly]=\"true\" format=\"n2\"></wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'Orden calculo'\" [binding]=\"'ordenCalculo'\" [width]=\"'25*'\" [isReadOnly]=\"true\" format=\"n0\"></wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'Tipo calculo'\" [binding]=\"'tipoCalculo'\" [width]=\"'25*'\" [isReadOnly]=\"true\" format=\"n0\"></wj-flex-grid-column>\n                              </wj-flex-grid>\n                          </tab>\n                      </tabset>\n                  </div>\n              </div>\n            \n\n          </azteca-catalog-editor>\n\n          <accounting-impuesto-asignacion (dataUpdater)=\"onAgregarImpuesto($event)\">\n\n          </accounting-impuesto-asignacion>\n\n      </form>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return NotasConceptosEditor_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: nota_concepto_service_1.NotaConceptoService
                }
            ]
        }),
        __metadata("design:paramtypes", [router_1.Router, router_1.ActivatedRoute, forms_1.FormBuilder, core_1.ChangeDetectorRef,
            core_2.Context, common_1.Location, nota_concepto_service_1.NotaConceptoService])
    ], NotasConceptosEditor);
    return NotasConceptosEditor;
    var NotasConceptosEditor_1;
}(editors_1.CatalogEditor));
exports.NotasConceptosEditor = NotasConceptosEditor;
