import { ChangeDetectorRef } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { Context } from 'framework3/core';
import { CatalogOptions } from 'framework3/custom';
import { MenuItem } from 'framework3/controls';
import { CatalogEditor, EditorEventArgs } from 'framework3/editors';
import { SucursalService } from '../services/sucursal.service';
import { SucursalInfo } from '../models/sucursal';
import { SerieFiscalService } from '../../accounting/services/serie-fiscal.service';
import { SerieFiscalItem } from '../../accounting/models/serie-fiscal';
import { SegmentoNegocioService } from '../../accounting/services/segmento-negocio.service';
import { SegmentoNegocioItem } from '../../accounting/models/segmento-negocio';
export declare class SucursalesEditor extends CatalogEditor {
    protected router: Router;
    protected route: ActivatedRoute;
    private formBuilder;
    protected changeDetector: ChangeDetectorRef;
    protected context: Context;
    private location;
    private sucursalService;
    private serieFiscalService;
    private segmentoNegocioService;
    sucursal: SucursalInfo;
    idEmpresa: number;
    series: SerieFiscalItem[];
    segmentos: SegmentoNegocioItem[];
    constructor(router: Router, route: ActivatedRoute, formBuilder: FormBuilder, changeDetector: ChangeDetectorRef, context: Context, location: Location, sucursalService: SucursalService, serieFiscalService: SerieFiscalService, segmentoNegocioService: SegmentoNegocioService);
    onConfigureCatalog(options: CatalogOptions): void;
    onCreatingItem(): void;
    onViewingItem(id: number): void;
    onCloningItem(id: number): void;
    onLoadingItem(id: number): void;
    onSavingItem(args: EditorEventArgs): void;
    onCancelingEdit(): void;
    onMenuItemClick(option: MenuItem): void;
    onSelectTab(arg: any): void;
    loadSeries(): void;
    loadSegmentos(): void;
    onDomicilioValidChange(): void;
}
