"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//Features
var sucursal_service_1 = require("../services/sucursal.service");
var sucursal_1 = require("../models/sucursal");
var serie_fiscal_service_1 = require("../../accounting/services/serie-fiscal.service");
var segmento_negocio_service_1 = require("../../accounting/services/segmento-negocio.service");
var wijmo_1 = require("wijmo/wijmo");
var SucursalesEditor = /** @class */ (function (_super) {
    __extends(SucursalesEditor, _super);
    //
    function SucursalesEditor(router, route, formBuilder, changeDetector, context, location, sucursalService, serieFiscalService, segmentoNegocioService) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.router = router;
        _this.route = route;
        _this.formBuilder = formBuilder;
        _this.changeDetector = changeDetector;
        _this.context = context;
        _this.location = location;
        _this.sucursalService = sucursalService;
        _this.serieFiscalService = serieFiscalService;
        _this.segmentoNegocioService = segmentoNegocioService;
        _this.sucursal = new sucursal_1.SucursalInfo();
        _this.series = [];
        _this.segmentos = [];
        _this.catalogForm = formBuilder.group({
            'codigo': ['', forms_1.Validators.required],
            'nombre': ['', forms_1.Validators.required],
            'serieIngreso': [0],
            'serieCargo': [0],
            'serieCredito': [0],
            'seriePago': [0],
            'serieNomina': [0],
            'segmentoNegocio': [0],
            'domicilio': [''],
            'telefono1': [''],
            'telefono2': [''],
            'fax': [''],
            'paginaWeb': [''],
            'correo': ['']
        });
        return _this;
    }
    SucursalesEditor_1 = SucursalesEditor;
    ///////////////////////// METODOS ///////////////////////////////////////
    ///////////////////////// HANDLERS ///////////////////////////////////////
    SucursalesEditor.prototype.onConfigureCatalog = function (options) {
        var _this = this;
        this.route.params.forEach(function (params) {
            _this.idEmpresa = +params['idEmpresa'];
        });
        this.loadSeries();
        this.loadSegmentos();
        this.autogeneratedCode = options.codigoAutogenerado;
    };
    SucursalesEditor.prototype.onCreatingItem = function () {
        //Asignar y cargar datos de la empresa que dependerá la sucursal
        this.sucursal.idCompany = this.idEmpresa;
        this.sucursal.sucursalBase.idCompany = this.idEmpresa;
    };
    SucursalesEditor.prototype.onViewingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.sucursalService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.sucursal = info;
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    SucursalesEditor.prototype.onCloningItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.sucursalService.clone(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.sucursal = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    SucursalesEditor.prototype.onLoadingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.sucursalService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.sucursal = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    SucursalesEditor.prototype.onSavingItem = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.sucursalService.update(this.sucursal)
            .then(function (info) {
            _this.context.app.hideSpinner();
            //Si es un elemento nuevo y no se cerrará el editor, navegar a nueva ruta
            _this.reset();
            if (!args.closeEditor && _this.sucursal.identity == 0) {
                _this.router.navigate(['../', info.identity], { relativeTo: _this.route });
            }
            else {
                if (args.closeEditor)
                    _this.location.back();
                else
                    _this.showAlert('La información ha sido actualizada con éxito', 'success');
            }
            _this.sucursal = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    SucursalesEditor.prototype.onCancelingEdit = function () {
        this.location.back();
    };
    SucursalesEditor.prototype.onMenuItemClick = function (option) {
        if (option.name == 'USERS') {
            this.router.navigate(['kernel/security/sucursales/', this.process.id, this.idEmpresa, this.sucursal.identity, 'members']);
        }
    };
    SucursalesEditor.prototype.onSelectTab = function (arg) {
        wijmo_1.Control.invalidateAll();
    };
    SucursalesEditor.prototype.loadSeries = function () {
        var _this = this;
        this.serieFiscalService.loadList(this.context.app.defaultCompany.identity.toString())
            .then(function (series) { return _this.series = series; })
            .catch(function (error) { return _this.handleError(error); });
    };
    SucursalesEditor.prototype.loadSegmentos = function () {
        var _this = this;
        this.segmentoNegocioService.loadList(this.context.app.defaultCompany.identity)
            .then(function (segmentos) { return _this.segmentos = segmentos; })
            .catch(function (error) { return _this.handleError(error); });
    };
    SucursalesEditor.prototype.onDomicilioValidChange = function () {
        this.changeDetector.detectChanges();
    };
    SucursalesEditor = SucursalesEditor_1 = __decorate([
        core_1.Component({
            selector: 'contabilidad-sucursales-editor',
            template: "\n      <form [formGroup]=\"catalogForm\">\n\n          <azteca-catalog-editor #catalogEditor \n                                 [title]=\"'Sucursal'\"\n                                 [info]=\"sucursal\"\n                                 [valid]=\"valid && domicilioEditor.valid\"\n                                 (configureCatalog)=\"onConfigureCatalog($event)\"\n                                 (creatingItem)=\"onCreatingItem()\"\n                                 (viewingItem)=\"onViewingItem($event)\"\n                                 (cloningItem)=\"onCloningItem($event)\"\n                                 (savingItem)=\"onSavingItem($event)\"\n                                 (loadingItem)=\"onLoadingItem($event)\"\n                                 (menuItemClick)=\"onMenuItemClick($event)\">\n\n\n              <!------------------- Menu de acciones adicionales --------------------->\n              <azteca-menu-item [name]=\"'USERS'\" [icon]=\"'glyphicon glyphicon-user'\" [text]=\"'Miembros'\" [smallText]=\"'editar usuarios miembro'\"></azteca-menu-item>\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-lg-10\">\n                      <azteca-form-field [label]=\"'C\u00F3digo:'\">\n                          <catalog-code formControlName=\"codigo\" [(ngModel)]=\"sucursal.code\" [automatic]=\"autogeneratedCode\"></catalog-code>\n                      </azteca-form-field>\n                      <azteca-form-field [label]=\"'Nombre:'\">\n                          <az-textbox formControlName=\"nombre\" [(ngModel)]=\"sucursal.sucursalBase.nombre\"></az-textbox>\n                      </azteca-form-field>                \n                  </div>\n              </div>\n\n        \n              <div class=\"row\">\n                  <div class=\"col-12 col-lg-10\">\n                      <tabset>\n                          <tab heading=\"Series fiscales\" (select)=\"onSelectTab($event)\">\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-lg-10\">\n                                                                       \n                                      <azteca-form-field [label]=\"'Serie de ingresos:'\">\n                                          <az-combobox formControlName=\"serieIngreso\"\n                                                          [(ngModel)]=\"sucursal.idSerieIngreso\"\n                                                          [items]=\"series\"\n                                                          [displayMember]=\"'nombre'\"\n                                                          [valueMember]=\"'id'\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n\n\n                                      <azteca-form-field [label]=\"'Serie de Notas de Cargo:'\">\n                                          <az-combobox formControlName=\"serieCargo\"\n                                                          [(ngModel)]=\"sucursal.idSerieCargo\"\n                                                          [items]=\"series\"\n                                                          [displayMember]=\"'nombre'\"\n                                                          [valueMember]=\"'id'\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n\n                                      <azteca-form-field [label]=\"'Serie de Notas de Cr\u00E9dito:'\">\n                                          <az-combobox formControlName=\"serieCredito\"\n                                                          [(ngModel)]=\"sucursal.idSerieCredito\"\n                                                          [items]=\"series\"\n                                                          [displayMember]=\"'nombre'\"\n                                                          [valueMember]=\"'id'\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n\n                                      <azteca-form-field [label]=\"'Serie de pagos:'\">\n                                          <az-combobox formControlName=\"seriePago\"\n                                                          [(ngModel)]=\"sucursal.idSeriePago\"\n                                                          [items]=\"series\"\n                                                          [displayMember]=\"'nombre'\"\n                                                          [valueMember]=\"'id'\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n\n\n                                      <azteca-form-field [label]=\"'Serie de recibos de n\u00F3mina:'\">\n                                          <az-combobox formControlName=\"serieNomina\"\n                                                          [(ngModel)]=\"sucursal.idSerieNomina\"\n                                                          [items]=\"series\"\n                                                          [displayMember]=\"'nombre'\"\n                                                          [valueMember]=\"'id'\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n\n                                      <azteca-form-field [label]=\"'Segmento de negocio:'\">\n                                          <az-combobox formControlName=\"segmentoNegocio\"\n                                                       [(ngModel)]=\"sucursal.idSegmentoNegocio\"\n                                                       [items]=\"segmentos\"\n                                                       [displayMember]=\"'nombre'\"\n                                                       [valueMember]=\"'id'\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n\n                                  </div>\n                              </div>\n                          </tab>\n\n                          <tab heading=\"Contacto\" (select)=\"onSelectTab($event)\">\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-lg-10\">\n                                      <azteca-form-field [label]=\"'Telefono 1:'\">\n                                          <az-textbox formControlName=\"telefono1\" [(ngModel)]=\"sucursal.sucursalBase.telefono1\"></az-textbox>\n                                      </azteca-form-field>\n\n                                      <azteca-form-field [label]=\"'Telefono 2:'\">\n                                          <az-textbox formControlName=\"telefono2\" [(ngModel)]=\"sucursal.sucursalBase.telefono2\"></az-textbox>\n                                      </azteca-form-field>\n\n                                      <azteca-form-field [label]=\"'Fax:'\">\n                                          <az-textbox formControlName=\"fax\" [(ngModel)]=\"sucursal.sucursalBase.fax\"></az-textbox>\n                                      </azteca-form-field>\n\n                                      <azteca-form-field [label]=\"'Correo:'\">\n                                          <az-textbox formControlName=\"correo\" [(ngModel)]=\"sucursal.sucursalBase.correo\"></az-textbox>\n                                      </azteca-form-field>\n\n\n                                  </div>\n                              </div>\n                          </tab>\n\n                          <tab heading=\"Domicilio\" (select)=\"onSelectTab($event)\">\n                              <general-domicilio-editor #domicilioEditor\n                                                        formControlName=\"domicilio\"\n                                                        [(ngModel)]=\"sucursal.sucursalBase.domicilio\"\n                                                        [poblacionRequired]=\"true\"\n                                                        [cruceUnoVisible]=\"false\"\n                                                        [cruceDosVisible]=\"false\"\n                                                        (validChange)=\"onDomicilioValidChange($event)\">\n\n                              </general-domicilio-editor>\n\n                          </tab>\n                      </tabset>\n                  </div>\n              </div>\n            \n\n          </azteca-catalog-editor>\n      </form>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return SucursalesEditor_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: sucursal_service_1.SucursalService
                }
            ]
        }),
        __metadata("design:paramtypes", [router_1.Router, router_1.ActivatedRoute, forms_1.FormBuilder, core_1.ChangeDetectorRef,
            core_2.Context, common_1.Location, sucursal_service_1.SucursalService, serie_fiscal_service_1.SerieFiscalService,
            segmento_negocio_service_1.SegmentoNegocioService])
    ], SucursalesEditor);
    return SucursalesEditor;
    var SucursalesEditor_1;
}(editors_1.CatalogEditor));
exports.SucursalesEditor = SucursalesEditor;
