import { EventEmitter } from '@angular/core';
import { Observable } from 'rxjs';
import { Context, CatalogItem } from 'framework3/core';
import { SearchRequest, HierarchySelector, ITreeHost } from 'framework3/search/index';
import { CuentaInfo, CuentaItem } from '../models/cuenta';
import { CuentaService } from '../services/cuenta.service';
export declare class CuentaSelectorComponent extends HierarchySelector implements ITreeHost {
    protected context: Context;
    private cuentaService;
    cuentas: CuentaItem[];
    nodes: CuentaInfo[];
    selectedItem: CuentaInfo;
    idDocumento: number;
    version: number;
    idPadre: number;
    selectedItemChanged: EventEmitter<CuentaInfo>;
    constructor(context: Context, cuentaService: CuentaService);
    loadItem(itemID: number): void;
    doSearch(request: SearchRequest): void;
    findKeyword(keyword: string): Observable<CatalogItem[]>;
    onKeywordSearch(keyword: string): void;
    onLoadingHierarchy(): void;
    loadChildren(parent: CuentaInfo): Promise<CuentaInfo[]>;
}
