"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var wijmo_grid_1 = require("wijmo/wijmo.grid");
//
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
var editors_1 = require("framework3/editors");
//
var empresa_service_1 = require("../services/empresa.service");
//import { PeriodoItem } from '../models/periodo';
var periodos_component_1 = require("../components/periodos.component");
var EjerciciosComponent = /** @class */ (function () {
    function EjerciciosComponent(context, router, route, empresaService) {
        this.context = context;
        this.router = router;
        this.route = route;
        this.empresaService = empresaService;
        this.ejercicios = new editors_1.TrackableCollection(); // EjercicioItem[] = [];
        //this.fechaInicial = moment().subtract(1, 'day').toDate();
        //this.fechaFinal = moment().add(1, 'day').toDate();
    }
    EjerciciosComponent.prototype.ngOnInit = function () {
        //this.loadEjercicioActual();
        this.loadEjercicios();
    };
    //loadEjercicioActual() {
    //    this.empresaService.getPeriodoActual(this.context.app.defaultCompany.identity)
    //        .then(actual => this.setActuales(actual))
    //        .catch(error => this.handleError(error));
    //}
    //setActuales(actuales: any) {
    //    this.idEjercicioActual = actuales.idEjercicio;
    //    this.idPeriodoActual = actuales.idPeriodo;
    //}
    EjerciciosComponent.prototype.loadEjercicios = function () {
        var _this = this;
        this.empresaService.loadEjercicios(this.context.app.defaultCompany.identity, false)
            .then(function (ejercicios) { return _this.ejercicios.sourceCollection = ejercicios; })
            .catch(function (error) { return _this.handleError(error); });
    };
    EjerciciosComponent.prototype.nuevoEjercicio = function () {
        var _this = this;
        this.empresaService.nuevoEjercicio(this.context.app.defaultCompany.identity)
            .then(function (_) {
            _this.context.app.hideSpinner();
            _this.alerts.showAlert('Se ha generado el ejercicio con éxito.', 'success');
            _this.loadEjercicios();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    EjerciciosComponent.prototype.abrirEjercicio = function (idEjercicio) {
        var _this = this;
        this.empresaService.abrirEjercicio(idEjercicio)
            .then(function (_) {
            _this.context.app.hideSpinner();
            _this.alerts.showAlert('El ejercicio ha sido abierto con éxito.', 'success');
            _this.loadEjercicios();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    EjerciciosComponent.prototype.cerrarEjercicio = function (idEjercicio) {
        var _this = this;
        this.empresaService.cerrarEjercicio(idEjercicio)
            .then(function (_) {
            _this.context.app.hideSpinner();
            _this.alerts.showAlert('El ejercicio ha sido cerrado con éxito.', 'success');
            _this.loadEjercicios();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    EjerciciosComponent.prototype.handleError = function (error) {
        console.error(error);
        this.context.app.hideSpinner();
        var message = this.context.getExceptionMessage(error);
        this.alerts.showAlert(message, 'danger');
    };
    EjerciciosComponent.prototype.gridEjerciciosInitialized = function (sender, args) {
        var self = this;
        //Agregar manejador para menú contextual        
        sender.addEventListener(sender.hostElement, "contextmenu", function (e) {
            var ht = sender.hitTest(e);
            sender.select(new wijmo_grid_1.CellRange(ht.row, ht.col), true);
        });
    };
    EjerciciosComponent.prototype.onEjerciciosToolbar = function (button) {
        if (button.name == 'ADD') {
            this.nuevoEjercicio();
        }
    };
    EjerciciosComponent.prototype.onMenuItemEjercicioClicked = function (menu, args) {
        if (menu.selectedIndex == 0) {
            //Editar
            this.dlgPeriodos.show(this.ejercicios.currentItem.id);
        }
        if (menu.selectedIndex == 2) {
            //Abrir
            this.abrirEjercicio(this.ejercicios.currentItem.id);
        }
        if (menu.selectedIndex == 3) {
            //Abrir
            this.cerrarEjercicio(this.ejercicios.currentItem.id);
        }
    };
    __decorate([
        core_1.ViewChild(controls_1.AlertsBarComponent),
        __metadata("design:type", controls_1.AlertsBarComponent)
    ], EjerciciosComponent.prototype, "alerts", void 0);
    __decorate([
        core_1.ViewChild('dlgPeriodos'),
        __metadata("design:type", periodos_component_1.PeriodosComponent)
    ], EjerciciosComponent.prototype, "dlgPeriodos", void 0);
    EjerciciosComponent = __decorate([
        core_1.Component({
            selector: 'accounting-ejercicios',
            template: "\n      <div class=\"row\">\n          <div class=\"col-12\">\n              <alerts-bar></alerts-bar>\n          </div>\n      </div>\n\n      <div class=\"row\">\n          <div class=\"col-12\">\n              <az-panel [header]=\"'Administrador de Ejercicios Fiscales'\">\n         \n              </az-panel>\n\n              <az-toolbar (buttonClick)=\"onEjerciciosToolbar($event)\">\n                  <az-toolbar-button [name]=\"'ADD'\" [type]=\"'primary'\" [text]=\"'Agregar'\" [toolTip]=\"'Agregar nuevo ejercicio'\" [icon]=\"'glyphicon glyphicon-plus'\"></az-toolbar-button>\n              </az-toolbar>\n\n\n              <div class=\"row\">\n                  <div class=\"col-12\">\n                      <wj-flex-grid #gridInsumos style=\"height:550px\"\n                                    [itemsSource]=\"ejercicios\"\n                                    [wjContextMenu]=\"ctxMenuEjercicios\"\n                                    (initialized)=\"gridEjerciciosInitialized(gridInsumos, $event)\">\n                                                                                          \n\n                          <wj-flex-grid-column [header]=\"'Ejercicio'\" [binding]=\"'nombre'\" [width]=\"'10*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                          <wj-flex-grid-column [header]=\"'Fecha Ini'\" [binding]=\"'fechaIni'\" [width]=\"'20*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                          <wj-flex-grid-column [header]=\"'Fecha Fin'\" [binding]=\"'fechaFin'\" [width]=\"'20*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                          <wj-flex-grid-column [header]=\"'Status'\" [binding]=\"'estatusText'\" [width]=\"'10*'\"></wj-flex-grid-column>\n                    \n                      </wj-flex-grid>\n                  </div>\n              </div>\n\n        \n              <wj-menu #ctxMenuEjercicios (itemClicked)=\"onMenuItemEjercicioClicked(ctxMenuEjercicios, $event)\" style=\"display:none\">\n                  <wj-menu-item>\n                      <span class=\"glyphicon glyphicon-pencil\"></span><b> Editar</b>\n                      <br />\n                      <small><i>editar Ejercicio</i></small>\n                  </wj-menu-item>\n                  <wj-menu-separator></wj-menu-separator>\n                  <wj-menu-item>\n                      <span class=\"glyphicon glyphicon-ok\"></span><b> Abrir</b>\n                      <br />\n                      <small><i>abrir Ejercicio</i></small>\n                  </wj-menu-item>\n                  <wj-menu-item>\n                      <span class=\"glyphicon glyphicon-remove\"></span><b> Cerrar</b>\n                      <br />\n                      <small><i>cerrar Ejercicio</i></small>\n                  </wj-menu-item>\n              </wj-menu>\n\n          </div>\n      </div>\n\n\n      <accounting-periodos-component #dlgPeriodos>\n\n      </accounting-periodos-component>\n    "
        }),
        __metadata("design:paramtypes", [core_2.Context, router_1.Router, router_1.ActivatedRoute,
            empresa_service_1.EmpresaService])
    ], EjerciciosComponent);
    return EjerciciosComponent;
}());
exports.EjerciciosComponent = EjerciciosComponent;
