import { FormGroup, FormBuilder } from '@angular/forms';
import { Router, ActivatedRoute } from '@angular/router';
import { CollectionView } from 'wijmo/wijmo';
import { AlertsBarComponent, ToolbarButton } from 'framework3/controls';
import { Context } from 'framework3/core';
import { ComprobanteFiscalService } from '../services/comprobante-fiscal.service';
export declare class EnvioComprobantesFiscalesComponent {
    private formBuilder;
    private router;
    private route;
    private context;
    private comprobanteFiscalService;
    form: FormGroup;
    tipos: {
        id: string;
        nombre: string;
    }[];
    comprobantesDestinosCollection: CollectionView;
    comprobantesList: EnvioComprobantesItem[];
    alertsBar: AlertsBarComponent;
    constructor(formBuilder: FormBuilder, router: Router, route: ActivatedRoute, context: Context, comprobanteFiscalService: ComprobanteFiscalService);
    busquedaComprobantes(): void;
    onToolbarButtonClick(button: ToolbarButton): void;
    selectedCell(comprobantes: EnvioComprobantesItem, selected: boolean): void;
    handleError(error: any): void;
    getStatusColor(status: string): string;
}
export declare class EnvioComprobantesItem {
    id: number;
    idJob: number;
    fechaComprobantes: Date;
    uuid: string;
    serie: string;
    folio: string;
    razonSocial: string;
    status: string;
    completado: boolean;
    selected?: boolean;
}
