"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var wijmo_grid_1 = require("wijmo/wijmo.grid");
var ngx_bootstrap_1 = require("ngx-bootstrap");
//
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
var editors_1 = require("framework3/editors");
//
var empresa_service_1 = require("../services/empresa.service");
var PeriodosComponent = /** @class */ (function () {
    function PeriodosComponent(context, router, route, empresaService) {
        this.context = context;
        this.router = router;
        this.route = route;
        this.empresaService = empresaService;
        this.periodos = new editors_1.TrackableCollection(); // EjercicioItem[] = [];
        //this.fechaInicial = moment().subtract(1, 'day').toDate();
        //this.fechaFinal = moment().add(1, 'day').toDate();
    }
    PeriodosComponent.prototype.show = function (idEjercicio) {
        this.dlgPeriodos.config.backdrop = false;
        this.idEjercicioActual = idEjercicio;
        this.dlgPeriodos.show();
        this.cargarPeriodos();
    };
    PeriodosComponent.prototype.cargarPeriodos = function () {
        var _this = this;
        this.empresaService.cargarPeriodos(this.idEjercicioActual, false)
            .then(function (periodos) { return _this.periodos.sourceCollection = periodos; })
            .catch(function (error) { return _this.handleError(error); });
    };
    PeriodosComponent.prototype.abrirPeriodo = function (IdPeriodo) {
        var _this = this;
        this.empresaService.abrirPeriodo(IdPeriodo)
            .then(function (_) {
            _this.context.app.hideSpinner();
            _this.alerts.showAlert('El periodo ha sido abierto con éxito.', 'success');
            _this.cargarPeriodos();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    PeriodosComponent.prototype.cerrarPeriodo = function (IdPeriodo) {
        var _this = this;
        this.empresaService.cerrarPeriodo(IdPeriodo)
            .then(function (_) {
            _this.context.app.hideSpinner();
            _this.alerts.showAlert('El periodo ha sido cerrado con éxito.', 'success');
            _this.cargarPeriodos();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    PeriodosComponent.prototype.handleError = function (error) {
        console.error(error);
        this.context.app.hideSpinner();
        var message = this.context.getExceptionMessage(error);
        this.alerts.showAlert(message, 'danger');
    };
    PeriodosComponent.prototype.gridPeriodosInitialized = function (sender, args) {
        var self = this;
        //Agregar manejador para menú contextual        
        sender.addEventListener(sender.hostElement, "contextmenu", function (e) {
            var ht = sender.hitTest(e);
            sender.select(new wijmo_grid_1.CellRange(ht.row, ht.col), true);
        });
    };
    PeriodosComponent.prototype.onMenuItemPeriodoClicked = function (menu, args) {
        if (menu.selectedIndex == 0) {
            //abrir
            this.abrirPeriodo(this.periodos.currentItem.id);
        }
        if (menu.selectedIndex == 1) {
            //cerrar
            this.cerrarPeriodo(this.periodos.currentItem.id);
        }
    };
    __decorate([
        core_1.ViewChild(controls_1.AlertsBarComponent),
        __metadata("design:type", controls_1.AlertsBarComponent)
    ], PeriodosComponent.prototype, "alerts", void 0);
    __decorate([
        core_1.ViewChild('dlgPeriodos'),
        __metadata("design:type", ngx_bootstrap_1.ModalDirective)
    ], PeriodosComponent.prototype, "dlgPeriodos", void 0);
    PeriodosComponent = __decorate([
        core_1.Component({
            selector: 'accounting-periodos-component',
            template: "\n      <div bsModal #dlgPeriodos=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"myLargeModalLabel\" aria-hidden=\"true\">\n          <div class=\"modal-dialog modal-lg\">\n              <div class=\"modal-content\">\n                  <div class=\"modal-body\">\n\n              \n\n                          <div class=\"row\">\n                              <div class=\"col-12\">\n                                  <alerts-bar></alerts-bar>\n                              </div>\n                          </div>\n\n                          <div class=\"row\">\n                              <div class=\"col-12\">\n                                  <az-panel [header]=\"'Administrador de Periodos'\">\n\n                                      <div class=\"row\">\n                                          <div class=\"col-12\">\n                                              <wj-flex-grid #gridInsumos style=\"height:550px\"\n                                                            [itemsSource]=\"periodos\"\n                                                            [wjContextMenu]=\"ctxMenuPeriodos\"\n                                                            (initialized)=\"gridPeriodosInitialized(gridInsumos, $event)\">\n\n\n                                                  <wj-flex-grid-column [header]=\"'Periodo'\" [binding]=\"'nombre'\" [width]=\"'10*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                                  <wj-flex-grid-column [header]=\"'Fecha Ini'\" [binding]=\"'fechaIni'\" [width]=\"'20*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                                  <wj-flex-grid-column [header]=\"'Fecha Fin'\" [binding]=\"'fechaFin'\" [width]=\"'20*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                                  <wj-flex-grid-column [header]=\"'Status'\" [binding]=\"'estatusText'\" [width]=\"'10*'\"></wj-flex-grid-column>\n\n                                              </wj-flex-grid>\n                                          </div>\n                                      </div>\n\n\n                                      <wj-menu #ctxMenuPeriodos (itemClicked)=\"onMenuItemPeriodoClicked(ctxMenuPeriodos, $event)\" style=\"display:none\">                                    \n                                          <wj-menu-item>\n                                              <span class=\"glyphicon glyphicon-ok\"></span><b> Abrir</b>\n                                              <br />\n                                              <small><i>abrir Periodo</i></small>\n                                          </wj-menu-item>\n                                          <wj-menu-item>\n                                              <span class=\"glyphicon glyphicon-remove\"></span><b> Cerrar</b>\n                                              <br />\n                                              <small><i>cerrar Periodo</i></small>\n                                          </wj-menu-item>\n                                      </wj-menu>\n\n                                  </az-panel>\n\n                                  <div class=\"row\">\n                                      <button type=\"button\" class=\"btn btn-primary\" (click)=\"dlgPeriodos.hide()\">Cerrar</button>\n                                  </div>\n\n                              </div>\n                          </div>\n\n               \n                  </div>\n\n              </div> <!-- Modal Content-->\n          </div> <!--Modal-->\n      </div> <!--Modal directive-->\n    "
        }),
        __metadata("design:paramtypes", [core_2.Context, router_1.Router, router_1.ActivatedRoute,
            empresa_service_1.EmpresaService])
    ], PeriodosComponent);
    return PeriodosComponent;
}());
exports.PeriodosComponent = PeriodosComponent;
