"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var rxjs_1 = require("rxjs");
//
var core_2 = require("framework3/core");
var document_selector_1 = require("framework3/search/models/document-selector");
var comprobante_fiscal_service_1 = require("../services/comprobante-fiscal.service");
//
var nota_relaciones_1 = require("../models/nota-relaciones");
var ComprobanteFiscalSelectorComponent = /** @class */ (function (_super) {
    __extends(ComprobanteFiscalSelectorComponent, _super);
    function ComprobanteFiscalSelectorComponent(context, comprobanteFiscalService) {
        var _this = _super.call(this, context) || this;
        _this.context = context;
        _this.comprobanteFiscalService = comprobanteFiscalService;
        //selectedItem: ComprobanteFiscalInfo = new ComprobanteFiscalInfo;
        _this.selectedItem = new nota_relaciones_1.NotaRelaciones;
        _this.idContribuyente = 0;
        //
        _this.selectedItemChanged = new core_1.EventEmitter();
        _this.keywordSearchSource = rxjs_1.Observable.create(function (observer) {
            observer.next(_this.innerSelector.displayValue);
        })
            .mergeMap(function (keyword) { return _this.findComprobantesFiscales(keyword); });
        return _this;
    }
    ComprobanteFiscalSelectorComponent_1 = ComprobanteFiscalSelectorComponent;
    ComprobanteFiscalSelectorComponent.prototype.loadItem = function (itemID) {
        if (itemID != '' && itemID != '0') {
            var sRet = itemID.split('/');
            this.selectedItem = null;
            this.selectedItem = new nota_relaciones_1.NotaRelaciones;
            this.selectedItem.serie = sRet[0];
            this.selectedItem.folio = +sRet[1];
            this.selectedItem.uuid = sRet[2];
            this.selectedItem.total = +sRet[3];
            /*
            this.comprobanteFiscalService.getDetail(itemID)
                .then(info => {
                    this.selectedItem = info;
                    this.displayValue = info.serie + '-' + info.folio;
                    this.selectedItemChanged.emit(this.selectedItem);
                })
                .catch(error => this.handleError(error));
            */
        }
        else {
            this.selectedItem = null;
            this.displayValue = "";
            this.selectedItemChanged.emit(null);
        }
    };
    ComprobanteFiscalSelectorComponent.prototype.doSearch = function (request) {
        var _this = this;
        this.context.app.showSpinner();
        var condiciones = { field: "idContribuyente", operator: "=", valueType: "int", value: this.idContribuyente.toString() };
        request.conditions.push(condiciones);
        this.comprobanteFiscalService.search(this.context.app.defaultSite.identity, request)
            .then(function (response) {
            _this.context.app.hideSpinner();
            //
            _this.comprobanteFiscal = response.rows;
            _this.totalRows = response.totalRows;
            _this.pageIndex = request.pageIndex;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ComprobanteFiscalSelectorComponent.prototype.findComprobantesFiscales = function (keyword) {
        return this.comprobanteFiscalService.searchKeyword(this.context.app.defaultSite.identity, keyword, this.idContribuyente);
    };
    ComprobanteFiscalSelectorComponent.prototype.onKeywordSearch = function (keyword) {
        this.markUnselected();
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], ComprobanteFiscalSelectorComponent.prototype, "idContribuyente", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", core_1.EventEmitter)
    ], ComprobanteFiscalSelectorComponent.prototype, "selectedItemChanged", void 0);
    ComprobanteFiscalSelectorComponent = ComprobanteFiscalSelectorComponent_1 = __decorate([
        core_1.Component({
            selector: 'accounting-comprobante-fiscal-selector',
            template: "\n      <azteca-document-selector [displayValue]=\"displayValue\"                         \n                               [selectedItem]=\"selectedItem\"                         \n                               [pageSize]=\"pageSize\"\n                               [enabled]=\"enabled\"\n                               [visible]=\"visible\"\n                               [dataSource]=\"keywordSearchSource\"\n                               (selectedItemChanged)=\"itemChangedHandler($event)\"\n                               (keywordSearch)=\"onKeywordSearch($event)\">\n\n      </azteca-document-selector>\n    ",
            providers: [{
                    provide: core_2.BaseComponent,
                    useExisting: core_1.forwardRef(function () { return ComprobanteFiscalSelectorComponent_1; })
                },
                {
                    provide: forms_1.NG_VALUE_ACCESSOR,
                    useExisting: core_1.forwardRef(function () { return ComprobanteFiscalSelectorComponent_1; }),
                    multi: true
                }]
        }),
        __metadata("design:paramtypes", [core_2.Context, comprobante_fiscal_service_1.ComprobanteFiscalService])
    ], ComprobanteFiscalSelectorComponent);
    return ComprobanteFiscalSelectorComponent;
    var ComprobanteFiscalSelectorComponent_1;
}(document_selector_1.DocumentSelector));
exports.ComprobanteFiscalSelectorComponent = ComprobanteFiscalSelectorComponent;
