import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { Context, DocumentItem, DocumentTypeService, DocumentTypeInfo } from 'framework3/core';
import { DocumentEditor, EditableListComponent, EditorEventArgs, WorkflowEventArgs } from 'framework3/editors';
import { ComprobanteFiscalInfo } from '../models/comprobante-fiscal';
import { ComprobanteFiscalDetail } from '../models/comprobante-fiscal-detail';
import { ComprobanteFiscalService } from '../services/comprobante-fiscal.service';
import { ComprobanteFiscalDetailEditor } from './parts/comprobantes-detail.editor';
export declare class ComprobantesEditor extends DocumentEditor {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    private location;
    private formBuilder;
    protected documentTypeService: DocumentTypeService;
    private comprobanteFiscalService;
    comprobanteFiscal: ComprobanteFiscalInfo;
    detailsList: EditableListComponent;
    detailsEditor: ComprobanteFiscalDetailEditor;
    constructor(context: Context, router: Router, route: ActivatedRoute, location: Location, formBuilder: FormBuilder, documentTypeService: DocumentTypeService, comprobanteFiscalService: ComprobanteFiscalService);
    onConfigureDocument(docType: DocumentTypeInfo): void;
    onCreatingDocument(): void;
    onViewingDocument(id: string): void;
    onCloningDocument(id: string): void;
    onLoadingDocument(id: string): void;
    onSavingDocument(args: EditorEventArgs): void;
    onApplyingNextStep(args: WorkflowEventArgs): void;
    onApplyingPreviousStep(document: DocumentItem): void;
    onTabSelected(args: any): void;
    onAddingDetail(): void;
    onEditingDetail(detail: ComprobanteFiscalDetail): void;
    onDeletingDetail(detail: ComprobanteFiscalDetail): void;
    onListItemsUpdated(updatedDetails: ComprobanteFiscalDetail[]): void;
    onSavingDetail(detail: ComprobanteFiscalDetail): void;
}
