"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Wijmo
var wijmo_1 = require("wijmo/wijmo");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//Locales
var comprobante_fiscal_1 = require("../models/comprobante-fiscal");
var comprobante_fiscal_detail_1 = require("../models/comprobante-fiscal-detail");
var comprobante_fiscal_service_1 = require("../services/comprobante-fiscal.service");
var comprobantes_detail_editor_1 = require("./parts/comprobantes-detail.editor");
var ComprobantesEditor = /** @class */ (function (_super) {
    __extends(ComprobantesEditor, _super);
    function ComprobantesEditor(context, router, route, location, formBuilder, documentTypeService, comprobanteFiscalService) {
        var _this = _super.call(this, context, router, route, documentTypeService) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.location = location;
        _this.formBuilder = formBuilder;
        _this.documentTypeService = documentTypeService;
        _this.comprobanteFiscalService = comprobanteFiscalService;
        _this.comprobanteFiscal = new comprobante_fiscal_1.ComprobanteFiscalInfo();
        _this.documentForm = formBuilder.group({
            'sample': ['', forms_1.Validators.required],
        });
        return _this;
    }
    ComprobantesEditor_1 = ComprobantesEditor;
    ComprobantesEditor.prototype.onConfigureDocument = function (docType) {
        this.applyPolicies();
    };
    ComprobantesEditor.prototype.onCreatingDocument = function () {
    };
    ComprobantesEditor.prototype.onViewingDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.comprobanteFiscalService.getDetail(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.comprobanteFiscal = doc;
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ComprobantesEditor.prototype.onCloningDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.comprobanteFiscalService.clone(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.comprobanteFiscal = doc;
            _this.detailsEditor.clientIndexStart = _this.comprobanteFiscal.details.length;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ComprobantesEditor.prototype.onLoadingDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.comprobanteFiscalService.getDetail(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.comprobanteFiscal = doc;
            _this.detailsEditor.clientIndexStart = _this.comprobanteFiscal.details.length;
            if (_this.comprobanteFiscal.status != core_2.DocumentStatus.DRAFT)
                _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ComprobantesEditor.prototype.onSavingDocument = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.comprobanteFiscalService.update(this.comprobanteFiscal)
            .then(function (updatedDoc) {
            _this.context.app.hideSpinner();
            //Si es un elemento nuevo y no se cerrará el editor, navegar a nueva ruta
            _this.reset();
            if (!args.closeEditor && _this.comprobanteFiscal.identity == '') {
                _this.router.navigate(['../', updatedDoc.identity], { relativeTo: _this.route });
            }
            else {
                if (args.closeEditor)
                    _this.router.navigate(['../'], { relativeTo: _this.route });
                else
                    _this.showAlert('La información ha sido actualizada con éxito', 'success');
            }
            _this.comprobanteFiscal = updatedDoc;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ComprobantesEditor.prototype.onApplyingNextStep = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.comprobanteFiscalService.nextStep(args.document.id, args.step.idWorkflowStep, null)
            .then(function (_) {
            //Volver a cargar documento
            _this.onViewingDocument(args.document.id);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ComprobantesEditor.prototype.onApplyingPreviousStep = function (document) {
        var _this = this;
        this.context.app.showSpinner();
        this.comprobanteFiscalService.previousStep(document.id, null)
            .then(function (_) {
            //Volver a cargar documento
            _this.onViewingDocument(document.id);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ComprobantesEditor.prototype.onTabSelected = function (args) {
        if (args.heading) {
            //Al seleccionar la pestaña de historial, realizar carga de información
            if (args.heading == 'Historial') {
                this.loadHistory(this.comprobanteFiscal.identity);
            }
            //Actualizar controles de wijmo
            wijmo_1.Control.invalidateAll();
        }
    };
    ///////////// DETALLE DEL DOCUMENTO /////////////////////////
    ComprobantesEditor.prototype.onAddingDetail = function () {
        this.detailsEditor.detail = new comprobante_fiscal_detail_1.ComprobanteFiscalDetail();
        this.detailsEditor.show();
    };
    ComprobantesEditor.prototype.onEditingDetail = function (detail) {
        this.detailsEditor.detail = detail;
        this.detailsEditor.show();
    };
    ComprobantesEditor.prototype.onDeletingDetail = function (detail) {
        this.detailsList.deleteItem(detail);
    };
    ComprobantesEditor.prototype.onListItemsUpdated = function (updatedDetails) {
        this.comprobanteFiscal.details = updatedDetails;
    };
    ComprobantesEditor.prototype.onSavingDetail = function (detail) {
        this.detailsList.updateItem(detail);
    };
    __decorate([
        core_1.ViewChild('detailsList'),
        __metadata("design:type", editors_1.EditableListComponent)
    ], ComprobantesEditor.prototype, "detailsList", void 0);
    __decorate([
        core_1.ViewChild('detailsEditor'),
        __metadata("design:type", comprobantes_detail_editor_1.ComprobanteFiscalDetailEditor)
    ], ComprobantesEditor.prototype, "detailsEditor", void 0);
    ComprobantesEditor = ComprobantesEditor_1 = __decorate([
        core_1.Component({
            selector: 'contabilidad-comprobantes-editor',
            template: "\n      <form [formGroup]=\"documentForm\">\n          <azteca-document-editor #documentEditor\n                                         [title]=\"'Comprobantes'\"\n                                         [document]=\"comprobanteFiscal\"\n                                         [valid]=\"valid\"\n                                         (configureDocument)=\"onConfigureDocument($event)\"\n                                         (creatingDocument)=\"onCreatingDocument()\"\n                                         (viewingDocument)=\"onViewingDocument($event)\"\n                                         (cloningDocument)=\"onCloningDocument($event)\"\n                                         (savingDocument)=\"onSavingDocument($event)\"\n                                         (loadingDocument)=\"onLoadingDocument($event)\"\n                                         (applyingNextStep)=\"onApplyingNextStep($event)\"\n                                         (menuItemClick)=\"onMenuItemClick($event)\">\n\n              <!------------------- Menu de acciones adicionales --------------------->\n\n              <!------------------- Controles del editor ----------------------------->\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <tabset>\n                          <tab heading=\"Generales\" (select)=\"onTabSelected($event)\">\n\n\n                          </tab>\n                          <tab heading=\"Detalle\" (select)=\"onTabSelected($event)\">\n                              <azteca-editable-list   #detailsList\n                                                      (addingItem)=\"onAddingDetail()\"\n                                                      (editingItem)=\"onEditingDetail($event)\"\n                                                      (deletingItem)=\"onDeletingDetail($event)\"\n                                                      (listItemsUpdated)=\"onListItemsUpdated($event)\"\n                                                      [listItems]=\"comprobanteFiscal.details\">\n\n                                  <!-- OPCIONES DEL MENU-->\n                                  <azteca-menu-item [name]=\"'EDIT'\" [icon]=\"'glyphicon glyphicon-pencil'\" [text]=\"'Editar'\" [smallText]=\"'editar registro'\"></azteca-menu-item>\n                                  <azteca-menu-item [name]=\"'DELETE'\" [icon]=\"'glyphicon glyphicon-trash'\" [text]=\"'Eliminar'\" [smallText]=\"'eliminar registro'\"></azteca-menu-item>\n\n                                  <!-- COLUMNAS DEL GRID-->\n      \t\t\t\t\t\t\t<!-- Columnas de Ejemplo\n                                  <azteca-grid-column [header]=\"'Art\u00EDculo'\" [binding]=\"'articulo'\" [width]=\"'30*'\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'U.M.'\" [binding]=\"'unidad'\" [width]=\"'10*'\" [isReadOnly]=\"false\"></azteca-grid-column>                            \n      \t\t\t\t\t\t\t-->\n\n                              </azteca-editable-list>\n                          </tab>\n                          <tab heading=\"Historial\" (select)=\"onTabSelected($event)\">\n                              <document-history [history]=\"history\"></document-history>\n                          </tab>\n                      </tabset>\n\n                  </div>\n              </div>\n          </azteca-document-editor>\n      </form>\n\n      <contabilidad-comprobante-fiscal-detail-editor #detailsEditor                                     \n                                           (savingItem)=\"onSavingDetail($event)\">\n\n      </contabilidad-comprobante-fiscal-detail-editor>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return ComprobantesEditor_1; })
                },
                {
                    provide: core_2.DocumentService, useExisting: comprobante_fiscal_service_1.ComprobanteFiscalService
                }
            ]
        }),
        __metadata("design:paramtypes", [core_2.Context,
            router_1.Router,
            router_1.ActivatedRoute,
            common_1.Location,
            forms_1.FormBuilder,
            core_2.DocumentTypeService,
            comprobante_fiscal_service_1.ComprobanteFiscalService])
    ], ComprobantesEditor);
    return ComprobantesEditor;
    var ComprobantesEditor_1;
}(editors_1.DocumentEditor));
exports.ComprobantesEditor = ComprobantesEditor;
