import { Router, ActivatedRoute } from '@angular/router';
import { ModalDirective } from 'ngx-bootstrap';
import { Context, DocumentItem } from 'framework3/core';
import { DocumentManager, WorkflowEventArgs } from 'framework3/editors';
import { SearchRequest } from 'framework3/search';
import { ComprobanteFiscalInfo, ComprobanteFiscalItem } from '../models/comprobante-fiscal';
import { ComprobanteFiscalService } from '../services/comprobante-fiscal.service';
import { MenuItem, DownloadPopupComponent } from 'framework3/controls';
export declare class ComprobantesManager extends DocumentManager {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    private comprobanteFiscalService;
    comprobantes: ComprobanteFiscalItem[];
    currentComprobante: ComprobanteFiscalInfo;
    comprobantesDownLoad: string[];
    correo: string;
    downloadPopup: DownloadPopupComponent;
    viewDialog: ModalDirective;
    sendDialog: ModalDirective;
    constructor(context: Context, router: Router, route: ActivatedRoute, comprobanteFiscalService: ComprobanteFiscalService);
    onConfigureDocument(): void;
    onSearchRequested(request: SearchRequest): void;
    onAddingItem(): void;
    onViewingItem(document: DocumentItem): void;
    onEditingItem(document: DocumentItem): void;
    onDeletingItem(document: DocumentItem): void;
    onCloningItem(document: DocumentItem): void;
    onExportingItem(document: DocumentItem): void;
    onApplyingNextStep(args: WorkflowEventArgs): void;
    onApplyingPreviousStep(document: DocumentItem): void;
    onMenuItemClick(option: MenuItem): void;
    sendMail(): void;
}
