"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var ngx_bootstrap_1 = require("ngx-bootstrap");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//Locales
var comprobante_fiscal_1 = require("../models/comprobante-fiscal");
var comprobante_fiscal_service_1 = require("../services/comprobante-fiscal.service");
var controls_1 = require("framework3/controls");
var ComprobantesManager = /** @class */ (function (_super) {
    __extends(ComprobantesManager, _super);
    function ComprobantesManager(context, router, route, comprobanteFiscalService) {
        var _this = _super.call(this, context, router, route) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.comprobanteFiscalService = comprobanteFiscalService;
        _this.currentComprobante = new comprobante_fiscal_1.ComprobanteFiscalInfo();
        _this.comprobantesDownLoad = [];
        _this.correo = '';
        return _this;
    }
    ComprobantesManager_1 = ComprobantesManager;
    ComprobantesManager.prototype.onConfigureDocument = function () {
        this.refreshList();
        this.applyPolicies();
    };
    ComprobantesManager.prototype.onSearchRequested = function (request) {
        var _this = this;
        this.context.app.showSpinner();
        this.comprobanteFiscalService.search(this.context.app.defaultSite.identity, request)
            .then(function (response) {
            _this.context.app.hideSpinner();
            //
            _this.comprobantes = response.rows;
            _this.totalRows = response.totalRows;
            _this.filterGroups = response.filterGroups;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ComprobantesManager.prototype.onAddingItem = function () {
    };
    ComprobantesManager.prototype.onViewingItem = function (document) {
        var _this = this;
        this.context.app.showSpinner();
        this.comprobanteFiscalService.getDetail(document.id)
            .then(function (comprobante) {
            _this.currentComprobante = comprobante;
            _this.context.app.hideSpinner();
            _this.viewDialog.config.backdrop = false;
            _this.viewDialog.show();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ComprobantesManager.prototype.onEditingItem = function (document) {
    };
    ComprobantesManager.prototype.onDeletingItem = function (document) {
    };
    ComprobantesManager.prototype.onCloningItem = function (document) {
    };
    ComprobantesManager.prototype.onExportingItem = function (document) {
        var _this = this;
        this.comprobanteFiscalService.export(document.id)
            .then(function (_) {
            _this.refreshList();
            _this.showAlert('El proceso de exportación ha terminado con éxito.', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ComprobantesManager.prototype.onApplyingNextStep = function (args) {
    };
    ComprobantesManager.prototype.onApplyingPreviousStep = function (document) {
    };
    ComprobantesManager.prototype.onMenuItemClick = function (option) {
        var _this = this;
        if (option.name == 'TIMBRAR') {
            this.context.app.showSpinner();
            this.comprobanteFiscalService.timbrar(this.manager.currentDocument.id)
                .then(function (file) {
                _this.context.app.hideSpinner();
                _this.showAlert("El comprobante se ha timbrado con exito", "success");
            })
                .catch(function (error) { return _this.handleError(error); });
        }
        if (option.name == 'CANCEL') {
            this.context.app.showSpinner();
            this.comprobanteFiscalService.cancelar(this.manager.currentDocument.id)
                .then(function (file) {
                _this.context.app.hideSpinner();
                _this.showAlert("El comprobante se ha cancelado con exito", "success");
            })
                .catch(function (error) { return _this.handleError(error); });
        }
        if (option.name == 'PDF') {
            this.context.app.showSpinner();
            this.comprobanteFiscalService.generarPdfTemporal(this.manager.currentDocument.id)
                .then(function (file) {
                _this.context.app.hideSpinner();
                window.open('/file-server/' + file.uri, '_blank');
            })
                .catch(function (error) { return _this.handleError(error); });
        }
        if (option.name == "DOWNLOAD") {
            this.context.app.showSpinner();
            //Generar PDF
            this.comprobanteFiscalService.generarPdfTemporal(this.manager.currentDocument.id)
                .then(function (pdf) {
                //Descargar xml
                _this.comprobanteFiscalService.getXmlFile(_this.manager.currentDocument.id)
                    .then(function (xml) {
                    _this.context.app.hideSpinner();
                    var links = [];
                    links.push(pdf);
                    links.push(xml);
                    _this.downloadPopup.show(links);
                })
                    .catch(function (error) { return _this.handleError(error); });
            })
                .catch(function (error) { return _this.handleError(error); });
        }
        if (option.name == "DOWNLOAD-ALL") {
            this.context.app.showSpinner();
            var i = 0;
            for (i = 0; i <= this.manager.baseList.documentsView.totalItemCount - 1; i++) {
                this.comprobantesDownLoad[i] = this.manager.baseList.documentsView.items[i].id;
            }
            this.comprobanteFiscalService.generarPdfTemporalArr(this.comprobantesDownLoad)
                .then(function (pdf) {
                //Descargar zip
                _this.comprobanteFiscalService.getXmlFileArr(_this.comprobantesDownLoad)
                    .then(function (xml) {
                    _this.context.app.hideSpinner();
                    var links = [];
                    links.push(pdf);
                    links.push(xml);
                    _this.downloadPopup.show(links);
                })
                    .catch(function (error) { return _this.handleError(error); });
            })
                .catch(function (error) { return _this.handleError(error); });
        }
        if (option.name == 'SEND') {
            var comprobante = this.manager.currentDocument;
            this.correo = comprobante.correo;
            this.sendDialog.config.backdrop = false;
            this.sendDialog.show();
        }
    };
    ComprobantesManager.prototype.sendMail = function () {
        var _this = this;
        this.context.app.showSpinner();
        this.comprobanteFiscalService.enviar(this.manager.currentDocument.id, this.correo, 'Comprobante fiscal')
            .then(function (file) {
            _this.context.app.hideSpinner();
            _this.showAlert("El comprobante se ha enviado con exito", "success");
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    __decorate([
        core_1.ViewChild(controls_1.DownloadPopupComponent),
        __metadata("design:type", controls_1.DownloadPopupComponent)
    ], ComprobantesManager.prototype, "downloadPopup", void 0);
    __decorate([
        core_1.ViewChild('viewDialog'),
        __metadata("design:type", ngx_bootstrap_1.ModalDirective)
    ], ComprobantesManager.prototype, "viewDialog", void 0);
    __decorate([
        core_1.ViewChild('sendMailDialog'),
        __metadata("design:type", ngx_bootstrap_1.ModalDirective)
    ], ComprobantesManager.prototype, "sendDialog", void 0);
    ComprobantesManager = ComprobantesManager_1 = __decorate([
        core_1.Component({
            selector: 'contabilidad-comprobantes-manager',
            template: "\n      <div class=\"card\">\n          <div class=\"card-header\">Comprobantes</div>\n          <div class=\"card-block\">\n              <azteca-document-manager (searchRequested)=\"onSearchRequested($event)\"\n                                       (addingItem)=\"onAddingItem()\"\n                                       (viewingItem)=\"onViewingItem($event)\"\n                                       (editingItem)=\"onEditingItem($event)\"\n                                       (deletingItem)=\"onDeletingItem($event)\"\n                                       (cloningItem)=\"onCloningItem($event)\"\n                                       (exportingItem)=\"onExportingItem($event)\"\n                                       (applyingNextStep)=\"onApplyingNextStep($event)\"\n                                       (applyingPreviousStep)=\"onApplyingPreviousStep($event)\"\n                                       (configureDocument)=\"onConfigureDocument($event)\"\n                                       (menuItemClick)=\"onMenuItemClick($event)\"\n                                       [enabled]=\"enabled\"\n                                       [allowNew]=\"false\"\n                                       [allowView]=\"true\"\n                                       [allowEdit]=\"false\"\n                                       [allowDelete]=\"false\"\n                                       [allowClone]=\"false\"\n                                       [allowNext]=\"false\"\n                                       [allowPrevious]=\"false\"\n                                       [allowAudit]=\"false\"\n                                       [allowExport]=\"true\"\n                                       [filterGroups]=\"filterGroups\"\n                                       [documentList]=\"comprobantes\"\n                                       [startPeriod]=\"3\">\n\n\n                  <!------------------- Menu de acciones adicionales --------------------->\n                  <azteca-menu-item [name]=\"'CANCEL'\" [icon]=\"'glyphicon glyphicon-remove'\" [text]=\"'Cancelar'\" [smallText]=\"'cancelar el comprobante'\"></azteca-menu-item>\n                  <azteca-menu-item [name]=\"'TIMBRAR'\" [icon]=\"'glyphicon glyphicon-cloud-upload'\" [text]=\"'Timbrar'\" [smallText]=\"'timbrar el comprobante fiscal'\"></azteca-menu-item>\n                  <azteca-menu-item [name]=\"'PDF'\" [icon]=\"'glyphicon glyphicon-print'\" [text]=\"'Imprimir'\" [smallText]=\"'generar pdf del comprobante'\"></azteca-menu-item>\n                  <azteca-menu-item [name]=\"'DOWNLOAD'\" [icon]=\"'glyphicon glyphicon-save'\" [text]=\"'Descargar'\" [smallText]=\"'descargar xml y pdf'\"></azteca-menu-item>\n                  <azteca-menu-item [name]=\"'DOWNLOAD-ALL'\" [icon]=\"'glyphicon glyphicon-save'\" [text]=\"'Descargar los ' +  manager.baseList.documentsView.totalItemCount + ' comprobantes listados' \" [smallText]=\"'descargar los ' +  manager.baseList.documentsView.totalItemCount + ' comprobantes listados'\"></azteca-menu-item>\n                  <azteca-menu-item [name]=\"'SEND'\" [icon]=\"'glyphicon glyphicon-send'\" [text]=\"'Enviar'\" [smallText]=\"'enviar el xml y pdf por correo'\"></azteca-menu-item>\n                  <!------------------- Columnas del listado ----------------------------->\n\n                  <azteca-grid-column [header]=\"'Folio'\" [binding]=\"'id'\" [width]=\"170\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Fecha'\" [binding]=\"'fechaCreacion'\" [width]=\"120\" dataType=\"Date\" format=\"dd-MM-yyyy\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Timbrado'\" [binding]=\"'fechaTimbrado'\" [width]=\"120\" dataType=\"Date\" format=\"dd-MM-yyyy\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Tipo'\" [binding]=\"'tipoComprobante'\" [width]=\"'1*'\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Receptor'\" [binding]=\"'rfcReceptor'\" [width]=\"'2*'\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Serie'\" [binding]=\"'serie'\" [width]=\"'1*'\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Folio'\" [binding]=\"'folio'\" [width]=\"'1*'\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Total'\" [binding]=\"'total'\" [width]=\"'2*'\" dataType=\"Number\" format=\"c\"> </azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Ref'\" [binding]=\"'observaciones'\" [width]=\"'1*'\"></azteca-grid-column>\n\n              </azteca-document-manager>\n          </div>\n      </div>\n\n      <download-popup></download-popup>\n\n\n      <div bsModal #viewDialog=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"myLargeModalLabel\" aria-hidden=\"true\">\n          <div class=\"modal-dialog modal-lg\">\n              <div class=\"modal-content\">\n                  <div class=\"modal-header\">\n                      <h4 class=\"modal-title\"></h4>\n                      <button type=\"button\" class=\"close pull-right\" aria-label=\"Close\" (click)=\"viewDialog.hide()\">\n                          <span aria-hidden=\"true\">&times;</span>\n                      </button>\n                  </div>\n                  <div class=\"modal-body\">\n                      <accounting-comprobante-viewer [comprobante]=\"currentComprobante\"></accounting-comprobante-viewer>\n                  </div> <!--Modal Body-->\n              </div> <!-- Modal Content-->\n          </div> <!--Modal-->\n      </div> <!--Modal directive-->\n\n\n      <div bsModal #sendMailDialog=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"mySmallModalLabel\" aria-hidden=\"true\">\n          <div class=\"modal-dialog modal-sm\">\n              <div class=\"modal-content\">\n                  <div class=\"modal-body\">\n                      <label>Correo electr\u00F3nico:</label>\n                      <az-textbox [(ngModel)]=\"correo\"></az-textbox>\n                  </div> <!--Modal Body-->\n                  <div class=\"modal-footer\">\n                      <button type=\"button\" class=\"btn btn-primary\" (click)=\"sendMail()\">Aceptar</button>\n                      <button type=\"button\" class=\"btn btn-danger\" (click)=\"sendMailDialog.hide()\">Cancelar</button>\n                  </div> <!--Modal Footer-->\n\n              </div> <!-- Modal Content-->\n          </div> <!--Modal-->\n      </div> <!--Modal directive-->\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return ComprobantesManager_1; })
                },
                {
                    provide: core_2.DocumentService, useExisting: comprobante_fiscal_service_1.ComprobanteFiscalService
                }
            ]
        }),
        __metadata("design:paramtypes", [core_2.Context, router_1.Router, router_1.ActivatedRoute, comprobante_fiscal_service_1.ComprobanteFiscalService])
    ], ComprobantesManager);
    return ComprobantesManager;
    var ComprobantesManager_1;
}(editors_1.DocumentManager));
exports.ComprobantesManager = ComprobantesManager;
