import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { Context, DocumentItem, DocumentTypeService, DocumentTypeInfo } from 'framework3/core';
import { DocumentEditor, EditableListComponent, EditorEventArgs, WorkflowEventArgs } from 'framework3/editors';
import { FichaInfo } from '../models/ficha';
import { FichaDetail } from '../models/ficha-detail';
import { FichaService } from '../services/ficha.service';
import { FichaDetailEditor } from './parts/fichas-detail.editor';
export declare class FichasEditor extends DocumentEditor {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    private location;
    private formBuilder;
    protected documentTypeService: DocumentTypeService;
    private fichaService;
    ficha: FichaInfo;
    afectadores: {
        id: string;
        nombre: string;
    }[];
    detailsList: EditableListComponent;
    detailsEditor: FichaDetailEditor;
    constructor(context: Context, router: Router, route: ActivatedRoute, location: Location, formBuilder: FormBuilder, documentTypeService: DocumentTypeService, fichaService: FichaService);
    onConfigureDocument(docType: DocumentTypeInfo): void;
    onCreatingDocument(): void;
    onViewingDocument(id: string): void;
    onCloningDocument(id: string): void;
    onLoadingDocument(id: string): void;
    onSavingDocument(args: EditorEventArgs): void;
    onApplyingNextStep(args: WorkflowEventArgs): void;
    onApplyingPreviousStep(document: DocumentItem): void;
    onTabSelected(args: any): void;
    onAddingDetail(): void;
    onEditingDetail(detail: FichaDetail): void;
    onDeletingDetail(detail: FichaDetail): void;
    onListItemsUpdated(updatedDetails: FichaDetail[]): void;
    onSavingDetail(detail: FichaDetail): void;
}
