import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { CollectionView } from 'wijmo/wijmo';
import { Menu } from 'wijmo/wijmo.input';
import { Context, DocumentItem, DocumentTypeService, DocumentTypeInfo } from 'framework3/core';
import { ToolbarButton } from 'framework3/controls';
import { DocumentEditor, EditableListComponent, EditorEventArgs, WorkflowEventArgs } from 'framework3/editors';
import { NotaInfo } from '../models/nota';
import { NotaDetail } from '../models/nota-detail';
import { NotaRelaciones } from '../models/nota-relaciones';
import { NotaService } from '../services/nota.service';
import { NotaDetailEditor } from './parts/notas-detail.editor';
import { DivisaService } from '../services/divisa.service';
import { DivisaInfo } from '../models/divisa';
import { FormaPagoService } from '../services/forma-pago.service';
import { FormaPagoItem } from '../models/forma-pago';
import { ComprobanteFiscalSelectorComponent, ContribuyenteSelectorComponent } from '../../accounting';
export declare class NotasEditor extends DocumentEditor {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    private location;
    private formBuilder;
    protected documentTypeService: DocumentTypeService;
    private notaService;
    private formaPagoService;
    private divisaService;
    nota: NotaInfo;
    divisaInfo: DivisaInfo;
    formasPago: FormaPagoItem[];
    detailsList: EditableListComponent;
    detailsEditor: NotaDetailEditor;
    selectorComprobante: ComprobanteFiscalSelectorComponent;
    selectorContribuyente: ContribuyenteSelectorComponent;
    comprobantes: NotaRelaciones[];
    currentComprobante: NotaRelaciones;
    comprobantesCollection: CollectionView;
    divisaDefault: number;
    constructor(context: Context, router: Router, route: ActivatedRoute, location: Location, formBuilder: FormBuilder, documentTypeService: DocumentTypeService, notaService: NotaService, formaPagoService: FormaPagoService, divisaService: DivisaService);
    onConfigureDocument(docType: DocumentTypeInfo): void;
    onCreatingDocument(): void;
    onViewingDocument(id: string): void;
    onCloningDocument(id: string): void;
    onLoadingDocument(id: string): void;
    onSavingDocument(args: EditorEventArgs): void;
    onApplyingNextStep(args: WorkflowEventArgs): void;
    onApplyingPreviousStep(document: DocumentItem): void;
    onTabSelected(args: any): void;
    onAddingDetail(): void;
    onEditingDetail(detail: NotaDetail): void;
    onDeletingDetail(detail: NotaDetail): void;
    onListItemsUpdated(updatedDetails: NotaDetail[]): void;
    onSavingDetail(detail: NotaDetail): void;
    loadFormasPago(): void;
    listComprobantes(): void;
    asignarComprobante(comprobante: NotaRelaciones): void;
    getDivisaDefault(): void;
    onToolbarButtonClick(button: ToolbarButton): void;
    onMenuComprobantesClicked(menu: Menu, args: any): void;
}
