"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
//
var comprobante_fiscal_1 = require("../../models/comprobante-fiscal");
var ComprobanteViewerComponent = /** @class */ (function () {
    function ComprobanteViewerComponent() {
        this.comprobante = new comprobante_fiscal_1.ComprobanteFiscalInfo();
    }
    Object.defineProperty(ComprobanteViewerComponent.prototype, "totalTraslados", {
        get: function () {
            return this.comprobante.impuestos.totalTraslados + (this.comprobante.impuestosLocales ? this.comprobante.impuestosLocales.totalTraslados : 0);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ComprobanteViewerComponent.prototype, "totalRetenciones", {
        get: function () {
            return this.comprobante.impuestos.totalRetenciones + (this.comprobante.impuestosLocales ? this.comprobante.impuestosLocales.totalRetenciones : 0);
        },
        enumerable: true,
        configurable: true
    });
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], ComprobanteViewerComponent.prototype, "comprobante", void 0);
    ComprobanteViewerComponent = __decorate([
        core_1.Component({
            selector: 'accounting-comprobante-viewer',
            template: "\n      <div *ngIf=\"comprobante.errorTimbrado != ''\" class=\"alert alert-danger\" role=\"alert\">{{comprobante.errorTimbrado}}</div>\n\n      <!--------- COMPROBANTE ----------->\n      <div class=\"row\">\n          <div class=\"col-12\">\n              <az-panel [header]=\"'Comprobante'\">\n\n                  <div class=\"row\">\n                      <div class=\"col-12 col-lg-6\">\n                          <label class=\"control-label\">Folio fiscal:</label>\n                          <az-label [text]=\"comprobante.timbreFiscal.uuid\"></az-label>\n                      </div>\n                      <div class=\"col-12 col-lg-6\">\n                          <label class=\"control-label\">No. de serie del certificado de CSD:</label>\n                          <az-label [text]=\"comprobante.numeroCertificado\"></az-label>\n                      </div>\n                  </div>\n\n                  <div class=\"row\">\n                      <div class=\"col-12 col-lg-6\">\n                          <label class=\"control-label\">Serie y folio:</label>\n                          <az-label [text]=\"comprobante.serie + ' ' + comprobante.folio\"></az-label>\n                      </div>\n                      <div class=\"col-12 col-lg-6\">\n                          <label class=\"control-label\">Fecha y hora de emisi\u00F3n:</label>\n                          <az-label [text]=\"comprobante.fecha | dateFormat:'DD/MM/YYYY HH:mm'\"></az-label>\n                      </div>\n                  </div>\n\n              </az-panel>\n          </div>\n      </div>\n\n\n      <div class=\"row\">\n          <!--------- EMISOR ----------->\n          <div class=\"col-12 col-lg-6\">\n              <az-panel [header]=\"'Emisor'\">\n                  <label class=\"control-label\">RFC:</label>\n                  <az-label [text]=\"comprobante.emisor.rfc\"></az-label>\n\n                  <label class=\"control-label\">Raz\u00F3n social:</label>\n                  <az-label [text]=\"comprobante.emisor.nombre\"></az-label>\n\n                  <label class=\"control-label\">R\u00E9gimen fiscal:</label>\n                  <az-label [text]=\"comprobante.emisor.regimenFiscal\"></az-label>\n\n              </az-panel>\n          </div>\n          <!--------- RECEPTOR ----------->\n          <div class=\"col-12 col-lg-6\">\n              <az-panel [header]=\"'Receptor'\">\n                  <label class=\"control-label\">RFC:</label>\n                  <az-label [text]=\"comprobante.receptor.rfc\"></az-label>\n\n                  <label class=\"control-label\">Raz\u00F3n social:</label>\n                  <az-label [text]=\"comprobante.receptor.nombre\"></az-label>\n\n              </az-panel>\n          </div>\n      </div>\n\n\n      <!--------- CONCEPTOS ----------->\n\n      <az-panel [header]=\"'Conceptos'\">\n          <div class=\"row\">\n              <div class=\"col-12\">\n                  <table class=\"table table-sm\">\n                      <thead class=\"thead-light\">\n                          <tr>\n                              <th scope=\"col\">Cantidad</th>\n                              <th scope=\"col\">U.M.</th>\n                              <th scope=\"col\">Descripci\u00F3n</th>\n                              <th scope=\"col\">P. Unitario</th>\n                              <th scope=\"col\">Descuento</th>\n                              <th scope=\"col\">Importe</th>\n                          </tr>\n                      </thead>\n                      <tbody>\n                          <tr *ngFor=\"let detail of comprobante.details\">\n                              <td>{{detail.cantidad}}</td>\n                              <td>{{detail.unidadMedida}}</td>\n                              <td>{{detail.descripcion}}</td>\n                              <td>{{detail.valorUnitario | currency : comprobante.divisa.code : 'symbol'}}</td>\n                              <td>{{detail.descuento | currency : comprobante.divisa.code : 'symbol'}}</td>\n                              <td>{{detail.importe | currency : comprobante.divisa.code : 'symbol'}}</td>\n                          </tr>\n                      </tbody>\n                  </table>\n              </div>\n          </div>\n\n      </az-panel>\n\n\n      <!--------- TOTALES ----------->\n      <div class=\"row justify-content-end\">\n          <div class=\"col-12 col-lg-6\">\n\n              <label class=\"control-label\">Sub total:</label>\n              <az-label [text]=\"comprobante.subTotal | currency : comprobante.divisa.code : 'symbol'\"></az-label>\n\n              <label class=\"control-label\">Impuestos trasladados:</label>\n              <az-label [text]=\"totalTraslados | currency : comprobante.divisa.code : 'symbol'\"></az-label>\n\n              <label class=\"control-label\">Impuestos retenidos:</label>\n              <az-label [text]=\"totalRetenciones | currency : comprobante.divisa.code : 'symbol'\"></az-label>\n\n              <label class=\"control-label\">Total:</label>\n              <az-label [text]=\"comprobante.total | currency : comprobante.divisa.code : 'symbol'\"></az-label>\n\n          </div>\n      </div>\n    "
        })
    ], ComprobanteViewerComponent);
    return ComprobanteViewerComponent;
}());
exports.ComprobanteViewerComponent = ComprobanteViewerComponent;
