import { Router, ActivatedRoute } from '@angular/router';
import { FormGroup, FormBuilder } from '@angular/forms';
import { ModalDirective } from 'ngx-bootstrap';
import { Context, ProcessComponent, PolicyInfo } from 'framework3/core';
import { MenuItem, ToolbarButton, AlertsBarComponent } from 'framework3/controls';
import { DocumentListComponent } from 'framework3/search';
import { PolizaService } from '../../services/poliza.service';
import { PolizaInfo, PolizaPerfilItem } from '../../models/poliza';
export declare class PolizasByLoteEditor extends ProcessComponent {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    private formBuilder;
    private polizaService;
    form: FormGroup;
    menuItems: MenuItem[];
    polizaPerfilCurrent: PolizaPerfilItem;
    idPolizaPerfil: number;
    fechaInicial: Date;
    fechaFinal: Date;
    perfiles: PolizaPerfilItem[];
    poliza: PolizaInfo;
    cargos: number;
    abonos: number;
    rango: boolean;
    cargando: boolean;
    viewDialog: ModalDirective;
    documentList: DocumentListComponent;
    alerts: AlertsBarComponent;
    constructor(context: Context, router: Router, route: ActivatedRoute, formBuilder: FormBuilder, polizaService: PolizaService);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    loadPerfiles(): void;
    onCargarPoliza(): void;
    getPolizaExists(): void;
    loadPoliza(): void;
    savePoliza(): void;
    onMainToolbar(button: ToolbarButton): void;
    onPolizaPerfilChanged(idPolizaPerfil: any): void;
    fechaIniChange(arg: any): void;
    resetScreen(): void;
    onValidateMenu(): void;
    currentItemChangedHandler(): void;
    handleError(error: any): void;
    applyPolicy(policy: PolicyInfo): void;
}
