"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var moment = require("moment");
//Bootstrap
var ngx_bootstrap_1 = require("ngx-bootstrap");
//Azteca Kernel
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
var search_1 = require("framework3/search");
//Locales
var poliza_service_1 = require("../../services/poliza.service");
var poliza_1 = require("../../models/poliza");
var PolizasByLoteEditor = /** @class */ (function (_super) {
    __extends(PolizasByLoteEditor, _super);
    function PolizasByLoteEditor(context, router, route, formBuilder, polizaService) {
        var _this = _super.call(this, context, router, route) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.formBuilder = formBuilder;
        _this.polizaService = polizaService;
        _this.menuItems = [];
        _this.polizaPerfilCurrent = new poliza_1.PolizaPerfilItem();
        _this.fechaInicial = new Date();
        _this.fechaFinal = new Date();
        _this.perfiles = [];
        _this.poliza = new poliza_1.PolizaInfo();
        //currentMovimiento = new PolizaDetail();
        _this.rango = true;
        _this.cargando = false;
        //Crear formulario de parámetros
        _this.form = formBuilder.group({
            'fechaInicial': [new Date()],
            'fechaFinal': [new Date()],
            'perfil': [0, forms_1.Validators.required],
            'abonos': [0],
            'cargos': [0],
            'folio': [0]
        });
        return _this;
    }
    PolizasByLoteEditor.prototype.ngOnInit = function () {
        //this.createMenu();
        this.loadPerfiles();
    };
    PolizasByLoteEditor.prototype.ngAfterViewInit = function () {
        this.fechaInicial = moment().subtract(15, 'day').toDate();
        this.fechaFinal = moment().add(1, 'day').toDate();
        //setTimeout(_ => this.refreshList());
    };
    /////////////////////// METODOS ////////////////////////////////////
    PolizasByLoteEditor.prototype.loadPerfiles = function () {
        var _this = this;
        this.polizaService.loadPerfilesByLote(this.context.app.defaultCompany.identity, this.context.session.user.identity)
            .then(function (response) {
            _this.perfiles = response;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    PolizasByLoteEditor.prototype.onCargarPoliza = function () {
        var _this = this;
        this.context.app.showSpinner();
        setTimeout(function (_) { return _this.resetScreen(); });
        this.fechaInicial.setHours(0);
        this.fechaFinal.setHours(0);
        this.fechaInicial.setMinutes(0);
        this.fechaFinal.setMinutes(0);
        this.fechaInicial.setSeconds(0);
        this.fechaFinal.setSeconds(0);
        this.cargando = true;
        if (this.polizaPerfilCurrent.rango == "D") {
            this.fechaFinal = this.fechaInicial;
            setTimeout(function (_) { return _this.getPolizaExists(); });
        }
        else
            setTimeout(function (_) { return _this.loadPoliza(); });
        ;
    };
    PolizasByLoteEditor.prototype.getPolizaExists = function () {
        var _this = this;
        this.context.app.showSpinner();
        //Verificamos si existe una poliza de este perfil en esta fecha 
        this.polizaService.getPolizaByPerfil(this.context.app.defaultSite.identity, this.idPolizaPerfil, this.fechaInicial)
            .then(function (response) {
            _this.poliza = response;
            if (_this.poliza.identity.trim() == '')
                setTimeout(function (_) { return _this.loadPoliza(); });
            else {
                _this.context.app.hideSpinner();
                _this.cargando = false;
                _this.cargos = Math.round(_this.poliza.cargos * 100) / 100;
                _this.abonos = Math.round(_this.poliza.abonos * 100) / 100;
            }
        })
            .catch(function (error) {
            _this.context.app.hideSpinner();
            _this.handleError(error);
        });
    };
    PolizasByLoteEditor.prototype.loadPoliza = function () {
        var _this = this;
        this.context.app.showSpinner();
        this.polizaService.contabilizarByLote(this.context.app.defaultSite.identity, this.idPolizaPerfil, this.fechaInicial, this.fechaFinal)
            .then(function (response) {
            _this.context.app.hideSpinner();
            _this.poliza = response;
            _this.cargando = false;
            _this.cargos = Math.round(_this.poliza.cargos * 100) / 100;
            _this.abonos = Math.round(_this.poliza.abonos * 100) / 100;
            _this.alerts.showAlert('Se ha cargado la informacion', 'success');
        })
            .catch(function (error) {
            _this.context.app.hideSpinner();
            _this.handleError(error);
        });
    };
    PolizasByLoteEditor.prototype.savePoliza = function () {
        var _this = this;
        this.context.app.showSpinner();
        if (this.poliza.idPolizaOrigen == 0)
            this.poliza.idPolizaOrigen = 1; //Manual
        this.polizaService.update(this.poliza)
            .then(function (updatedDoc) {
            _this.context.app.hideSpinner();
            _this.alerts.showAlert('La información ha sido actualizada con éxito', 'success');
            _this.poliza = updatedDoc;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    //createMenu() {
    //    //Agregar opciones estándar del catálogo
    //    let mnuView: MenuItem = { icon: "glyphicon glyphicon-folder-open", text: "Ver", name: "OPEN", smallText: "ver resumen del comprobante" };
    //    let mnuPdf: MenuItem = { icon: "glyphicon glyphicon-download-alt", text: "Descargar PDF", name: "PDF", smallText: "descargar en formato PDF" };
    //    let mnuXml: MenuItem = { icon: "glyphicon glyphicon-download-alt", text: "Descargar XML", name: "XML", smallText: "descargar en formato XML" };
    //    this.menuItems.push(mnuView, mnuPdf, mnuXml);
    //    this.menuItems.forEach(item => {
    //        if (item.enabled == undefined) item.enabled = true;
    //    });
    //}
    /////////////////////// HANDLERS //////////////////////////////////
    PolizasByLoteEditor.prototype.onMainToolbar = function (button) {
        if (button.name == 'SAVE') {
            this.savePoliza();
        }
    };
    PolizasByLoteEditor.prototype.onPolizaPerfilChanged = function (idPolizaPerfil) {
        var _this = this;
        this.polizaPerfilCurrent = this.perfiles.find(function (perfil) { return perfil.id = idPolizaPerfil; });
        this.idPolizaPerfil = idPolizaPerfil;
        if (this.polizaPerfilCurrent.rango == "D") {
            this.rango = false;
        }
        setTimeout(function (_) { return _this.resetScreen(); });
    };
    PolizasByLoteEditor.prototype.fechaIniChange = function (arg) {
        var _this = this;
        setTimeout(function (_) { return _this.resetScreen(); });
    };
    PolizasByLoteEditor.prototype.resetScreen = function () {
        this.poliza = new poliza_1.PolizaInfo();
        this.cargos = 0;
        this.abonos = 0;
    };
    //optionClick(option: MenuItem) {
    //    if (option.name == 'OPEN') {
    //        //this.viewComprobante();
    //    }
    //    if (option.name == 'PDF') {
    //    }
    //    if (option.name == 'XML') {
    //    }
    //}
    PolizasByLoteEditor.prototype.onValidateMenu = function () {
    };
    PolizasByLoteEditor.prototype.currentItemChangedHandler = function () {
    };
    PolizasByLoteEditor.prototype.handleError = function (error) {
        this.context.app.hideSpinner();
        var message = this.context.getExceptionMessage(error);
        this.cargando = false;
        this.alerts.showAlert(message, 'danger');
    };
    //Implementacion de politicas
    PolizasByLoteEditor.prototype.applyPolicy = function (policy) {
    };
    __decorate([
        core_1.ViewChild('viewDialog'),
        __metadata("design:type", ngx_bootstrap_1.ModalDirective)
    ], PolizasByLoteEditor.prototype, "viewDialog", void 0);
    __decorate([
        core_1.ViewChild(search_1.DocumentListComponent),
        __metadata("design:type", search_1.DocumentListComponent)
    ], PolizasByLoteEditor.prototype, "documentList", void 0);
    __decorate([
        core_1.ViewChild(controls_1.AlertsBarComponent),
        __metadata("design:type", controls_1.AlertsBarComponent)
    ], PolizasByLoteEditor.prototype, "alerts", void 0);
    PolizasByLoteEditor = __decorate([
        core_1.Component({
            selector: 'accounting-polizas-by-lote',
            template: "\n      <form [formGroup]=\"form\">\n\n          <!--PANEL DE PERIODO Y RESUMEN DE ESTATUS-->\n          <div class=\"row\">\n              <div class=\"col-12 col-lg-3\">\n                  <div class=\"row\">\n                      <div class=\"col-12\">\n\n                          <az-panel [header]=\"'Per\u00EDodo'\">\n\n                              <azteca-form-field [label]=\"'Perfil de poliza:'\">\n                                  <az-combobox formControlName=\"perfil\"\n                                               [(ngModel)]=\"idPolizaPerfil\"\n                                               [items]=\"perfiles\"\n                                               [displayMember]=\"'nombre'\"\n                                               [valueMember]=\"'id'\"\n                                               (selectedItemChanged)=\"onPolizaPerfilChanged($event)\">\n                                      >\n                                  </az-combobox>\n                              </azteca-form-field>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-5\">\n                                      <azteca-form-field [label]=\"'Fecha inicial:'\">\n                                          <az-input-date formControlName=\"fechaInicial\" [(ngModel)]=\"fechaInicial\" (valueChange)=\"fechaIniChange($event)\"></az-input-date>\n                                      </azteca-form-field>\n                                  </div>\n\n\n                                  <div class=\"col-12 col-md-5\">\n                                      <azteca-form-field [label]=\"'Fecha final:'\" *ngIf=\"rango\">\n                                          <az-input-date formControlName=\"fechaFinal\" [(ngModel)]=\"fechaFinal\"></az-input-date>\n                                      </azteca-form-field>\n                                  </div>\n\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-5\">\n                                      <azteca-form-field [label]=\"'Cargos:'\">\n                                          <az-input-number formControlName=\"cargos\" [(ngModel)]=\"cargos\" format=\"'n2'\" [enabled]=\"false\"></az-input-number>\n                                      </azteca-form-field>\n                                  </div>\n\n                                  <div class=\"col-12 col-md-5\">\n                                      <azteca-form-field [label]=\"'Abonos:'\">\n                                          <az-input-number formControlName=\"abonos\" [(ngModel)]=\"abonos\" format=\"'n2'\" [enabled]=\"false\"></az-input-number>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-5\">\n                                      <az-label text=\"Folio:\"> </az-label>                                \n                                  </div>\n                                  <div class=\"col-12 col-md-5\">\n                                      <azteca-form-field [label]=\"''\">\n                                          <az-input-number formControlName=\"folio\" [(ngModel)]=\"poliza.folio\" format=\"'n0'\" [enabled]=\"false\"></az-input-number>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <br />\n                              <button type=\"button\" class=\"btn btn-primary\" (click)=\"onCargarPoliza()\"  ><span class=\"glyphicon glyphicon-refresh\"></span> Consultar</button>\n\n                          </az-panel>\n                      </div> <!-- COL-->\n                  </div> <!--ROW PANEL-->\n              </div> <!--COL PANEL-->\n\n              <div class=\"col-12 col-lg-9\">\n\n                  <div class=\"row\">\n                      <div class=\"col-12\">\n                          <alerts-bar></alerts-bar>\n                      </div>\n                  </div>\n\n                  <az-toolbar (buttonClick)=\"onMainToolbar($event)\" (menuItemClick)=\"optionClick($event)\">\n                      <az-toolbar-button [name]=\"'SAVE'\" [type]=\"'primary'\" [text]=\"'Guardar'\" [icon]=\"'glyphicon glyphicon-floppy-disk'\" [title]=\"'Guardar'\" [enabled]=\"poliza.identity=='' && poliza.details.length>0 && cargos==abonos\"></az-toolbar-button>\n                      <az-toolbar-button [name]=\"'CNL'\"  [type]=\"'primary'\" [text]=\"'Cancelar'\" [icon]=\"'glyphicon glyphicon-remove'\" [title]=\"'Cancelar'\" [enabled]=\"poliza.identity!=''\"> </az-toolbar-button>\n                      <!--<az-toolbar-menu [name]=\"'OPTIONS'\" [header]=\"'Opciones'\" [menuItems]=\"menuItems\"></az-toolbar-menu>-->\n                  </az-toolbar>\n\n                  <wj-flex-grid #grid\n                                [itemsSource]=\"poliza.details\"\n                                [isReadOnly]=\"true\">\n\n                      <wj-flex-grid-column [header]=\"'Cuenta'\" [binding]=\"'cuentaText'\" [width]=\"'9*'\"> </wj-flex-grid-column>\n                      <wj-flex-grid-column [header]=\"'Concepto'\" [binding]=\"'conceptoText'\" [width]=\"'15*'\"></wj-flex-grid-column>\n                      <wj-flex-grid-column [header]=\"'Nota'\" [binding]=\"'notas'\" [width]=\"'15*'\"></wj-flex-grid-column>\n                      <wj-flex-grid-column [header]=\"'Cargo'\" [binding]=\"'cargo'\" [width]=\"'9*'\" format=\"c\"></wj-flex-grid-column>\n                      <wj-flex-grid-column [header]=\"'Abono'\" [binding]=\"'abono'\" [width]=\"'9*'\" format=\"c\"></wj-flex-grid-column>\n                      <wj-flex-grid-column [header]=\"'Referencia'\" [binding]=\"'referencia'\" [width]=\"'9*'\"></wj-flex-grid-column>\n                      <wj-flex-grid-column [header]=\"'Segmento'\" [binding]=\"'segmentoNegocioText'\" [width]=\"'9*'\"></wj-flex-grid-column>\n\n                  </wj-flex-grid>\n\n              </div> <!--COL GRID-->\n          </div><!--ROW-->\n\n      </form>\n    "
        }),
        __metadata("design:paramtypes", [core_2.Context, router_1.Router, router_1.ActivatedRoute, forms_1.FormBuilder,
            poliza_service_1.PolizaService])
    ], PolizasByLoteEditor);
    return PolizasByLoteEditor;
}(core_2.ProcessComponent));
exports.PolizasByLoteEditor = PolizasByLoteEditor;
