"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
//Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//Locales
var controls_1 = require("framework3/controls");
var poliza_detail_1 = require("../../models/poliza-detail");
var segmento_negocio_service_1 = require("../../services/segmento-negocio.service");
var PolizaDetailEditor = /** @class */ (function (_super) {
    __extends(PolizaDetailEditor, _super);
    function PolizaDetailEditor(context, builder, segmentoNegocioService) {
        var _this = _super.call(this, context) || this;
        _this.context = context;
        _this.builder = builder;
        _this.segmentoNegocioService = segmentoNegocioService;
        //Copia temporal que se utilizará para edición y no afecte al objeto original por si el usuario decide cancelar la edición
        _this.detailCopy = new poliza_detail_1.PolizaDetail();
        //Objeto original que se editará
        _this.detail = new poliza_detail_1.PolizaDetail();
        _this.afectadores = [];
        _this.segmentos = [];
        _this.form = builder.group({
            'cuenta': ['', forms_1.Validators.required],
            'afectador': ['', forms_1.Validators.required],
            'importe': ['', forms_1.Validators.required],
            'segmento': [''],
        });
        _this.afectadores =
            [
                { "id": "C", "nombre": "Cargo" },
                { "id": "A", "nombre": "Abono" }
            ];
        return _this;
    }
    /////////////////// METODOS ///////////////////////////////
    /////////////////// HANDLERS //////////////////////////////
    PolizaDetailEditor.prototype.ngOnInit = function () {
        //this.loadEjercicioActual();
        this.loadSegmentos();
    };
    PolizaDetailEditor.prototype.onCreatingItem = function () {
        this.form.reset({
            'cuenta': [0],
            'importe': [0],
            'segmento': [0],
        });
        this.form.markAsPristine();
        this.detailCopy = this.detail;
    };
    PolizaDetailEditor.prototype.onLoadingItem = function (detail) {
        this.detailCopy = this.copyItem(this.detail);
    };
    PolizaDetailEditor.prototype.onUpdatingItem = function (detail) {
        if (this.detailCopy._clientID == 0) {
            this.detailCopy._clientID = this.createClientID();
        }
        else {
            this.detailCopy.state = editors_1.ChangeState.MODIFIED;
        }
        this.savingItem.emit(this.detailCopy);
    };
    PolizaDetailEditor.prototype.selectedCuenta = function (cuenta) {
        if (cuenta != undefined) {
            this.detailCopy.cuentaText = cuenta.code;
            this.detailCopy.conceptoText = cuenta.nombre;
        }
    };
    PolizaDetailEditor.prototype.selectedAfectador = function (afectador) {
        if (afectador != undefined) {
            if (afectador == 'C')
                this.detailCopy.afectadorText = "Cargo";
            else
                this.detailCopy.afectadorText = "Abono";
        }
    };
    PolizaDetailEditor.prototype.selectedSegmento = function (segmento) {
        if (segmento != undefined) {
            this.detailCopy.segmentoNegocioText = this.cboSegmento.selectedItem.nombre;
        }
    };
    PolizaDetailEditor.prototype.loadSegmentos = function () {
        var _this = this;
        this.segmentoNegocioService.loadList(this.context.app.defaultCompany.identity)
            .then(function (segmentos) { return _this.segmentos = segmentos; })
            .catch(function (error) { return console.error = error; });
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", poliza_detail_1.PolizaDetail)
    ], PolizaDetailEditor.prototype, "detail", void 0);
    __decorate([
        core_1.ViewChild('cboSegmento'),
        __metadata("design:type", controls_1.AzComboboxComponent)
    ], PolizaDetailEditor.prototype, "cboSegmento", void 0);
    PolizaDetailEditor = __decorate([
        core_1.Component({
            selector: 'contabilidad-poliza-detail-editor',
            template: "\n      <form [formGroup]=\"form\">\n          <azteca-basic-editor [item]=\"detail\"\n                               [dirty]=\"dirty\"\n                               [valid]=\"valid\"\n                               (creatingItem)=\"onCreatingItem()\"\n                               (loadingItem)=\"onLoadingItem($event)\"\n                               (updatingItem)=\"onUpdatingItem($event)\">\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <azteca-form-field [label]=\"'Cuenta:'\">\n                          <accounting-cuenta-selector formControlName=\"cuenta\" [(ngModel)]=\"detailCopy.idCuenta\" (selectedItemChanged)=\"selectedCuenta($event)\"></accounting-cuenta-selector>\n                      </azteca-form-field>\n                  </div>\n              </div>\n\n              <div class=\"row\">\n                  <div class=\"col-8 col-md-5\">\n                      <azteca-form-field [label]=\"'Afectador:'\">\n                          <az-combobox formControlName=\"afectador\"\n                                       [(ngModel)]=\"detailCopy.afectador\"\n                                       (selectedItemChanged)=\"selectedAfectador($event)\"\n                                       [items]=\"afectadores\"\n                                       [displayMember]=\"'nombre'\"\n                                       [valueMember]=\"'id'\">\n                          </az-combobox>\n                      </azteca-form-field>\n                  </div>\n                  <div class=\"col-8 col-md-5\">\n                      <azteca-form-field [label]=\"'Importe:'\">\n                          <az-input-number formControlName=\"importe\" [(ngModel)]=\"detailCopy.importe\" format=\"N2\"></az-input-number>\n                      </azteca-form-field>\n                  </div>\n              </div>\n\n              <div class=\"row\">\n                  <div class=\"col-8 col-md-5\">\n                      <azteca-form-field [label]=\"'Segmento de Negocio:'\">\n                          <az-combobox #cboSegmento\n                                       formControlName=\"segmento\"\n                                       [(ngModel)]=\"detailCopy.idSegmentoNegocio\"\n                                       (selectedItemChanged)=\"selectedSegmento($event)\"\n                                       [items]=\"segmentos\"\n                                       [displayMember]=\"'nombre'\"\n                                       [valueMember]=\"'id'\">\n                          </az-combobox>\n                      </azteca-form-field>\n                  </div>\n              </div>\n\n          </azteca-basic-editor>\n      </form>\n    "
        }),
        __metadata("design:paramtypes", [core_2.Context, forms_1.FormBuilder, segmento_negocio_service_1.SegmentoNegocioService])
    ], PolizaDetailEditor);
    return PolizaDetailEditor;
}(editors_1.BasicEditor));
exports.PolizaDetailEditor = PolizaDetailEditor;
