"use strict";
//Frameworks
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var forms_1 = require("@angular/forms");
//Bootstrap
//Features
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var wijmo_1 = require("wijmo/wijmo");
var ngx_bootstrap_1 = require("ngx-bootstrap");
//Azteca Kernel
var controls_1 = require("framework3/controls");
var core_2 = require("framework3/core");
//
var poliza_service_1 = require("../../services/poliza.service");
var poliza_log_entry_1 = require("../../models/poliza-log-entry");
var PolizasLogComponent = /** @class */ (function () {
    function PolizasLogComponent(formBuilder, context, router, route, polizaService) {
        this.formBuilder = formBuilder;
        this.context = context;
        this.router = router;
        this.route = route;
        this.polizaService = polizaService;
        this.logCollection = new wijmo_1.CollectionView();
        this.currentEntry = new poliza_log_entry_1.PolizaLogEntry();
        this.editorForm = formBuilder.group({
            'idInsumo': [0],
        });
    }
    /////////////////////// METODOS ////////////////////////////////////////////////
    PolizasLogComponent.prototype.loadLog = function () {
        var _this = this;
        this.context.app.showSpinner();
        this.polizaService.loadLog(this.id)
            .then(function (log) {
            _this.logCollection.sourceCollection = log;
            _this.context.app.hideSpinner();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    /////////////////////// HANDLERS ///////////////////////////////////////////////
    PolizasLogComponent.prototype.mainToolbarClick = function (button) {
        if (button.name == 'REFRESH') {
            this.loadLog();
        }
    };
    PolizasLogComponent.prototype.onRowView = function (entry) {
        this.currentEntry = entry;
        this.detailsDialog.config.backdrop = false;
        this.detailsDialog.show();
    };
    PolizasLogComponent.prototype.handleError = function (error) {
        console.error(error);
        this.context.app.hideSpinner();
        var message = this.context.getExceptionMessage(error);
        this.alerts.showAlert(message, 'danger');
    };
    PolizasLogComponent.prototype.show = function (id) {
        this.logCollection = new wijmo_1.CollectionView();
        this.polizaLogDialog.config.backdrop = false;
        this.id = id;
        this.polizaLogDialog.show();
        this.loadLog();
    };
    __decorate([
        core_1.ViewChild(controls_1.AlertsBarComponent),
        __metadata("design:type", controls_1.AlertsBarComponent)
    ], PolizasLogComponent.prototype, "alerts", void 0);
    __decorate([
        core_1.ViewChild('detailsDialog'),
        __metadata("design:type", ngx_bootstrap_1.ModalDirective)
    ], PolizasLogComponent.prototype, "detailsDialog", void 0);
    __decorate([
        core_1.ViewChild('polizaLog'),
        __metadata("design:type", ngx_bootstrap_1.ModalDirective)
    ], PolizasLogComponent.prototype, "polizaLogDialog", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], PolizasLogComponent.prototype, "id", void 0);
    PolizasLogComponent = __decorate([
        core_1.Component({
            selector: 'accounting-polizas-log-component',
            template: "\n\n      <div bsModal #polizaLog=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"myLargeModalLabel\" aria-hidden=\"true\">\n          <div class=\"modal-dialog modal-lg\">\n              <div class=\"modal-content\">\n                  <div class=\"modal-body\">\n\n                      <form [formGroup]=\"editorForm\">\n\n                          <div class=\"row\">\n                              <div class=\"col-12\">\n                                  <alerts-bar></alerts-bar>\n                              </div>\n                          </div>\n                    \n                          <div class=\"row\">\n\n                              <div class=\"col-12\">\n                                  <az-panel [header]=\"'Registros'\">\n\n                                      <wj-flex-grid style=\"height:550px\" [itemsSource]=\"logCollection\" [isReadOnly]=\"true\">\n\n                                          <wj-flex-grid-filter #filter></wj-flex-grid-filter>\n\n                                          <wj-flex-grid-column [header]=\"''\" [width]=\"60\" [isReadOnly]=\"true\">\n                                              <ng-template wjFlexGridCellTemplate [cellType]=\"'Cell'\" let-cell=\"cell\">\n                                                  <button type=\"button\" class=\"btn btn-default\" (click)=\"onRowView(cell.item)\">\n                                                      <span class=\"glyphicon glyphicon-search\"></span>\n                                                  </button>\n                                              </ng-template>\n                                          </wj-flex-grid-column>\n\n                                          <wj-flex-grid-column [header]=\"'Fecha'\" [binding]=\"'time'\" [width]=\"200\" [format]=\"'dd/MM/yyyy hh:mm tt'\"></wj-flex-grid-column>\n                                          <wj-flex-grid-column [header]=\"'Mensaje'\" [binding]=\"'message'\" [width]=\"'50*'\"></wj-flex-grid-column>\n                                          <!--<wj-flex-grid-column [header]=\"'Origen'\" [binding]=\"'source'\" [width]=\"'15*'\"></wj-flex-grid-column>\n                                          <wj-flex-grid-column [header]=\"'Tipo'\" [binding]=\"'type'\" [width]=\"'15*'\"></wj-flex-grid-column>-->\n                                      </wj-flex-grid>\n\n                                      <div class=\"row\">\n                                          <button type=\"button\" class=\"btn btn-primary\" (click)=\"polizaLog.hide()\">Cerrar</button>                                    \n                                      </div>\n\n                                  </az-panel>\n\n                              </div> <!--Modal Body-->\n                        \n                          </div>\n\n                      </form>\n\n\n                      <div bsModal #detailsDialog=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"myLargeModalLabel\" aria-hidden=\"true\">\n                          <div class=\"modal-dialog modal-lg\">\n                              <div class=\"modal-content\">\n                                  <div class=\"modal-header\">\n                                      <h4 class=\"modal-title\">Detalles del error</h4>\n                                      <button type=\"button\" class=\"close pull-right\" (click)=\"detailsDialog.hide()\" aria-label=\"Close\">\n                                          <span aria-hidden=\"true\">&times;</span>\n                                      </button>\n                                  </div>\n                                  <div class=\"modal-body\">\n                                      <textarea readonly style=\"height: 500px;\" class=\"form-control\" [value]=\"currentEntry.message\"></textarea>\n                                  </div> <!--Modal Body-->\n                                  <div class=\"modal-footer\">\n                                      <button type=\"button\" class=\"btn btn-primary\" (click)=\"detailsDialog.hide()\">Cerrar</button>\n                                  </div> <!--Modal Footer-->\n\n                              </div> <!-- Modal Content-->\n                          </div> <!--Modal-->\n                      </div> <!--Modal directive-->\n           \n                  </div>\n              </div> <!-- Modal Content-->\n          </div> <!--Modal-->\n      </div> <!--Modal directive-->\n\n           \n    "
        }),
        __metadata("design:paramtypes", [forms_1.FormBuilder, core_2.Context, router_1.Router, router_1.ActivatedRoute,
            poliza_service_1.PolizaService])
    ], PolizasLogComponent);
    return PolizasLogComponent;
}());
exports.PolizasLogComponent = PolizasLogComponent;
