import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { Context, DocumentItem, DocumentTypeService, DocumentTypeInfo } from 'framework3/core';
import { DocumentEditor, EditorEventArgs, WorkflowEventArgs } from 'framework3/editors';
import { PeriodoInfo } from '../models/periodo';
import { PeriodoService } from '../services/periodo.service';
import { EjercicioService } from '../services/ejercicio.service';
import { EjercicioInfo } from '../models/ejercicio';
export declare class PeriodosEditor extends DocumentEditor {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    private location;
    private formBuilder;
    protected documentTypeService: DocumentTypeService;
    private periodoService;
    private ejercicioService;
    periodo: PeriodoInfo;
    ejercicio: EjercicioInfo;
    meses: {
        id: number;
        nombre: string;
    }[];
    constructor(context: Context, router: Router, route: ActivatedRoute, location: Location, formBuilder: FormBuilder, documentTypeService: DocumentTypeService, periodoService: PeriodoService, ejercicioService: EjercicioService);
    onConfigureDocument(docType: DocumentTypeInfo): void;
    onCreatingDocument(): void;
    ngOnInit(): void;
    onCancelingEdit(): void;
    onViewingDocument(id: string): void;
    onCloningDocument(id: string): void;
    onLoadingDocument(id: string): void;
    onSavingDocument(args: EditorEventArgs): void;
    onApplyingNextStep(args: WorkflowEventArgs): void;
    onApplyingPreviousStep(document: DocumentItem): void;
    onTabSelected(args: any): void;
}
