"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Wijmo
var wijmo_1 = require("wijmo/wijmo");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//Locales
var periodo_1 = require("../models/periodo");
var periodo_service_1 = require("../services/periodo.service");
var ejercicio_service_1 = require("../services/ejercicio.service");
var ejercicio_1 = require("../models/ejercicio");
var moment = require("moment");
var PeriodosEditor = /** @class */ (function (_super) {
    __extends(PeriodosEditor, _super);
    function PeriodosEditor(context, router, route, location, formBuilder, documentTypeService, periodoService, ejercicioService) {
        var _this = _super.call(this, context, router, route, documentTypeService) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.location = location;
        _this.formBuilder = formBuilder;
        _this.documentTypeService = documentTypeService;
        _this.periodoService = periodoService;
        _this.ejercicioService = ejercicioService;
        _this.periodo = new periodo_1.PeriodoInfo();
        _this.ejercicio = new ejercicio_1.EjercicioInfo();
        _this.meses = [
            { "id": 1, "nombre": "Enero" },
            { "id": 2, "nombre": "Febrero" },
            { "id": 3, "nombre": "Marzo" },
            { "id": 4, "nombre": "Abril" },
            { "id": 5, "nombre": "Mayo" },
            { "id": 6, "nombre": "Junio" },
            { "id": 7, "nombre": "Julio" },
            { "id": 8, "nombre": "Agosto" },
            { "id": 9, "nombre": "Septiembre" },
            { "id": 10, "nombre": "Octubre" },
            { "id": 11, "nombre": "Noviembre" },
            { "id": 12, "nombre": "Diciembre" }
        ];
        _this.documentForm = formBuilder.group({
            'meses': ['', forms_1.Validators.required],
            'fechaIni': ['', forms_1.Validators.required],
            'fechaFin': ['', forms_1.Validators.required]
        });
        return _this;
    }
    PeriodosEditor_1 = PeriodosEditor;
    PeriodosEditor.prototype.onConfigureDocument = function (docType) {
        this.applyPolicies();
    };
    PeriodosEditor.prototype.onCreatingDocument = function () {
    };
    PeriodosEditor.prototype.ngOnInit = function () {
        var _this = this;
        this.route.params.forEach(function (params) {
            _this.ejercicioService.getDetail(params['idEjercicio'])
                .then(function (x) {
                _this.ejercicio = x;
                _this.ejercicio.fechaIni = moment(_this.ejercicio.fechaIni).toDate();
                _this.ejercicio.fechaFin = moment(_this.ejercicio.fechaFin).toDate();
                _this.periodo.idEjercicio = x.identity;
                _this.periodo.fechaEjercicio = x.fechaSys;
            })
                .catch(function (error) { return _this.handleError(error); });
        });
    };
    PeriodosEditor.prototype.onCancelingEdit = function () {
        this.router.navigate(['accounting/ejercicios/' + this.process.id + '/' + this.ejercicio.identity]);
    };
    PeriodosEditor.prototype.onViewingDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.periodoService.getDetail(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.periodo = doc;
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    PeriodosEditor.prototype.onCloningDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.periodoService.clone(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.periodo = doc;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    PeriodosEditor.prototype.onLoadingDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.periodoService.getDetail(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.periodo = doc;
            if (_this.periodo.status != core_2.DocumentStatus.DRAFT)
                _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    PeriodosEditor.prototype.onSavingDocument = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        if (this.periodo.fechaIni >= this.ejercicio.fechaIni && this.periodo.fechaIni < this.ejercicio.fechaFin && this.periodo.fechaFin > this.ejercicio.fechaIni && this.periodo.fechaFin <= this.ejercicio.fechaFin) {
            this.periodoService.update(this.periodo)
                .then(function (updatedDoc) {
                _this.context.app.hideSpinner();
                //Si es un elemento nuevo y no se cerrará el editor, navegar a nueva ruta
                _this.reset();
                if (!args.closeEditor && _this.periodo.identity == '') {
                    _this.router.navigate(['../', updatedDoc.identity], { relativeTo: _this.route });
                }
                else {
                    if (args.closeEditor)
                        _this.router.navigate(['../'], { relativeTo: _this.route });
                    else
                        _this.showAlert('La información ha sido actualizada con éxito', 'success');
                }
                _this.periodo = updatedDoc;
            })
                .catch(function (error) { return _this.handleError(error); });
        }
        else {
            this.context.app.hideSpinner();
            this.showAlert('Las fechas deben de estar entre el rango de fechas del ejercicio', 'warning');
        }
    };
    PeriodosEditor.prototype.onApplyingNextStep = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.periodoService.nextStep(args.document.id, args.step.idWorkflowStep, null)
            .then(function (_) {
            //Volver a cargar documento
            _this.onViewingDocument(args.document.id);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    PeriodosEditor.prototype.onApplyingPreviousStep = function (document) {
        var _this = this;
        this.context.app.showSpinner();
        this.periodoService.previousStep(document.id, null)
            .then(function (_) {
            //Volver a cargar documento
            _this.onViewingDocument(document.id);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    PeriodosEditor.prototype.onTabSelected = function (args) {
        if (args.heading) {
            //Al seleccionar la pestaña de historial, realizar carga de información
            if (args.heading == 'Historial') {
                this.loadHistory(this.periodo.identity);
            }
            //Actualizar controles de wijmo
            wijmo_1.Control.invalidateAll();
        }
    };
    PeriodosEditor = PeriodosEditor_1 = __decorate([
        core_1.Component({
            selector: 'contabilidad-periodos-editor',
            template: "\n      <form [formGroup]=\"documentForm\">\n          <azteca-document-editor #documentEditor\n                                         [title]=\"'Periodos'\"\n                                         [document]=\"periodo\"\n                                         [valid]=\"valid\"\n                                         (configureDocument)=\"onConfigureDocument($event)\"\n                                         (creatingDocument)=\"onCreatingDocument()\"\n                                         (viewingDocument)=\"onViewingDocument($event)\"\n                                         (cloningDocument)=\"onCloningDocument($event)\"\n                                         (savingDocument)=\"onSavingDocument($event)\"\n                                         (loadingDocument)=\"onLoadingDocument($event)\"\n                                         (applyingNextStep)=\"onApplyingNextStep($event)\"\n                                         (menuItemClick)=\"onMenuItemClick($event)\">\n\n              <!------------------- Menu de acciones adicionales --------------------->\n\n              <!------------------- Controles del editor ----------------------------->\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <tabset>\n                          <tab heading=\"Generales\" (select)=\"onTabSelected($event)\">\n                              <div class=\"row\">\n                                  <div class=\"col-6\">\n                                      <azteca-form-field [label]=\"'Mes:'\">\n                                          <az-combobox formControlName=\"meses\"\n                                                       [(ngModel)]=\"periodo.idMes\"\n                                                       [items]=\"meses\"\n                                                       [valueMember]=\"'id'\"\n                                                       [displayMember]=\"'nombre'\">\n\n                                          </az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-6\">\n                                      <label class=\"control-label\">Fecha Inicial:</label>\n                                      <az-input-date formControlName=\"fechaIni\" [(ngModel)]=\"periodo.fechaIni\"></az-input-date>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-6\">\n                                      <label class=\"control-label\">Fecha Final:</label>\n                                      <az-input-date formControlName=\"fechaFin\" [(ngModel)]=\"periodo.fechaFin\"></az-input-date>\n                                  </div>\n                              </div>\n\n                          </tab>\n\n                          <tab heading=\"Historial\" (select)=\"onTabSelected($event)\" [disabled]=\"periodo.identity==''\">\n                              <document-history [history]=\"history\"></document-history>\n                          </tab>\n                      </tabset>\n\n                  </div>\n              </div>\n          </azteca-document-editor>\n      </form>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return PeriodosEditor_1; })
                },
                {
                    provide: core_2.DocumentService, useExisting: periodo_service_1.PeriodoService
                }
            ]
        }),
        __metadata("design:paramtypes", [core_2.Context,
            router_1.Router,
            router_1.ActivatedRoute,
            common_1.Location,
            forms_1.FormBuilder,
            core_2.DocumentTypeService,
            periodo_service_1.PeriodoService,
            ejercicio_service_1.EjercicioService])
    ], PeriodosEditor);
    return PeriodosEditor;
    var PeriodosEditor_1;
}(editors_1.DocumentEditor));
exports.PeriodosEditor = PeriodosEditor;
