import { Router, ActivatedRoute } from '@angular/router';
import { Context, DocumentItem } from 'framework3/core';
import { DocumentManager, WorkflowEventArgs } from 'framework3/editors';
import { SearchRequest } from 'framework3/search';
import { PeriodoItem } from '../models/periodo';
import { PeriodoService } from '../services/periodo.service';
export declare class PeriodosManager extends DocumentManager {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    private periodoService;
    idEjercicio: string;
    fechaEjercicio: Date;
    fechaIni: Date;
    fechaFin: Date;
    periodos: PeriodoItem[];
    constructor(context: Context, router: Router, route: ActivatedRoute, periodoService: PeriodoService);
    onConfigureDocument(): void;
    ngOnInit(): void;
    onSearchRequested(request: SearchRequest): void;
    onAddingItem(): void;
    onViewingItem(document: DocumentItem): void;
    onEditingItem(document: DocumentItem): void;
    onDeletingItem(document: DocumentItem): void;
    onCloningItem(document: DocumentItem): void;
    onApplyingNextStep(args: WorkflowEventArgs): void;
    onApplyingPreviousStep(document: DocumentItem): void;
}
