import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { Context, DocumentItem, DocumentTypeService, DocumentTypeInfo } from 'framework3/core';
import { MenuItem } from 'framework3/controls';
import { DocumentEditor, EditableListComponent, EditorEventArgs, WorkflowEventArgs } from 'framework3/editors';
import { PolizaInfo } from '../models/poliza';
import { PolizaDetail } from '../models/poliza-detail';
import { PolizaService } from '../services/poliza.service';
import { PolizaDetailEditor } from './parts/polizas-detail.editor';
import { DivisaItem } from '../models/divisa';
import { DivisaService } from '../services/divisa.service';
import { PolizasAsociacionesComponent } from './parts/polizas-asociaciones.component';
export declare class PolizasEditor extends DocumentEditor {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    private location;
    private formBuilder;
    protected documentTypeService: DocumentTypeService;
    private polizaService;
    private divisaService;
    poliza: PolizaInfo;
    cargos: number;
    abonos: number;
    detailsList: EditableListComponent;
    detailsEditor: PolizaDetailEditor;
    dlgAsociaciones: PolizasAsociacionesComponent;
    divisas: DivisaItem[];
    constructor(context: Context, router: Router, route: ActivatedRoute, location: Location, formBuilder: FormBuilder, documentTypeService: DocumentTypeService, polizaService: PolizaService, divisaService: DivisaService);
    onConfigureDocument(docType: DocumentTypeInfo): void;
    onCreatingDocument(): void;
    onViewingDocument(id: string): void;
    onCloningDocument(id: string): void;
    onLoadingDocument(id: string): void;
    onSavingDocument(args: EditorEventArgs): void;
    onApplyingNextStep(args: WorkflowEventArgs): void;
    onApplyingPreviousStep(document: DocumentItem): void;
    onTabSelected(args: any): void;
    onAddingDetail(): void;
    onEditingDetail(detail: PolizaDetail): void;
    onDeletingDetail(detail: PolizaDetail): void;
    onListItemsUpdated(updatedDetails: PolizaDetail[]): void;
    onSavingDetail(detail: PolizaDetail): void;
    loadDivisas(): void;
    sumarizacion(): void;
    onMenuItemClick(item: MenuItem): void;
}
