"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var router_1 = require("@angular/router");
var ngx_bootstrap_1 = require("ngx-bootstrap");
var moment = require("moment");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
var file_1 = require("framework3/general/models/file");
//Features
var comprobante_service_1 = require("../services/comprobante.service");
var ComprobanteMaintenance = /** @class */ (function (_super) {
    __extends(ComprobanteMaintenance, _super);
    function ComprobanteMaintenance(router, route, context, comprobanteService, formBuilder) {
        var _this = _super.call(this, context, router, route) || this;
        _this.router = router;
        _this.route = route;
        _this.context = context;
        _this.comprobanteService = comprobanteService;
        _this.formBuilder = formBuilder;
        _this.companias = [{ id: '01', nombre: 'Embotelladora AGA' }, { id: '02', nombre: 'POLI' }, { id: '03', nombre: 'PET' }, { id: '04', nombre: 'CONCENTRADOS' }, { id: '05', nombre: 'LOMAS' }, { id: '06', nombre: 'VARIOS' }];
        _this.compania = "01";
        _this.fechaInicial = new Date();
        _this.fechaFinal = new Date();
        _this.tienePoliza = false;
        _this.noTienePoliza = false;
        _this.existeSiSatNoPixcua = false;
        _this.existeNoSatSiPixcua = false;
        _this.cancSiSatNoPixcua = false;
        _this.cancNoSatSiPixcua = false;
        _this.docEmitido = false;
        _this.docRecibido = false;
        _this.comprobantes = new Array();
        _this.selectedFile = new file_1.FileInfo();
        _this.search = null;
        _this.cancelado = false;
        _this.comparativo = null;
        _this.timerInterval = null;
        _this.form = formBuilder.group({
            'cboCompania': [],
            'fechaInicial': [new Date()],
            'fechaFinal': [new Date()],
            'flbComprobante': ['', forms_1.Validators.required],
            'chkCancelado': [false],
            'chkTitnePoliza': [false],
            'chkNoTitnePoliza': [false],
            'chkExisteSiSatNoPixcua': [false],
            'chkExisteNoSatSiPixcua': [false],
            'chkCanSiSatNoPixcua': [false],
            'chkCanNoSatSiPixcua': [false],
            'chkDocEmitido': [false],
            'chkDocRecibido': [false]
        });
        return _this;
    }
    ComprobanteMaintenance_1 = ComprobanteMaintenance;
    ///////////////////////// METODOS ///////////////////////////////////////
    ///////////////////////// HANDLERS ///////////////////////////////////////
    ComprobanteMaintenance.prototype.onConfigureCatalog = function (options) {
        this.manager.serverSide = options.busquedasServidor;
        this.manager.pageSize = 100;
        this.manager.allowNew = false;
        this.manager.allowView = true;
        this.manager.allowEdit = false;
        this.manager.allowDelete = false;
        this.manager.allowClone = false;
        this.manager.allowChangeState = false;
        this.manager.allowAudit = false;
        this.refreshList();
    };
    ComprobanteMaintenance.prototype.doSearch = function (request) {
        var _this = this;
        this.search = request;
        this.context.app.showSpinner();
        this.comprobanteService.search(this.compania, moment(this.fechaInicial).format(), moment(this.fechaFinal).format(), this.tienePoliza, this.noTienePoliza, this.existeSiSatNoPixcua, this.existeNoSatSiPixcua, this.cancSiSatNoPixcua, this.cancNoSatSiPixcua, this.docEmitido, this.docRecibido, this.context.app.defaultSite.identity, request)
            .then(function (response) {
            _this.context.app.hideSpinner();
            response.rows.forEach(function (r) {
                r['comFechaFactura'] = moment(r['comFechaFactura']).toDate();
                r['activo'] = r['activo'] == '1';
            });
            _this.comprobantes = response.rows;
            _this.totalRows = response.totalRows;
            _this.pageIndex = request.pageIndex;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ComprobanteMaintenance.prototype.onAddingItem = function () {
        this.addComprobanteDialog.config.backdrop = false;
        this.addComprobanteDialog.show();
    };
    ComprobanteMaintenance.prototype.onViewingItem = function (item) {
    };
    ComprobanteMaintenance.prototype.onEditingItem = function (item) {
    };
    ComprobanteMaintenance.prototype.onDeletingItem = function (item) {
    };
    ComprobanteMaintenance.prototype.onCloningItem = function (item) {
    };
    ComprobanteMaintenance.prototype.onChangingItemState = function (item) {
    };
    ComprobanteMaintenance.prototype.onFilterGroupChanged = function (group) {
    };
    ComprobanteMaintenance.prototype.hideAddComprobanteDialog = function () {
        this.addComprobanteDialog.hide();
    };
    ComprobanteMaintenance.prototype.addComprobante = function () {
        var _this = this;
        this.context.app.showSpinner();
        this.comprobanteService.uploadComprobante(this.cancelado, this.selectedFile)
            .then(function (info) {
            _this.context.app.hideSpinner();
        })
            .catch(function (error) { return _this.handleError(error); });
        this.addComprobanteDialog.hide();
    };
    ComprobanteMaintenance.prototype.onMenuItemClick = function (item) {
        var _this = this;
        if (item.name == 'PRINT') {
            this.context.app.showSpinner();
            this.comprobanteService.getComprobanteFiscalV32(this.manager.currentItem.data.comSerie, this.manager.currentItem.data.comFolio, moment(this.manager.currentItem.data.comFechaFactura).format(), this.manager.currentItem.data.uuid)
                .then(function (report) {
                window.open("data:application/pdf;base64, " + report);
                _this.context.app.hideSpinner();
            })
                .catch(function (error) { return _this.handleError(error); });
        }
        else if (item.name == 'DOWNLOAD-EXCEL') {
            this.context.app.showSpinner();
            this.comprobanteService.getComprativoComprobante(this.compania, moment(this.fechaInicial).format(), moment(this.fechaFinal).format(), this.tienePoliza, this.noTienePoliza, this.existeSiSatNoPixcua, this.existeNoSatSiPixcua, this.cancSiSatNoPixcua, this.cancNoSatSiPixcua, this.docEmitido, this.docRecibido, this.context.app.defaultSite.identity, this.search)
                .then(function (comparativo) {
                _this.comparativo = comparativo;
                if (_this.timerInterval != null)
                    clearInterval(_this.timerInterval);
                _this.timerInterval = setInterval(function () {
                    _this.verificarImportExcel();
                }, 3000);
            })
                .catch(function (error) { return _this.handleError(error); });
        }
        else if (item.name == 'DOWNLOAD-EXCEL') {
            this.context.app.showSpinner();
            this.comprobanteService.getComprativoComprobante(this.compania, moment(this.fechaInicial).format(), moment(this.fechaFinal).format(), this.tienePoliza, this.noTienePoliza, this.existeSiSatNoPixcua, this.existeNoSatSiPixcua, this.cancSiSatNoPixcua, this.cancNoSatSiPixcua, this.docEmitido, this.docRecibido, this.context.app.defaultSite.identity, this.search)
                .then(function (comparativo) {
                _this.comparativo = comparativo;
                if (_this.timerInterval != null)
                    clearInterval(_this.timerInterval);
                _this.timerInterval = setInterval(function () {
                    _this.verificarImportExcel();
                }, 3000);
            })
                .catch(function (error) { return _this.handleError(error); });
        }
    };
    ComprobanteMaintenance.prototype.verificarImportExcel = function () {
        var _this = this;
        this.context.app.showSpinner();
        this.comprobanteService.getProgramacionComparativo(this.comparativo.idProgramacion)
            .then(function (response) {
            if (response.idStatus == 2) {
                window.open(_this.context.fileServerPath + "/" + response.fileServer);
                clearInterval(_this.timerInterval);
                _this.context.app.hideSpinner();
            }
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ComprobanteMaintenance.prototype.createMenu = function () {
    };
    __decorate([
        core_1.ViewChild('addComprobanteDialog'),
        __metadata("design:type", ngx_bootstrap_1.ModalDirective)
    ], ComprobanteMaintenance.prototype, "addComprobanteDialog", void 0);
    ComprobanteMaintenance = ComprobanteMaintenance_1 = __decorate([
        core_1.Component({
            selector: 'comprobante-maintenance',
            template: "\n\n      <form [formGroup]=\"form\">\n\n          <div class=\"form-inline\">\n              <div class=\"form-group\">\n                  <label for=\"cboCompania\">Compa&ntilde;&iacute;a</label>\n                  <az-combobox id=\"cboCompania\" style=\"padding: .5rem .75rem;\" formControlName=\"cboCompania\" [(ngModel)]=\"compania\" [items]=\"companias\" [valueMember]=\"'id'\" [displayMember]=\"'nombre'\"></az-combobox>\n              </div>\n              <div class=\"form-group\">\n                  <label for=\"fechaInicial\">Fecha Ini</label>\n                  <az-input-date id=\"fechaInicial\" style=\"padding: .5rem .75rem;\" formControlName=\"fechaInicial\" [(ngModel)]=\"fechaInicial\"></az-input-date>\n              </div>\n              <div class=\"form-group\">\n                  <label for=\"fechaFinal\">Fecha Fin</label>\n                  <az-input-date id=\"fechaFinal\" style=\"padding: .5rem .75rem;\" formControlName=\"fechaFinal\"  [(ngModel)]=\"fechaFinal\"></az-input-date>\n              </div>\n          </div>\n    \n          <div class=\"form-inline\">\n              <div class=\"checkbox\" style=\"padding: .5rem .75rem;\">\n                  <label>\n                      <input formControlName=\"chkTitnePoliza\" type=\"checkbox\" [(ngModel)]=\"tienePoliza\"> Tiene P&oacute;liza\n                  </label>\n              </div>\n              <div class=\"checkbox\" style=\"padding: .5rem .75rem;\">\n                  <label>\n                      <input formControlName=\"chkNoTitnePoliza\" type=\"checkbox\" [(ngModel)]=\"noTienePoliza\"> No tiene P&oacute;liza\n                  </label>\n              </div>\n              <div class=\"checkbox\" style=\"padding: .5rem .75rem;\" [hidden]=\"!(compania == '01')\">\n                  <label>\n                      <input formControlName=\"chkExisteSiSatNoPixcua\" type=\"checkbox\" [(ngModel)]=\"existeSiSatNoPixcua\"> Exista (SI) SAT (NO) Pixcua\n                  </label>\n              </div>\n              <div class=\"checkbox\" style=\"padding: .5rem .75rem;\" [hidden]=\"!(compania == '01')\">\n                  <label>\n                      <input formControlName=\"chkExisteNoSatSiPixcua\" type=\"checkbox\" [(ngModel)]=\"existeNoSatSiPixcua\"> Exista (NO) SAT (SI) Pixcua\n                  </label>\n              </div>\n              <div class=\"checkbox\" style=\"padding: .5rem .75rem;\" [hidden]=\"!(compania == '01')\">\n                  <label>\n                      <input formControlName=\"chkCanSiSatNoPixcua\" type=\"checkbox\" [(ngModel)]=\"cancSiSatNoPixcua\"> Cancelado (SI) SAT (NO) Pixcua\n                  </label>\n              </div>\n              <div class=\"checkbox\" style=\"padding: .5rem .75rem;\" [hidden]=\"!(compania == '01')\">\n                  <label>\n                      <input formControlName=\"chkCanNoSatSiPixcua\" type=\"checkbox\" [(ngModel)]=\"cancNoSatSiPixcua\"> Activo (NO) SAT (SI) Pixcua\n                  </label>\n              </div>\n              <div class=\"checkbox\" style=\"padding: .5rem .75rem;\">\n                  <label>\n                      <input formControlName=\"chkDocEmitido\" type=\"checkbox\" [(ngModel)]=\"docEmitido\"> Emitidos\n                  </label>\n              </div>\n              <div class=\"checkbox\" style=\"padding: .5rem .75rem;\">\n                  <label>\n                      <input formControlName=\"chkDocRecibido\" type=\"checkbox\" [(ngModel)]=\"docRecibido\"> Recibidos\n                  </label>\n              </div>\n          </div>\n\n          <div class=\"container-fluid\">\n              <azteca-catalog-manager (searchRequested)=\"doSearch($event)\"\n                                      (addingItem)=\"onAddingItem()\"\n                                      (viewingItem)=\"onViewingItem($event)\"\n                                      (editingItem)=\"onEditingItem($event)\"\n                                      (deletingItem)=\"onDeletingItem($event)\"\n                                      (cloningItem)=\"onCloningItem($event)\"\n                                      (changingItemState)=\"onChangingItemState($event)\"\n                                      (configureCatalog)=\"onConfigureCatalog($event)\"\n                                      (menuItemClick)=\"onMenuItemClick($event)\"\n                                      [enabled]=\"true\"\n                                      [allowNew]=\"false\"\n                                      [allowView]=\"false\"\n                                      [allowEdit]=\"false\"\n                                      [allowDelete]=\"false\"\n                                      [allowClone]=\"false\"\n                                      [allowChangeState]=\"false\"\n                                      [catalogList]=\"comprobantes\"\n                                      [totalRows]=\"totalRows\"\n                                      [pageIndex]=\"pageIndex\"\n                                      [pageSize]=\"100\"\n                                      [standAlone]=\"false\">\n\n                  <azteca-grid-column [header]=\"'Fecha'\" [binding]=\"'comFechaFactura'\" [format]=\"'dd-MM-yyyy'\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Emisor'\" [binding]=\"'comEmisor'\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Receptor'\" [binding]=\"'comReceptor'\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Folio Fiscal'\" [binding]=\"'comUUID'\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Subtotal'\" [binding]=\"'comSubTotal'\" [format]=\"'n2'\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Descuento'\" [binding]=\"'comDescuento'\" [format]=\"'n2'\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Total'\" [binding]=\"'comTotal'\" [format]=\"'n2'\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Compa\u00F1\u00EDa'\" [binding]=\"'compania'\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Poliza'\" [binding]=\"'tienePoliza'\" dataType=\"Boolean\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'SAT'\" [binding]=\"'existeSAT'\" dataType=\"Boolean\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Pixcua'\" [binding]=\"'existePixcua'\" dataType=\"Boolean\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Cancelada SAT'\" [binding]=\"'cancelado'\" dataType=\"Boolean\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Cancelada Pixcua'\" [binding]=\"'activo'\" dataType=\"Boolean\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Estado'\" [binding]=\"'estado'\"></azteca-grid-column>\n\n                  <!------------------- Menu de acciones adicionales --------------------->\n                  <azteca-menu-item [name]=\"'PRINT'\" [icon]=\"'glyphicon glyphicon-modal-window'\" [text]=\"'Visualizar'\" [smallText]=\"'Ver'\"></azteca-menu-item>\n                  <azteca-menu-item [name]=\"'DOWNLOAD-EXCEL'\" [icon]=\"'glyphicon glyphicon-modal-window'\" [text]=\"'Excel'\" [smallText]=\"'Descargar a excel'\"></azteca-menu-item>\n              </azteca-catalog-manager>\n          </div>\n\n\n          <!--DIALOGO DE CARGA DE COMPROBANTES-->\n          <div bsModal #addComprobanteDialog=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-hidden=\"true\">\n              <div class=\"modal-dialog\">\n                  <div class=\"modal-content\">\n                      <div class=\"modal-body\">\n                          <div>Para cargar un nuevo comprobante seleccione un xml o un archivo zip con un conjunto de comprobantes</div>\n                          <azteca-form-field [label]=\"'Archivo:'\">\n                              <azteca-file-box formControlName=\"flbComprobante\" [(ngModel)]=\"selectedFile\"></azteca-file-box>\n                          </azteca-form-field>\n                          <input type=\"checkbox\" formControlName=\"chkCancelado\" [(ngModel)]=\"cancelado\"> Cancelado\n                      </div>\n                      <div class=\"modal-footer\">\n                          <button type=\"button\" class=\"btn btn-primary\" (click)=\"hideAddComprobanteDialog()\">Cancelar</button>\n                          <button type=\"button\" class=\"btn btn-default\" (click)=\"addComprobante()\">Aceptar</button>\n                      </div>\n                  </div>\n              </div>\n          </div>\n\n      </form>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return ComprobanteMaintenance_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: comprobante_service_1.ComprobanteService
                }
            ]
        }),
        __metadata("design:paramtypes", [router_1.Router, router_1.ActivatedRoute, core_2.Context, comprobante_service_1.ComprobanteService, forms_1.FormBuilder])
    ], ComprobanteMaintenance);
    return ComprobanteMaintenance;
    var ComprobanteMaintenance_1;
}(editors_1.CatalogManager));
exports.ComprobanteMaintenance = ComprobanteMaintenance;
