import { DocumentInfo, DocumentItem } from 'framework3/core';
import { ComprobanteFiscalDetail } from './comprobante-fiscal-detail';
import { DivisaInfo } from './divisa';
export declare class ComprobanteFiscalInfo extends DocumentInfo<ComprobanteFiscalDetail> {
    serie: string;
    idCFDSerie: number;
    folio: string;
    fecha: Date;
    idContribuyente: number;
    idDocumento: string;
    fechaDocumento: Date;
    archivo: string;
    emisor: EmisorInfo;
    receptor: ReceptorInfo;
    impuestos: ImpuestosInfo;
    comprobantesRelacionados: ComprobantesRelacionadosInfo;
    timbreFiscal: TimbreFiscalInfo;
    cadenaOriginal: string;
    cadenaOriginalTimbre: string;
    selloDigital: string;
    numeroCertificado: string;
    certificado: string;
    tipoComprobante: number;
    divisa: DivisaInfo;
    tipoCambio: number;
    subTotal: number;
    descuentos: number;
    total: number;
    credito: boolean;
    diasCredito: number;
    idAddenda: number;
    gLNBuyer: string;
    gLNSeller: string;
    gLNStore: string;
    sellerID: string;
    version: number;
    referencia: string;
    observaciones: string;
    cancelado: boolean;
    fechaCancelacion: Date;
    acuseCancelacion: string;
    idPAC: number;
    emitido: boolean;
    contenidoXML: string;
    errorTimbrado: string;
    uuid: string;
    impuestosLocales: ImpuestosLocalesInfo;
    constructor();
}
export declare class ComprobanteFiscalItem implements DocumentItem {
    id: string;
    fechaCreacion: Date;
    fechaTimbrado?: Date;
    fechaCancelacion?: Date;
    serie?: string;
    folio?: number;
    uud?: string;
    tipoComprobante?: string;
    rfcEmisor?: string;
    rfcReceptor?: string;
    correo?: string;
    idStatus: number;
    status: string;
    idWorkflowStep: number;
    workflowStep: string;
}
export declare class EmisorInfo {
    rfc: string;
    nombre: string;
    regimenFiscal: string;
    constructor();
}
export declare class ReceptorInfo {
    rfc: string;
    nombre: string;
    residenciaFiscal: string;
    numRegIdTrib: string;
    usoCFDI: string;
    constructor();
}
export declare class ImpuestosInfo {
    totalTraslados: number;
    totalRetenciones: number;
    constructor();
}
export declare class ComprobantesRelacionadosInfo {
    tipoRelacion: string;
    comprobantes: string[];
    constructor();
}
export declare class TimbreFiscalInfo {
    version: string;
    fecha: Date;
    uuid: string;
    rfcProvCertif: string;
    selloSAT: string;
    numeroCertificadoSAT: string;
    selloCFD: string;
    leyenda: string;
}
export declare class ImpuestosLocalesInfo {
    totalTraslados: number;
    totalRetenciones: number;
}
