"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var http_1 = require("@angular/common/http");
require("rxjs/add/operator/toPromise");
var moment = require("moment");
//Azteca Kernel
var core_2 = require("framework3/core");
//Locales
var cfd_certificado_1 = require("../models/cfd-certificado");
var CFDCertificadoService = /** @class */ (function (_super) {
    __extends(CFDCertificadoService, _super);
    function CFDCertificadoService(http, context) {
        return _super.call(this, http, context, "api/contabilidad/cfd-certificados") || this;
    }
    CFDCertificadoService.prototype.create = function () {
        return Promise.resolve(new cfd_certificado_1.CFDCertificadoInfo());
    };
    CFDCertificadoService.prototype.search = function (idBranch, request) {
        var params = new http_1.HttpParams()
            .set('idBranch', idBranch.toString());
        //
        return this.apiService.post('search', params, request)
            .map(function (result) {
            result.rows.forEach(function (row) {
                row.validFrom = moment(row.validFrom).toDate();
                row.validTo = moment(row.validTo).toDate();
            });
            return result;
        })
            .toPromise();
    };
    CFDCertificadoService.prototype.getDetailByID = function (itemID) {
        var params = new http_1.HttpParams()
            .set('itemID', itemID.toString());
        return this.apiService.get('get-detail-id', params)
            .map(function (info) {
            info.validFrom = moment(info.validFrom).toDate();
            info.validTo = moment(info.validTo).toDate();
            return info;
        })
            .toPromise();
    };
    CFDCertificadoService.prototype.getDetailByCode = function (idBranch, code) {
        var params = new http_1.HttpParams()
            .set('idBranch', idBranch.toString())
            .set('code', code);
        return this.apiService.get('get-detail-code', params)
            .map(function (info) {
            info.validFrom = moment(info.validFrom).toDate();
            info.validTo = moment(info.validTo).toDate();
            return info;
        })
            .toPromise();
    };
    CFDCertificadoService.prototype.loadVigencias = function (idEmpresa) {
        var params = new http_1.HttpParams()
            .set('idEmpresa', idEmpresa.toString());
        //
        return this.apiService.get('vigencias', params)
            .map(function (vigencias) {
            vigencias.forEach(function (cert) {
                cert.validFrom = moment(cert.validFrom).toDate();
                cert.validTo = moment(cert.validTo).toDate();
            });
            return vigencias;
        })
            .toPromise();
    };
    CFDCertificadoService = __decorate([
        core_1.Injectable(),
        __metadata("design:paramtypes", [http_1.HttpClient, core_2.Context])
    ], CFDCertificadoService);
    return CFDCertificadoService;
}(core_2.CatalogService));
exports.CFDCertificadoService = CFDCertificadoService;
