import { HttpClient } from '@angular/common/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
import { Context, DocumentService, FileLink } from 'framework3/core';
import { ComprobanteFiscalInfo, ComprobanteFiscalItem } from '../models/comprobante-fiscal';
import { ComprobanteFiscalDetail } from '../models/comprobante-fiscal-detail';
import { AddendaItem } from '../models/addenda';
import { EnvioComprobantesItem } from '../components/envio-comprobantes-fiscales.component';
export declare class ComprobanteFiscalService extends DocumentService<ComprobanteFiscalDetail, ComprobanteFiscalInfo> {
    protected http: HttpClient;
    protected context: Context;
    constructor(http: HttpClient, context: Context);
    create(): Promise<ComprobanteFiscalInfo>;
    loadListAddendas(idEmpresa: number): Promise<AddendaItem[]>;
    searchKeyword(idBranch: number, keyword: string, idContribuyente: number): Observable<ComprobanteFiscalItem[]>;
    generarPdfTemporal(idComprobante: string): Promise<FileLink>;
    generarPdfTemporalArr(idComprobante: string[]): Promise<FileLink>;
    getXml(idComprobanteFiscal: string): Promise<string>;
    getXmlFileArr(idComprobanteFiscal: string[]): Promise<FileLink>;
    getXmlFile(idComprobanteFiscal: string): Promise<FileLink>;
    cancelar(idComprobanteFiscal: string): Promise<string>;
    timbrar(idComprobanteFiscal: string): Promise<any>;
    enviar(idComprobanteFiscal: string, correo: string, mensaje: string): Promise<any>;
    getEnvioFacturas(idEmpresa: number, fechaIni: Date, fechaFin: Date): Promise<EnvioComprobantesItem[]>;
    ComprobantesDestinosList(): Promise<any[]>;
    resetEnvioFacturas(idJob: number[]): Promise<any>;
    protected mapSearchResult(row: any): void;
    protected mapDocument(document: ComprobanteFiscalInfo): void;
    portalClientes(idCliente: number, fechaIni: Date, fechaFin: Date): Promise<any[]>;
}
