import { HttpClient } from '@angular/common/http';
import 'rxjs/add/operator/toPromise';
import { Context, CatalogService } from 'framework3/core';
import { EmpresaInfo, RegimenFiscalItem } from '../models/empresa';
import { EjercicioItem } from '../models/ejercicio';
import { PeriodoItem } from '../models/periodo';
export declare class EmpresaService extends CatalogService<EmpresaInfo> {
    constructor(http: HttpClient, context: Context);
    create(): Promise<EmpresaInfo>;
    getPeriodoActual(idEmpresa: number): Promise<any>;
    loadEjercicios(idEmpresa: number, soloAbiertos: boolean): Promise<EjercicioItem[]>;
    nuevoEjercicio(idEmpresa: number): Promise<any>;
    abrirEjercicio(idEjercicio: string): Promise<any>;
    cerrarEjercicio(idEjercicio: string): Promise<any>;
    cargarPeriodos(idEjercicio: string, soloAbiertos: boolean): Promise<PeriodoItem[]>;
    abrirPeriodo(idPeriodo: string): Promise<any>;
    cerrarPeriodo(idPeriodo: string): Promise<any>;
    loadRegimenesFiscales(idEmpresa: number): Promise<RegimenFiscalItem[]>;
}
