import { HttpClient } from '@angular/common/http';
import 'rxjs/add/operator/toPromise';
import { Context, DocumentService } from 'framework3/core';
import { PolizaInfo, PolizaPerfilItem } from '../models/poliza';
import { PolizaDetail } from '../models/poliza-detail';
import { PolizaLogEntry } from '../models/poliza-log-entry';
import { AsociacionItem } from '../models/asociacion';
export declare class PolizaService extends DocumentService<PolizaDetail, PolizaInfo> {
    protected http: HttpClient;
    protected context: Context;
    constructor(http: HttpClient, context: Context);
    create(): Promise<PolizaInfo>;
    marcarExportacion(idPolizaTit: string, status: number, mensaje: string): Promise<any>;
    loadLog(idPolizaTit: string): Promise<PolizaLogEntry[]>;
    loadAsociaciones(idPolizaTit: string): Promise<AsociacionItem[]>;
    loadPerfilesByLote(idEmpresa: number, idUsuario: number): Promise<PolizaPerfilItem[]>;
    contabilizarByLote(idSucursal: number, idPerfil: number, fechaIni: Date, fechaFin: Date): Promise<PolizaInfo>;
    getPolizaByPerfil(idSucursal: number, idPerfil: number, fecha: Date): Promise<PolizaInfo>;
}
