import { ChangeDetectorRef } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { Context } from 'framework3/core';
import { CatalogOptions } from 'framework3/custom';
import { CatalogEditor, EditorEventArgs } from 'framework3/editors';
import { DeudorService } from '../services/deudor.service';
import { DeudorInfo } from '../models/deudor';
import { GrupoDeudorInfo } from '../models/grupo-deudor';
import { FormaPagoService } from '../services/forma-pago.service';
import { FormaPagoItem } from '../models/forma-pago';
import { GrupoDeudorSelectorComponent } from '../components/grupo-deudores-selector.component';
import { AddendaService } from '../../accounting/services/addenda.service';
import { ComprobanteFiscalService } from '../../accounting/services/comprobante-fiscal.service';
export declare class DeudoresEditor extends CatalogEditor {
    protected router: Router;
    protected route: ActivatedRoute;
    private formBuilder;
    protected changeDetector: ChangeDetectorRef;
    protected context: Context;
    private location;
    private deudorService;
    private formaPagoService;
    private addendaService;
    private comprobanteFiscalService;
    deudor: DeudorInfo;
    condicionesPago: {
        id: string;
        nombre: string;
    }[];
    formasPago: FormaPagoItem[];
    adendacbo: {
        id: number;
        nombre: string;
    }[];
    comprobantecbo: {
        id: number;
        nombre: string;
    }[];
    selInsumo: GrupoDeudorSelectorComponent;
    constructor(router: Router, route: ActivatedRoute, formBuilder: FormBuilder, changeDetector: ChangeDetectorRef, context: Context, location: Location, deudorService: DeudorService, formaPagoService: FormaPagoService, addendaService: AddendaService, comprobanteFiscalService: ComprobanteFiscalService);
    onConfigureCatalog(options: CatalogOptions): void;
    ngOnInit(): void;
    onCreatingItem(): void;
    onViewingItem(id: number): void;
    onCloningItem(id: number): void;
    onLoadingItem(id: number): void;
    onSavingItem(args: EditorEventArgs): void;
    loadFormasPago(): void;
    onGrupoDeudorSelected(grupo: GrupoDeudorInfo): void;
}
