"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//Features
var deudor_service_1 = require("../services/deudor.service");
var deudor_1 = require("../models/deudor");
var forma_pago_service_1 = require("../services/forma-pago.service");
var grupo_deudores_selector_component_1 = require("../components/grupo-deudores-selector.component");
var addenda_service_1 = require("../../accounting/services/addenda.service");
var comprobante_fiscal_service_1 = require("../../accounting/services/comprobante-fiscal.service");
var DeudoresEditor = /** @class */ (function (_super) {
    __extends(DeudoresEditor, _super);
    //
    function DeudoresEditor(router, route, formBuilder, changeDetector, context, location, deudorService, formaPagoService, addendaService, comprobanteFiscalService) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.router = router;
        _this.route = route;
        _this.formBuilder = formBuilder;
        _this.changeDetector = changeDetector;
        _this.context = context;
        _this.location = location;
        _this.deudorService = deudorService;
        _this.formaPagoService = formaPagoService;
        _this.addendaService = addendaService;
        _this.comprobanteFiscalService = comprobanteFiscalService;
        _this.deudor = new deudor_1.DeudorInfo();
        _this.condicionesPago = [];
        _this.formasPago = [];
        _this.adendacbo = [];
        _this.comprobantecbo = [];
        _this.catalogForm = formBuilder.group({
            'codigo': ['', forms_1.Validators.required],
            'nombre': ['', forms_1.Validators.required],
            'condiciones': ['', forms_1.Validators.required],
            'domicilio': [''],
            'limiteCredito': [''],
            'diasCredito': [''],
            'idFormaPago': [''],
            'cuentaPago': [''],
            'cuenta': [''],
            'idGrupoDeudor': [0],
            'facturable': [''],
            'rfc': [''],
            'razonSocial': [''],
            'desgloseIEPS': [''],
            'addenda': [''],
            'gln': [''],
            'glnTienda': [''],
            'glnComprador': [''],
            'numProveedor': [''],
            'comprobanteDestino': ['']
        });
        _this.condicionesPago =
            [
                { "id": 'C', "nombre": "Credito" },
                { "id": 'E', "nombre": "Contado" }
            ];
        return _this;
    }
    DeudoresEditor_1 = DeudoresEditor;
    ///////////////////////// METODOS ///////////////////////////////////////
    ///////////////////////// HANDLERS ///////////////////////////////////////
    DeudoresEditor.prototype.onConfigureCatalog = function (options) {
        this.autogeneratedCode = options.codigoAutogenerado;
        this.loadFormasPago();
    };
    DeudoresEditor.prototype.ngOnInit = function () {
        var _this = this;
        this.addendaService.AddendaList(this.context.app.defaultCompany.identity)
            .then(function (x) { return _this.adendacbo = x; })
            .catch(function (error) { return _this.handleError(error); });
        this.comprobanteFiscalService.ComprobantesDestinosList()
            .then(function (x) { return _this.comprobantecbo = x; })
            .catch(function (error) { return _this.handleError(error); });
    };
    DeudoresEditor.prototype.onCreatingItem = function () {
    };
    DeudoresEditor.prototype.onViewingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.deudorService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.deudor = info;
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    DeudoresEditor.prototype.onCloningItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.deudorService.clone(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.deudor = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    DeudoresEditor.prototype.onLoadingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.deudorService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.deudor = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    DeudoresEditor.prototype.onSavingItem = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.deudorService.update(this.deudor)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.deudor = info;
            _this.reset();
            if (args.closeEditor)
                _this.location.back();
            else
                _this.showAlert('La información ha sido actualizada con éxito', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    DeudoresEditor.prototype.loadFormasPago = function () {
        var _this = this;
        this.formaPagoService.loadList(this.context.app.defaultSite.identity)
            .then(function (formas) { return _this.formasPago = formas; })
            .catch(function (error) { return _this.handleError(error); });
    };
    DeudoresEditor.prototype.onGrupoDeudorSelected = function (grupo) {
        this.deudor.contribuyente = grupo.contribuyente;
    };
    __decorate([
        core_1.ViewChild('selGrupoDeudor'),
        __metadata("design:type", grupo_deudores_selector_component_1.GrupoDeudorSelectorComponent)
    ], DeudoresEditor.prototype, "selInsumo", void 0);
    DeudoresEditor = DeudoresEditor_1 = __decorate([
        core_1.Component({
            selector: 'credito-deudores-editor',
            template: "\n      <form [formGroup]=\"catalogForm\">\n\n          <azteca-catalog-editor #catalogEditor\n                                 [title]=\"'Deudor'\"\n                                 [info]=\"deudor\"\n                                 [valid]=\"valid\"\n                                 (configureCatalog)=\"onConfigureCatalog($event)\"\n                                 (creatingItem)=\"onCreatingItem()\"\n                                 (viewingItem)=\"onViewingItem($event)\"\n                                 (cloningItem)=\"onCloningItem($event)\"\n                                 (savingItem)=\"onSavingItem($event)\"\n                                 (loadingItem)=\"onLoadingItem($event)\">\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <azteca-form-field [label]=\"'C\u00F3digo:'\">\n                          <catalog-code formControlName=\"codigo\" [(ngModel)]=\"deudor.code\" [automatic]=\"autogeneratedCode\"></catalog-code>\n                      </azteca-form-field>\n\n                      <azteca-form-field [label]=\"'Nombre:'\">\n                          <az-textbox formControlName=\"nombre\" [(ngModel)]=\"deudor.nombre\"></az-textbox>\n                      </azteca-form-field>\n\n                  </div>\n              </div>\n\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <tabset>\n                          <tab heading=\"Generales\">\n\n                              <az-panel [header]=\"'Condiciones de Cr\u00E9dito'\">\n                                  <div class=\"row\">\n                                      <div class=\"col-5 col-md-4\">\n                                          <azteca-form-field [label]=\"''\">\n                                              <az-combobox formControlName=\"condiciones\"\n                                                           [(ngModel)]=\"deudor.condicionesPago\"\n                                                           [items]=\"condicionesPago\"\n                                                           [displayMember]=\"'nombre'\"\n                                                           [valueMember]=\"'id'\">\n                                              </az-combobox>\n                                          </azteca-form-field>\n                                      </div>\n                                  </div>\n\n                                  <div class=\"row\">\n                                      <div class=\"col-5 col-md-4\">\n                                          <azteca-form-field [label]=\"'Limite de Cr\u00E9dito:'\">\n                                              <az-input-number formControlName=\"limiteCredito\" [(ngModel)]=\"deudor.limiteCredito\" format=\"'n2'\" [enabled]=\"deudor.condicionesPago=='C'\"></az-input-number>\n                                          </azteca-form-field>\n                                      </div>\n                                      <div class=\"col-5 col-md-4\">\n                                          <azteca-form-field [label]=\"'Dias de Cr\u00E9dito:'\">\n                                              <az-input-number formControlName=\"diasCredito\" [(ngModel)]=\"deudor.diasCredito\" format=\"'n0'\" [enabled]=\"deudor.condicionesPago=='C'\"></az-input-number>\n                                          </azteca-form-field>\n                                      </div>\n                                  </div>\n\n                              </az-panel>\n\n                              <div class=\"row\">\n                                  <div class=\"col-5 col-md-4\">\n                                      <azteca-form-field [label]=\"'Forma de Pago:'\">\n                                          <az-combobox formControlName=\"idFormaPago\"\n                                                       [(ngModel)]=\"deudor.idFormaPago\"\n                                                       [items]=\"formasPago\"\n                                                       [displayMember]=\"'nombre'\"\n                                                       [valueMember]=\"'id'\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n\n                                  <div class=\"col-5 col-md-4\">\n                                      <azteca-form-field [label]=\"'Cuenta de Pago:'\">\n                                          <az-textbox formControlName=\"cuentaPago\" [(ngModel)]=\"deudor.cuentaPago\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-10\">\n                                      <azteca-form-field [label]=\"'Cuenta:'\">\n                                          <accounting-cuenta-selector formControlName=\"cuenta\" [(ngModel)]=\"deudor.idCuenta\"></accounting-cuenta-selector>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                          </tab>\n\n                          <tab heading=\"Domicilio\">\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-10\">\n                                      <azteca-form-field [label]=\"''\">\n                                          <general-domicilio-editor #domicilio formControlName=\"domicilio\"\n                                                                    [(ngModel)]=\"deudor.domicilio\"\n                                                                    [asentamientoVisible]=\"false\">\n                                          </general-domicilio-editor>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n                          </tab>\n\n                          <tab heading=\"Facturaci\u00F3n\">\n                              <div class=\"col-10 col-md-8\">\n                                  <azteca-form-field [label]=\"'Grupo deudor:'\">\n                                      <credit-grupo-deudores-selector #selGrupoDeudor formControlName=\"idGrupoDeudor\" [(ngModel)]=\"deudor.idGrupoDeudor\" ngDefaultControl=\"\" (itemSelected)=\"onGrupoDeudorSelected($event)\"></credit-grupo-deudores-selector>\n                                  </azteca-form-field>\n                              </div>\n\n                              <az-checkbox formControlName=\"facturable\" [label]=\"'Solicita factura'\" [(ngModel)]=\"deudor.facturable\"></az-checkbox>\n\n                              <az-panel [enabled]=\"deudor.facturable\">\n                                  <div class=\"col-4 col-md-4\">\n                                      <azteca-form-field [label]=\"'RFC:'\">\n                                          <az-textbox formControlName=\"rfc\" [(ngModel)]=\"deudor.contribuyente.rfc\" [enabled]=\"deudor.facturable && deudor.idGrupoDeudor==0\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n\n                                  <div class=\"col-10 col-md-8\">\n                                      <azteca-form-field [label]=\"'Raz\u00F3n Social:'\">\n                                          <az-textbox formControlName=\"razonSocial\" [(ngModel)]=\"deudor.contribuyente.razonSocial\" [enabled]=\"deudor.facturable && deudor.idGrupoDeudor==0\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n\n                                  <div class=\"row\">\n                                      <div class=\"col-10 col-md-8\">\n                                          <azteca-form-field [label]=\"''\">\n                                              <general-domicilio-editor #domicilioFiscal [enabled]=\"deudor.facturable && deudor.idGrupoDeudor==0\"\n                                                                        formControlName=\"domicilio\"\n                                                                        [(ngModel)]=\"deudor.contribuyente.domicilio\"\n                                                                        [cruceUnoVisible]=\"false\"\n                                                                        [cruceDosVisible]=\"false\">\n\n                                              </general-domicilio-editor>\n                                          </azteca-form-field>\n                                      </div>\n                                  </div>\n\n                                  <az-checkbox formControlName=\"desgloseIEPS\" [label]=\"'Desglosa IEPS'\" [(ngModel)]=\"deudor.desgloseIEPS\"></az-checkbox>\n\n                                  <!--<div class=\"row\">\n                                      <div class=\"col-5 col-md-4\">\n                                          <azteca-form-field [label]=\"'Addenda:'\">\n                                              <az-combobox formControlName=\"idAddenda\"\n                                                           [(ngModel)]=\"cliente.idComprobanteAddenda\"\n                                                           [items]=\"addendas\"\n                                                           [displayMember]=\"'nombre'\"\n                                                           [valueMember]=\"'id'\">\n                                              </az-combobox>\n                                          </azteca-form-field>\n                                      </div>\n                                  </div>-->\n\n                              </az-panel>\n\n                          </tab>\n\n                          <tab heading=\"Datos Edi\">\n                              <az-panel [header]=\"'Datos Edi'\">\n                                  <div class=\"row\">\n                                      <div class=\"col-5 col-md-4\">\n                                          <azteca-form-field [label]=\"'Addenda'\">\n                                              <az-combobox formControlName=\"addenda\"\n                                                           [(ngModel)]=\"deudor.idComprobanteAddenda\"\n                                                           [items]=\"adendacbo\"\n                                                           [displayMember]=\"'nombre'\"\n                                                           [valueMember]=\"'id'\">\n                                              </az-combobox>\n                                          </azteca-form-field>\n                                      </div>\n                                  </div>\n\n                                  <div class=\"row\">\n                                      <div class=\"col-5 col-md-4\">\n                                          <azteca-form-field [label]=\"'GLN:'\">\n                                              <az-textbox formControlName=\"gln\" [(ngModel)]=\"deudor.gln\"></az-textbox>\n                                          </azteca-form-field>\n                                      </div>\n                                  </div>\n\n                                  <div class=\"row\">\n                                      <div class=\"col-5 col-md-4\">\n                                          <azteca-form-field [label]=\"'GLN Tienda:'\">\n                                              <az-textbox formControlName=\"glnTienda\" [(ngModel)]=\"deudor.glnTienda\"></az-textbox>\n                                          </azteca-form-field>\n                                      </div>\n                                  </div>\n\n                                  <div class=\"row\">\n                                      <div class=\"col-5 col-md-4\">\n                                          <azteca-form-field [label]=\"'GLN Comprador:'\">\n                                              <az-textbox formControlName=\"glnComprador\" [(ngModel)]=\"deudor.glnComprador\"></az-textbox>\n                                          </azteca-form-field>\n                                      </div>\n                                  </div>\n\n                                  <div class=\"row\">\n                                      <div class=\"col-5 col-md-4\">\n                                          <azteca-form-field [label]=\"'Numero de Proveedor:'\">\n                                              <az-textbox formControlName=\"numProveedor\" [(ngModel)]=\"deudor.numProveedor\"></az-textbox>\n                                          </azteca-form-field>\n                                      </div>\n                                  </div>\n\n                                  <div class=\"row\">\n                                      <div class=\"col-5 col-md-4\">\n                                          <azteca-form-field [label]=\"'Destino de Envio'\">\n                                              <az-combobox formControlName=\"comprobanteDestino\"\n                                                           [(ngModel)]=\"deudor.idComprobanteDestino\"\n                                                           [items]=\"comprobantecbo\"\n                                                           [displayMember]=\"'nombre'\"\n                                                           [valueMember]=\"'id'\">\n                                              </az-combobox>\n                                          </azteca-form-field>\n                                      </div>\n                                  </div>\n\n                              </az-panel>\n                          </tab>\n                      </tabset>\n                  </div>\n              </div>\n\n\n          </azteca-catalog-editor>\n      </form>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return DeudoresEditor_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: deudor_service_1.DeudorService
                }
            ]
        }),
        __metadata("design:paramtypes", [router_1.Router, router_1.ActivatedRoute, forms_1.FormBuilder, core_1.ChangeDetectorRef,
            core_2.Context, common_1.Location, deudor_service_1.DeudorService, forma_pago_service_1.FormaPagoService, addenda_service_1.AddendaService,
            comprobante_fiscal_service_1.ComprobanteFiscalService])
    ], DeudoresEditor);
    return DeudoresEditor;
    var DeudoresEditor_1;
}(editors_1.CatalogEditor));
exports.DeudoresEditor = DeudoresEditor;
