import { ChangeDetectorRef } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { Context } from 'framework3/core';
import { CatalogOptions } from 'framework3/custom';
import { CatalogEditor, EditorEventArgs } from 'framework3/editors';
import { FormaPagoService } from '../services/forma-pago.service';
import { FormaPagoInfo } from '../models/forma-pago';
import { MetodoPagoItem } from '../../accounting/models/metodo-pago';
import { MetodoPagoService } from '../../accounting/services/metodo-pago.service';
export declare class FormasPagoEditor extends CatalogEditor {
    protected router: Router;
    protected route: ActivatedRoute;
    private formBuilder;
    protected changeDetector: ChangeDetectorRef;
    protected context: Context;
    private location;
    private formaPagoService;
    private metodoPagoService;
    formapago: FormaPagoInfo;
    metodosPago: MetodoPagoItem[];
    constructor(router: Router, route: ActivatedRoute, formBuilder: FormBuilder, changeDetector: ChangeDetectorRef, context: Context, location: Location, formaPagoService: FormaPagoService, metodoPagoService: MetodoPagoService);
    onConfigureCatalog(options: CatalogOptions): void;
    onCreatingItem(): void;
    onViewingItem(id: number): void;
    onCloningItem(id: number): void;
    onLoadingItem(id: number): void;
    onSavingItem(args: EditorEventArgs): void;
    loadMetodosPago(): void;
}
