import { ChangeDetectorRef } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { Context } from 'framework3/core';
import { CatalogOptions } from 'framework3/custom';
import { CatalogEditor, EditorEventArgs } from 'framework3/editors';
import { GrupoDeudorService } from '../services/grupo-deudor.service';
import { GrupoDeudorInfo } from '../models/grupo-deudor';
import { SerieFiscalItem } from '../../accounting/models/serie-fiscal';
import { SerieFiscalService } from '../../accounting/services/serie-fiscal.service';
import { UsoCFDIItem } from '../../accounting/models/contribuyente';
import { ContribuyenteService } from '../../accounting/services/contribuyente.service';
export declare class GruposDeudoresEditor extends CatalogEditor {
    protected router: Router;
    protected route: ActivatedRoute;
    private formBuilder;
    protected changeDetector: ChangeDetectorRef;
    protected context: Context;
    private location;
    private grupoDeudorService;
    private serieFiscalService;
    private contribuyenteService;
    grupodeudor: GrupoDeudorInfo;
    series: SerieFiscalItem[];
    usosCFDI: UsoCFDIItem[];
    constructor(router: Router, route: ActivatedRoute, formBuilder: FormBuilder, changeDetector: ChangeDetectorRef, context: Context, location: Location, grupoDeudorService: GrupoDeudorService, serieFiscalService: SerieFiscalService, contribuyenteService: ContribuyenteService);
    onConfigureCatalog(options: CatalogOptions): void;
    onCreatingItem(): void;
    onViewingItem(id: number): void;
    onCloningItem(id: number): void;
    onLoadingItem(id: number): void;
    onSavingItem(args: EditorEventArgs): void;
    loadSeries(): void;
    loadUsosCFDI(): void;
}
