"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
//Azteca Kernel
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
var content_viewer_component_1 = require("framework3/controls/components/content-viewer.component");
//Features
var reporte_service_1 = require("../services/reporte.service");
var concepto_service_1 = require("../services/concepto.service");
var AbonosComponent = /** @class */ (function () {
    function AbonosComponent(formBuilder, router, reporteService, context, conceptoService) {
        this.formBuilder = formBuilder;
        this.router = router;
        this.reporteService = reporteService;
        this.context = context;
        this.conceptoService = conceptoService;
        this.abono = [];
        this.editorForm = formBuilder.group({
            'fechaIni': [0, forms_1.Validators.required],
            'fechaFin': [0, forms_1.Validators.required],
            'abono': [0, controls_1.AztecaValidators.selected]
        });
    }
    AbonosComponent.prototype.ngOnInit = function () {
        var _this = this;
        this.conceptoService.getConceptos()
            .then(function (conceptos) { return _this.abono = conceptos; });
    };
    AbonosComponent.prototype.onAccept = function () {
        var _this = this;
        this.reporteService.printAbonos(this.fechaIni, this.fechaFin, this.editorForm.controls.abono.value)
            .then(function (report) { return _this.printReport(report); });
    };
    AbonosComponent.prototype.printReport = function (report) {
        this.reportViewer.show("data:application/pdf; base64, " + report);
    };
    AbonosComponent.prototype.showAlert = function (message, type) {
        this.alerts.showAlert(message, type);
    };
    AbonosComponent.prototype.handleError = function (error) {
        console.error(error);
        this.alerts.showAlert(error.tostring(), 'danger');
    };
    __decorate([
        core_1.ViewChild(controls_1.AlertsBarComponent),
        __metadata("design:type", controls_1.AlertsBarComponent)
    ], AbonosComponent.prototype, "alerts", void 0);
    __decorate([
        core_1.ViewChild(content_viewer_component_1.ContentViewerComponent),
        __metadata("design:type", content_viewer_component_1.ContentViewerComponent)
    ], AbonosComponent.prototype, "reportViewer", void 0);
    AbonosComponent = __decorate([
        core_1.Component({
            selector: 'credit-abonos-reporte',
            template: "\n      <div class=\"row justify-content-center\">\n          <div class=\"col-12 col-md-10 col-lg-8\">\n              <form [formGroup]=\"editorForm\">\n\n                  <alerts-bar></alerts-bar>\n\n                  <az-panel [header]=\"'Abonos'\">\n                      <azteca-form-field [label]=\"'Fecha Inical'\">\n                          <az-input-date formControlName=\"fechaIni\" [(ngModel)]=\"fechaIni\"></az-input-date>\n                      </azteca-form-field>\n\n                      <azteca-form-field [label]=\"'Fecha Final'\">\n                          <az-input-date formControlName=\"fechaFin\" [(ngModel)]=\"fechaFin\"></az-input-date>\n                      </azteca-form-field>\n\n                      <azteca-form-field [label]=\"'Tipo de Abono'\">\n                          <az-combobox formControlName=\"abono\"\n                                       [items]=\"abono\"\n                                       [displayMember]=\"'nombre'\"\n                                       [valueMember]=\"'id'\">\n                          </az-combobox>\n                      </azteca-form-field>\n\n                      <div class=\"modal-footer\">\n                          <button type=\"button\" class=\"btn btn-primary\" (click)=\"onAccept()\" [disabled]=\"!editorForm.valid\">Aceptar</button>\n                      </div>\n                  </az-panel>\n\n                  <azteca-content-viewer [title]=\"'Abonos'\" [fileName]=\"'Abonos'\"></azteca-content-viewer>\n              </form>\n          </div>\n      </div>\n    "
        }),
        __metadata("design:paramtypes", [forms_1.FormBuilder, router_1.Router, reporte_service_1.ReporteService, core_2.Context, concepto_service_1.ConceptoService])
    ], AbonosComponent);
    return AbonosComponent;
}());
exports.AbonosComponent = AbonosComponent;
