"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
//Azteca Kernel
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
var content_viewer_component_1 = require("framework3/controls/components/content-viewer.component");
//Features
var reporte_service_1 = require("../services/reporte.service");
var EstructuraClasificacionesComponent = /** @class */ (function () {
    function EstructuraClasificacionesComponent(formBuilder, router, reporteService, context) {
        this.formBuilder = formBuilder;
        this.router = router;
        this.reporteService = reporteService;
        this.context = context;
        this.clasificacion = [];
        this.editorForm = formBuilder.group({
            'clasificacion': [0, controls_1.AztecaValidators.selected]
        });
    }
    EstructuraClasificacionesComponent.prototype.ngOnInit = function () {
        var _this = this;
        this.reporteService.loadClasificacionesList()
            .then(function (clasificacion) { return _this.clasificacion = clasificacion; });
    };
    EstructuraClasificacionesComponent.prototype.onAccept = function () {
        var _this = this;
        this.reporteService.printEstructuraClasificaciones(this.editorForm.controls.clasificacion.value)
            .then(function (report) { return _this.printReport(report); });
    };
    EstructuraClasificacionesComponent.prototype.printReport = function (report) {
        this.reportViewer.show("data:application/pdf; base64, " + report);
    };
    EstructuraClasificacionesComponent.prototype.showAlert = function (message, type) {
        this.alerts.showAlert(message, type);
    };
    EstructuraClasificacionesComponent.prototype.handleError = function (error) {
        console.error(error);
        this.alerts.showAlert(error.tostring(), 'danger');
    };
    __decorate([
        core_1.ViewChild(controls_1.AlertsBarComponent),
        __metadata("design:type", controls_1.AlertsBarComponent)
    ], EstructuraClasificacionesComponent.prototype, "alerts", void 0);
    __decorate([
        core_1.ViewChild(content_viewer_component_1.ContentViewerComponent),
        __metadata("design:type", content_viewer_component_1.ContentViewerComponent)
    ], EstructuraClasificacionesComponent.prototype, "reportViewer", void 0);
    EstructuraClasificacionesComponent = __decorate([
        core_1.Component({
            selector: 'credit-estructura-clasificaciones-reporte',
            template: "\n      <div class=\"row justify-content-center\">\n          <div class=\"col-12 col-md-10 col-lg-8\">\n              <form [formGroup]=\"editorForm\">\n\n                  <alerts-bar></alerts-bar>\n\n                  <az-panel [header]=\"'Estructura de Clasificaciones'\">\n                      <azteca-form-field [label]=\"'Clasificacion'\">\n                          <az-combobox formControlName=\"clasificacion\"\n                                       [items]=\"clasificacion\"\n                                       [displayMember]=\"'nombre'\"\n                                       [valueMember]=\"'idClasificacion'\">\n                          </az-combobox>\n                      </azteca-form-field>\n\n                      <div class=\"modal-footer\">\n                          <button type=\"button\" class=\"btn btn-primary\" (click)=\"onAccept()\" [disabled]=\"!editorForm.valid\">Aceptar</button>\n                      </div>\n                  </az-panel>\n\n                  <azteca-content-viewer [title]=\"'Estructura de Clasificaciones'\" [fileName]=\"'Estructura de Clasificaciones'\"></azteca-content-viewer>\n              </form>\n          </div>\n      </div>\n    "
        }),
        __metadata("design:paramtypes", [forms_1.FormBuilder, router_1.Router, reporte_service_1.ReporteService, core_2.Context])
    ], EstructuraClasificacionesComponent);
    return EstructuraClasificacionesComponent;
}());
exports.EstructuraClasificacionesComponent = EstructuraClasificacionesComponent;
