"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
//Azteca Kernel
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
var content_viewer_component_1 = require("framework3/controls/components/content-viewer.component");
//Features
var reporte_service_1 = require("../services/reporte.service");
var region_service_1 = require("../../sales/services/region.service");
var EstructuraClientesCadenasComponent = /** @class */ (function () {
    function EstructuraClientesCadenasComponent(formBuilder, router, reporteService, context, regionService) {
        this.formBuilder = formBuilder;
        this.router = router;
        this.reporteService = reporteService;
        this.context = context;
        this.regionService = regionService;
        this.region = [];
        this.editorForm = formBuilder.group({
            'region': [0, controls_1.AztecaValidators.selected]
        });
    }
    EstructuraClientesCadenasComponent.prototype.ngOnInit = function () {
        var _this = this;
        this.regionService.loadList(this.context.app.defaultCompany.identity)
            .then(function (region) { return _this.region = region; });
    };
    EstructuraClientesCadenasComponent.prototype.onAccept = function () {
        var _this = this;
        this.reporteService.printEstructuraClientesCadenas(this.editorForm.controls.region.value)
            .then(function (report) { return _this.printReport(report); });
    };
    EstructuraClientesCadenasComponent.prototype.printReport = function (report) {
        this.reportViewer.show("data:application/pdf; base64, " + report);
    };
    EstructuraClientesCadenasComponent.prototype.showAlert = function (message, type) {
        this.alerts.showAlert(message, type);
    };
    EstructuraClientesCadenasComponent.prototype.handleError = function (error) {
        console.error(error);
        this.alerts.showAlert(error.tostring(), 'danger');
    };
    __decorate([
        core_1.ViewChild(controls_1.AlertsBarComponent),
        __metadata("design:type", controls_1.AlertsBarComponent)
    ], EstructuraClientesCadenasComponent.prototype, "alerts", void 0);
    __decorate([
        core_1.ViewChild(content_viewer_component_1.ContentViewerComponent),
        __metadata("design:type", content_viewer_component_1.ContentViewerComponent)
    ], EstructuraClientesCadenasComponent.prototype, "reportViewer", void 0);
    EstructuraClientesCadenasComponent = __decorate([
        core_1.Component({
            selector: 'credit-estructura-clientes-cadenas-reporte',
            template: "\n      <div class=\"row justify-content-center\">\n          <div class=\"col-12 col-md-10 col-lg-8\">\n              <form [formGroup]=\"editorForm\">\n\n                  <alerts-bar></alerts-bar>\n\n                  <az-panel [header]=\"'Estructura de Clientes y Cadenas'\">\n                      <azteca-form-field [label]=\"'Region'\">\n                          <az-combobox formControlName=\"region\"\n                                       [items]=\"region\"\n                                       [displayMember]=\"'nombre'\"\n                                       [valueMember]=\"'id'\">\n                          </az-combobox>\n                      </azteca-form-field>\n\n                      <div class=\"modal-footer\">\n                          <button type=\"button\" class=\"btn btn-primary\" (click)=\"onAccept()\" [disabled]=\"!editorForm.valid\">Aceptar</button>\n                      </div>\n                  </az-panel>\n\n                  <azteca-content-viewer [title]=\"'Estructura de Clientes y Cadenas'\" [fileName]=\"'Estructura de Clientes y Cadenas'\"></azteca-content-viewer>\n              </form>\n          </div>\n      </div>\n    "
        }),
        __metadata("design:paramtypes", [forms_1.FormBuilder, router_1.Router, reporte_service_1.ReporteService, core_2.Context, region_service_1.RegionService])
    ], EstructuraClientesCadenasComponent);
    return EstructuraClientesCadenasComponent;
}());
exports.EstructuraClientesCadenasComponent = EstructuraClientesCadenasComponent;
