import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { Context, DocumentItem, DocumentTypeService, DocumentTypeInfo } from 'framework3/core';
import { AzComboboxComponent } from 'framework3/controls';
import { DocumentEditor, EditableListComponent, EditorEventArgs, WorkflowEventArgs } from 'framework3/editors';
import { AnticipoInfo } from '../models/anticipo';
import { AnticipoDetail } from '../models/anticipo-detail';
import { AnticipoService } from '../services/anticipo.service';
import { AnticipoDetailEditor } from './parts/anticipos-detail.editor';
import { GrupoDeudorInfo } from '../models/grupo-deudor';
import { DeudorInfo } from '../models/deudor';
import { FormaPagoService } from '../services/forma-pago.service';
import { FormaPagoItem } from '../models/forma-pago';
import { EmpresaService } from '../services/empresa.service';
import { EmpresaInfo } from '../models/empresa';
import { EmpresaService as EmpresaServiceCont } from '../../accounting/services/empresa.service';
import { EmpresaInfo as EmpresaInfoCont } from '../../accounting/models/empresa';
import { CajasSelectorComponent } from '../../credit';
import { ImpuestoService } from '../../accounting/services/impuesto.service';
import { ImpuestoInfo } from '../../accounting/models/impuesto';
import { DivisaService } from '../../accounting/services/divisa.service';
import { DivisaInfo } from '../../accounting/models/divisa';
export declare class AnticiposEditor extends DocumentEditor {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    private location;
    private formBuilder;
    protected documentTypeService: DocumentTypeService;
    private anticipoService;
    private formaPagoService;
    private empresaService;
    private empresaServiceCont;
    private impuestoService;
    private divisaService;
    anticipo: AnticipoInfo;
    empresa: EmpresaInfo;
    divisa: DivisaInfo;
    empresaCont: EmpresaInfoCont;
    impuesto: ImpuestoInfo;
    formasPago: FormaPagoItem[];
    detailsList: EditableListComponent;
    detailsEditor: AnticipoDetailEditor;
    selectorCaja: CajasSelectorComponent;
    cboSegmento: AzComboboxComponent;
    busquedaTipos: {
        id: string;
        nombre: string;
    }[];
    tipoBusqueda: string;
    idGrupoDeudor: number;
    idDeudor: number;
    sImporteImpuesto: string;
    constructor(context: Context, router: Router, route: ActivatedRoute, location: Location, formBuilder: FormBuilder, documentTypeService: DocumentTypeService, anticipoService: AnticipoService, formaPagoService: FormaPagoService, empresaService: EmpresaService, empresaServiceCont: EmpresaServiceCont, impuestoService: ImpuestoService, divisaService: DivisaService);
    selectedBusqueda(item: any): void;
    onGrupoDeudorSelected(grupo: GrupoDeudorInfo): void;
    onDeudorSelected(deudor: DeudorInfo): void;
    onConfigureDocument(docType: DocumentTypeInfo): void;
    onCreatingDocument(): void;
    onViewingDocument(id: string): void;
    onCloningDocument(id: string): void;
    onLoadingDocument(id: string): void;
    onSavingDocument(args: EditorEventArgs): void;
    onApplyingNextStep(args: WorkflowEventArgs): void;
    onApplyingPreviousStep(document: DocumentItem): void;
    onTabSelected(args: any): void;
    onAddingDetail(): void;
    onEditingDetail(detail: AnticipoDetail): void;
    onDeletingDetail(detail: AnticipoDetail): void;
    onListItemsUpdated(updatedDetails: AnticipoDetail[]): void;
    onSavingDetail(detail: AnticipoDetail): void;
    loadFormasPago(): void;
    onImporteChanged(importe: number): void;
    loadEmpresa(): void;
    loadDivisa(idDivisa: number): void;
    loadEmpresaCont(): void;
    loadImpuesto(idImpuesto: number): void;
}
