"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Wijmo
var wijmo_1 = require("wijmo/wijmo");
//Azteca Kernel
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
var editors_1 = require("framework3/editors");
//Locales
var cobranza_1 = require("../models/cobranza");
var cobranza_detail_1 = require("../models/cobranza-detail");
var cobranza_service_1 = require("../services/cobranza.service");
var caja_service_1 = require("../services/caja.service");
//Cobranza
var cobranza_component_1 = require("../parts/cobranza.component");
var cobranzas_detail_editor_1 = require("./parts/cobranzas-detail.editor");
var anticipo_1 = require("../models/anticipo");
var CobranzasEditor = /** @class */ (function (_super) {
    __extends(CobranzasEditor, _super);
    function CobranzasEditor(context, router, route, location, formBuilder, documentTypeService, cobranzaService, cajaService) {
        var _this = _super.call(this, context, router, route, documentTypeService) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.location = location;
        _this.formBuilder = formBuilder;
        _this.documentTypeService = documentTypeService;
        _this.cobranzaService = cobranzaService;
        _this.cajaService = cajaService;
        _this.cobranza = new cobranza_1.CobranzaInfo();
        _this.cajas = [];
        _this.cuentasXCobrar = new wijmo_1.CollectionView();
        _this.anticipo = new anticipo_1.AnticipoInfo();
        _this.documentForm = formBuilder.group({
            'caja': ['', forms_1.Validators.required],
            'referenciaAlf': [''],
            'referenciaNum': [''],
            'observaciones': [''],
            //'monto': [''],
            'monto': ['0', function (_) { return _this.validateMontos(); }],
            'acumulado': ['0', ''] // _ => this.validateMontos()]            
        });
        return _this;
    }
    CobranzasEditor_1 = CobranzasEditor;
    CobranzasEditor.prototype.validateMontos = function () {
        if (this.cobranza.total == this.acumulado && this.acumulado > 0)
            return null;
        else
            return 'No coincide el monto deseado con el monto acumulado.';
    };
    CobranzasEditor.prototype.onConfigureDocument = function (docType) {
        this.applyPolicies();
        this.loadCajas();
        this.documentType = docType;
        this.anticipo = new anticipo_1.AnticipoInfo();
    };
    CobranzasEditor.prototype.onCreatingDocument = function () {
    };
    CobranzasEditor.prototype.onViewingDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.cobranzaService.getDetail(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.cobranza = doc;
            _this.cuentasXCobrar.sourceCollection = _this.cobranza.details;
            _this.calcularAcumulado();
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CobranzasEditor.prototype.onCloningDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.cobranzaService.clone(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.cobranza = doc;
            _this.detailsEditor.clientIndexStart = _this.cobranza.details.length;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CobranzasEditor.prototype.onLoadingDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.cobranzaService.getDetail(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.cobranza = doc;
            _this.cuentasXCobrar.sourceCollection = _this.cobranza.details;
            _this.calcularAcumulado();
            _this.detailsEditor.clientIndexStart = _this.cobranza.details.length;
            if (_this.cobranza.status != core_2.DocumentStatus.DRAFT)
                _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CobranzasEditor.prototype.onSavingDocument = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.cobranza.details = this.cuentasXCobrar.sourceCollection;
        this.cobranza.idCobroTipo = 1;
        this.argsEditorEvent = args;
        this.cobranzaService.update(this.cobranza)
            .then(function (updatedDoc) {
            _this.context.app.hideSpinner();
            //Si es un elemento nuevo y no se cerrará el editor, navegar a nueva ruta
            _this.reset();
            _this.cobranza = updatedDoc;
            _this.editor.document = updatedDoc;
            _this.editor.nextStep();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CobranzasEditor.prototype.onApplyingNextStep = function (args) {
        var _this = this;
        this.argsCurrentDocument = args;
        args.step.activities.forEach(function (activity) {
            if (activity.tag == 'APPLY') {
                _this.dlgCobranza.showSinCaja(_this.cobranza.total, _this.cobranza.idCaja, _this.idDeudorDefault);
            }
            else {
                _this.context.app.showSpinner();
                _this.cobranzaService.nextStep(args.document.id, args.step.idWorkflowStep, null)
                    .then(function (_) {
                    _this.context.app.hideSpinner();
                    //Volver a cargar documento
                    _this.onViewingDocument(args.document.id);
                })
                    .catch(function (error) { return _this.handleError(error); });
            }
        });
    };
    CobranzasEditor.prototype.onApplyingPreviousStep = function (document) {
        var _this = this;
        this.context.app.showSpinner();
        this.cobranzaService.previousStep(document.id, null)
            .then(function (_) {
            //Volver a cargar documento
            _this.onViewingDocument(document.id);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CobranzasEditor.prototype.onTabSelected = function (args) {
        if (args.heading) {
            //Al seleccionar la pestaña de historial, realizar carga de información
            if (args.heading == 'Historial') {
                this.loadHistory(this.cobranza.identity);
            }
            //Actualizar controles de wijmo
            wijmo_1.Control.invalidateAll();
        }
    };
    ///////////// DETALLE DEL DOCUMENTO /////////////////////////
    CobranzasEditor.prototype.onAddingDetail = function () {
        //this.detailsEditor.detail = new CobranzaDetail();
        //this.detailsEditor.show();
    };
    CobranzasEditor.prototype.onEditingDetail = function (detail) {
        //this.detailsEditor.detail = detail;
        //this.detailsEditor.show();
    };
    CobranzasEditor.prototype.onDeletingDetail = function (detail) {
        //this.detailsList.deleteItem(detail);
    };
    //onListItemsUpdated(updatedDetails: CobranzaDetail[]) {
    //    if (this.detailsEditor.anticipo.identity != '') {
    //        this.anticipo = this.detailsEditor.anticipo;
    //        this.cobranza.total = this.anticipo.importe;
    //        this.cobranza.idAnticipo = this.anticipo.identity;
    //        this.cobranza.fechaAnticipo = this.anticipo.fechaSys;
    //    }
    //    this.cobranza.details = updatedDetails;
    //    this.detailsList.listItems = updatedDetails;        
    //    this.cuentasXCobrar.sourceCollection = updatedDetails;
    //}
    CobranzasEditor.prototype.onSavingDetail = function (detail) {
        //this.detailsList.updateItem(detail);
    };
    CobranzasEditor.prototype.onDetailsLoaded = function (details) {
        if (this.detailsEditor.anticipo.identity != '') {
            this.anticipo = this.detailsEditor.anticipo;
            this.cobranza.total = this.anticipo.importe;
            this.cobranza.idAnticipo = this.anticipo.identity;
            this.cobranza.fechaAnticipo = this.anticipo.fechaSys;
        }
        if (details.length > 0)
            this.idDeudorDefault = details[0].idDeudor;
        this.detailsList.listItems = details;
        this.cobranza.details = details;
        this.cuentasXCobrar.sourceCollection = details;
    };
    CobranzasEditor.prototype.onToolbarButtonClick = function (button) {
        if (button.name == 'ADD') {
            this.detailsEditor.detail = new cobranza_detail_1.CobranzaDetail();
            this.detailsEditor.show();
        }
    };
    CobranzasEditor.prototype.onImporteCheck = function (item) {
        var _this = this;
        var condicionPago = this.cobranza.details.find(function (search) { return search.importe > 0 && search.condicionesPago != item.condicionesPago; });
        if (condicionPago == undefined) {
            var tempCXC = this.cuentasXCobrar.sourceCollection.slice();
            item.importe = item.saldo;
            item.state = "MODIFIED";
            this.cuentasXCobrar.sourceCollection = tempCXC;
            //this.cuentasXCobrar.refresh();
            setTimeout(function (_) { return _this.calcularAcumulado(); });
        }
        else
            this.showAlert("No puede mezclar documentos de diferentes condiciones de pago[Credito/Contado]", "danger");
    };
    CobranzasEditor.prototype.cellEditEndingHandler = function (flex, e) {
        var _this = this;
        var cxc = flex.rows[e.row].dataItem;
        if (cxc.importe > cxc.saldo)
            cxc.importe = cxc.saldo;
        var condicionPago = this.cuentasXCobrar.sourceCollection.find(function (search) { return search.importe > 0 && search.condicionesPago != cxc.condicionesPago; });
        if (condicionPago == undefined)
            setTimeout(function (_) { return _this.calcularAcumulado(); });
        else {
            e.cancel = true;
            this.showAlert("No puede mezclar documentos de diferentes condiciones de pago[Credito/Contado]", "danger");
        }
        cxc.state = "MODIFIED";
    };
    CobranzasEditor.prototype.onCellEditEnded = function (flex, row) {
        var _this = this;
        this.cuentasXCobrar.refresh();
        setTimeout(function (_) { return _this.calcularAcumulado(); });
    };
    CobranzasEditor.prototype.loadCajas = function () {
        var _this = this;
        this.cajaService.loadListByUser(this.context.app.defaultSite.identity)
            .then(function (cajas) { return _this.cajas = cajas; })
            .catch(function (error) { return _this.handleError(error); });
    };
    CobranzasEditor.prototype.calcularAcumulado = function () {
        this.acumulado = this.cobranza.details
            .map(function (c) { return c.importe; })
            .reduce(function (sum, current) { return sum + current; });
    };
    CobranzasEditor.prototype.showAlert = function (message, type) {
        this.alerts.showAlert(message, type);
    };
    CobranzasEditor.prototype.cobroAceptado = function (formasPagoCobro) {
        var _this = this;
        var cobro = { formasPago: formasPagoCobro };
        this.context.app.showSpinner();
        this.cobranzaService.nextStep(this.editor.document.identity, this.argsCurrentDocument.step.idWorkflowStep, cobro)
            .then(function (_) {
            _this.context.app.hideSpinner();
            //this.refreshList();
            _this.dlgCobranza.clear();
            _this.onViewingDocument(_this.editor.document.identity);
            if (!_this.argsEditorEvent.closeEditor && _this.cobranza.identity == '') {
                _this.router.navigate(['../', _this.editor.document.identity], { relativeTo: _this.route });
            }
            else {
                if (_this.argsEditorEvent.closeEditor)
                    _this.router.navigate(['../'], { relativeTo: _this.route });
                else
                    _this.showAlert('La información ha sido actualizada con éxito', 'success');
            }
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    __decorate([
        core_1.ViewChild('detailsList'),
        __metadata("design:type", editors_1.EditableListComponent)
    ], CobranzasEditor.prototype, "detailsList", void 0);
    __decorate([
        core_1.ViewChild('detailsEditor'),
        __metadata("design:type", cobranzas_detail_editor_1.CobranzaDetailEditor)
    ], CobranzasEditor.prototype, "detailsEditor", void 0);
    __decorate([
        core_1.ViewChild(controls_1.AlertsBarComponent),
        __metadata("design:type", controls_1.AlertsBarComponent
        //
        )
    ], CobranzasEditor.prototype, "alerts", void 0);
    __decorate([
        core_1.ViewChild('dlgCobranza'),
        __metadata("design:type", cobranza_component_1.CobranzaComponent)
    ], CobranzasEditor.prototype, "dlgCobranza", void 0);
    CobranzasEditor = CobranzasEditor_1 = __decorate([
        core_1.Component({
            selector: 'credito-cobranzas-editor',
            template: "\n      <form [formGroup]=\"documentForm\">\n    \n          <alerts-bar></alerts-bar>\n\n          <azteca-document-editor #documentEditor\n                                         [title]=\"'CobranzasTit'\"\n                                         [document]=\"cobranza\"\n                                         [valid]=\"valid\"\n                                         (configureDocument)=\"onConfigureDocument($event)\"\n                                         (creatingDocument)=\"onCreatingDocument()\"\n                                         (viewingDocument)=\"onViewingDocument($event)\"\n                                         (cloningDocument)=\"onCloningDocument($event)\"\n                                         (savingDocument)=\"onSavingDocument($event)\"\n                                         (loadingDocument)=\"onLoadingDocument($event)\"\n                                         (applyingNextStep)=\"onApplyingNextStep($event)\"\n                                         (menuItemClick)=\"onMenuItemClick($event)\">\n\n              <!------------------- Menu de acciones adicionales --------------------->\n\n              <!------------------- Controles del editor ----------------------------->\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <tabset>\n                          <tab heading=\"Generales\" (select)=\"onTabSelected($event)\">\n                        \n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'Referencia Alfanumerica:'\">\n                                          <az-textbox formControlName=\"referenciaAlf\" [(ngModel)]=\"cobranza.referenciaAlf\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'Referencia Numerica:'\">\n                                          <az-textbox formControlName=\"referenciaNum\" [(ngModel)]=\"cobranza.referenciaNum\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-12\">\n                                      <azteca-form-field [label]=\"'Observaciones:'\">\n                                          <az-textbox formControlName=\"observaciones\" [(ngModel)]=\"cobranza.observaciones\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\t\n\n                          </tab>\n                          <tab heading=\"Detalle\" (select)=\"onTabSelected($event)\">\n                        \n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'Caja'\">\n                                          <az-combobox formControlName=\"caja\"\n                                                       [(ngModel)]=\"cobranza.idCaja\"\n                                                       [items]=\"cajas\"\n                                                       [displayMember]=\"'nombre'\"\n                                                       [valueMember]=\"'id'\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n\n                                  <div class=\"col-12 col-md-3\">\n                                      <azteca-form-field [label]=\"'Monto:'\">\n                                          <az-input-number formControlName=\"monto\" [(ngModel)]=\"cobranza.total\" format=\"'n2'\" [enabled]=\"cobranza.identity=='' && anticipo.identity=='' && acumulado >0\"></az-input-number>\n                                      </azteca-form-field>\n                                  </div>\n                       \n                                  <div class=\"col-12 col-md-3\">\n                                      <azteca-form-field [label]=\"'Capturado:'\">\n                                          <az-input-number formControlName=\"acumulado\" [(ngModel)]=\"acumulado\" format=\"'n2'\" [enabled]=\"false\"></az-input-number>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n\n                              <az-toolbar (buttonClick)=\"onToolbarButtonClick($event)\">\n                                  <az-toolbar-button [name]=\"'ADD'\" [type]=\"'primary'\" [text]=\"'Agregar'\" [toolTip]=\"'Agregar documentos a la cobranza'\" [icon]=\"'glyphicon glyphicon-plus'\"></az-toolbar-button>\n                              </az-toolbar>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12\">\n                                      <wj-flex-grid #detailsList style=\"height:550px\"\n                                                    (dataLoaded)=\"onListItemsUpdated($event)\"\n                                                    (listItemsUpdated)=\"onListItemsUpdated($event)\"\n                                                    (cellEditEnding)=\"cellEditEndingHandler(detailsList, $event)\"\n                                                    (cellEditEnded)=\"onCellEditEnded(detailsList, $event)\"\n                                                    [itemsSource]=\"cuentasXCobrar\">\n\n                                          <wj-flex-grid-filter #filter></wj-flex-grid-filter>\n\n                                          <wj-flex-grid-column [header]=\"'Ref CXC'\" [binding]=\"'idCuentaPorCobrarTit'\" [width]=\"140\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                          <wj-flex-grid-column [header]=\"'Ref Origen'\" [binding]=\"'idDocumentoRef'\" [width]=\"140\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                          <wj-flex-grid-column [header]=\"'Fecha'\" [binding]=\"'fechaCuentaPorCobrar'\" [width]=\"100\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                          <wj-flex-grid-column [header]=\"'Deudor'\" [binding]=\"'deudor'\" [width]=\"200\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                          <wj-flex-grid-column [header]=\"'Serie'\" [binding]=\"'serie'\" [width]=\"80\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                          <wj-flex-grid-column [header]=\"'Folio'\" [binding]=\"'folioFactura'\" [width]=\"100\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                          <wj-flex-grid-column [header]=\"'Vencimiento'\" [binding]=\"'vencimiento'\" [width]=\"100\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                          <wj-flex-grid-column [header]=\"'Cond.Pago'\" [binding]=\"'condicionesPagoText'\" [width]=\"100\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                          <wj-flex-grid-column [header]=\"'Saldo'\" [binding]=\"'saldo'\" [width]=\"100\" dataType=\"Number\" format=\"C\" [isReadOnly]=\"true\"> </wj-flex-grid-column>\n                                          <wj-flex-grid-column [header]=\"'Cobro'\" [binding]=\"'importe'\" [width]=\"100\" dataType=\"Number\" format=\"C\" [isReadOnly]=\"condicionesPago == 'E'\" [aggregate]=\"'Sum'\"  >\n                                              <ng-template wjFlexGridCellTemplate [cellType]=\"'ColumnFooter'\" let-cell=\"cell\">\n                                                  Total: {{cell.value | currency:'USD':true:'.2-2'}}\n                                              </ng-template>\n                                          </wj-flex-grid-column>\n\n                                          <wj-flex-grid-column [header]=\"''\" [width]=\"55\" [isReadOnly]=\"true\">\n                                              <ng-template wjFlexGridCellTemplate [cellType]=\"'Cell'\" let-cell=\"cell\">\n                                                  <button type=\"button\" class=\"btn btn-default\" (click)=\"onImporteCheck(cell.item)\">\n                                                      <span class=\"glyphicon glyphicon-check\"></span>\n                                                  </button>\n                                              </ng-template>\n                                          </wj-flex-grid-column>\n\n                                      </wj-flex-grid>\n                                  </div>\n                              </div>                        \n\n\n                              <!--<azteca-editable-list #detailsList\n                                                      (addingItem)=\"onAddingDetail()\"\n                                                      (editingItem)=\"onEditingDetail($event)\"\n                                                      (deletingItem)=\"onDeletingDetail($event)\"\n                                                      (listItemsUpdated)=\"onListItemsUpdated($event)\"\n                                                      [listItems]=\"cobranza.details\">\n\n                                   \n                                          <azteca-grid-column [header]=\"'Ref CXC'\" [binding]=\"'idCuentaPorCobrarTit'\" [width]=\"130\"></azteca-grid-column>\n                                          <azteca-grid-column [header]=\"'Ref Origen'\" [binding]=\"'idDocumentoRef'\" [width]=\"130\"></azteca-grid-column>\n                                          <azteca-grid-column [header]=\"'Fecha'\" [binding]=\"'fechaCuentaPorCobrar'\" [width]=\"100\"></azteca-grid-column>\n                                          <azteca-grid-column [header]=\"'Deudor'\" [binding]=\"'deudor'\" [width]=\"200\"></azteca-grid-column>\n                                          <azteca-grid-column [header]=\"'Serie'\" [binding]=\"'serie'\" [width]=\"80\"></azteca-grid-column>\n                                          <azteca-grid-column [header]=\"'Folio'\" [binding]=\"'folioFactura'\" [width]=\"100\"></azteca-grid-column>\n                                          <azteca-grid-column [header]=\"'Vencimiento'\" [binding]=\"'vencimiento'\" [width]=\"100\" [isReadOnly]=\"true\"></azteca-grid-column>\n                                          <azteca-grid-column [header]=\"'Cond.Pago'\" [binding]=\"'condicionesPagoText'\" [width]=\"100\" [isReadOnly]=\"true\"></azteca-grid-column>\n                                          <azteca-grid-column [header]=\"'Saldo'\" [binding]=\"'saldo'\" [width]=\"100\" dataType=\"Number\" format=\"n2\"> </azteca-grid-column>\n                                          <azteca-grid-column [header]=\"'Cobro'\" [binding]=\"'importe'\" [width]=\"100\" dataType=\"Number\" format=\"n2\"> </azteca-grid-column>\n                                          <azteca-grid-column [header]=\"\" [binding]=\"'folioFactura'\" [width]=\"50\" dataType=\"Boolean\"></azteca-grid-column>\n                              </azteca-editable-list>-->\n                          </tab>\n\n                          <tab heading=\"Historial\" (select)=\"onTabSelected($event)\" [disabled]=\"cobranza.identity==''\" >\n                              <document-history [history]=\"history\"></document-history>\n                          </tab>\n\n                      </tabset>\n\n                  </div>\n              </div>\n          </azteca-document-editor>\n      </form>\n\n      <credito-cobranza-detail-editor #detailsEditor                                     \n                                           (savingItem)=\"onSavingDetail($event)\"                                     \n                                           (dataLoaded)=\"onDetailsLoaded($event)\"  >\n\n      </credito-cobranza-detail-editor>\n\n\n      <credit-cobranza #dlgCobranza (cobroAcceptado)=\"cobroAceptado($event)\">\n\n      </credit-cobranza>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return CobranzasEditor_1; })
                },
                {
                    provide: core_2.DocumentService, useExisting: cobranza_service_1.CobranzaService
                }
            ]
        }),
        __metadata("design:paramtypes", [core_2.Context,
            router_1.Router,
            router_1.ActivatedRoute,
            common_1.Location,
            forms_1.FormBuilder,
            core_2.DocumentTypeService,
            cobranza_service_1.CobranzaService,
            caja_service_1.CajaService])
    ], CobranzasEditor);
    return CobranzasEditor;
    var CobranzasEditor_1;
}(editors_1.DocumentEditor));
exports.CobranzasEditor = CobranzasEditor;
