import { Router, ActivatedRoute } from '@angular/router';
import { Context, DocumentItem } from 'framework3/core';
import { DocumentManager, WorkflowEventArgs } from 'framework3/editors';
import { SearchRequest } from 'framework3/search';
import { MenuItem, DownloadPopupComponent } from 'framework3/controls';
import { CobranzaItem } from '../models/cobranza';
import { CobranzaService } from '../services/cobranza.service';
import { CobranzaComponent } from '../parts/cobranza.component';
import { CobranzaFormaPagoDetail } from '../models/forma-pago-detail';
export declare class CobranzasManager extends DocumentManager {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    private cobranzaService;
    cobranzasTit: CobranzaItem[];
    argsCurrentDocument: WorkflowEventArgs;
    dlgCobranza: CobranzaComponent;
    downloadPopup: DownloadPopupComponent;
    constructor(context: Context, router: Router, route: ActivatedRoute, cobranzaService: CobranzaService);
    onConfigureDocument(): void;
    onSearchRequested(request: SearchRequest): void;
    onAddingItem(): void;
    onViewingItem(document: DocumentItem): void;
    onEditingItem(document: DocumentItem): void;
    onDeletingItem(document: DocumentItem): void;
    onCloningItem(document: DocumentItem): void;
    onApplyingNextStep(args: WorkflowEventArgs): void;
    onApplyingPreviousStep(document: DocumentItem): void;
    cobroAceptado(formasPagoCobro: CobranzaFormaPagoDetail): void;
    onMenuItemClick(option: MenuItem): void;
}
