import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { Context, DocumentItem, DocumentTypeService, DocumentTypeInfo } from 'framework3/core';
import { DocumentEditor, EditableListComponent, EditorEventArgs, WorkflowEventArgs } from 'framework3/editors';
import { CuentaPorCobrarInfo } from '../models/cuenta-por-cobrar';
import { CuentaPorCobrarDetail } from '../models/cuenta-por-cobrar-detail';
import { CuentaPorCobrarService } from '../services/cuenta-por-cobrar.service';
import { CuentaPorCobrarDetailEditor } from './parts/cuentas-por-cobrar-detail.editor';
export declare class CuentasPorCobrarEditor extends DocumentEditor {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    private location;
    private formBuilder;
    protected documentTypeService: DocumentTypeService;
    private cuentaPorCobrarService;
    cuentaPorCobrar: CuentaPorCobrarInfo;
    detailsList: EditableListComponent;
    detailsEditor: CuentaPorCobrarDetailEditor;
    constructor(context: Context, router: Router, route: ActivatedRoute, location: Location, formBuilder: FormBuilder, documentTypeService: DocumentTypeService, cuentaPorCobrarService: CuentaPorCobrarService);
    onConfigureDocument(docType: DocumentTypeInfo): void;
    onCreatingDocument(): void;
    onViewingDocument(id: string): void;
    onCloningDocument(id: string): void;
    onLoadingDocument(id: string): void;
    onSavingDocument(args: EditorEventArgs): void;
    onApplyingNextStep(args: WorkflowEventArgs): void;
    onApplyingPreviousStep(document: DocumentItem): void;
    onTabSelected(args: any): void;
    onAddingDetail(): void;
    onEditingDetail(detail: CuentaPorCobrarDetail): void;
    onDeletingDetail(detail: CuentaPorCobrarDetail): void;
    onListItemsUpdated(updatedDetails: CuentaPorCobrarDetail[]): void;
    onSavingDetail(detail: CuentaPorCobrarDetail): void;
}
