"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
var cuenta_por_cobrar_service_1 = require("../services/cuenta-por-cobrar.service");
var CuentasPorCobrarManager = /** @class */ (function (_super) {
    __extends(CuentasPorCobrarManager, _super);
    function CuentasPorCobrarManager(context, router, route, cuentaPorCobrarService) {
        var _this = _super.call(this, context, router, route) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.cuentaPorCobrarService = cuentaPorCobrarService;
        return _this;
    }
    CuentasPorCobrarManager_1 = CuentasPorCobrarManager;
    CuentasPorCobrarManager.prototype.onConfigureDocument = function () {
        this.refreshList();
        this.applyPolicies();
    };
    CuentasPorCobrarManager.prototype.onSearchRequested = function (request) {
        var _this = this;
        this.context.app.showSpinner();
        this.cuentaPorCobrarService.search(this.context.app.defaultSite.identity, request)
            .then(function (response) {
            _this.context.app.hideSpinner();
            //
            _this.cuentasPorCobrarTit = response.rows;
            _this.totalRows = response.totalRows;
            _this.filterGroups = response.filterGroups;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CuentasPorCobrarManager.prototype.onAddingItem = function () {
        this.router.navigate(['0'], { relativeTo: this.route });
    };
    CuentasPorCobrarManager.prototype.onViewingItem = function (document) {
        this.router.navigate([document.id, { readonly: true }], { relativeTo: this.route });
    };
    CuentasPorCobrarManager.prototype.onEditingItem = function (document) {
        this.router.navigate([document.id], { relativeTo: this.route });
    };
    CuentasPorCobrarManager.prototype.onDeletingItem = function (document) {
        var _this = this;
        this.cuentaPorCobrarService.delete(document.id)
            .then(function (success) {
            _this.refreshList();
            _this.showAlert('El documento ha sido eliminado con éxito.', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CuentasPorCobrarManager.prototype.onCloningItem = function (document) {
        this.router.navigate([0, { cloneId: document.id }], { relativeTo: this.route });
    };
    CuentasPorCobrarManager.prototype.onApplyingNextStep = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.cuentaPorCobrarService.nextStep(args.document.id, args.step.idWorkflowStep, null)
            .then(function (_) {
            _this.context.app.hideSpinner();
            _this.refreshList();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CuentasPorCobrarManager.prototype.onApplyingPreviousStep = function (document) {
        var _this = this;
        this.context.app.showSpinner();
        this.cuentaPorCobrarService.previousStep(document.id, null)
            .then(function (_) {
            _this.context.app.hideSpinner();
            _this.refreshList();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CuentasPorCobrarManager = CuentasPorCobrarManager_1 = __decorate([
        core_1.Component({
            selector: 'credito-cuentas-por-cobrar-manager',
            template: "\n      <div class=\"card\">\n          <div class=\"card-header\">Cuentas Por Cobrar</div>\n          <div class=\"card-body\">\n              <azteca-document-manager    (searchRequested)=\"onSearchRequested($event)\"\n                                          (addingItem)=\"onAddingItem()\"\n                                          (viewingItem)=\"onViewingItem($event)\"\n                                          (editingItem)=\"onEditingItem($event)\"\n                                          (deletingItem)=\"onDeletingItem($event)\"\n                                          (cloningItem)=\"onCloningItem($event)\"\n                                          (applyingNextStep)=\"onApplyingNextStep($event)\"\n                                          (applyingPreviousStep)=\"onApplyingPreviousStep($event)\"\n                                          (configureDocument)=\"onConfigureDocument($event)\"\n                                          [enabled]=\"enabled\"\n                                          [allowNew]=\"allowNew\"\n                                          [allowView]=\"allowView\"\n                                          [allowEdit]=\"allowEdit\"\n                                          [allowDelete]=\"allowDelete\"\n                                          [allowClone]=\"allowClone\"\n                                          [allowNext]=\"allowNext\"\n                                          [allowPrevious]=\"allowPrevious\"\n                                          [allowAudit]=\"allowAudit\"\n                                          [filterGroups]=\"filterGroups\"\n                                          [documentList]=\"cuentasPorCobrarTit\">\n\n\n              <!------------------- Menu de acciones adicionales --------------------->\n\n              <!------------------- Columnas del listado ----------------------------->\n\n                  <azteca-grid-column [header]=\"'Folio'\" [binding]=\"'id'\" [width]=\"150\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Fecha'\" [binding]=\"'fechaCreacion'\" [width]=\"130\" dataType=\"Date\" format=\"dd-MM-yyyy HH:mm\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Serie'\" [binding]=\"'serie'\" [width]=\"50\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Factura'\" [binding]=\"'folioFactura'\" [width]=\"60\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Condiciones'\" [binding]=\"'condicionesPago'\" [width]=\"60\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Deudor'\" [binding]=\"'deudor'\" [width]=\"200\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Total'\" [binding]=\"'total'\" [width]=\"80\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Paso'\" [binding]=\"'workflowStep'\" [width]=\"80\"></azteca-grid-column>\n\n              </azteca-document-manager>\n          </div>\n      </div>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return CuentasPorCobrarManager_1; })
                },
                {
                    provide: core_2.DocumentService, useExisting: cuenta_por_cobrar_service_1.CuentaPorCobrarService
                }
            ]
        }),
        __metadata("design:paramtypes", [core_2.Context, router_1.Router, router_1.ActivatedRoute, cuenta_por_cobrar_service_1.CuentaPorCobrarService])
    ], CuentasPorCobrarManager);
    return CuentasPorCobrarManager;
    var CuentasPorCobrarManager_1;
}(editors_1.DocumentManager));
exports.CuentasPorCobrarManager = CuentasPorCobrarManager;
