import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { CollectionView } from 'wijmo/wijmo';
import { Context, DocumentItem, DocumentTypeService, DocumentTypeInfo } from 'framework3/core';
import { ToolbarButton } from 'framework3/controls';
import { DocumentEditor, EditableListComponent, EditorEventArgs, WorkflowEventArgs } from 'framework3/editors';
import { NotaInfo } from '../models/nota';
import { FacturaInfo } from '../models/factura';
import { NotaDetail } from '../../accounting/models/nota-detail';
import { NotaService } from '../services/nota.service';
import { NotaDetailEditor } from '../../accounting/documents/parts/notas-detail.editor';
import { FormaPagoService } from '../../accounting/services/forma-pago.service';
import { FormaPagoItem } from '../../accounting/models/forma-pago';
import { FacturaSelectorComponent } from '../../credit';
export declare class NotasEditor extends DocumentEditor {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    private location;
    private formBuilder;
    protected documentTypeService: DocumentTypeService;
    private notaService;
    private formaPagoService;
    nota: NotaInfo;
    formasPago: FormaPagoItem[];
    detailsList: EditableListComponent;
    detailsEditor: NotaDetailEditor;
    selectorFactura: FacturaSelectorComponent;
    cuentasCollection: CollectionView;
    constructor(context: Context, router: Router, route: ActivatedRoute, location: Location, formBuilder: FormBuilder, documentTypeService: DocumentTypeService, notaService: NotaService, formaPagoService: FormaPagoService);
    onConfigureDocument(docType: DocumentTypeInfo): void;
    onCreatingDocument(): void;
    onViewingDocument(id: string): void;
    onCloningDocument(id: string): void;
    onLoadingDocument(id: string): void;
    onSavingDocument(args: EditorEventArgs): void;
    onApplyingNextStep(args: WorkflowEventArgs): void;
    onApplyingPreviousStep(document: DocumentItem): void;
    onTabSelected(args: any): void;
    onAddingDetail(): void;
    onEditingDetail(detail: NotaDetail): void;
    onDeletingDetail(detail: NotaDetail): void;
    onListItemsUpdated(updatedDetails: NotaDetail[]): void;
    onSavingDetail(detail: NotaDetail): void;
    loadFormasPago(): void;
    asignarFactura(factura: FacturaInfo): void;
    onToolbarButtonClick(button: ToolbarButton): void;
}
