"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Wijmo
var wijmo_1 = require("wijmo/wijmo");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//Locales
var nota_1 = require("../models/nota");
var nota_relaciones_1 = require("../models/nota-relaciones");
var nota_detail_1 = require("../../accounting/models/nota-detail");
var nota_service_1 = require("../services/nota.service");
var notas_detail_editor_1 = require("../../accounting/documents/parts/notas-detail.editor");
var forma_pago_service_1 = require("../../accounting/services/forma-pago.service");
var credit_1 = require("../../credit");
var NotasEditor = /** @class */ (function (_super) {
    __extends(NotasEditor, _super);
    function NotasEditor(context, router, route, location, formBuilder, documentTypeService, notaService, formaPagoService) {
        var _this = _super.call(this, context, router, route, documentTypeService) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.location = location;
        _this.formBuilder = formBuilder;
        _this.documentTypeService = documentTypeService;
        _this.notaService = notaService;
        _this.formaPagoService = formaPagoService;
        _this.nota = new nota_1.NotaInfo();
        _this.formasPago = [];
        _this.cuentasCollection = new wijmo_1.CollectionView();
        _this.documentForm = formBuilder.group({
            'deudor': [0, forms_1.Validators.required],
            'divisa': [0, forms_1.Validators.required],
            'idFormaPago': [0, forms_1.Validators.required],
            'observaciones': ['', forms_1.Validators.required],
            'factura': [''],
        });
        return _this;
    }
    NotasEditor_1 = NotasEditor;
    NotasEditor.prototype.onConfigureDocument = function (docType) {
        this.loadFormasPago();
        this.applyPolicies();
    };
    NotasEditor.prototype.onCreatingDocument = function () {
    };
    NotasEditor.prototype.onViewingDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.notaService.getDetail(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.nota = doc;
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    NotasEditor.prototype.onCloningDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.notaService.clone(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.nota = doc;
            _this.detailsEditor.clientIndexStart = _this.nota.details.length;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    NotasEditor.prototype.onLoadingDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.notaService.getDetail(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.nota = doc;
            _this.cuentasCollection.sourceCollection = _this.nota.relaciones;
            _this.detailsEditor.clientIndexStart = _this.nota.details.length;
            if (_this.nota.status != core_2.DocumentStatus.DRAFT)
                _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    NotasEditor.prototype.onSavingDocument = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.notaService.update(this.nota)
            .then(function (updatedDoc) {
            _this.context.app.hideSpinner();
            //Si es un elemento nuevo y no se cerrará el editor, navegar a nueva ruta
            _this.reset();
            if (!args.closeEditor && _this.nota.identity == '') {
                _this.router.navigate(['../', updatedDoc.identity], { relativeTo: _this.route });
            }
            else {
                if (args.closeEditor)
                    _this.router.navigate(['../'], { relativeTo: _this.route });
                else
                    _this.showAlert('La información ha sido actualizada con éxito', 'success');
            }
            _this.nota = updatedDoc;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    NotasEditor.prototype.onApplyingNextStep = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.notaService.nextStep(args.document.id, args.step.idWorkflowStep, null)
            .then(function (_) {
            //Volver a cargar documento
            _this.onViewingDocument(args.document.id);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    NotasEditor.prototype.onApplyingPreviousStep = function (document) {
        var _this = this;
        this.context.app.showSpinner();
        this.notaService.previousStep(document.id, null)
            .then(function (_) {
            //Volver a cargar documento
            _this.onViewingDocument(document.id);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    NotasEditor.prototype.onTabSelected = function (args) {
        if (args.heading) {
            //Al seleccionar la pestaña de historial, realizar carga de información
            if (args.heading == 'Historial') {
                this.loadHistory(this.nota.identity);
            }
            //Actualizar controles de wijmo
            wijmo_1.Control.invalidateAll();
        }
    };
    ///////////// DETALLE DEL DOCUMENTO /////////////////////////
    NotasEditor.prototype.onAddingDetail = function () {
        this.detailsEditor.detail = new nota_detail_1.NotaDetail();
        this.detailsEditor.show();
    };
    NotasEditor.prototype.onEditingDetail = function (detail) {
        this.detailsEditor.detail = detail;
        this.detailsEditor.show();
    };
    NotasEditor.prototype.onDeletingDetail = function (detail) {
        this.detailsList.deleteItem(detail);
    };
    NotasEditor.prototype.onListItemsUpdated = function (updatedDetails) {
        this.nota.notaBase.details = updatedDetails;
    };
    NotasEditor.prototype.onSavingDetail = function (detail) {
        this.detailsList.updateItem(detail);
    };
    NotasEditor.prototype.loadFormasPago = function () {
        var _this = this;
        this.formaPagoService.loadList(this.context.app.defaultSite.identity)
            .then(function (formas) { return _this.formasPago = formas; })
            .catch(function (error) { return _this.handleError(error); });
    };
    NotasEditor.prototype.asignarFactura = function (factura) {
        var rel = new nota_relaciones_1.NotaRelaciones;
        factura.details.forEach(function (detail) {
            rel.idCuentaPorCobrar = detail.idCuentaPorCobrarTit;
            rel.idNotaRelacion = 0;
            rel.saldoInicial = detail.cuentaPorCobrar.saldo;
            rel.importe = detail.cuentaPorCobrar.saldo;
            rel.saldoFinal = detail.cuentaPorCobrar.saldo;
        });
        var newRel = this.nota.relaciones.slice();
        newRel.push(rel);
        this.nota.relaciones = newRel;
        this.cuentasCollection.sourceCollection = newRel;
        this.cuentasCollection.refresh;
    };
    NotasEditor.prototype.onToolbarButtonClick = function (button) {
        if (button.name == 'ADD') {
            this.asignarFactura(this.selectorFactura.selectedItem);
        }
    };
    __decorate([
        core_1.ViewChild('detailsList'),
        __metadata("design:type", editors_1.EditableListComponent)
    ], NotasEditor.prototype, "detailsList", void 0);
    __decorate([
        core_1.ViewChild('detailsEditor'),
        __metadata("design:type", notas_detail_editor_1.NotaDetailEditor)
    ], NotasEditor.prototype, "detailsEditor", void 0);
    __decorate([
        core_1.ViewChild('selectorFactura'),
        __metadata("design:type", credit_1.FacturaSelectorComponent)
    ], NotasEditor.prototype, "selectorFactura", void 0);
    NotasEditor = NotasEditor_1 = __decorate([
        core_1.Component({
            selector: 'credito-notas-editor',
            template: "\n      <form [formGroup]=\"documentForm\">\n          <azteca-document-editor #documentEditor\n                                         [title]=\"'Notas'\"\n                                         [document]=\"nota\"\n                                         [valid]=\"valid\"\n                                         (configureDocument)=\"onConfigureDocument($event)\"\n                                         (creatingDocument)=\"onCreatingDocument()\"\n                                         (viewingDocument)=\"onViewingDocument($event)\"\n                                         (cloningDocument)=\"onCloningDocument($event)\"\n                                         (savingDocument)=\"onSavingDocument($event)\"\n                                         (loadingDocument)=\"onLoadingDocument($event)\"\n                                         (applyingNextStep)=\"onApplyingNextStep($event)\"\n                                         (menuItemClick)=\"onMenuItemClick($event)\">\n\n              <!------------------- Menu de acciones adicionales --------------------->\n\n              <!------------------- Controles del editor ----------------------------->\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <tabset>\n                          <tab heading=\"Generales\" (select)=\"onTabSelected($event)\">\n\n                              <azteca-form-field [label]=\"'Seleccionar deudor:'\">\n                                  <azteca-form-field [label]=\"Deudor\">\n                                      <credit-deudores-selector formControlName=\"deudor\" [(ngModel)]=\"nota.idDeudor\"></credit-deudores-selector>\n                                  </azteca-form-field>\n                              </azteca-form-field>\n\n                              <azteca-form-field [label]=\"'Seleccionar divisa:'\">\n                                  <azteca-form-field [label]=\"Divisa\">\n                                      <accounting-divisas-selector formControlName=\"divisa\" [(ngModel)]=\"nota.notaBase.idDivisa\"></accounting-divisas-selector>\n                                  </azteca-form-field>\n                              </azteca-form-field>\n\n                              <azteca-form-field [label]=\"'Forma de Pago:'\">\n                                  <az-combobox formControlName=\"idFormaPago\"\n                                               [(ngModel)]=\"nota.notaBase.idFormaPago\"\n                                               [items]=\"formasPago\"\n                                               [displayMember]=\"'nombre'\"\n                                               [valueMember]=\"'id'\">\n                                  </az-combobox>\n                              </azteca-form-field>\n\n                              <azteca-form-field [label]=\"'Observaciones:'\">\n                                  <az-textarea formControlName=\"observaciones\" [(ngModel)]=\"nota.notaBase.observaciones\"></az-textarea>\n                              </azteca-form-field>\n\n\n                          </tab>\n                          <tab heading=\"Detalle\" (select)=\"onTabSelected($event)\">\n                              <azteca-editable-list   #detailsList\n                                                      (addingItem)=\"onAddingDetail()\"\n                                                      (editingItem)=\"onEditingDetail($event)\"\n                                                      (deletingItem)=\"onDeletingDetail($event)\"\n                                                      (listItemsUpdated)=\"onListItemsUpdated($event)\"\n                                                      [listItems]=\"nota.notaBase.details\">\n\n                                  <!-- OPCIONES DEL MENU-->\n                                  <azteca-menu-item [name]=\"'EDIT'\" [icon]=\"'glyphicon glyphicon-pencil'\" [text]=\"'Editar'\" [smallText]=\"'editar registro'\"></azteca-menu-item>\n                                  <azteca-menu-item [name]=\"'DELETE'\" [icon]=\"'glyphicon glyphicon-trash'\" [text]=\"'Eliminar'\" [smallText]=\"'eliminar registro'\"></azteca-menu-item>\n\n                                  <!-- COLUMNAS DEL GRID-->\n                                  <!-- Columnas de Ejemplo-->\n                                  <azteca-grid-column [header]=\"'Concepto'\" [binding]=\"'concepto'\" [width]=\"'30*'\" [isReadOnly]=\"true\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Importe'\" [binding]=\"'importe'\" [width]=\"'10*'\" [isReadOnly]=\"true\"></azteca-grid-column>\n\n                              </azteca-editable-list>\n                          </tab>\n\n                          <tab heading=\"Comprobantes fiscales\" (select)=\"onTabSelected($event)\">\n\n\n                              <div class=\"row\">\n                                  <div class=\"col-12\">\n                                      <azteca-form-field [label]=\"'Agregar comprobante:'\">\n                                          <azteca-form-field [label]=\"Comprobante\">\n                                              <credit-facturas-selector formControlName=\"factura\" [idDeudor]=\"nota.idDeudor\" #selectorFactura> </credit-facturas-selector>\n                                          </azteca-form-field>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <az-toolbar (buttonClick)=\"onToolbarButtonClick($event)\">\n                                  <az-toolbar-button [name]=\"'ADD'\" [type]=\"'primary'\" [text]=\"'Agregar'\" [toolTip]=\"'Agregar comprobante'\" [icon]=\"'glyphicon glyphicon-plus'\" [enabled]=\"true\"></az-toolbar-button>\n                              </az-toolbar>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12\">\n                                      <wj-flex-grid #grid style=\"height:550px\"\n                                                    [itemsSource]=\"cuentasCollection\"\n                                                    [wjContextMenu]=\"ctxMenuComprobantes\"\n                                                    [isReadOnly]=\"false\">\n                                          <wj-flex-grid-filter #filter></wj-flex-grid-filter>\n\n                                          <wj-flex-grid-column [header]=\"'Cuenta por Cobrar'\" [binding]=\"'idCuentaPorCobrar'\" [width]=\"'30*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                          <wj-flex-grid-column [header]=\"'Saldo inicial'\" [binding]=\"'saldoInicial'\" [width]=\"'20*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                          <wj-flex-grid-column [header]=\"'Importe'\" [binding]=\"'importe'\" [width]=\"'20*'\" [isReadOnly]=\"false\"></wj-flex-grid-column>\n\n                                      </wj-flex-grid>\n                                  </div>\n                              </div>\n\n\n\n                          </tab>\n\n                              <tab heading=\"Historial\" (select)=\"onTabSelected($event)\">\n                                  <document-history [history]=\"history\"></document-history>\n                              </tab>\n                 </tabset>\n\n                  </div>\n              </div>\n          </azteca-document-editor>\n      </form>\n\n      <credito-nota-detail-editor #detailsEditor                                     \n                                           (savingItem)=\"onSavingDetail($event)\">\n\n      </credito-nota-detail-editor>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return NotasEditor_1; })
                },
                {
                    provide: core_2.DocumentService, useExisting: nota_service_1.NotaService
                }
            ]
        }),
        __metadata("design:paramtypes", [core_2.Context,
            router_1.Router,
            router_1.ActivatedRoute,
            common_1.Location,
            forms_1.FormBuilder,
            core_2.DocumentTypeService,
            nota_service_1.NotaService,
            forma_pago_service_1.FormaPagoService])
    ], NotasEditor);
    return NotasEditor;
    var NotasEditor_1;
}(editors_1.DocumentEditor));
exports.NotasEditor = NotasEditor;
