import { EventEmitter } from '@angular/core';
import { FormBuilder } from '@angular/forms';
import { Context } from 'framework3/core';
import { BasicEditor } from 'framework3/editors';
import { AlertsBarComponent } from 'framework3/controls';
import { CobranzaDetail } from '../../models/cobranza-detail';
import { CobranzaService } from '../../services/cobranza.service';
import { GrupoDeudorInfo } from '../../models/grupo-deudor';
import { DeudorInfo } from '../../models/deudor';
import { AnticipoInfo } from '../../models/anticipo';
import { ContribuyenteInfo } from '../../../accounting/models/contribuyente';
export declare class CobranzaDetailEditor extends BasicEditor {
    protected context: Context;
    private builder;
    private cobranzaService;
    detailCopy: CobranzaDetail;
    detail: CobranzaDetail;
    details: CobranzaDetail[];
    dataLoaded: EventEmitter<CobranzaDetail[]>;
    alerts: AlertsBarComponent;
    busquedaTipos: {
        id: string;
        nombre: string;
    }[];
    tipoBusqueda: string;
    idGrupoDeudor: number;
    idDeudor: number;
    idAnticipo: string;
    idContribuyente: number;
    rfc: string;
    fechaIni: Date;
    fechaFin: Date;
    anticipo: AnticipoInfo;
    constructor(context: Context, builder: FormBuilder, cobranzaService: CobranzaService);
    onCreatingItem(): void;
    onLoadingItem(detail: CobranzaDetail): void;
    onUpdatingItem(detail: CobranzaDetail): void;
    loadCxCbyGrupoDeudor(): void;
    loadCxCbyDeudor(): void;
    loadCxCbyRFC(): void;
    selectedBusqueda(item: any): void;
    onGrupoDeudorSelected(grupo: GrupoDeudorInfo): void;
    onDeudorSelected(deudor: DeudorInfo): void;
    onContribuyenteSelected(contribuyente: ContribuyenteInfo): void;
    onAnticipoSelected(anticipo: AnticipoInfo): void;
    showAlert(message: string, type: string): void;
}
