"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
//Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//Locales
var nota_detail_1 = require("../../../accounting/models/nota-detail");
var accounting_1 = require("../../../accounting");
var nota_concepto_1 = require("../../../accounting/models/nota-concepto");
var NotaDetailEditor = /** @class */ (function (_super) {
    __extends(NotaDetailEditor, _super);
    function NotaDetailEditor(context, builder) {
        var _this = _super.call(this, context) || this;
        _this.context = context;
        _this.builder = builder;
        //Copia temporal que se utilizará para edición y no afecte al objeto original por si el usuario decide cancelar la edición
        _this.detailCopy = new nota_detail_1.NotaDetail();
        _this.notaConcepto = new nota_concepto_1.NotaConceptoInfo();
        //Objeto original que se editará
        _this.detail = new nota_detail_1.NotaDetail();
        _this.form = builder.group({
            'idNotaConcepto': [0, forms_1.Validators.required],
            'importe': [0, forms_1.Validators.required],
            'concepto': [''],
        });
        return _this;
    }
    /////////////////// METODOS ///////////////////////////////
    /////////////////// HANDLERS //////////////////////////////
    NotaDetailEditor.prototype.onSelectedItemChanged = function (concepto) {
        if (concepto) {
            this.notaConcepto = concepto;
        }
    };
    NotaDetailEditor.prototype.onCreatingItem = function () {
        this.detailCopy = this.detail;
        this.form.reset({ sample: '' });
        this.form.markAsPristine();
    };
    NotaDetailEditor.prototype.onLoadingItem = function (detail) {
        this.detailCopy = this.copyItem(this.detail);
    };
    NotaDetailEditor.prototype.onUpdatingItem = function (detail) {
        var _this = this;
        if (this.detailCopy._clientID == 0) {
            this.detailCopy._clientID = this.createClientID();
            ////Calculando los impuestos////
            this.notaConcepto.impuestos.forEach(function (det) {
                var nuevoImpuesto = new accounting_1.ImpuestoDetailInfo;
                nuevoImpuesto.importe = detail.importe; //detail.importe * det.tasaOCuota;
                nuevoImpuesto.tasaOCuota = det.tasaOCuota;
                nuevoImpuesto.tipoAplicacion = det.tipoAplicacion;
                nuevoImpuesto.tipoFactor = det.impuesto.factor;
                nuevoImpuesto.base = detail.importe / (1 + det.tasaOCuota);
                nuevoImpuesto.impuesto = det.impuesto;
                if (det.impuesto.factor == "T") {
                    _this.impuestoCalculado = detail.importe * det.tasaOCuota;
                }
                else {
                    _this.impuestoCalculado = det.tasaOCuota;
                }
                _this.detailCopy.impuestos.push(nuevoImpuesto);
            });
            ////////////////////////////////
        }
        else {
            this.detailCopy.state = editors_1.ChangeState.MODIFIED;
        }
        this.savingItem.emit(this.detailCopy);
    };
    __decorate([
        core_1.ViewChild('selectorNotaConcepto'),
        __metadata("design:type", accounting_1.NotaConceptoSelectorComponent)
    ], NotaDetailEditor.prototype, "selectorNotaConcepto", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", nota_detail_1.NotaDetail)
    ], NotaDetailEditor.prototype, "detail", void 0);
    NotaDetailEditor = __decorate([
        core_1.Component({
            selector: 'credito-nota-detail-editor',
            template: "\n      <form [formGroup]=\"form\">\n          <azteca-basic-editor [item]=\"detail\"\n                               [dirty]=\"dirty\"\n                               [valid]=\"valid\"\n                               (creatingItem)=\"onCreatingItem()\"\n                               (loadingItem)=\"onLoadingItem($event)\"\n                               (updatingItem)=\"onUpdatingItem($event)\">\n\n              <azteca-form-field [label]=\"'Seleccionar concepto:'\">\n                  <azteca-form-field [label]=\"Concepto\">\n                      <accounting-nota-concepto-selector formControlName=\"idNotaConcepto\" [(ngModel)]=\"detailCopy.idNotaConcepto\" #selectorNotaConcepto (selectedItemChanged)=\"onSelectedItemChanged($event)\"></accounting-nota-concepto-selector>\n                  </azteca-form-field>\n              </azteca-form-field>\n\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <azteca-form-field [label]=\"'Concepto:'\">\n                          <az-textbox formControlName=\"concepto\" [(ngModel)]=\"detailCopy.concepto\" [enabled]=\"notaConcepto.conceptoLibre>0\"></az-textbox>\n                      </azteca-form-field>\n                  </div>\n              </div>\n\n\n              <azteca-form-field [label]=\"'Importe:'\">\n                  <az-input-number formControlName=\"importe\" [(ngModel)]=\"detailCopy.importe\" format=\"c\"></az-input-number>\n              </azteca-form-field>\n\n          </azteca-basic-editor>\n      </form>\n    "
        }),
        __metadata("design:paramtypes", [core_2.Context, forms_1.FormBuilder])
    ], NotaDetailEditor);
    return NotaDetailEditor;
}(editors_1.BasicEditor));
exports.NotaDetailEditor = NotaDetailEditor;
