import { Router, ActivatedRoute } from '@angular/router';
import { Location } from '@angular/common';
import { BaseComponent, Context, CatalogItem, PolicyInfo, UsuarioItem } from 'framework3/core';
import { ToolbarButton, AlertsBarComponent } from 'framework3/controls';
import { UsuariosListComponent } from 'framework3/security';
import { CajaService } from '../services/caja.service';
import { CajaInfo } from '../models/caja';
export declare class CajaMiembrosComponent extends BaseComponent {
    private context;
    private cajaService;
    private router;
    private route;
    private location;
    title: string;
    usuarios: UsuarioItem[];
    idCaja: number;
    caja: CajaInfo;
    currentItem: CatalogItem;
    usuariosDialog: UsuariosListComponent;
    alerts: AlertsBarComponent;
    constructor(context: Context, cajaService: CajaService, router: Router, route: ActivatedRoute, location: Location);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    loadCaja(): void;
    refreshList(): void;
    onCurrentItemChanged(item: CatalogItem): void;
    onToolbarButtonClick(button: ToolbarButton): void;
    onSelectedUsersChanged(newUsers: UsuarioItem[]): void;
    onRemoveUser(): void;
    applyPolicy(policy: PolicyInfo): void;
    handleError(error: any): void;
}
