"use strict";
//Frameworks
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var forms_1 = require("@angular/forms");
//Bootstrap
//Features
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var moment = require("moment");
var wijmo_1 = require("wijmo/wijmo");
var ngx_bootstrap_1 = require("ngx-bootstrap");
//Azteca Kernel
var controls_1 = require("framework3/controls");
var core_2 = require("framework3/core");
//
var caja_service_1 = require("../services/caja.service");
var caja_1 = require("../models/caja");
//import { PolizaLogEntry } from '../../models/poliza-log-entry';
var CorteHistoricoComponent = /** @class */ (function () {
    function CorteHistoricoComponent(formBuilder, context, router, route, cajaService) {
        this.formBuilder = formBuilder;
        this.context = context;
        this.router = router;
        this.route = route;
        this.cajaService = cajaService;
        this.logCollection = new wijmo_1.CollectionView();
        this.currentEntry = new caja_1.CorteItem();
        this.editorForm = formBuilder.group({
            'fechaIni': [0],
            'fechaFin': [0],
        });
    }
    /////////////////////// METODOS ////////////////////////////////////////////////
    CorteHistoricoComponent.prototype.loadLog = function () {
        var _this = this;
        this.context.app.showSpinner();
        this.cajaService.loadCortesHistorico(this.idCaja, this.fechaIni, this.fechaFin)
            .then(function (log) {
            _this.logCollection.sourceCollection = log;
            _this.context.app.hideSpinner();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    /////////////////////// HANDLERS ///////////////////////////////////////////////
    CorteHistoricoComponent.prototype.mainToolbarClick = function (button) {
        if (button.name == 'REFRESH') {
            this.loadLog();
        }
    };
    CorteHistoricoComponent.prototype.onRowView = function (entry) {
        this.currentEntry = entry;
        this.detailsDialog.config.backdrop = false;
        this.detailsDialog.show();
    };
    CorteHistoricoComponent.prototype.handleError = function (error) {
        console.error(error);
        this.context.app.hideSpinner();
        var message = this.context.getExceptionMessage(error);
        this.alerts.showAlert(message, 'danger');
    };
    CorteHistoricoComponent.prototype.show = function (idCaja) {
        this.logCollection = new wijmo_1.CollectionView();
        this.corteHistoricoDialog.config.backdrop = false;
        this.idCaja = idCaja;
        this.corteHistoricoDialog.show();
        this.fechaIni = moment().subtract(2, 'week').toDate();
        this.fechaFin = moment().toDate();
        this.loadLog();
    };
    __decorate([
        core_1.ViewChild(controls_1.AlertsBarComponent),
        __metadata("design:type", controls_1.AlertsBarComponent)
    ], CorteHistoricoComponent.prototype, "alerts", void 0);
    __decorate([
        core_1.ViewChild('detailsDialog'),
        __metadata("design:type", ngx_bootstrap_1.ModalDirective)
    ], CorteHistoricoComponent.prototype, "detailsDialog", void 0);
    __decorate([
        core_1.ViewChild('corteHistorico'),
        __metadata("design:type", ngx_bootstrap_1.ModalDirective)
    ], CorteHistoricoComponent.prototype, "corteHistoricoDialog", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], CorteHistoricoComponent.prototype, "idCaja", void 0);
    CorteHistoricoComponent = __decorate([
        core_1.Component({
            selector: 'credit-corte-historico-component',
            template: "\n      <div bsModal #corteHistorico=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"myLargeModalLabel\" aria-hidden=\"true\">\n          <div class=\"modal-dialog modal-lg\">\n              <div class=\"modal-content\">\n                  <div class=\"modal-body\">\n\n                      <form [formGroup]=\"editorForm\">\n\n                          <div class=\"row\">\n                              <div class=\"col-12\">\n                                  <alerts-bar></alerts-bar>\n                              </div>\n                          </div>\n\n                          <div class=\"row\">\n\n                              <div class=\"col-12\">\n                                  <az-panel [header]=\"'Historial de Cortes de la caja'\">\n\n                                      <az-panel [header]=\"'Rango de Fechas'\">\n                                          <div class=\"row\">\n                                              <div class=\"col-10 col-md-5\">\n                                                  <azteca-form-field [label]=\"'Fecha Inicial:'\">\n                                                      <az-input-date-time [(ngModel)]=\"fechaIni\" formControlName=\"fechaIni\" format='dd-MM-yyyy'></az-input-date-time>\n                                                  </azteca-form-field>\n                                              </div>\n\n                                              <div class=\"col-10 col-md-5\">\n                                                  <azteca-form-field [label]=\"'Fecha Final:'\">\n                                                      <az-input-date-time [(ngModel)]=\"fechaFin\" formControlName=\"fechaFin\" format='dd-MM-yyyy'></az-input-date-time>\n                                                  </azteca-form-field>\n                                              </div>\n                                              <div class=\"col-12 col-lg-2\">\n                                                  <button type=\"submit\" class=\"btn btn-primary\" (click)=\"loadLog()\" >\n                                                      <span class=\"glyphicon glyphicon-refresh\" aria-hidden=\"true\"></span> Actualizar\n                                                  </button>\n                                              </div>                                    \n                                          </div>\n                                      </az-panel>\n\n\n                                      <wj-flex-grid style=\"height:550px\" [itemsSource]=\"logCollection\" [isReadOnly]=\"true\">\n\n                                          <wj-flex-grid-filter #filter></wj-flex-grid-filter>\n\n                                          <wj-flex-grid-column [header]=\"''\" [width]=\"60\" [isReadOnly]=\"true\">\n                                              <ng-template wjFlexGridCellTemplate [cellType]=\"'Cell'\" let-cell=\"cell\">\n                                                  <button type=\"button\" class=\"btn btn-default\" (click)=\"onRowView(cell.item)\">\n                                                      <span class=\"glyphicon glyphicon-print\"></span>\n                                                  </button>\n                                              </ng-template>\n                                          </wj-flex-grid-column>\n\n                                          <wj-flex-grid-column [header]=\"'Apertura'\" [binding]=\"'horaApertura'\" [width]=\"200\" [format]=\"'dd/MM/yyyy hh:mm tt'\"></wj-flex-grid-column>\n                                          <wj-flex-grid-column [header]=\"'Cierre'\" [binding]=\"'horaCierre'\" [width]=\"200\" [format]=\"'dd/MM/yyyy hh:mm tt'\"></wj-flex-grid-column>\n                                          <wj-flex-grid-column [header]=\"'Cajero'\" [binding]=\"'cajero'\" [width]=\"'50*'\"></wj-flex-grid-column>\n                                          <!--<wj-flex-grid-column [header]=\"'Origen'\" [binding]=\"'source'\" [width]=\"'15*'\"></wj-flex-grid-column>\n                                          <wj-flex-grid-column [header]=\"'Tipo'\" [binding]=\"'type'\" [width]=\"'15*'\"></wj-flex-grid-column>-->\n                                      </wj-flex-grid>\n\n                                      <div class=\"row\">\n                                          <button type=\"button\" class=\"btn btn-primary\" (click)=\"corteHistorico.hide()\">Cerrar</button>\n                                      </div>\n\n                                  </az-panel>\n\n                              </div> <!--Modal Body-->\n\n                          </div>\n\n                      </form>\n\n                  </div>\n              </div> <!-- Modal Content-->\n          </div> <!--Modal-->\n      </div> <!--Modal directive-->\n    "
        }),
        __metadata("design:paramtypes", [forms_1.FormBuilder, core_2.Context, router_1.Router, router_1.ActivatedRoute,
            caja_service_1.CajaService])
    ], CorteHistoricoComponent);
    return CorteHistoricoComponent;
}());
exports.CorteHistoricoComponent = CorteHistoricoComponent;
