import { HttpClient } from '@angular/common/http';
import 'rxjs/add/operator/toPromise';
import { Context, DocumentService, FileLink } from 'framework3/core';
import { CobranzaInfo } from '../models/cobranza';
import { CobranzaDetail } from '../models/cobranza-detail';
export declare class CobranzaService extends DocumentService<CobranzaDetail, CobranzaInfo> {
    protected http: HttpClient;
    protected context: Context;
    constructor(http: HttpClient, context: Context);
    create(): Promise<CobranzaInfo>;
    loadCxCByGrupoDeudor(fechaIni: string, fechaFin: string, idGrupoDeudor: number): Promise<CobranzaDetail[]>;
    loadCxCByDeudor(fechaIni: string, fechaFin: string, idDeudor: number): Promise<CobranzaDetail[]>;
    loadCxCByRFC(fechaIni: string, fechaFin: string, rfc: string): Promise<CobranzaDetail[]>;
    generarPdfFactura(idCobranza: string): Promise<FileLink>;
    getXmlFactura(idCobranza: string): Promise<FileLink>;
}
