"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var http_1 = require("@angular/common/http");
require("rxjs/add/operator/toPromise");
//Azteca Framework
var core_2 = require("framework3/core");
//Locales
var cobranza_1 = require("../models/cobranza");
var CobranzaService = /** @class */ (function (_super) {
    __extends(CobranzaService, _super);
    function CobranzaService(http, context) {
        var _this = _super.call(this, http, context, 'api/credito/cobranzas-tit') || this;
        _this.http = http;
        _this.context = context;
        return _this;
    }
    CobranzaService.prototype.create = function () {
        var newDoc = new cobranza_1.CobranzaInfo();
        return Promise.resolve(newDoc);
    };
    //cargar cxc por grupo deudor
    CobranzaService.prototype.loadCxCByGrupoDeudor = function (fechaIni, fechaFin, idGrupoDeudor) {
        var params = new http_1.HttpParams()
            .set('FechaIni', fechaIni.toString())
            .set('FechaFin', fechaFin.toString())
            .set('IdGrupoDeudor', idGrupoDeudor.toString());
        return this.apiService.get('load-cxc-by-grupo-deudor', params)
            .toPromise();
    };
    //cargar cxc por deudor
    CobranzaService.prototype.loadCxCByDeudor = function (fechaIni, fechaFin, idDeudor) {
        var params = new http_1.HttpParams()
            .set('fechaIni', fechaIni.toString())
            .set('fechaFin', fechaFin.toString())
            .set('idDeudor', idDeudor.toString());
        return this.apiService.get('load-cxc-by-deudor', params)
            .toPromise();
    };
    //cargar cxc por rfc
    CobranzaService.prototype.loadCxCByRFC = function (fechaIni, fechaFin, rfc) {
        var params = new http_1.HttpParams()
            .set('fechaIni', fechaIni.toString())
            .set('fechaFin', fechaFin.toString())
            .set('rfc', rfc);
        return this.apiService.get('load-cxc-by-rfc', params)
            .toPromise();
    };
    CobranzaService.prototype.generarPdfFactura = function (idCobranza) {
        var params = new http_1.HttpParams()
            .set("idCobranza", idCobranza);
        return this.apiService.get("pdf-comprobante", params)
            .toPromise();
    };
    CobranzaService.prototype.getXmlFactura = function (idCobranza) {
        var params = new http_1.HttpParams()
            .set("idCobranza", idCobranza);
        return this.apiService.get("xml-comprobante", params)
            .toPromise();
    };
    CobranzaService = __decorate([
        core_1.Injectable(),
        __metadata("design:paramtypes", [http_1.HttpClient, core_2.Context])
    ], CobranzaService);
    return CobranzaService;
}(core_2.DocumentService));
exports.CobranzaService = CobranzaService;
