"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var common_1 = require("@angular/common");
//
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
//
var core_3 = require("framework3/core");
var almacen_editar_stock_component_1 = require("../components/almacen-editar-stock.component");
var almacen_service_1 = require("../services/almacen.service");
var stock_1 = require("../models/stock");
var AlmacenArticulosStock = /** @class */ (function (_super) {
    __extends(AlmacenArticulosStock, _super);
    //
    function AlmacenArticulosStock(context, almacenService, grupoService, router, route, location) {
        var _this = _super.call(this) || this;
        _this.context = context;
        _this.almacenService = almacenService;
        _this.grupoService = grupoService;
        _this.router = router;
        _this.route = route;
        _this.location = location;
        _this.articulosStock = [];
        _this.data = new stock_1.StockInfo();
        return _this;
    }
    AlmacenArticulosStock.prototype.ngOnInit = function () {
        var _this = this;
        this.route.params.forEach(function (param) {
            _this.idAlmacen = +param['idAlmacen'];
        });
    };
    AlmacenArticulosStock.prototype.ngAfterViewInit = function () {
        var _this = this;
        setTimeout(function (_) { return _this.loadArticulosStock(); });
    };
    //////////////////// METODOS /////////////////////////////////////////////////////////
    AlmacenArticulosStock.prototype.loadArticulosStock = function () {
        var _this = this;
        this.context.app.showSpinner();
        this.almacenService.loadStockAlmacen(this.idAlmacen)
            .then(function (articulosStock) {
            _this.articulosStock = articulosStock;
            _this.context.app.hideSpinner();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    //////////////////// HANDLERS /////////////////////////////////////////////////////////
    AlmacenArticulosStock.prototype.onCurrentItemChanged = function (item) {
        this.currentItem = item;
    };
    AlmacenArticulosStock.prototype.onToolbarButtonClick = function (button) {
        if (button.name == 'ADD') {
            this.articulosStockDialog.show();
        }
        if (button.name == 'REFRESH') {
            this.loadArticulosStock();
        }
        if (button.name == 'CLOSE') {
            this.location.back();
        }
    };
    AlmacenArticulosStock.prototype.onEditItem = function (Stock) {
        this.articulosStockDialog.show();
        this.articulosStockDialog.data = Stock;
    };
    AlmacenArticulosStock.prototype.applyPolicy = function (policy) {
    };
    AlmacenArticulosStock.prototype.handleError = function (error) {
        this.context.app.hideSpinner();
        var message = this.getErrorMessage(error);
        this.alerts.showAlert(message, 'danger');
    };
    AlmacenArticulosStock.prototype.actualizarStock = function (arg) {
        var _this = this;
        this.almacenService.updateStock(this.idAlmacen, arg)
            .then(function (r) {
            _this.loadArticulosStock();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    __decorate([
        core_1.ViewChild(almacen_editar_stock_component_1.AlmacenEditarStock),
        __metadata("design:type", almacen_editar_stock_component_1.AlmacenEditarStock)
    ], AlmacenArticulosStock.prototype, "articulosStockDialog", void 0);
    __decorate([
        core_1.ViewChild(controls_1.AlertsBarComponent),
        __metadata("design:type", controls_1.AlertsBarComponent)
    ], AlmacenArticulosStock.prototype, "alerts", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", stock_1.StockInfo)
    ], AlmacenArticulosStock.prototype, "data", void 0);
    AlmacenArticulosStock = __decorate([
        core_1.Component({
            selector: 'inventario-articulos-stock',
            template: "\n      <div class=\"row\">\n          <div class=\"col-12 col-md-10\">\n              <az-panel [header]=\"title\">\n                  <alerts-bar></alerts-bar>\n                  <!--Toolbar Principal-->\n                  <az-toolbar (buttonClick)=\"onToolbarButtonClick($event)\">\n                      <az-toolbar-button [name]=\"'ADD'\" [type]=\"'primary'\" [text]=\"'Agregar Articulos'\" [icon]=\"'glyphicon glyphicon-plus'\"></az-toolbar-button>\n                      <az-toolbar-button [name]=\"'REFRESH'\" [text]=\"'Actualizar'\" [icon]=\"'glyphicon glyphicon-refresh'\" [class]=\"'d-none d-lg-block'\"></az-toolbar-button>\n                      <az-toolbar-button [name]=\"'CLOSE'\" [text]=\"'Regresar'\" [icon]=\"'glyphicon glyphicon-circle-arrow-left'\"></az-toolbar-button>\n                  </az-toolbar>\n            \n                  <wj-flex-grid #gridArticulosPermitidos style=\"height:550px\"\n                                [itemsSource]=\"articulosStock\">\n\n                      <wj-flex-grid-column [width]=\"55\" [isReadOnly]=\"true\">\n                          <ng-template wjFlexGridCellTemplate [cellType]=\"'Cell'\" let-cell=\"cell\">\n                              <button type=\"button\" class=\"btn btn-default\" (click)=\"onEditItem(cell.item)\">\n                                  <span class=\"glyphicon glyphicon-edit\"></span>\n                              </button>\n                          </ng-template>\n                      </wj-flex-grid-column>\n                      <wj-flex-grid-column [header]=\"'C\u00F3digo'\" [binding]=\"'codigo'\" [width]=\"'10*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                      <wj-flex-grid-column [header]=\"'Nombre'\" [binding]=\"'nombre'\" [width]=\"'25*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                      <wj-flex-grid-column [header]=\"'Stock Min'\" [binding]=\"'stockMinimo'\" [width]=\"'11*'\" [isReadOnly]=\"true\" format=\"n2\"></wj-flex-grid-column>\n                      <wj-flex-grid-column [header]=\"'Stock Max'\" [binding]=\"'stockMaximo'\" [width]=\"'11*'\" [isReadOnly]=\"true\" format=\"n2\"></wj-flex-grid-column>\n                      <wj-flex-grid-column [header]=\"'P. Reorden'\" [binding]=\"'puntoReorden'\" [width]=\"'11*'\" [isReadOnly]=\"true\" format=\"n2\"></wj-flex-grid-column>\n                      <wj-flex-grid-column [header]=\"'Ubicaci\u00F3n'\" [binding]=\"'ubicacion'\" [width]=\"'15*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                      <wj-flex-grid-column [header]=\"'Tipo Inv.'\" [binding]=\"'tipoInventario'\" [width]=\"'15*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                      <wj-flex-grid-column [header]=\"'Maneja Series'\" [binding]=\"'manejaSeriesDspl'\" [width]=\"'15*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                      <wj-flex-grid-column [header]=\"'Maneja Caducidad'\" [binding]=\"'manejaCaducidadDspl'\" [width]=\"'15*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                      <wj-flex-grid-column [header]=\"'Maneja Lotes'\" [binding]=\"'manejaLotesDspl'\" [width]=\"'15*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                      <wj-flex-grid-column [header]=\"'M\u00E9todo de valuaci\u00F3n'\" [binding]=\"'metodoValuacionDspl'\" [width]=\"'15*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                  </wj-flex-grid>\n          \n              </az-panel>\n          </div>\n      </div>\n\n      <inventario-almacen-editar-stock\n                                      (dataUpdated)=\"actualizarStock($event)\">\n                                  <!--(selectedItemsChanged)=\"onSelectedArtChanged($event)\"\n                                  [excludedItems]=\"articulospermitidos\"\n                                  [multiSelect]=\"true\">-->\n\n      </inventario-almacen-editar-stock>\n    "
        }),
        __metadata("design:paramtypes", [core_2.Context, almacen_service_1.AlmacenService, core_3.GrupoService, router_1.Router, router_1.ActivatedRoute,
            common_1.Location])
    ], AlmacenArticulosStock);
    return AlmacenArticulosStock;
}(core_2.BaseComponent));
exports.AlmacenArticulosStock = AlmacenArticulosStock;
