"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var common_1 = require("@angular/common");
//
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
//
var core_3 = require("framework3/core");
var almacen_service_1 = require("../services/almacen.service");
var AlmacenExistencias = /** @class */ (function (_super) {
    __extends(AlmacenExistencias, _super);
    //
    function AlmacenExistencias(context, almacenService, grupoService, router, route, location) {
        var _this = _super.call(this) || this;
        _this.context = context;
        _this.almacenService = almacenService;
        _this.grupoService = grupoService;
        _this.router = router;
        _this.route = route;
        _this.location = location;
        _this.almacenExistencias = [];
        return _this;
    }
    AlmacenExistencias.prototype.ngOnInit = function () {
        var _this = this;
        this.route.params.forEach(function (param) {
            _this.idAlmacen = +param['idAlmacen'];
        });
    };
    AlmacenExistencias.prototype.ngAfterViewInit = function () {
        var _this = this;
        setTimeout(function (_) { return _this.loadExistencias(); });
    };
    //////////////////// METODOS /////////////////////////////////////////////////////////
    AlmacenExistencias.prototype.loadExistencias = function () {
        var _this = this;
        this.context.app.showSpinner();
        this.almacenService.loadExistencias(this.idAlmacen)
            .then(function (almacenExistencias) {
            _this.almacenExistencias = almacenExistencias;
            _this.context.app.hideSpinner();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    AlmacenExistencias.prototype.onToolbarButtonClick = function (button) {
        if (button.name == 'REFRESH') {
            this.loadExistencias();
        }
        if (button.name == 'CLOSE') {
            this.location.back();
        }
    };
    AlmacenExistencias.prototype.applyPolicy = function (policy) {
    };
    AlmacenExistencias.prototype.handleError = function (error) {
        this.context.app.hideSpinner();
        var message = this.getErrorMessage(error);
        this.alerts.showAlert(message, 'danger');
    };
    __decorate([
        core_1.ViewChild(controls_1.AlertsBarComponent),
        __metadata("design:type", controls_1.AlertsBarComponent)
    ], AlmacenExistencias.prototype, "alerts", void 0);
    AlmacenExistencias = __decorate([
        core_1.Component({
            selector: 'inventario-almacen-existencias',
            template: "\n      <div class=\"row\">\n          <div class=\"col-12 col-md-10\">\n              <az-panel [header]=\"title\">\n                  <alerts-bar></alerts-bar>\n                  <az-toolbar (buttonClick)=\"onToolbarButtonClick($event)\">\n                      <az-toolbar-button [name]=\"'REFRESH'\" [text]=\"'Actualizar'\" [icon]=\"'glyphicon glyphicon-refresh'\" [class]=\"'d-none d-lg-block'\"></az-toolbar-button>\n                      <az-toolbar-button [name]=\"'CLOSE'\" [text]=\"'Regresar'\" [icon]=\"'glyphicon glyphicon-circle-arrow-left'\"></az-toolbar-button>\n                  </az-toolbar>\n\n                  <wj-flex-grid #gridArticulosPermitidos style=\"height:550px\"\n                                [itemsSource]=\"almacenExistencias\">\n\n                      <wj-flex-grid-column [header]=\"'C\u00F3digo'\" [binding]=\"'codigo'\" [width]=\"'10*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                      <wj-flex-grid-column [header]=\"'Nombre'\" [binding]=\"'nombre'\" [width]=\"'25*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                      <wj-flex-grid-column [header]=\"'Disponible'\" [binding]=\"'disponible'\" [width]=\"'15*'\" [isReadOnly]=\"true\" format=\"n3\"></wj-flex-grid-column>\n                      <wj-flex-grid-column [header]=\"'Apartado'\" [binding]=\"'apartado'\" [width]=\"'15*'\" [isReadOnly]=\"true\" format=\"n3\"></wj-flex-grid-column>\n                      <wj-flex-grid-column [header]=\"'Existencia'\" [binding]=\"'existencia'\" [width]=\"'15*'\" [isReadOnly]=\"true\" format=\"n3\"></wj-flex-grid-column>\n                      <wj-flex-grid-column [header]=\"'Tr\u00E1nsito'\" [binding]=\"'transito'\" [width]=\"'15*'\" [isReadOnly]=\"true\" format=\"n3\"></wj-flex-grid-column>\n                  </wj-flex-grid>\n          \n              </az-panel>\n          </div>\n      </div>\n    "
        }),
        __metadata("design:paramtypes", [core_2.Context, almacen_service_1.AlmacenService, core_3.GrupoService, router_1.Router, router_1.ActivatedRoute,
            common_1.Location])
    ], AlmacenExistencias);
    return AlmacenExistencias;
}(core_2.BaseComponent));
exports.AlmacenExistencias = AlmacenExistencias;
