import { ChangeDetectorRef } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { Context } from 'framework3/core';
import { CatalogOptions } from 'framework3/custom';
import { MenuItem } from 'framework3/controls';
import { CatalogEditor, EditorEventArgs } from 'framework3/editors';
import { Clasificacion } from 'framework3/general';
import { AlmacenService } from '../services/almacen.service';
import { AlmacenInfo } from '../models/almacen';
export declare class AlmacenesEditor extends CatalogEditor {
    protected router: Router;
    protected route: ActivatedRoute;
    private formBuilder;
    protected changeDetector: ChangeDetectorRef;
    protected context: Context;
    private location;
    private almacenService;
    idArea: number;
    almacen: AlmacenInfo;
    clasificadores: Clasificacion[];
    constructor(router: Router, route: ActivatedRoute, formBuilder: FormBuilder, changeDetector: ChangeDetectorRef, context: Context, location: Location, almacenService: AlmacenService);
    onConfigureCatalog(options: CatalogOptions): void;
    loadClasificadores(): void;
    ngOnInit(): void;
    onCreatingItem(): void;
    onViewingItem(id: number): void;
    onCloningItem(id: number): void;
    onLoadingItem(id: number): void;
    onSavingItem(args: EditorEventArgs): void;
    onMenuItemClick(item: MenuItem): void;
    onSelectTab(args: any): void;
}
