"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Wijmo
var wijmo_1 = require("wijmo/wijmo");
//Azteca Kernel
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
var editors_1 = require("framework3/editors");
//Features
var almacen_service_1 = require("../services/almacen.service");
var almacen_1 = require("../models/almacen");
var AlmacenesEditor = /** @class */ (function (_super) {
    __extends(AlmacenesEditor, _super);
    //
    function AlmacenesEditor(router, route, formBuilder, changeDetector, context, location, almacenService) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.router = router;
        _this.route = route;
        _this.formBuilder = formBuilder;
        _this.changeDetector = changeDetector;
        _this.context = context;
        _this.location = location;
        _this.almacenService = almacenService;
        _this.idArea = 0;
        _this.almacen = new almacen_1.AlmacenInfo();
        _this.clasificadores = [];
        _this.catalogForm = formBuilder.group({
            'codigo': ['', forms_1.Validators.required],
            'nombre': ['', forms_1.Validators.required],
            'Negativos': [''],
            'InventarioFisico': [''],
            'RestriccionUsuario': [''],
            'RestriccionArticulos': [''],
            'clasificaciones': [[], controls_1.AztecaValidators.validClasifications]
        });
        return _this;
    }
    AlmacenesEditor_1 = AlmacenesEditor;
    ///////////////////////// METODOS ///////////////////////////////////////
    ///////////////////////// HANDLERS ///////////////////////////////////////
    AlmacenesEditor.prototype.onConfigureCatalog = function (options) {
        this.autogeneratedCode = options.codigoAutogenerado;
        //Cargar catálogos
        this.loadClasificadores();
    };
    ///////////// METODOS /////////////////////////////////
    AlmacenesEditor.prototype.loadClasificadores = function () {
        var _this = this;
        this.almacenService.loadClassifiers(this.context.app.defaultSite.identity)
            .then(function (clasificadores) { return _this.clasificadores = clasificadores; })
            .catch(function (error) { return _this.handleError(error); });
    };
    AlmacenesEditor.prototype.ngOnInit = function () {
        var _this = this;
        this.route.params.forEach(function (params) {
            _this.idArea = +params['idArea'];
        });
    };
    AlmacenesEditor.prototype.onCreatingItem = function () {
        this.almacen.idArea = this.idArea;
    };
    AlmacenesEditor.prototype.onViewingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.almacenService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.almacen = info;
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    AlmacenesEditor.prototype.onCloningItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.almacenService.clone(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.almacen = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    AlmacenesEditor.prototype.onLoadingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.almacenService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.almacen = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    AlmacenesEditor.prototype.onSavingItem = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.almacenService.update(this.almacen)
            .then(function (info) {
            _this.context.app.hideSpinner();
            //Si es un elemento nuevo y no se cerrará el editor, navegar a nueva ruta
            _this.reset();
            if (!args.closeEditor && _this.almacen.identity == 0) {
                _this.router.navigate(['../', info.identity], { relativeTo: _this.route });
            }
            else {
                if (args.closeEditor)
                    _this.router.navigate(['../'], { relativeTo: _this.route });
                else
                    _this.showAlert('La información ha sido actualizada con éxito', 'success');
            }
            _this.almacen = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    AlmacenesEditor.prototype.onMenuItemClick = function (item) {
        if (item.name == 'USERS') {
            this.router.navigate(['inventory/almacenes-usuarios/' + this.process.id + '/' + this.almacen.identity.toString()]);
        }
        else if (item.name == 'ALLOWARTICLES') {
            this.router.navigate(['inventory/almacenes-clasificaciones-articulos/' + this.process.id + '/' + this.almacen.identity.toString()]);
        }
        else if (item.name == 'LOCATIONS') {
            this.router.navigate(['inventory/ubicaciones/' + this.process.id + '/' + this.almacen.identity.toString()]);
        }
        else if (item.name == 'EXISTENCES') {
            this.router.navigate(['inventory/almacenes-existencias/' + this.process.id + '/' + this.almacen.identity.toString()]);
        }
        else if (item.name == 'STOCK') {
            this.router.navigate(['inventory/almacenes-stock/' + this.process.id + '/' + this.almacen.identity.toString()]);
        }
    };
    AlmacenesEditor.prototype.onSelectTab = function (args) {
        if (args.heading) {
            wijmo_1.Control.invalidateAll();
        }
    };
    AlmacenesEditor = AlmacenesEditor_1 = __decorate([
        core_1.Component({
            selector: 'inventario-almacenes-editor',
            template: "\n      <form [formGroup]=\"catalogForm\">\n\n          <azteca-catalog-editor #catalogEditor\n                                 [title]=\"'Almacen'\"\n                                 [info]=\"almacen\"\n                                 [valid]=\"valid\"\n                                 (configureCatalog)=\"onConfigureCatalog($event)\"\n                                 (creatingItem)=\"onCreatingItem()\"\n                                 (viewingItem)=\"onViewingItem($event)\"\n                                 (cloningItem)=\"onCloningItem($event)\"\n                                 (savingItem)=\"onSavingItem($event)\"\n                                 (loadingItem)=\"onLoadingItem($event)\"\n                                 (menuItemClick)=\"onMenuItemClick($event)\">\n\n              <!------------------- Menu de acciones --------------------->\n              <azteca-menu-item [name]=\"'USERS'\" [icon]=\"'glyphicon glyphicon-user'\" [text]=\"'Usuarios'\" [smallText]=\"'configuraci\u00F3n de usuarios'\"></azteca-menu-item>\n              <azteca-menu-item [name]=\"'LOCATIONS'\" [icon]=\"'glyphicon glyphicon-globe'\" [text]=\"'Ubicaciones'\" [smallText]=\"'configuraci\u00F3n de ubicaciones del almacen'\"></azteca-menu-item>\n              <azteca-menu-item [name]=\"'ALLOWARTICLES'\" [icon]=\"'glyphicon glyphicon-check'\" [text]=\"'Art. Permitidos'\" [smallText]=\"'configuraci\u00F3n de los articulos permitidos'\"></azteca-menu-item>\n              <azteca-menu-item [name]=\"'EXISTENCES'\" [icon]=\"'glyphicon glyphicon-edit'\" [text]=\"'Existencias'\" [smallText]=\"'configuraci\u00F3n de existencias'\"></azteca-menu-item>\n              <azteca-menu-item [name]=\"'STOCK'\" [icon]=\"'glyphicon glyphicon-share'\" [text]=\"'Stock'\" [smallText]=\"'configuraci\u00F3n de stock'\"></azteca-menu-item>\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <tabset>\n                          <tab heading=\"Datos Generales\" (select)=\"onSelectTab($event)\">>\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-10\">\n                                      <azteca-form-field [label]=\"'C\u00F3digo:'\">\n                                          <catalog-code formControlName=\"codigo\" [(ngModel)]=\"almacen.code\" [automatic]=\"autogeneratedCode\"></catalog-code>\n                                      </azteca-form-field>\n\n                                      <azteca-form-field [label]=\"'Nombre:'\">\n                                          <az-textbox formControlName=\"nombre\" [(ngModel)]=\"almacen.nombre\"></az-textbox>\n                                      </azteca-form-field>\n\n                                      <az-checkbox [label]=\"'Permite existencias en negativo'\" formControlName=\"Negativos\" [(ngModel)]=\"almacen.permiteNegativos\"></az-checkbox>\n\n                                      <az-checkbox [label]=\"'Requiere captura de inventario fisico'\" formControlName=\"InventarioFisico\" [(ngModel)]=\"almacen.reqCapturaFisico\"></az-checkbox>\n\n                                      <az-checkbox [label]=\"'Habilitar restriccion de usuario con acceso'\" formControlName=\"RestriccionUsuario\" [(ngModel)]=\"almacen.restriccionAccesos\"></az-checkbox>\n\n                                      <az-checkbox [label]=\"'Habilitar restriccion de Art\u00EDculos'\" formControlName=\"RestriccionArticulos\" [(ngModel)]=\"almacen.restriccionArticulos\"></az-checkbox>\n                                  </div>\n                              </div>\n                          </tab>\n                          <tab heading=\"Clasificaciones\" (select)=\"onSelectTab($event)\">>\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-10\">\n\n                                      <label>Clasificaciones</label>\n\n                                      <az-clasificaciones-editor formControlName=\"clasificaciones\" [(ngModel)]=\"almacen.clasificaciones\" [clasificadores]=\"clasificadores\">\n\n                                      </az-clasificaciones-editor>\n\n\n                                  </div>\n                              </div>\n                          </tab>\n                      </tabset>\n                  </div>\n              </div>\n          </azteca-catalog-editor>\n      </form>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return AlmacenesEditor_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: almacen_service_1.AlmacenService
                }
            ]
        }),
        __metadata("design:paramtypes", [router_1.Router, router_1.ActivatedRoute, forms_1.FormBuilder, core_1.ChangeDetectorRef,
            core_2.Context, common_1.Location, almacen_service_1.AlmacenService])
    ], AlmacenesEditor);
    return AlmacenesEditor;
    var AlmacenesEditor_1;
}(editors_1.CatalogEditor));
exports.AlmacenesEditor = AlmacenesEditor;
