import { Router, ActivatedRoute } from '@angular/router';
import { Context, CatalogItem } from 'framework3/core';
import { CatalogOptions } from 'framework3/custom';
import { MenuItem } from 'framework3/controls';
import { CatalogManager } from 'framework3/editors';
import { SearchRequest } from 'framework3/search';
import { AlmacenService } from '../services/almacen.service';
import { AlmacenItem } from '../models/almacen';
export declare class AlmacenesManager extends CatalogManager {
    protected router: Router;
    protected route: ActivatedRoute;
    protected context: Context;
    private almacenService;
    almacenes: AlmacenItem[];
    idArea: number;
    constructor(router: Router, route: ActivatedRoute, context: Context, almacenService: AlmacenService);
    loadAlmacenes(): void;
    ngOnInit(): void;
    onConfigureCatalog(options: CatalogOptions): void;
    doSearch(request: SearchRequest): void;
    onAddingItem(): void;
    onViewingItem(item: CatalogItem): void;
    onEditingItem(item: CatalogItem): void;
    onDeletingItem(item: CatalogItem): void;
    onCloningItem(item: CatalogItem): void;
    onChangingItemState(item: CatalogItem): void;
    onMenuItemClick(item: MenuItem, selectedItem: CatalogItem): void;
}
