import { ChangeDetectorRef } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { Context } from 'framework3/core';
import { CatalogOptions } from 'framework3/custom';
import { MenuItem } from 'framework3/controls';
import { CatalogEditor, EditorEventArgs } from 'framework3/editors';
import { Clasificacion } from 'framework3/general';
import { ArticuloStockService } from '../services/articulo-stock.service';
import { ArticuloStockInfo } from '../models/articulo-stock';
import { UnidadMedidaService } from '../services/unidad-medida.service';
import { UnidadMedidaItem } from '../models/unidad-medida';
import { UnidadMedidaTipoService } from '../services/unidad-medida-tipo.service';
import { UnidadMedidaTipoItem } from '../models/unidad-medida-tipo';
export declare class ArticulosStockEditor extends CatalogEditor {
    protected router: Router;
    protected route: ActivatedRoute;
    protected context: Context;
    private location;
    private articuloStockService;
    private unidadMedidaService;
    private tipoUnidadService;
    protected changeDetector: ChangeDetectorRef;
    articuloStock: ArticuloStockInfo;
    tiposUnidad: UnidadMedidaTipoItem[];
    unidadesMedida: UnidadMedidaItem[];
    clasificadores: Clasificacion[];
    metodosValuacion: {
        id: string;
        nombre: string;
    }[];
    constructor(router: Router, route: ActivatedRoute, formBuilder: FormBuilder, context: Context, location: Location, articuloStockService: ArticuloStockService, unidadMedidaService: UnidadMedidaService, tipoUnidadService: UnidadMedidaTipoService, changeDetector: ChangeDetectorRef);
    onConfigureCatalog(options: CatalogOptions): void;
    loadClasificadores(): void;
    loadTiposUnidad(): void;
    onTipoUnidadChanged(idTipoUnidad: any): void;
    loadUnidadesMedida(idTipoUnidad: number): void;
    onCreatingItem(): void;
    onViewingItem(id: number): void;
    onCloningItem(id: number): void;
    onLoadingItem(id: number): void;
    onSavingItem(args: EditorEventArgs): void;
    onMenuItemClick(item: MenuItem): void;
    onSelectTab(args: any): void;
}
