"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Wijmo
var wijmo_1 = require("wijmo/wijmo");
//Azteca Kernel
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
var editors_1 = require("framework3/editors");
//Features
var articulo_stock_service_1 = require("../services/articulo-stock.service");
var articulo_stock_1 = require("../models/articulo-stock");
var unidad_medida_service_1 = require("../services/unidad-medida.service");
var unidad_medida_tipo_service_1 = require("../services/unidad-medida-tipo.service");
var metodo_valuacion_1 = require("../models/metodo-valuacion");
var ArticulosStockEditor = /** @class */ (function (_super) {
    __extends(ArticulosStockEditor, _super);
    //
    function ArticulosStockEditor(router, route, formBuilder, context, location, articuloStockService, unidadMedidaService, tipoUnidadService, changeDetector) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.router = router;
        _this.route = route;
        _this.context = context;
        _this.location = location;
        _this.articuloStockService = articuloStockService;
        _this.unidadMedidaService = unidadMedidaService;
        _this.tipoUnidadService = tipoUnidadService;
        _this.changeDetector = changeDetector;
        _this.articuloStock = new articulo_stock_1.ArticuloStockInfo();
        _this.tiposUnidad = [];
        _this.unidadesMedida = [];
        _this.clasificadores = [];
        _this.metodosValuacion = metodo_valuacion_1.MetodoValuacion.list;
        _this.catalogForm = formBuilder.group({
            'codigo': ['', forms_1.Validators.required],
            'nombre': ['', forms_1.Validators.required],
            'gtin': [''],
            'idTipoUnidad': [0],
            'idUnidadMedida': [0],
            'categoriaFiscal': [0, forms_1.Validators.required],
            'metodoValuacion': [''],
            'manejaSeries': [false],
            'manejaCaducidad': [false],
            'manejaValuacion': [false],
            'manejaLotes': [false],
            'descripcion': [''],
            'clasificaciones': [[], controls_1.AztecaValidators.validClasifications]
        });
        //Hacer requerido el método de valuación sólo cuando se manejen lotes
        _this.catalogForm.controls['manejaLotes'].valueChanges.subscribe(function (value) {
            if (value == true) {
                _this.catalogForm.controls['metodoValuacion'].setValidators(forms_1.Validators.required);
            }
            else {
                _this.catalogForm.controls['metodoValuacion'].setValue('');
                _this.catalogForm.controls['metodoValuacion'].setValidators(null);
            }
            _this.catalogForm.controls['metodoValuacion'].updateValueAndValidity();
        });
        //Si se manejan series, la unidad de medida no será requerida
        _this.catalogForm.controls['manejaSeries'].valueChanges.subscribe(function (value) {
            if (value) {
                _this.catalogForm.controls['idUnidadMedida'].setValidators(null);
            }
            else {
                _this.catalogForm.controls['idUnidadMedida'].setValidators(controls_1.AztecaValidators.selected);
            }
            _this.catalogForm.controls['idUnidadMedida'].updateValueAndValidity();
        });
        return _this;
    }
    ArticulosStockEditor_1 = ArticulosStockEditor;
    ArticulosStockEditor.prototype.onConfigureCatalog = function (options) {
        this.autogeneratedCode = options.codigoAutogenerado;
        //Cargar catálogos
        this.loadClasificadores();
        this.loadTiposUnidad();
    };
    ///////////// METODOS /////////////////////////////////
    ArticulosStockEditor.prototype.loadClasificadores = function () {
        var _this = this;
        this.articuloStockService.loadClassifiers(this.context.app.defaultSite.identity)
            .then(function (clasificadores) { return _this.clasificadores = clasificadores; })
            .catch(function (error) { return _this.handleError(error); });
    };
    ArticulosStockEditor.prototype.loadTiposUnidad = function () {
        var _this = this;
        this.tipoUnidadService.loadList()
            .then(function (tipos) { return _this.tiposUnidad = tipos; })
            .catch(function (error) { return _this.handleError(error); });
    };
    ArticulosStockEditor.prototype.onTipoUnidadChanged = function (idTipoUnidad) {
        this.loadUnidadesMedida(idTipoUnidad);
    };
    ArticulosStockEditor.prototype.loadUnidadesMedida = function (idTipoUnidad) {
        var _this = this;
        this.unidadMedidaService.loadList(idTipoUnidad)
            .then(function (unidades) { return _this.unidadesMedida = unidades; })
            .catch(function (error) { return _this.handleError(error); });
    };
    ///////////// HANDLERS /////////////////////////////////
    ArticulosStockEditor.prototype.onCreatingItem = function () {
        var _this = this;
        this.articuloStockService.create()
            .then(function (articulo) { return _this.articuloStock = articulo; })
            .catch(function (error) { return _this.handleError(error); });
    };
    ArticulosStockEditor.prototype.onViewingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.articuloStockService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.articuloStock = info;
            _this.setReadonlyMode();
            _this.loadUnidadesMedida(info.unidadMedida.idUnidadMedidaTipo);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ArticulosStockEditor.prototype.onCloningItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.articuloStockService.clone(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.articuloStock = info;
            _this.loadUnidadesMedida(info.unidadMedida.idUnidadMedidaTipo);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ArticulosStockEditor.prototype.onLoadingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.articuloStockService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.articuloStock = info;
            _this.loadUnidadesMedida(info.unidadMedida.idUnidadMedidaTipo);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ArticulosStockEditor.prototype.onSavingItem = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.articuloStockService.update(this.articuloStock)
            .then(function (info) {
            _this.context.app.hideSpinner();
            //Si es un elemento nuevo y no se cerrará el editor, navegar a nueva ruta
            _this.reset();
            if (!args.closeEditor && _this.articuloStock.identity == 0) {
                _this.router.navigate(['../', info.identity], { relativeTo: _this.route });
            }
            else {
                if (args.closeEditor)
                    _this.router.navigate(['../'], { relativeTo: _this.route });
                else
                    _this.showAlert('La información ha sido actualizada con éxito', 'success');
            }
            _this.articuloStock = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ArticulosStockEditor.prototype.onMenuItemClick = function (item) {
        if (item.name == 'CONFIG') {
            this.router.navigate(['inventory/articulos-stock-configuracion/' + this.process.id + '/' + this.articuloStock.identity.toString()]);
        }
        else if (item.name == 'PICS') {
            this.router.navigate(['inventory/articulos-fotografias/' + this.process.id + '/' + this.articuloStock.identity.toString()]);
        }
        else if (item.name == 'STOCK') {
            this.router.navigate(['inventory/articulos-existencias/' + this.process.id + '/' + this.articuloStock.identity.toString()]);
        }
    };
    ArticulosStockEditor.prototype.onSelectTab = function (args) {
        if (args.heading) {
            wijmo_1.Control.invalidateAll();
        }
    };
    ArticulosStockEditor = ArticulosStockEditor_1 = __decorate([
        core_1.Component({
            selector: 'inventory-articulos-stock-editor',
            template: "\n      <form [formGroup]=\"catalogForm\">\n\n          <azteca-catalog-editor #catalogEditor\n                                 [title]=\"'Editar art\u00EDculo'\"\n                                 [info]=\"articuloStock\"\n                                 [valid]=\"valid\"\n                                 (configureCatalog)=\"onConfigureCatalog($event)\"\n                                 (creatingItem)=\"onCreatingItem()\"\n                                 (viewingItem)=\"onViewingItem($event)\"\n                                 (cloningItem)=\"onCloningItem($event)\"\n                                 (savingItem)=\"onSavingItem($event)\"\n                                 (loadingItem)=\"onLoadingItem($event)\"\n                                 (menuItemClick)=\"onMenuItemClick($event)\">\n\n              <!------------------- Menu de acciones adicionales --------------------->\n              <azteca-menu-item [name]=\"'CONFIG'\" [icon]=\"'glyphicon glyphicon-cog'\" [text]=\"'Configuraci\u00F3n de stock'\" [smallText]=\"'configuraci\u00F3n a nivel almac\u00E9n'\"></azteca-menu-item>\n              <azteca-menu-item [name]=\"'PICS'\" [icon]=\"'glyphicon glyphicon-picture'\" [text]=\"'Fotos'\" [smallText]=\"'fotos del art\u00EDculo'\"></azteca-menu-item>\n              <azteca-menu-item [name]=\"'STOCK'\" [icon]=\"'glyphicon glyphicon-tasks'\" [text]=\"'Existencias'\" [smallText]=\"'consultar existencias'\"></azteca-menu-item>\n\n              <!------------------- Controles del editor ----------------------------->\n\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-lg-5\">\n                      <azteca-form-field [label]=\"'C\u00F3digo:'\">\n                          <catalog-code formControlName=\"codigo\" [(ngModel)]=\"articuloStock.code\" [automatic]=\"autogeneratedCode\"></catalog-code>\n                      </azteca-form-field>\n                  </div>\n                  <div class=\"col-12 col-lg-5\">\n                      <azteca-form-field [label]=\"'GTIN:'\">\n                          <az-textbox formControlName=\"gtin\" [(ngModel)]=\"articuloStock.gtin\"></az-textbox>\n                      </azteca-form-field>\n                  </div>\n              </div>\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-lg-10\">\n                      <azteca-form-field [label]=\"'Nombre:'\">\n                          <az-textbox formControlName=\"nombre\" [(ngModel)]=\"articuloStock.nombre\"></az-textbox>\n                      </azteca-form-field>\n                  </div>\n              </div>\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-lg-10\">\n                      <tabset>\n                          <!------------------------------------------ GENERALES ----------------------------------->\n                          <tab heading=\"Datos Generales\">\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-lg-6\">\n                                      <!--Ocultar si se manejan series-->\n                                      <azteca-form-field *ngIf=\"!articuloStock.manejaSeries\" [label]=\"'Tipo de unidad de medida:'\">\n                                          <az-combobox formControlName=\"idTipoUnidad\"\n                                                       [(ngModel)]=\"articuloStock.unidadMedida.idUnidadMedidaTipo\"\n                                                       [items]=\"tiposUnidad\"\n                                                       [valueMember]=\"'id'\"\n                                                       [displayMember]=\"'nombre'\"\n                                                       (selectedItemChanged)=\"onTipoUnidadChanged($event)\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n                                  <div class=\"col-12 col-lg-6\">\n                                      <azteca-form-field *ngIf=\"!articuloStock.manejaSeries\" [label]=\"'Unidad de medida:'\">\n                                          <az-combobox formControlName=\"idUnidadMedida\"\n                                                       [(ngModel)]=\"articuloStock.idUnidadMedida\"\n                                                       [items]=\"unidadesMedida\"\n                                                       [valueMember]=\"'id'\"\n                                                       [displayMember]=\"'nombre'\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12\">\n                                      <!--Mostrar s\u00F3lo si se manejan series-->\n                                      <label *ngIf=\"articuloStock.manejaSeries\" class=\"control-label\">Unidad de medida:</label>\n                                      <az-label *ngIf=\"articuloStock.manejaSeries\" [text]=\"'Piezas'\"></az-label>\n\n                                      <azteca-form-field [label]=\"'Agregar Categoria Fiscal:'\">\n                                          <accounting-articulo-categoria-fiscal-selector formControlName=\"categoriaFiscal\" [(ngModel)]=\"articuloStock.idCategoriaFiscal\" [showListButton]=\"true\" #selectorCategoria></accounting-articulo-categoria-fiscal-selector>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <azteca-form-field [label]=\"'Descripci\u00F3n:'\">\n                                  <az-textarea formControlName=\"descripcion\" [(ngModel)]=\"articuloStock.descripcion\"></az-textarea>\n                              </azteca-form-field>\n\n                          </tab>\n                          <!------------------------------------------ CONFIGURACION DE LOTES ----------------------------------->\n                          <tab heading=\"Controles\">\n                              <az-checkbox [label]=\"'Requiere control por n\u00FAmero de serie'\" formControlName=\"manejaSeries\" [(ngModel)]=\"articuloStock.manejaSeries\"></az-checkbox>\n                              <az-checkbox [label]=\"'Requiere control por lotes'\" formControlName=\"manejaLotes\" [(ngModel)]=\"articuloStock.manejaLotes\"></az-checkbox>\n                              <az-checkbox [label]=\"'Requiere control de fechas de caducidad'\" formControlName=\"manejaCaducidad\" [(ngModel)]=\"articuloStock.manejaCaducidad\"></az-checkbox>\n\n                              <azteca-form-field *ngIf=\"articuloStock.manejaLotes\" [label]=\"'M\u00E9todo de valuaci\u00F3n de inventario:'\">\n                                  <az-combobox formControlName=\"metodoValuacion\" [(ngModel)]=\"articuloStock.metodoValuacion\" [items]=\"metodosValuacion\" [valueMember]=\"'id'\" [displayMember]=\"'nombre'\"></az-combobox>\n                              </azteca-form-field>\n                          </tab>\n                          <!------------------------------------------ CLASIFICACIONES ----------------------------------->\n                          <tab heading=\"Clasificaciones\" (select)=\"onSelectTab($event)\">\n                              <az-clasificaciones-editor formControlName=\"clasificaciones\" [(ngModel)]=\"articuloStock.clasificaciones\" [clasificadores]=\"clasificadores\">\n\n                              </az-clasificaciones-editor>\n                          </tab>\n                      </tabset>\n\n                  </div> <!-- Col -->\n              </div> <!-- Row -->\n\n          </azteca-catalog-editor>\n      </form>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return ArticulosStockEditor_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: articulo_stock_service_1.ArticuloStockService
                }
            ]
        }),
        __metadata("design:paramtypes", [router_1.Router, router_1.ActivatedRoute, forms_1.FormBuilder,
            core_2.Context, common_1.Location, articulo_stock_service_1.ArticuloStockService,
            unidad_medida_service_1.UnidadMedidaService, unidad_medida_tipo_service_1.UnidadMedidaTipoService,
            core_1.ChangeDetectorRef])
    ], ArticulosStockEditor);
    return ArticulosStockEditor;
    var ArticulosStockEditor_1;
}(editors_1.CatalogEditor));
exports.ArticulosStockEditor = ArticulosStockEditor;
