import { ChangeDetectorRef } from '@angular/core';
import { FormBuilder } from '@angular/forms';
import { Router, ActivatedRoute } from '@angular/router';
import { TreeNode } from 'angular-tree-component';
import { Context, HierarchyChanges } from 'framework3/core';
import { CatalogOptions } from 'framework3/custom';
import { HierarchyManager } from 'framework3/editors';
import { UbicacionInfo } from '../models/ubicacion';
import { TiposUbicacionItem } from '../models/tipo-ubicacion';
import { UbicacionService } from '../services/ubicacion.service';
import { TipoUbicacionService } from '../services/tipo-ubicacion.service';
export declare class UbicacionesManager extends HierarchyManager {
    protected context: Context;
    protected changeDetector: ChangeDetectorRef;
    private formBuilder;
    private ubicacionService;
    private tipoUbicacionService;
    protected router: Router;
    protected route: ActivatedRoute;
    ubicaciones: UbicacionInfo[];
    ubicacionEdicion: UbicacionInfo;
    currentNode: TreeNode;
    currentParent: TreeNode;
    idAlmacen: number;
    tiposUbicacion: TiposUbicacionItem[];
    constructor(context: Context, changeDetector: ChangeDetectorRef, formBuilder: FormBuilder, ubicacionService: UbicacionService, tipoUbicacionService: TipoUbicacionService, router: Router, route: ActivatedRoute);
    loadHierarchy(): void;
    ngOnInit(): void;
    onConfigureCatalog(options: CatalogOptions): void;
    loadTiposUbicaciones(): void;
    onNodesChanged(ubicaciones: UbicacionInfo[]): void;
    onCurrentNodeChanged(node: TreeNode): void;
    onCreatingNode(parentNode: TreeNode): void;
    onEditingNode(node: TreeNode): void;
    onSavingNode(): void;
    onDeletingNode(node: TreeNode): void;
    onSavingHierarchy(changes: HierarchyChanges<UbicacionInfo>): void;
}
