"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var router_1 = require("@angular/router");
//
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
var controls_1 = require("framework3/controls");
//
var ubicacion_1 = require("../models/ubicacion");
var ubicacion_service_1 = require("../services/ubicacion.service");
var tipo_ubicacion_service_1 = require("../services/tipo-ubicacion.service");
var UbicacionesManager = /** @class */ (function (_super) {
    __extends(UbicacionesManager, _super);
    function UbicacionesManager(context, changeDetector, formBuilder, ubicacionService, tipoUbicacionService, router, route) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.context = context;
        _this.changeDetector = changeDetector;
        _this.formBuilder = formBuilder;
        _this.ubicacionService = ubicacionService;
        _this.tipoUbicacionService = tipoUbicacionService;
        _this.router = router;
        _this.route = route;
        _this.ubicaciones = [];
        _this.ubicacionEdicion = new ubicacion_1.UbicacionInfo();
        _this.idAlmacen = 0;
        _this.tiposUbicacion = [];
        _this.nodeForm = formBuilder.group({
            'codigo': ['', forms_1.Validators.required],
            'nombre': ['', forms_1.Validators.required],
            'tipoUbicacion': [''],
            'idTipoUbicacion': [0, controls_1.AztecaValidators.selected]
        });
        return _this;
    }
    UbicacionesManager_1 = UbicacionesManager;
    ////////////////////// METODOS //////////////////////////////////////////////
    UbicacionesManager.prototype.loadHierarchy = function () {
        var _this = this;
        this.context.app.showSpinner();
        this.ubicacionService.loadJerarquia(this.context.app.defaultSite.identity, this.idAlmacen)
            .then(function (nodes) {
            _this.context.app.hideSpinner();
            _this.ubicaciones = nodes;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    //////////////////// HANDLERS //////////////////////////////////////
    UbicacionesManager.prototype.ngOnInit = function () {
        var _this = this;
        this.route.params.forEach(function (param) {
            _this.idAlmacen = +param['idAlmacen'];
        });
    };
    UbicacionesManager.prototype.onConfigureCatalog = function (options) {
        this.autogeneratedCode = options.codigoAutogenerado;
        this.loadHierarchy();
        this.loadTiposUbicaciones();
        //Hacer llamadas de carga inicial de datos aquí
    };
    UbicacionesManager.prototype.loadTiposUbicaciones = function () {
        var _this = this;
        this.tipoUbicacionService.loadList()
            .then(function (tipos) { return _this.tiposUbicacion = tipos; })
            .catch(function (error) { return _this.handleError(error); });
    };
    UbicacionesManager.prototype.onNodesChanged = function (ubicaciones) {
        this.ubicaciones = ubicaciones;
    };
    UbicacionesManager.prototype.onCurrentNodeChanged = function (node) {
        this.currentNode = node;
    };
    UbicacionesManager.prototype.onCreatingNode = function (parentNode) {
        this.ubicacionEdicion = new ubicacion_1.UbicacionInfo(); //Crear nueva instancia para evitar que reset modifique la información del último nodo en edición
        this.nodeForm.reset();
        this.ubicacionEdicion = new ubicacion_1.UbicacionInfo(); //Se vuelve a crear instancia para evitar valores nulos creados por reset
        //Inicializar valores del nodo
        this.ubicacionEdicion.idBranch = this.context.app.defaultSite.identity;
        this.ubicacionEdicion.idCompany = this.context.app.defaultCompany.identity;
        this.ubicacionEdicion.idImpresora = 0;
        this.ubicacionEdicion.idCuenta = 0;
        this.ubicacionEdicion.idAlmacen = this.idAlmacen;
        //
        this.currentParent = parentNode;
        this.showEditor();
    };
    UbicacionesManager.prototype.onEditingNode = function (node) {
        this.ubicacionEdicion = this.ubicacionService.copy(node.data);
        this.showEditor();
    };
    UbicacionesManager.prototype.onSavingNode = function () {
        //Si es un nuevo nodo
        if (this.ubicacionEdicion.clientID == 0) {
            this.addNode(this.ubicacionEdicion, this.currentParent);
        }
        else {
            this.updateNode(this.ubicacionEdicion);
        }
        this.ubicacionEdicion = new ubicacion_1.UbicacionInfo();
        this.hideEditor();
    };
    UbicacionesManager.prototype.onDeletingNode = function (node) {
        this.deleteNode(node);
    };
    UbicacionesManager.prototype.onSavingHierarchy = function (changes) {
        var _this = this;
        this.context.app.showSpinner();
        this.ubicacionService.saveHierarchy(changes)
            .then(function (ubicaciones) {
            _this.ubicaciones = ubicaciones;
            _this.reset();
            _this.context.app.hideSpinner();
            _this.showAlert('Los cambios han sido guardados con éxito.', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    UbicacionesManager = UbicacionesManager_1 = __decorate([
        core_1.Component({
            selector: 'inventario-ubicaciones-manager',
            template: "\n      <azteca-hierarchy-manager (configureCatalog)=\"onConfigureCatalog($event)\"\n                                (currentNodeChanged)=\"onCurrentNodeChanged($event)\"\n                                (creatingNode)=\"onCreatingNode($event)\"\n                                (editingNode)=\"onEditingNode($event)\"\n                                (savingNode)=\"onSavingNode()\"\n                                (deletingNode)=\"onDeletingNode($event)\"\n                                (savingHierarchy)=\"onSavingHierarchy($event)\"\n                                (nodesChanged)=\"onNodesChanged($event)\"\n                                [title]=\"'Administraci\u00F3n de ubicaciones'\"\n                                [validForm]=\"nodeForm.valid\"\n                                [currentNode]=\"currentNode\"\n                                [nodes]=\"ubicaciones\">\n\n          <!------------------- Menu de acciones adicionales --------------------->\n          <!--\n          <azteca-menu-item [name]=\"'OPT1'\" [icon]=\"'glyphicon glyphicon-cog'\" [text]=\"'Opci\u00F3n1'\" [smallText]=\"'descripci\u00F3n de opci\u00F3n'\"></azteca-menu-item>\n          -->\n          <!------------------- Formulario de edici\u00F3n  --------------------->\n          <form [formGroup]=\"nodeForm\">\n              <div class=\"row\">\n\n                  <div class=\"col-12 col-md-10\">\n                      <azteca-form-field [label]=\"'C\u00F3digo:'\">\n                          <catalog-code formControlName=\"codigo\" [(ngModel)]=\"ubicacionEdicion.code\" [automatic]=\"autogeneratedCode\"></catalog-code>\n                      </azteca-form-field>\n\n                      <label class=\"control-label\">Ruta:</label>\n                      <az-label [text]=\"ubicacionEdicion.namedPath\"></az-label>\n\n                      <azteca-form-field [label]=\"'Nombre:'\">\n                          <az-textbox formControlName=\"nombre\" [(ngModel)]=\"ubicacionEdicion.nombre\"></az-textbox>\n                      </azteca-form-field>\n\n                      <azteca-form-field [label]=\"'Tipo de ubicaci\u00F3n:'\">\n                          <az-combobox formControlName=\"idTipoUbicacion\"\n                                       [(ngModel)]=\"ubicacionEdicion.idTipoUbicacion\"\n                                       [items]=\"tiposUbicacion\"\n                                       [displayMember]=\"'nombre'\"\n                                       [valueMember]=\"'id'\">\n                          </az-combobox>\n                      </azteca-form-field>\n\n                  </div>\n              </div>\n          </form>\n\n      </azteca-hierarchy-manager>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return UbicacionesManager_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: tipo_ubicacion_service_1.TipoUbicacionService
                }
            ]
        }),
        __metadata("design:paramtypes", [core_2.Context, core_1.ChangeDetectorRef, forms_1.FormBuilder, ubicacion_service_1.UbicacionService, tipo_ubicacion_service_1.TipoUbicacionService,
            router_1.Router, router_1.ActivatedRoute])
    ], UbicacionesManager);
    return UbicacionesManager;
    var UbicacionesManager_1;
}(editors_1.HierarchyManager));
exports.UbicacionesManager = UbicacionesManager;
