"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//Features
var unidad_medida_tipo_service_1 = require("../services/unidad-medida-tipo.service");
var unidad_medida_tipo_1 = require("../models/unidad-medida-tipo");
var unidad_medida_service_1 = require("../services/unidad-medida.service");
var UnidadesMedidaTipoEditor = /** @class */ (function (_super) {
    __extends(UnidadesMedidaTipoEditor, _super);
    //
    function UnidadesMedidaTipoEditor(router, route, formBuilder, changeDetector, context, location, unidadMedidaTipoService, unidadMedidaService) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.router = router;
        _this.route = route;
        _this.formBuilder = formBuilder;
        _this.changeDetector = changeDetector;
        _this.context = context;
        _this.location = location;
        _this.unidadMedidaTipoService = unidadMedidaTipoService;
        _this.unidadMedidaService = unidadMedidaService;
        _this.unidadMedidaTipo = new unidad_medida_tipo_1.UnidadMedidaTipoInfo();
        _this.unidadesMedida = [];
        _this.catalogForm = formBuilder.group({
            'codigo': ['', forms_1.Validators.required],
            'nombre': ['', forms_1.Validators.required]
        });
        return _this;
    }
    UnidadesMedidaTipoEditor_1 = UnidadesMedidaTipoEditor;
    ///////// METODOS //////////////////////
    UnidadesMedidaTipoEditor.prototype.loadUnidadesMedida = function () {
        var _this = this;
        this.unidadMedidaService.loadList(this.unidadMedidaTipo.identity)
            .then(function (unidadesMedida) { return _this.unidadesMedida = unidadesMedida; })
            .catch(function (error) { return _this.handleError(error); });
    };
    ////////// HANDLERS /////////////////////
    UnidadesMedidaTipoEditor.prototype.onConfigureCatalog = function (options) {
        this.autogeneratedCode = options.codigoAutogenerado;
    };
    UnidadesMedidaTipoEditor.prototype.onCreatingItem = function () {
    };
    UnidadesMedidaTipoEditor.prototype.onViewingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.unidadMedidaTipoService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.unidadMedidaTipo = info;
            _this.setReadonlyMode();
            _this.loadUnidadesMedida();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    UnidadesMedidaTipoEditor.prototype.onCloningItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.unidadMedidaTipoService.clone(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.unidadMedidaTipo = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    UnidadesMedidaTipoEditor.prototype.onLoadingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.unidadMedidaTipoService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.unidadMedidaTipo = info;
            _this.loadUnidadesMedida();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    UnidadesMedidaTipoEditor.prototype.onSavingItem = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.unidadMedidaTipoService.update(this.unidadMedidaTipo)
            .then(function (info) {
            _this.context.app.hideSpinner();
            //Si es un elemento nuevo y no se cerrará el editor, navegar a nueva ruta
            _this.reset();
            if (!args.closeEditor && _this.unidadMedidaTipo.identity == 0) {
                _this.router.navigate(['../', info.identity], { relativeTo: _this.route });
            }
            else {
                if (args.closeEditor)
                    _this.router.navigate(['../'], { relativeTo: _this.route });
                else
                    _this.showAlert('La información ha sido actualizada con éxito', 'success');
            }
            _this.unidadMedidaTipo = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    UnidadesMedidaTipoEditor.prototype.onUnidadesUpdated = function () {
        this.loadUnidadesMedida();
    };
    UnidadesMedidaTipoEditor = UnidadesMedidaTipoEditor_1 = __decorate([
        core_1.Component({
            selector: 'inventario-unidades-medida-tipo-editor',
            template: "\n      <form [formGroup]=\"catalogForm\">\n\n          <azteca-catalog-editor #catalogEditor \n                                 [title]=\"'Tipo de Unidad de Medida'\"\n                                 [info]=\"unidadMedidaTipo\"\n                                 [valid]=\"valid\"\n                                 (configureCatalog)=\"onConfigureCatalog($event)\"\n                                 (creatingItem)=\"onCreatingItem()\"\n                                 (viewingItem)=\"onViewingItem($event)\"\n                                 (cloningItem)=\"onCloningItem($event)\"\n                                 (savingItem)=\"onSavingItem($event)\"\n                                 (loadingItem)=\"onLoadingItem($event)\">\n\n              <div class=\"row\">\n                  <div class=\"col-10 col-md-10\">\n                      <azteca-form-field [label]=\"'C\u00F3digo:'\">\n                          <catalog-code formControlName=\"codigo\" [(ngModel)]=\"unidadMedidaTipo.code\" [automatic]=\"autogeneratedCode\"></catalog-code>\n                      </azteca-form-field>\n\n                      <azteca-form-field [label]=\"'Nombre:'\">\n                          <az-textbox formControlName=\"nombre\" [(ngModel)]=\"unidadMedidaTipo.nombre\"></az-textbox>\n                      </azteca-form-field>\n\n                  </div>\n              </div>\n\n        \n              <div class=\"row\">\n                  <div class=\"col-10\">\n                      <inventario-unidades-medida-manager\n                                                             [name]=\"'Unidades Medida'\"\n                                                             [idTipoUnidad]=\"unidadMedidaTipo.identity\"\n                                                             [unidadesMedida]=\"unidadesMedida\"\n                                                             (listUpdated)=\"onUnidadesUpdated()\"\n                                                             [enabled]=\"unidadMedidaTipo.identity>0\">\n\n                      </inventario-unidades-medida-manager>\n                  </div>\n              </div>\n            \n\n          </azteca-catalog-editor>\n      </form>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return UnidadesMedidaTipoEditor_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: unidad_medida_tipo_service_1.UnidadMedidaTipoService
                }
            ]
        }),
        __metadata("design:paramtypes", [router_1.Router, router_1.ActivatedRoute, forms_1.FormBuilder, core_1.ChangeDetectorRef,
            core_2.Context, common_1.Location, unidad_medida_tipo_service_1.UnidadMedidaTipoService,
            unidad_medida_service_1.UnidadMedidaService])
    ], UnidadesMedidaTipoEditor);
    return UnidadesMedidaTipoEditor;
    var UnidadesMedidaTipoEditor_1;
}(editors_1.CatalogEditor));
exports.UnidadesMedidaTipoEditor = UnidadesMedidaTipoEditor;
