"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//Features
var unidad_medida_service_1 = require("../services/unidad-medida.service");
var unidad_medida_1 = require("../models/unidad-medida");
var UnidadesMedidaEditor = /** @class */ (function (_super) {
    __extends(UnidadesMedidaEditor, _super);
    //
    function UnidadesMedidaEditor(router, route, formBuilder, changeDetector, context, location, unidadMedidaService) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.router = router;
        _this.route = route;
        _this.formBuilder = formBuilder;
        _this.changeDetector = changeDetector;
        _this.context = context;
        _this.location = location;
        _this.unidadMedidaService = unidadMedidaService;
        _this.idTipoUnidad = 0;
        _this.unidadMedida = new unidad_medida_1.UnidadMedidaInfo();
        _this.catalogForm = formBuilder.group({
            'codigo': ['', forms_1.Validators.required],
            'nombre': ['', forms_1.Validators.required],
            'abreviatura': ['', forms_1.Validators.required],
            'factor': [1],
            'categoriaFiscal': [0],
            'base': [false],
            'fraccionable': [false],
            'paquete': [false]
        });
        return _this;
    }
    UnidadesMedidaEditor_1 = UnidadesMedidaEditor;
    UnidadesMedidaEditor.prototype.ngOnInit = function () {
        var _this = this;
        this.route.params.forEach(function (params) {
            _this.idTipoUnidad = +params['idTipo'];
        });
    };
    UnidadesMedidaEditor.prototype.onConfigureCatalog = function (options) {
        this.autogeneratedCode = options.codigoAutogenerado;
    };
    UnidadesMedidaEditor.prototype.onCancelingEdit = function () {
        this.location.back();
    };
    UnidadesMedidaEditor.prototype.onCreatingItem = function () {
        this.unidadMedida.idUnidadMedidaTipo = this.idTipoUnidad;
    };
    UnidadesMedidaEditor.prototype.onViewingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.unidadMedidaService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.unidadMedida = info;
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    UnidadesMedidaEditor.prototype.onCloningItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.unidadMedidaService.clone(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.unidadMedida = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    UnidadesMedidaEditor.prototype.onLoadingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.unidadMedidaService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.unidadMedida = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    UnidadesMedidaEditor.prototype.onSavingItem = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        //Si la unidad es fraccionable o es la unidad base, desmarcar bandera de paquete
        if (this.unidadMedida.fraccionable || this.unidadMedida.base) {
            this.unidadMedida.paquete = false;
        }
        //
        this.unidadMedidaService.update(this.unidadMedida)
            .then(function (info) {
            _this.context.app.hideSpinner();
            //Si es un elemento nuevo y no se cerrará el editor, navegar a nueva ruta
            _this.reset();
            if (!args.closeEditor && _this.unidadMedida.identity == 0) {
                _this.router.navigate(['../', info.identity], { relativeTo: _this.route });
                _this.showAlert('La información ha sido actualizada con éxito', 'success');
            }
            else {
                if (args.closeEditor)
                    _this.location.back();
                else
                    _this.showAlert('La información ha sido actualizada con éxito', 'success');
            }
            _this.unidadMedida = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    UnidadesMedidaEditor = UnidadesMedidaEditor_1 = __decorate([
        core_1.Component({
            selector: 'inventario-unidades-medida-editor',
            template: "\n      <form [formGroup]=\"catalogForm\">\n\n          <azteca-catalog-editor #catalogEditor \n                                 [title]=\"'Unidades de Medida'\"\n                                 [info]=\"unidadMedida\"\n                                 [valid]=\"valid\"\n                                 (configureCatalog)=\"onConfigureCatalog($event)\"\n                                 (creatingItem)=\"onCreatingItem()\"\n                                 (viewingItem)=\"onViewingItem($event)\"\n                                 (cloningItem)=\"onCloningItem($event)\"\n                                 (savingItem)=\"onSavingItem($event)\"\n                                 (loadingItem)=\"onLoadingItem($event)\">\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <azteca-form-field [label]=\"'C\u00F3digo:'\">\n                          <catalog-code formControlName=\"codigo\" [(ngModel)]=\"unidadMedida.code\" [automatic]=\"autogeneratedCode\"></catalog-code>\n                      </azteca-form-field>\n\n                      <azteca-form-field [label]=\"'Nombre:'\">\n                          <az-textbox formControlName=\"nombre\" [(ngModel)]=\"unidadMedida.nombre\"></az-textbox>\n                      </azteca-form-field>\n\n                  </div>\n              </div>\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-5\">\n                      <azteca-form-field [label]=\"'Abreviatura:'\">\n                          <az-textbox formControlName=\"abreviatura\" [(ngModel)]=\"unidadMedida.abreviatura\"></az-textbox>\n                      </azteca-form-field>\n                  </div>\n                  <div class=\"col-12 col-md-5\">\n                      <azteca-form-field [label]=\"'Factor:'\">\n                          <az-textbox formControlName=\"factor\" [(ngModel)]=\"unidadMedida.factor\"></az-textbox>\n                      </azteca-form-field>\n                  </div>\n              </div>\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <azteca-form-field [label]=\"'Categor\u00EDa fiscal:'\">\n                          <accounting-unidades-categoria-fiscal-selector formControlName=\"categoriaFiscal\" [(ngModel)]=\"unidadMedida.idCategoriaFiscal\">\n                          </accounting-unidades-categoria-fiscal-selector>\n                      </azteca-form-field>\n\n                      <az-checkbox [label]=\"'\u00C9sta unidad de medida es la base entre las unidades del mismo tipo'\" formControlName=\"base\" [(ngModel)]=\"unidadMedida.base\"></az-checkbox>\n\n                      <az-checkbox [label]=\"'Puede fraccionarse (admite valores decimales)'\" formControlName=\"fraccionable\" [(ngModel)]=\"unidadMedida.fraccionable\"></az-checkbox>\n\n                      <az-checkbox *ngIf=\"!unidadMedida.fraccionable && !unidadMedida.base\" [label]=\"'Representa un paquete de otras unidades'\" formControlName=\"paquete\" [(ngModel)]=\"unidadMedida.paquete\"></az-checkbox>\n                  </div>\n              </div>\n\n\n          </azteca-catalog-editor>\n      </form>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return UnidadesMedidaEditor_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: unidad_medida_service_1.UnidadMedidaService
                }
            ]
        }),
        __metadata("design:paramtypes", [router_1.Router, router_1.ActivatedRoute, forms_1.FormBuilder, core_1.ChangeDetectorRef,
            core_2.Context, common_1.Location, unidad_medida_service_1.UnidadMedidaService])
    ], UnidadesMedidaEditor);
    return UnidadesMedidaEditor;
    var UnidadesMedidaEditor_1;
}(editors_1.CatalogEditor));
exports.UnidadesMedidaEditor = UnidadesMedidaEditor;
