"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//Features
var unidad_medida_service_1 = require("../services/unidad-medida.service");
var UnidadesMedidaManager = /** @class */ (function (_super) {
    __extends(UnidadesMedidaManager, _super);
    //    
    function UnidadesMedidaManager(router, route, context, unidadMedidaService) {
        var _this = _super.call(this, context, router, route) || this;
        _this.router = router;
        _this.route = route;
        _this.context = context;
        _this.unidadMedidaService = unidadMedidaService;
        _this.idTipoUnidad = 0;
        _this.unidadesMedida = [];
        _this.listUpdated = new core_1.EventEmitter();
        return _this;
    }
    UnidadesMedidaManager_1 = UnidadesMedidaManager;
    UnidadesMedidaManager.prototype.onConfigureCatalog = function (options) {
        this.manager.serverSide = options.busquedasServidor;
        this.manager.pageSize = options.tamanioPagina;
    };
    UnidadesMedidaManager.prototype.doSearch = function (request) {
    };
    UnidadesMedidaManager.prototype.onAddingItem = function () {
        this.router.navigate(['inventory/unidades-medida/' + this.process.id + '/' + this.idTipoUnidad + '/0']);
    };
    UnidadesMedidaManager.prototype.onViewingItem = function (item) {
        this.router.navigate(['inventory/unidades-medida/' + this.process.id + '/' + item.data.idUnidadMedidaTipo + '/' + item.id, { readonly: true }]);
    };
    UnidadesMedidaManager.prototype.onEditingItem = function (item) {
        this.router.navigate(['inventory/unidades-medida/' + this.process.id + '/' + item.data.idUnidadMedidaTipo + '/' + item.id]);
    };
    UnidadesMedidaManager.prototype.onDeletingItem = function (item) {
        var _this = this;
        this.unidadMedidaService.delete(item.id)
            .then(function (success) {
            _this.listUpdated.emit();
            _this.showAlert('El registro ha sido eliminado con éxito.', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    UnidadesMedidaManager.prototype.onCloningItem = function (item) {
        this.router.navigate(['inventory/unidades-medida/' + this.process.id + '/' + this.idTipoUnidad + '/' + 0, { cloneId: item.id }]);
    };
    UnidadesMedidaManager.prototype.onChangingItemState = function (item) {
        var _this = this;
        this.unidadMedidaService.changeStatus(item.id, !item.activo)
            .then(function (success) {
            _this.listUpdated.emit();
            _this.showAlert('El estatus del registro ha sido actualizado con éxito.', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], UnidadesMedidaManager.prototype, "idTipoUnidad", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Array)
    ], UnidadesMedidaManager.prototype, "unidadesMedida", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", core_1.EventEmitter)
    ], UnidadesMedidaManager.prototype, "listUpdated", void 0);
    UnidadesMedidaManager = UnidadesMedidaManager_1 = __decorate([
        core_1.Component({
            selector: 'inventario-unidades-medida-manager',
            template: "\n      <azteca-catalog-manager (searchRequested)=\"doSearch($event)\"\n                              (addingItem)=\"onAddingItem()\"\n                              (viewingItem)=\"onViewingItem($event)\"\n                              (editingItem)=\"onEditingItem($event)\"\n                              (deletingItem)=\"onDeletingItem($event)\"\n                              (cloningItem)=\"onCloningItem($event)\"\n                              (changingItemState)=\"onChangingItemState($event)\"\n      \t\t\t\t\t\t(configureCatalog)=\"onConfigureCatalog($event)\"\n                              [enabled]=\"enabled\"\n                              [allowNew]=\"allowNew\"\n                              [allowView]=\"allowView\"\n                              [allowEdit]=\"allowEdit\"\n                              [allowDelete]=\"allowDelete\"\n                              [allowClone]=\"allowClone\"\n                              [allowChangeState]=\"allowChangeState\"\n                              [catalogList]=\"unidadesMedida\"\n                              [totalRows]=\"totalRows\"\n                              [pageIndex]=\"pageIndex\"\n                              [standAlone]=\"false\"\n                              [serverSide]=\"false\"\n                              [pageSize]=\"10\">\n    \n          <azteca-grid-column [header]=\"'Codigo'\" [binding]=\"'codigo'\" [width]=\"100\"></azteca-grid-column>\n          <azteca-grid-column [header]=\"'Nombre'\" [binding]=\"'nombre'\" [width]=\"'60*'\"></azteca-grid-column>\n          <azteca-grid-column [header]=\"'Base'\" [binding]=\"'base'\" [width]=\"80\" dataType=\"Boolean\"></azteca-grid-column>\n          <azteca-grid-column [header]=\"'Factor'\" [binding]=\"'factor'\" [width]=\"80\"></azteca-grid-column>\n    \n\n      </azteca-catalog-manager>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return UnidadesMedidaManager_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: unidad_medida_service_1.UnidadMedidaService
                }
            ]
        }),
        __metadata("design:paramtypes", [router_1.Router, router_1.ActivatedRoute, core_2.Context, unidad_medida_service_1.UnidadMedidaService])
    ], UnidadesMedidaManager);
    return UnidadesMedidaManager;
    var UnidadesMedidaManager_1;
}(editors_1.CatalogManager));
exports.UnidadesMedidaManager = UnidadesMedidaManager;
