import { Router, ActivatedRoute } from '@angular/router';
import { Location } from '@angular/common';
import { BaseComponent, Context, CatalogItem } from 'framework3/core';
import { ToolbarButton, AlertsBarComponent } from 'framework3/controls';
import { PolicyInfo, GrupoService } from 'framework3/core';
import { TrackableCollection } from 'framework3/editors';
import { UsuariosListComponent } from 'framework3/security/components/dialogs/usuarios-list.component';
import { AlmacenService } from '../services/almacen.service';
import { AlmacenUsuarioItem } from '../models/almacen';
export declare class AlmacenUsuariosComponent extends BaseComponent {
    private context;
    private almacenService;
    private grupoService;
    private router;
    private route;
    private location;
    usuarios: AlmacenUsuarioItem[];
    idAlmacen: number;
    currentItem: CatalogItem;
    usuariosCollection: TrackableCollection;
    usuariosDialog: UsuariosListComponent;
    alerts: AlertsBarComponent;
    constructor(context: Context, almacenService: AlmacenService, grupoService: GrupoService, router: Router, route: ActivatedRoute, location: Location);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    loadAlmacen(): void;
    refreshList(): void;
    saveUserList(): void;
    onCurrentItemChanged(item: CatalogItem): void;
    onToolbarButtonClick(button: ToolbarButton): void;
    onSelectedUsersChanged(newUsers: AlmacenUsuarioItem[]): void;
    onRemoveUser(item: any): void;
    applyPolicy(policy: PolicyInfo): void;
    handleError(error: any): void;
}
