"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var common_1 = require("@angular/common");
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//Bootstrap
var ngx_bootstrap_1 = require("ngx-bootstrap");
//Features
var articulo_stock_1 = require("../models/articulo-stock");
var articulo_stock_service_1 = require("../services/articulo-stock.service");
var ArticulosFotografias = /** @class */ (function (_super) {
    __extends(ArticulosFotografias, _super);
    function ArticulosFotografias(router, route, context, articuloStockService, location) {
        var _this = _super.call(this, context, router, route) || this;
        _this.router = router;
        _this.route = route;
        _this.context = context;
        _this.articuloStockService = articuloStockService;
        _this.location = location;
        _this.fotografiaItem = new articulo_stock_1.ArticulosFotografia;
        _this.fotografias = [];
        _this.fotografiasCollection = new editors_1.TrackableCollection();
        _this.fileSelected = '';
        _this.idArticulo = 0;
        return _this;
    }
    ArticulosFotografias.prototype.ngOnInit = function () {
        var _this = this;
        this.route.params.forEach(function (params) {
            _this.idArticulo = params['idArticulo'];
        });
    };
    ArticulosFotografias.prototype.applyPolicy = function (policy) {
    };
    ArticulosFotografias.prototype.ngAfterViewInit = function () {
        this.llenandoGrid(this.idArticulo);
    };
    ArticulosFotografias.prototype.llenandoGrid = function (idArticulo) {
        var _this = this;
        this.articuloStockService.loadFotografias(idArticulo)
            .then(function (docs) {
            _this.fotografias = docs;
            _this.fotografiasCollection.sourceCollection = _this.fotografias;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ArticulosFotografias.prototype.agregarFotografia = function (idArticulo, articulosFotografia) {
        var _this = this;
        this.articuloStockService.agregarFotografia(idArticulo, articulosFotografia)
            .then(function (r) {
            _this.llenandoGrid(_this.idArticulo);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ArticulosFotografias.prototype.show = function () {
        this.dialog.config.backdrop = false;
        this.dialog.config.ignoreBackdropClick = true;
        this.dialog.config.animated = true;
        this.dialog.show();
    };
    ArticulosFotografias.prototype.handleError = function (error) {
        console.log = error;
    };
    ArticulosFotografias.prototype.onUpdate = function () {
        this.fotografiaItem.archivo = this.fileSelected;
        this.agregarFotografia(this.idArticulo, this.fotografiaItem);
        this.dialog.hide();
    };
    ArticulosFotografias.prototype.onToolbarButtonClick = function (button) {
        var _this = this;
        if (button.name == 'ADD') {
            this.fileSelected = '';
            this.fotografiaItem.descripcion = '';
            this.show();
        }
        if (button.name == 'DEL' && this.fotografiasCollection.currentItem != null) {
            this.articuloStockService.eliminarFotografia(this.idArticulo, this.fotografiasCollection.currentItem.idArchivo)
                .then(function (r) {
                _this.llenandoGrid(_this.idArticulo);
            })
                .catch(function (error) { return _this.handleError(error); });
        }
        if (button.name == 'BACK') {
            this.location.back();
        }
    };
    __decorate([
        core_1.ViewChild('dialog'),
        __metadata("design:type", ngx_bootstrap_1.ModalDirective)
    ], ArticulosFotografias.prototype, "dialog", void 0);
    ArticulosFotografias = __decorate([
        core_1.Component({
            selector: 'inventario-articulos-fotografias',
            template: "\n      <div class=\"col-12\">\n          <az-toolbar (buttonClick)=\"onToolbarButtonClick($event)\">\n              <az-toolbar-button [name]=\"'ADD'\" [type]=\"'primary'\" [text]=\"'Agregar'\" [toolTip]=\"'Agregar fotograf\u00EDa'\" [icon]=\"'glyphicon glyphicon-plus'\"></az-toolbar-button>\n              <az-toolbar-button [name]=\"'DEL'\" [type]=\"'primary'\" [text]=\"'Eliminar'\" [toolTip]=\"'Eliminar fotograf\u00EDa'\" [icon]=\"'glyphicon glyphicon-trash'\"></az-toolbar-button>\n              <az-toolbar-button [name]=\"'BACK'\" [text]=\"'Regresar'\" [icon]=\"'glyphicon glyphicon-circle-arrow-left'\"></az-toolbar-button>\n          </az-toolbar>\n\n\n          <carousel [interval]=\"false\">\n              <slide *ngFor=\"let foto of fotografiasCollection.sourceCollection\">\n                  <img [src]=\"context.fileServerPath + foto.uri\">\n\n                  <div class=\"carousel-caption\">\n                      <p>{{foto.descripcion}}</p>\n                  </div>\n              </slide>\n          </carousel>\n\n      </div>\n\n      <div bsModal #dialog=\"bs-modal\" class=\"modal faude\" tabindex=\"-1\" role=\"dialog\" arial-labelledby=\"myLargeModalLabel\" aria-hidden=\"true\">\n          <div class=\"modal-dialog modal-lg\">\n              <div class=\"modal-content\">\n                  <h4 class=\"modal-title pull-left\"></h4>\n              </div>\n              <div class=\"modal-body\">\n                  <label class=\"form-control-label\">Seleccionar una fotograf\u00EDa:</label>\n                  <azteca-image-box [(ngModel)]=\"fileSelected\"></azteca-image-box>\n                  <br />\n                  <label class=\"form-control-label\">Descripci\u00F3n:</label>\n                  <az-textbox [(ngModel)]=\"fotografiaItem.descripcion\"></az-textbox>\n\n              </div>\n              <div class=\"modal-footer\">\n                  <button type=\"button\" class=\"btn btn-danger\" (click)=\"dialog.hide()\">Cancelar</button>\n                  <button type=\"button\" class=\"btn btn-primary\" (click)=\"onUpdate()\" [disabled]=\"(fileSelected == '')\">Aceptar</button>\n              </div>\n          </div>\n      </div>\n    "
        }),
        __metadata("design:paramtypes", [router_1.Router, router_1.ActivatedRoute, core_2.Context, articulo_stock_service_1.ArticuloStockService, common_1.Location])
    ], ArticulosFotografias);
    return ArticulosFotografias;
}(core_2.ProcessComponent));
exports.ArticulosFotografias = ArticulosFotografias;
