"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
//Bootstrap
var ngx_bootstrap_1 = require("ngx-bootstrap");
//Azteca Kernel
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
var almacen_service_1 = require("../services/almacen.service");
var wijmo_1 = require("wijmo/wijmo");
var ClasificacionesArticulosComponent = /** @class */ (function (_super) {
    __extends(ClasificacionesArticulosComponent, _super);
    function ClasificacionesArticulosComponent(almacenService, context, formBuilder) {
        var _this = _super.call(this) || this;
        _this.almacenService = almacenService;
        _this.context = context;
        _this.formBuilder = formBuilder;
        _this.clasificacionesArticulosItem = [];
        //Inputs
        _this.data = [];
        //outputs
        _this.dataUpdated = new core_1.EventEmitter();
        _this.editorForm = formBuilder.group({});
        return _this;
    }
    ClasificacionesArticulosComponent.prototype.show = function () {
        var _this = this;
        this.dialog.config.backdrop = false;
        this.dialog.show();
        setTimeout(function (_) { return _this.editorForm.reset(); });
        wijmo_1.Control.invalidateAll();
    };
    ClasificacionesArticulosComponent.prototype.ngOnInit = function () {
        var _this = this;
        this.almacenService.LoadClasificacionesArticulos()
            .then(function (clasificacionesArticulosItem) {
            _this.clasificacionesArticulosItem = clasificacionesArticulosItem;
            _this.data = clasificacionesArticulosItem;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ClasificacionesArticulosComponent.prototype.onUpdate = function () {
        this.dataUpdated.emit(this.data);
        this.dialog.hide();
    };
    ClasificacionesArticulosComponent.prototype.applyPolicy = function (policy) {
    };
    ClasificacionesArticulosComponent.prototype.handleError = function (error) {
        this.context.app.hideSpinner();
        var message = this.getErrorMessage(error);
        this.alerts.showAlert(message, 'danger');
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", Array)
    ], ClasificacionesArticulosComponent.prototype, "data", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", core_1.EventEmitter)
    ], ClasificacionesArticulosComponent.prototype, "dataUpdated", void 0);
    __decorate([
        core_1.ViewChild('dialog'),
        __metadata("design:type", ngx_bootstrap_1.ModalDirective)
    ], ClasificacionesArticulosComponent.prototype, "dialog", void 0);
    __decorate([
        core_1.ViewChild(controls_1.AlertsBarComponent),
        __metadata("design:type", controls_1.AlertsBarComponent)
    ], ClasificacionesArticulosComponent.prototype, "alerts", void 0);
    ClasificacionesArticulosComponent = __decorate([
        core_1.Component({
            selector: 'inventario-clasificaciones-articulos',
            template: "\n      <form [formGroup]=\"editorForm\">\n\n          <div bsModal #dialog=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"myLargeModalLabel\" aria-hidden=\"true\">\n              <div class=\"modal-dialog modal-lg\">\n                  <div class=\"modal-content\">\n                      <div class=\"modal-header\">\n                          <h4 class=\"modal-title\">Agregar Clasificaciones</h4>\n                      </div>\n\n                      <div class=\"modal-body\">\n\n                          <div class=\"row\">\n                              <div class=\"col-12\">\n\n                                  <wj-flex-grid #gridClasificacionesArticulos style=\"height:550px\"\n                                                [itemsSource]=\"clasificacionesArticulosItem\">\n\n                                      <wj-flex-grid-column [header]=\"' '\" [binding]=\"'selected'\" [width]=\"25\" [isReadOnly]=\"false\" dataType=\"Boolean\"></wj-flex-grid-column>\n                                      <wj-flex-grid-column [header]=\"'Grupo'\" [binding]=\"'grupo'\" [width]=\"'10*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                      <wj-flex-grid-column [header]=\"'Clasificaci\u00F3n'\" [binding]=\"'clasificacion'\" [width]=\"'10*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                  </wj-flex-grid>\n\n                              </div>\n                          </div>\n\n                      </div> <!--Modal Body-->\n                      <div class=\"modal-footer\">\n                          <button type=\"button\" class=\"btn btn-primary\" (click)=\"onUpdate()\" [disabled]=\"!editorForm.valid\">Aceptar</button>\n                          <button type=\"button\" class=\"btn btn-danger\" (click)=\"dialog.hide()\">Atr\u00E1s</button>\n                      </div> <!--Modal Footer-->\n\n                  </div> <!-- Modal Content-->\n              </div> <!--Modal-->\n          </div><!--Modal directive-->\n\n      </form>\n    "
        }),
        __metadata("design:paramtypes", [almacen_service_1.AlmacenService, core_2.Context, forms_1.FormBuilder])
    ], ClasificacionesArticulosComponent);
    return ClasificacionesArticulosComponent;
}(core_2.BaseComponent));
exports.ClasificacionesArticulosComponent = ClasificacionesArticulosComponent;
