import { ChangeDetectorRef } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder, FormGroup } from '@angular/forms';
import { Context, PolicyInfo } from 'framework3/core';
import { AlertsBarComponent } from 'framework3/controls';
import { CatalogEditor } from 'framework3/editors';
import { AreaService } from '../services/area.service';
import { AreaItem, TurnoItem } from '../models/area';
export declare class CortesComponent extends CatalogEditor {
    protected context: Context;
    private formBuilder;
    protected router: Router;
    protected route: ActivatedRoute;
    protected changeDetector: ChangeDetectorRef;
    private areaService;
    form: FormGroup;
    areascbo: AreaItem[];
    turnoscbo: TurnoItem[];
    corteActivo: string;
    corteActivoBool: boolean;
    ajustarInventario: boolean;
    fechaApertura: Date;
    idCorte: string;
    alerts: AlertsBarComponent;
    constructor(context: Context, formBuilder: FormBuilder, router: Router, route: ActivatedRoute, changeDetector: ChangeDetectorRef, areaService: AreaService);
    ngOnInit(): void;
    loadAreas(): void;
    loadCortes(idArea: number): void;
    loadTurnos(idArea: number): void;
    onItemChanged(args: number): void;
    onAbrirCorte(): void;
    onCerrarCorte(): void;
    applyPolicy(policy: PolicyInfo): void;
    handleError(error: any): void;
}
