"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var moment = require("moment");
//Azteca Kernel
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
var editors_1 = require("framework3/editors");
//Features
var area_service_1 = require("../services/area.service");
var CortesComponent = /** @class */ (function (_super) {
    __extends(CortesComponent, _super);
    function CortesComponent(context, formBuilder, router, route, changeDetector, areaService) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.context = context;
        _this.formBuilder = formBuilder;
        _this.router = router;
        _this.route = route;
        _this.changeDetector = changeDetector;
        _this.areaService = areaService;
        _this.areascbo = [];
        _this.turnoscbo = [];
        _this.corteActivo = 'No se a seleccionado area';
        _this.corteActivoBool = false;
        _this.ajustarInventario = false;
        _this.form = formBuilder.group({
            'area': ['', controls_1.AztecaValidators.selected],
            'turno': [''],
            'corteActivo': [''],
            'fechaApertura': [''],
            'ajustarInventario': ['']
        });
        return _this;
    }
    CortesComponent_1 = CortesComponent;
    CortesComponent.prototype.ngOnInit = function () {
        this.loadAreas();
    };
    CortesComponent.prototype.loadAreas = function () {
        var _this = this;
        this.areaService.loadListByUser(this.context.app.defaultSite.identity, this.context.session.user.identity)
            .then(function (x) {
            _this.areascbo = x;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CortesComponent.prototype.loadCortes = function (idArea) {
        var _this = this;
        this.areaService.getDetailByID(idArea)
            .then(function (x) {
            if (x.idCorteActual == '00000000-0000-0000-0000-000000000000') {
                _this.corteActivo = 'No existe corte actual';
                _this.corteActivoBool = false;
            }
            else {
                _this.areaService.LoadCorteActual(idArea)
                    .then(function (x) {
                    var fecha = moment(x.fechaApertura).format();
                    _this.fechaApertura = moment(fecha).toDate();
                    _this.idCorte = x.idCorte;
                    _this.form.controls.turno.patchValue(x.idTurno);
                    _this.corteActivoBool = true;
                    _this.corteActivo = 'Información del corte actual';
                })
                    .catch(function (error) { return _this.handleError(error); });
            }
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CortesComponent.prototype.loadTurnos = function (idArea) {
        var _this = this;
        this.areaService.LoadTurnos(idArea)
            .then(function (x) {
            if (x) {
                _this.ajustarInventario = false;
                _this.turnoscbo = x.filter(function (turno) { return turno.selected == true; });
            }
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CortesComponent.prototype.onItemChanged = function (args) {
        if (args != null) {
            this.form.controls.turno.patchValue('');
            this.loadTurnos(args);
            this.loadCortes(args);
        }
    };
    CortesComponent.prototype.onAbrirCorte = function () {
        var _this = this;
        this.areaService.AbrirCorte(this.form.controls.area.value, this.form.controls.turno.value, this.context.session.user.identity)
            .then(function (x) {
            _this.onItemChanged(_this.form.controls.area.value);
            _this.alerts.showAlert('El corte se a abierto con éxito', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CortesComponent.prototype.onCerrarCorte = function () {
        var _this = this;
        this.areaService.CerrarCorte(this.idCorte, this.ajustarInventario, this.context.session.user.identity)
            .then(function (x) {
            _this.onItemChanged(_this.form.controls.area.value);
            _this.alerts.showAlert('El corte se a cerrado con éxito', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CortesComponent.prototype.applyPolicy = function (policy) {
    };
    CortesComponent.prototype.handleError = function (error) {
        this.context.app.hideSpinner();
        var message = this.getErrorMessage(error);
        this.alerts.showAlert(message, 'danger');
    };
    __decorate([
        core_1.ViewChild(controls_1.AlertsBarComponent),
        __metadata("design:type", controls_1.AlertsBarComponent)
    ], CortesComponent.prototype, "alerts", void 0);
    CortesComponent = CortesComponent_1 = __decorate([
        core_1.Component({
            selector: 'inventario-corte',
            template: "\n      <form [formGroup]=\"form\">\n          <alerts-bar></alerts-bar>\n\n          <div class=\"row justify-content-center\">\n              <div class=\"col-12 col-lg-8\">\n                  <az-panel [header]=\"'Cortes'\">\n                      <div class=\"row\">\n                          <div class=\"col-6\">\n                              <label class=\"control-label\">Area:</label>\n                              <az-combobox formControlName=\"area\"\n                                           [items]=\"areascbo\"\n                                           [displayMember]=\"'nombre'\"\n                                           [valueMember]=\"'idArea'\"\n                                           (selectedItemChanged)=\"onItemChanged($event)\">\n                              </az-combobox>\n                          </div>\n                      </div>\n                      <div class=\"row\">\n                          <div class=\"col-12\">\n\n                          </div>\n                      </div>\n                      <div class=\"row\">\n                          <div class=\"col-lg-10\">\n                              <az-panel [header]=\"'Informaci\u00F3n del corte'\">\n                                  <div class=\"row\">\n                                      <div class=\"col-12 col-lg-6\">\n                                          <azteca-form-field [label]=\"'Estado del Corte:'\">\n                                              <az-textbox formControlName=\"corteActivo\" [(ngModel)]=\"corteActivo\" [enabled]=\"false\"></az-textbox>\n                                          </azteca-form-field>\n\n                                          <azteca-form-field [label]=\"'Fecha Apertura:'\" [hidden]=\"!corteActivoBool\">\n                                              <az-textbox formControlName=\"fechaApertura\" [(ngModel)]=\"fechaApertura\" [enabled]=\"false\"></az-textbox>\n                                          </azteca-form-field>\n\n                                          <azteca-form-field [label]=\"'Turno:'\">\n                                              <az-combobox formControlName=\"turno\"\n                                                           [items]=\"turnoscbo\"\n                                                           [displayMember]=\"'nombre'\"\n                                                           [valueMember]=\"'idTurno'\"\n                                                           [enabled]=\"form.controls.area.value!=='' && !corteActivoBool\">\n                                              </az-combobox>\n                                          </azteca-form-field>\n\n                                          <az-checkbox formControlName=\"ajustarInventario\" [(ngModel)]=\"ajustarInventario\" [label]=\"'Ajustar Inventario'\" [hidden]=\"form.controls.area.value==='' || !corteActivoBool\"></az-checkbox>\n\n                                      </div>\n                                      <div class=\"col-12\">\n                                          <button type=\"button\" class=\"btn btn-primary\" (click)=\"onAbrirCorte()\" [disabled]=\"!form.valid || corteActivoBool || form.controls.turno.value===''\" [hidden]=\"form.controls.area.value==='' || corteActivoBool\">Abrir Corte</button>\n                                      </div>\n                                      <div class=\"col-12\">\n                                          <button type=\"button\" class=\"btn btn-success\" (click)=\"onCerrarCorte()\" [disabled]=\"!form.valid || !corteActivoBool || form.controls.turno.value===''\" [hidden]=\"form.controls.area.value==='' || !corteActivoBool\">Cerrar Corte</button>\n                                      </div>\n                                  </div>\n                              </az-panel>\n                          </div>\n                      </div>\n\n                  </az-panel>\n\n              </div>\n          </div>\n      </form>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return CortesComponent_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: area_service_1.AreaService
                }
            ]
        }),
        __metadata("design:paramtypes", [core_2.Context, forms_1.FormBuilder, router_1.Router, router_1.ActivatedRoute,
            core_1.ChangeDetectorRef, area_service_1.AreaService])
    ], CortesComponent);
    return CortesComponent;
    var CortesComponent_1;
}(editors_1.CatalogEditor));
exports.CortesComponent = CortesComponent;
