"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
//Wijmo
var wijmo_1 = require("wijmo/wijmo");
//Framework3
var core_2 = require("framework3/core");
//Inventario
//Models
var serie_1 = require("../models/serie");
//Services
var articulo_stock_service_1 = require("../services/articulo-stock.service");
var ArticuloSeriesComponent = /** @class */ (function () {
    function ArticuloSeriesComponent(context, articuloService) {
        this.context = context;
        this.articuloService = articuloService;
        this.series = [];
        this.serie = '';
        this.seriesCollection = new wijmo_1.CollectionView();
        /////////// OUTPUS
        this.seriesChange = new core_1.EventEmitter();
    }
    /////////// METHODS
    ArticuloSeriesComponent.prototype.clear = function () {
        this.series = [];
        this.seriesCollection.sourceCollection = this.series;
        this.serieInput.nativeElement.focus();
        this.seriesChange.emit(this.series);
    };
    ArticuloSeriesComponent.prototype.addSerie = function () {
        var _this = this;
        //Verificar que la serie tenga contenido
        if (this.serie && this.serie != '') {
            this.context.app.showSpinner();
            this.articuloService.getSerieInfo(this.idArticuloStock, this.idAlmacen, this.serie)
                .then(function (info) {
                if (info) {
                    _this.updateSeries(info);
                }
                else {
                    var newSerie = new serie_1.SerieInfo();
                    //Crear un nuevo item para la serie que se agregó
                    newSerie.numeroSerie = _this.serie;
                    newSerie.idArticuloStock = _this.idArticuloStock;
                    newSerie.estatus = 'N';
                    _this.updateSeries(newSerie);
                }
                _this.context.app.hideSpinner();
            })
                .catch(function (error) { return _this.handleError(error); });
        }
    };
    ArticuloSeriesComponent.prototype.updateSeries = function (newSerie) {
        //Agregar a la colección
        var newSeries = this.series.slice();
        newSeries.push(newSerie);
        //Limpiar control para una posible nueva captura y establecer foco en el textbox
        this.serie = '';
        this.serieInput.nativeElement.focus();
        this.series = newSeries;
        //Actualizar grid y emitir evento de que las series han cambiado
        this.seriesCollection.sourceCollection = newSeries;
        this.seriesChange.emit(this.series);
    };
    ArticuloSeriesComponent.prototype.count = function () {
        return this.series.length;
    };
    /////////// HANDLERS
    ArticuloSeriesComponent.prototype.onAddSerie = function () {
        this.addSerie();
    };
    ArticuloSeriesComponent.prototype.onSerieKeyup = function (args) {
        //Si se presiona ENTER, ejecutar adición de elemento
        if (args.keyCode == 13) {
            this.addSerie();
        }
    };
    ArticuloSeriesComponent.prototype.onRowDelete = function (row) {
        this.seriesCollection.remove(row);
        this.seriesChange.emit(this.series);
    };
    ArticuloSeriesComponent.prototype.handleError = function (error) {
        console.log(error);
        this.context.app.hideSpinner();
    };
    __decorate([
        core_1.ViewChild('txtSerie'),
        __metadata("design:type", core_1.ElementRef)
    ], ArticuloSeriesComponent.prototype, "serieInput", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], ArticuloSeriesComponent.prototype, "idArticuloStock", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], ArticuloSeriesComponent.prototype, "idAlmacen", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], ArticuloSeriesComponent.prototype, "seriesChange", void 0);
    ArticuloSeriesComponent = __decorate([
        core_1.Component({
            selector: 'inventario-articulo-series',
            template: "\n      <div class=\"row\">\n          <div class=\"col-12\">        \n              <div class=\"input-group\">\n                  <input #txtSerie type=\"text\" placeholder=\"N\u00FAmero de serie\" tabindex=\"0\" class=\"form-control\" [(ngModel)]=\"serie\" (keyup)=\"onSerieKeyup($event)\" />\n                  <div class=\"input-group-btn\">\n                      <button type=\"button\" class=\"btn btn-primary\" (click)=\"onAddSerie()\" [disabled]=\"!serie || serie == ''\">\n                          <span class=\"glyphicon glyphicon-plus\"></span> Agregar\n                      </button>\n                  </div>\n              </div>\n          </div>\n      </div>\n\n      <div class=\"row\">\n          <div class=\"col-12\">\n\n              <wj-flex-grid style=\"height:300px\" [itemsSource]=\"seriesCollection\" [isReadOnly]=\"true\">            \n\n                  <wj-flex-grid-column [header]=\"''\" [width]=\"60\" [isReadOnly]=\"true\">\n                      <ng-template wjFlexGridCellTemplate [cellType]=\"'Cell'\" let-cell=\"cell\">\n                          <button type=\"button\" class=\"btn btn-default\" (click)=\"onRowDelete(cell.item)\">\n                              <span class=\"glyphicon glyphicon-trash\"></span>\n                          </button>\n                      </ng-template>\n                  </wj-flex-grid-column>\n\n                  <wj-flex-grid-column [header]=\"''\" [width]=\"60\" [isReadOnly]=\"true\">\n                      <ng-template wjFlexGridCellTemplate [cellType]=\"'Cell'\" let-cell=\"cell\">\n                          <div class=\"alert alert-warning\" role=\"alert\" *ngIf=\"cell.item.estatus=='N'\" style=\"margin-bottom:0px\">\n                              <span class=\"glyphicon glyphicon-warning-sign\"></span>\n                          </div>\n                          <div class=\"alert alert-success\" role=\"alert\" *ngIf=\"cell.item.estatus=='D'\" style=\"margin-bottom:0px\">\n                              <span class=\"glyphicon glyphicon-ok\"></span>\n                          </div>\n                      </ng-template>\n                  </wj-flex-grid-column>\n\n                  <wj-flex-grid-column [header]=\"'N\u00FAmero de serie'\" [binding]=\"'numeroSerie'\" [width]=\"'*'\"></wj-flex-grid-column>\n                  <wj-flex-grid-column [header]=\"'Costo'\" [binding]=\"'costo'\" [width]=\"100\" dataType=\"Number\" format=\"c\"></wj-flex-grid-column>            \n              </wj-flex-grid>\n\n          </div>\n      </div>\n    "
        }),
        __metadata("design:paramtypes", [core_2.Context, articulo_stock_service_1.ArticuloStockService])
    ], ArticuloSeriesComponent);
    return ArticuloSeriesComponent;
}());
exports.ArticuloSeriesComponent = ArticuloSeriesComponent;
