"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
//
var controls_1 = require("framework3/controls");
//
var stock_1 = require("../models/stock");
var quantity_input_component_1 = require("../controls/quantity-input.component");
var ArticuloStockEntradaComponent = /** @class */ (function (_super) {
    __extends(ArticuloStockEntradaComponent, _super);
    function ArticuloStockEntradaComponent(formBuilder) {
        var _this = _super.call(this) || this;
        _this.formBuilder = formBuilder;
        _this.idAlmacen = 0;
        _this.unidadesMedida = [];
        _this.cantidad = 0;
        _this.unidades = 0;
        _this.idUnidadMedida = 0;
        _this.costoUnitario = 0;
        _this.numeroSerie = '';
        _this.fechaCaducidad = new Date();
        /////////// OUTPUS
        _this.cantidadChange = new core_1.EventEmitter();
        _this.unidadesChange = new core_1.EventEmitter();
        _this.idUnidadMedidaChange = new core_1.EventEmitter();
        _this.costoUnitarioChange = new core_1.EventEmitter();
        _this.numeroSerieChange = new core_1.EventEmitter();
        _this.fechaCaducidadChange = new core_1.EventEmitter();
        _this.idUbicacionChange = new core_1.EventEmitter();
        _this.validChange = new core_1.EventEmitter();
        _this.propagateChange = function (_) { };
        //
        _this.form = formBuilder.group({
            'idUnidadMedida': [0],
            'numeroSerie': [''],
            'fechaCaducidad': [null],
            'costoUnitario': [0],
            'idUbicacion': [0]
        });
        //Suscribirse a cambios en la unidad de medida ya que esta determina varios comportamientos en los campos y validaciones
        _this.form.controls['idUnidadMedida'].valueChanges.subscribe(function (value) {
            setTimeout(function (_) { return _this.setCurrentUnidad(value); });
        });
        return _this;
    }
    Object.defineProperty(ArticuloStockEntradaComponent.prototype, "valid", {
        get: function () {
            return this.form.valid && (!this.quantity || this.quantity.total > 0);
        },
        enumerable: true,
        configurable: true
    });
    ArticuloStockEntradaComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        this.form.statusChanges.subscribe(function (_) {
            _this.validChange.emit(_this.valid);
        });
    };
    ArticuloStockEntradaComponent.prototype.ngOnChanges = function (changes) {
        var _this = this;
        var controlSerie = this.form.controls['numeroSerie'];
        var controlUnidadMedida = this.form.controls['idUnidadMedida'];
        if (changes['idUnidadMedida']) {
            controlUnidadMedida.setValue(this.idUnidadMedida);
        }
        if (changes['numeroSerie']) {
            controlSerie.setValue(this.numeroSerie);
        }
        if (changes['fechaCaducidad'] && !this.fechaCaducidad) {
            this.fechaCaducidad = new Date();
        }
        if (changes['unidadesMedida']) {
            setTimeout(function (_) { return _this.setCurrentUnidad(_this.idUnidadMedida); });
        }
        if (this.stockConfig && changes['stockConfig']) {
            //Establecer validadores dependiendo de las opciones del stock
            //Series
            if (this.stockConfig.manejaSeries) {
                controlSerie.setValidators(forms_1.Validators.required);
                controlUnidadMedida.setValidators(controls_1.AztecaValidators.selected);
                //Los articulos que se controlan por numero de serie siempre son piezas y su cantidad se establece a 1
                this.cantidadChange.emit(1);
                this.unidadesChange.emit(0);
            }
            else {
                controlSerie.setValidators(null);
                controlUnidadMedida.setValidators(null);
                this.numeroSerieChange.emit('');
                controlSerie.updateValueAndValidity();
            }
            //Si no se maneja control de caducidad, actualizar valor como nulo
            if (!this.stockConfig.manejaCaducidad) {
                this.fechaCaducidadChange.emit(null);
            }
            this.form.updateValueAndValidity();
        }
    };
    /////////// METHODS
    ArticuloStockEntradaComponent.prototype.setCurrentUnidad = function (idUnidadMedida) {
        this.selectedUM = this.unidadesMedida.find(function (u) { return u.id == idUnidadMedida; });
        if (this.quantity) {
            this.quantity.unidadMedida = this.selectedUM;
        }
        this.validChange.emit(this.valid);
    };
    /////////// HANDLERS
    ArticuloStockEntradaComponent.prototype.onCantidadChange = function (cantidad) {
        this.cantidadChange.emit(cantidad);
        this.validChange.emit(this.valid);
    };
    ArticuloStockEntradaComponent.prototype.onUnidadesChange = function (unidades) {
        this.unidadesChange.emit(unidades);
        this.validChange.emit(this.valid);
    };
    ArticuloStockEntradaComponent.prototype.onCostoChange = function (costo) {
        this.costoUnitarioChange.emit(costo);
    };
    ArticuloStockEntradaComponent.prototype.onNumSerieChange = function (numSerie) {
        this.numeroSerieChange.emit(numSerie);
    };
    ArticuloStockEntradaComponent.prototype.onFechaCaducidadChange = function (fecha) {
        if (this.stockConfig && this.stockConfig.manejaCaducidad) {
            this.fechaCaducidadChange.emit(fecha);
        }
        else {
            this.fechaCaducidadChange.emit(null);
        }
    };
    ArticuloStockEntradaComponent.prototype.onUbicacionChange = function (ubicacion) {
        if (ubicacion) {
            this.idUbicacionChange.emit(ubicacion.identity);
        }
        else {
            this.idUbicacionChange.emit(0);
        }
    };
    //Implementación de control value accesor
    ArticuloStockEntradaComponent.prototype.writeValue = function (value) {
    };
    ArticuloStockEntradaComponent.prototype.registerOnChange = function (fn) {
        this.propagateChange = fn;
    };
    ArticuloStockEntradaComponent.prototype.registerOnTouched = function () { };
    __decorate([
        core_1.Input(),
        __metadata("design:type", stock_1.StockInfo)
    ], ArticuloStockEntradaComponent.prototype, "stockConfig", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], ArticuloStockEntradaComponent.prototype, "idAlmacen", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Array)
    ], ArticuloStockEntradaComponent.prototype, "unidadesMedida", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], ArticuloStockEntradaComponent.prototype, "cantidad", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], ArticuloStockEntradaComponent.prototype, "unidades", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], ArticuloStockEntradaComponent.prototype, "idUnidadMedida", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], ArticuloStockEntradaComponent.prototype, "costoUnitario", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], ArticuloStockEntradaComponent.prototype, "numeroSerie", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Date)
    ], ArticuloStockEntradaComponent.prototype, "fechaCaducidad", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], ArticuloStockEntradaComponent.prototype, "idUbicacion", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], ArticuloStockEntradaComponent.prototype, "cantidadChange", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], ArticuloStockEntradaComponent.prototype, "unidadesChange", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], ArticuloStockEntradaComponent.prototype, "idUnidadMedidaChange", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], ArticuloStockEntradaComponent.prototype, "costoUnitarioChange", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], ArticuloStockEntradaComponent.prototype, "numeroSerieChange", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], ArticuloStockEntradaComponent.prototype, "fechaCaducidadChange", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], ArticuloStockEntradaComponent.prototype, "idUbicacionChange", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], ArticuloStockEntradaComponent.prototype, "validChange", void 0);
    __decorate([
        core_1.ViewChild(quantity_input_component_1.QuantityInputComponent),
        __metadata("design:type", quantity_input_component_1.QuantityInputComponent)
    ], ArticuloStockEntradaComponent.prototype, "quantity", void 0);
    ArticuloStockEntradaComponent = __decorate([
        core_1.Component({
            selector: 'inventory-articulo-stock-entrada',
            template: "\n      <form [formGroup]=\"form\">\n\n          <!--La unidad de medida no sera visible si se requiere el manejo de numeros de serie-->\n          <div *ngIf=\"stockConfig && !stockConfig.manejaSeries\" class=\"row\">\n              <div class=\"col-12\">\n                  <azteca-form-field [label]=\"'Unidad de medida:'\">\n                      <az-combobox formControlName=\"idUnidadMedida\"\n                                   [(ngModel)]=\"idUnidadMedida\"\n                                   [items]=\"unidadesMedida\"\n                                   [valueMember]=\"'id'\"\n                                   [displayMember]=\"'nombre'\">\n                      </az-combobox>\n                  </azteca-form-field>\n              </div>\n          </div>\n          <div class=\"row\">\n              <div *ngIf=\"stockConfig && !stockConfig.manejaSeries\" class=\"col-12 col-lg-6\">\n                  <inventory-quantity-input #quantity\n                                            [cantidad]=\"cantidad\"\n                                            [unidades]=\"unidades\"\n                                            [unidadMedida]=\"selectedUM\"\n                                            (cantidadChange)=\"onCantidadChange($event)\"\n                                            (unidadesChange)=\"onUnidadesChange($event)\">\n                  </inventory-quantity-input>\n              </div>\n\n              <div class=\"col-12 col-lg-6\">\n                  <azteca-form-field [label]=\"'Costo unitario:'\">\n                      <az-input-number formControlName=\"costoUnitario\" \n                                       [value]=\"costoUnitario\" \n                                       [min]=\"0\" \n                                       format=\"c\"\n                                       (valueChange)=\"onCostoChange($event)\">\n                      </az-input-number>\n                  </azteca-form-field>\n              </div>\n          </div>\n\n          <div class=\"row\">\n              <div *ngIf=\"stockConfig && stockConfig.manejaSeries\" class=\"col-12 col-lg-6\">\n                  <azteca-form-field [label]=\"'N\u00FAmero de serie:'\">\n                      <az-textbox formControlName=\"numeroSerie\" \n                                  [text]=\"numeroSerie\"\n                                  (textChange)=\"onNumSerieChange($event)\">\n                      </az-textbox>\n                  </azteca-form-field>\n              </div>\n              <div *ngIf=\"stockConfig && stockConfig.manejaCaducidad\" class=\"col-12 col-lg-6\">\n                  <azteca-form-field [label]=\"'Fecha de caducidad:'\">\n                      <az-input-date formControlName=\"fechaCaducidad\" \n                                     [value]=\"fechaCaducidad\"\n                                     (valueChange)=\"onFechaCaducidadChange($event)\">\n                      </az-input-date>\n                  </azteca-form-field>\n              </div>\n          </div>\n\n          <div class=\"row\">\n              <div class=\"col-12\">\n                  <azteca-form-field [label]=\"'Ubicaci\u00F3n:'\">\n                      <inventory-ubicaciones-selector formControlName=\"idUbicacion\" \n                                                      [selectedID]=\"idUbicacion\" \n                                                      [showListButton]=\"false\"\n                                                      [idAlmacen]=\"idAlmacen\"\n                                                      (selectedItemChanged)=\"onUbicacionChange($event)\">\n                      </inventory-ubicaciones-selector>\n                  </azteca-form-field>\n              </div>\n          </div>\n\n\n      </form>\n    "
        }),
        __metadata("design:paramtypes", [forms_1.FormBuilder])
    ], ArticuloStockEntradaComponent);
    return ArticuloStockEntradaComponent;
}(controls_1.BaseControl));
exports.ArticuloStockEntradaComponent = ArticuloStockEntradaComponent;
