import { EventEmitter, SimpleChange } from '@angular/core';
import { FormBuilder, ControlValueAccessor } from '@angular/forms';
import { BaseControl } from 'framework3/controls';
import { StockInfo } from '../models/stock';
import { LoteInfo } from '../models/lote';
import { UnidadMedidaItem } from '../models/unidad-medida';
import { SerieInfo } from '../models/serie';
import { QuantityInputComponent } from './quantity-input.component';
import { ArticuloSeriesComponent } from './articulo-series.component';
import { ArticuloLotesComponent } from './articulo-lotes.component';
export declare class ArticuloStockSalidaComponent extends BaseControl implements ControlValueAccessor {
    private formBuilder;
    private form;
    private selectedUM;
    private costoUnitario;
    private disponible;
    stockConfig: StockInfo;
    idArticuloStock: number;
    idAlmacen: number;
    unidadesMedida: UnidadMedidaItem[];
    cantidad: number;
    unidades: number;
    idUnidadMedida: number;
    cantidadChange: EventEmitter<number>;
    unidadesChange: EventEmitter<number>;
    idUnidadMedidaChange: EventEmitter<number>;
    validChange: EventEmitter<boolean>;
    lotesChange: EventEmitter<LoteInfo[]>;
    seriesChange: EventEmitter<SerieInfo[]>;
    quantity: QuantityInputComponent;
    seriesControl: ArticuloSeriesComponent;
    lotesControl: ArticuloLotesComponent;
    private readonly valid;
    constructor(formBuilder: FormBuilder);
    ngAfterViewInit(): void;
    ngOnChanges(changes: SimpleChange): void;
    setCurrentUnidad(idUnidadMedida: number): void;
    private showQuantity();
    private showSeries();
    private showLotes();
    onCantidadChange(cantidad: number): void;
    onUnidadesChange(unidades: number): void;
    onLotesChange(lotes: LoteInfo[]): void;
    onSeriesChange(series: SerieInfo[]): void;
    writeValue(value: any): void;
    propagateChange: (_: any) => void;
    registerOnChange(fn: any): void;
    registerOnTouched(): void;
}
