"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
//Framework3
var controls_1 = require("framework3/controls");
var QuantityInputComponent = /** @class */ (function (_super) {
    __extends(QuantityInputComponent, _super);
    function QuantityInputComponent() {
        var _this = _super.call(this) || this;
        _this.cantidad = 0;
        _this.unidades = 0;
        /////////// OUTPUS
        _this.cantidadChange = new core_1.EventEmitter();
        _this.unidadesChange = new core_1.EventEmitter();
        _this.propagateChange = function (_) { };
        return _this;
    }
    Object.defineProperty(QuantityInputComponent.prototype, "quantityFormat", {
        //Formato del campo cantidad, cuando la UM sea piezas el formato sera entero, en caso contrario se permitiran decimales
        get: function () {
            if (this.unidadMedida && this.unidadMedida.fraccionable) {
                return null;
            }
            else {
                return 'n0';
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(QuantityInputComponent.prototype, "quantityClass", {
        get: function () {
            if (this.unidadMedida && this.unidadMedida.paquete) {
                return 'col-12 col-lg-6';
            }
            else {
                return 'col-12';
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(QuantityInputComponent.prototype, "minQuantity", {
        //Obtener el valor minimo dependiendo de si la unidad es fraccionable o no
        get: function () {
            if (this.unidadMedida && this.unidadMedida.fraccionable) {
                return 0.0001;
                ;
            }
            else if (this.unidadMedida && this.unidadMedida.paquete) {
                return 0;
            }
            else {
                return 1;
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(QuantityInputComponent.prototype, "total", {
        //Obtener la cantidad absoluta que servira para validar el registro (cantidad > 0)
        get: function () {
            if (this.unidadMedida) {
                return (this.cantidad * this.unidadMedida.factor) + this.unidades;
            }
            else {
                return 0;
            }
        },
        enumerable: true,
        configurable: true
    });
    QuantityInputComponent.prototype.ngOnChanges = function (changes) {
        if (this.unidadMedida && changes['unidadMedida']) {
            if (!this.unidadMedida.paquete) {
                this.unidades = 0;
                this.unidadesChange.emit(0);
                this.propagateChange(0);
            }
            else {
                this.propagateChange(this.total);
            }
        }
    };
    /////////// METHODS
    /////////// HANDLERS
    QuantityInputComponent.prototype.onCantidadChange = function (value) {
        if (value != this.cantidad) {
            this.cantidad = value;
            this.cantidadChange.emit(value);
            this.propagateChange(this.total);
        }
    };
    QuantityInputComponent.prototype.onUnidadesChange = function (value) {
        if (this.unidades != value) {
            this.unidades = value;
            this.unidadesChange.emit(value);
            this.propagateChange(this.total);
        }
    };
    //Implementación de control value accesor
    QuantityInputComponent.prototype.writeValue = function (value) {
    };
    QuantityInputComponent.prototype.registerOnChange = function (fn) {
        this.propagateChange = fn;
    };
    QuantityInputComponent.prototype.registerOnTouched = function () { };
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], QuantityInputComponent.prototype, "unidadMedida", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], QuantityInputComponent.prototype, "cantidad", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], QuantityInputComponent.prototype, "unidades", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], QuantityInputComponent.prototype, "cantidadChange", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], QuantityInputComponent.prototype, "unidadesChange", void 0);
    QuantityInputComponent = __decorate([
        core_1.Component({
            selector: 'inventory-quantity-input',
            template: "\n      <div class=\"row\">\n          <div [class]=\"quantityClass\">\n              <label class=\"form-control-label\">Cantidad:</label>\n              <az-input-number [value]=\"cantidad\"\n                               [format]=\"quantityFormat\"\n                               [min]=\"minQuantity\"\n                               (valueChange)=\"onCantidadChange($event)\">\n              </az-input-number>\n          </div>\n          <div class=\"col-12 col-lg-6\" *ngIf=\"unidadMedida && unidadMedida.paquete && unidadMedida.factor > 1\">\n              <label class=\"form-control-label\">Unidades:</label>\n              <az-input-number [value]=\"unidades ? unidades : 0\"\n                               format=\"n0\"\n                               [min]=\"0\"\n                               [max]=\"unidadMedida ? unidadMedida.factor - 1 : 0\"\n                               (valueChange)=\"onUnidadesChange($event)\">\n              </az-input-number>\n          </div>\n      </div>\n    "
        }),
        __metadata("design:paramtypes", [])
    ], QuantityInputComponent);
    return QuantityInputComponent;
}(controls_1.BaseControl));
exports.QuantityInputComponent = QuantityInputComponent;
