"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
//Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
var controls_1 = require("framework3/controls");
//Locales
var entrada_detail_1 = require("../../models/entrada-detail");
var stock_1 = require("../../models/stock");
var unidad_medida_service_1 = require("../../services/unidad-medida.service");
var almacen_service_1 = require("../../services/almacen.service");
var EntradaDetailEditor = /** @class */ (function (_super) {
    __extends(EntradaDetailEditor, _super);
    function EntradaDetailEditor(context, builder, unidadService, almacenService) {
        var _this = _super.call(this, context) || this;
        _this.context = context;
        _this.builder = builder;
        _this.unidadService = unidadService;
        _this.almacenService = almacenService;
        _this.unidadesMedida = [];
        _this.validInput = false;
        //Copia temporal que se utilizará para edición y no afecte al objeto original por si el usuario decide cancelar la edición
        _this.detailCopy = new entrada_detail_1.EntradaDetail();
        //Objeto original que se editará
        _this.detail = new entrada_detail_1.EntradaDetail();
        _this.idAlmacen = 0;
        _this.form = builder.group({
            'idArticulo': [0, controls_1.AztecaValidators.selected]
        });
        return _this;
    }
    /////////////////// METODOS ///////////////////////////////
    EntradaDetailEditor.prototype.loadUnidadesMedida = function (idTipoUnidad) {
        var _this = this;
        //Si el articulo esta controlado por series, no se puede cambiar la unidad de medida, por lo tanto solo se debe utilizar la unidad de medida el articulo,
        //en caso contrario, cargar lista de unidades de medida del mismo tipo
        if (this.stockConfig.manejaSeries) {
            var unidadArticulo = this.detailCopy.articuloStock.unidadMedida;
            var newUnidad = {
                id: unidadArticulo.identity, codigo: unidadArticulo.code, idUnidadMedidaTipo: unidadArticulo.idUnidadMedidaTipo, base: unidadArticulo.base,
                factor: unidadArticulo.factor, fraccionable: unidadArticulo.fraccionable, paquete: unidadArticulo.paquete, activo: true
            };
            var newUnidades = [];
            newUnidades.push(newUnidad);
            this.unidadesMedida = newUnidades;
            this.detailCopy.idUnidadMedida = unidadArticulo.identity;
        }
        else {
            this.unidadService.loadList(idTipoUnidad)
                .then(function (unidadesMedida) {
                _this.unidadesMedida = unidadesMedida;
                _this.detailCopy.idUnidadMedida = _this.detailCopy.articuloStock.idUnidadMedida;
            })
                .catch(function (error) { return _this.handleError(error); });
        }
    };
    EntradaDetailEditor.prototype.loadStock = function (idArticulo) {
        var _this = this;
        this.almacenService.loadStock(this.idAlmacen, idArticulo)
            .then(function (stock) {
            _this.stockConfig = stock;
            _this.loadUnidadesMedida(_this.detailCopy.articuloStock.unidadMedida.idUnidadMedidaTipo);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    /////////////////// HANDLERS //////////////////////////////
    EntradaDetailEditor.prototype.onCreatingItem = function () {
        this.detailCopy = this.detail;
        this.form.reset({ idArticulo: 0 });
        this.form.markAsPristine();
    };
    EntradaDetailEditor.prototype.onLoadingItem = function (detail) {
        this.detailCopy = this.copyItem(this.detail);
        this.form.updateValueAndValidity();
    };
    EntradaDetailEditor.prototype.onUpdatingItem = function (detail) {
        var _this = this;
        this.unidadService.getDetailFromCache(this.detailCopy.idUnidadMedida)
            .then(function (unidad) {
            _this.detailCopy.unidadMedida = unidad;
            if (_this.detailCopy._clientID == 0) {
                _this.detailCopy._clientID = _this.createClientID();
            }
            else {
                _this.detailCopy.state = editors_1.ChangeState.MODIFIED;
            }
            _this.savingItem.emit(_this.detailCopy);
            _this.detailCopy = new entrada_detail_1.EntradaDetail();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    EntradaDetailEditor.prototype.onArticuloChanged = function (articulo) {
        if (articulo) {
            this.detailCopy.articuloStock = articulo;
            this.loadStock(articulo.identity);
        }
        else {
            this.unidadesMedida = [];
            this.stockConfig = new stock_1.StockInfo();
        }
    };
    EntradaDetailEditor.prototype.onInputValidChange = function (valid) {
        this.validInput = valid;
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", entrada_detail_1.EntradaDetail)
    ], EntradaDetailEditor.prototype, "detail", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], EntradaDetailEditor.prototype, "idAlmacen", void 0);
    EntradaDetailEditor = __decorate([
        core_1.Component({
            selector: 'inventario-entrada-detail-editor',
            template: "\n      <form [formGroup]=\"form\">\n          <azteca-basic-editor [item]=\"detail\"\n                               [dirty]=\"dirty\"\n                               [valid]=\"valid && validInput\"\n                               (creatingItem)=\"onCreatingItem()\"\n                               (loadingItem)=\"onLoadingItem($event)\"\n                               (updatingItem)=\"onUpdatingItem($event)\">\n\n                  <div class=\"row\">\n                      <div class=\"col-12\">\n\n                          <azteca-form-field [label]=\"'Art\u00EDculo:'\">\n                              <inventory-articulo-stock-selector formControlName=\"idArticulo\"\n                                                                 [(ngModel)]=\"detailCopy.idArticuloStock\"\n                                                                 [showListButton]=\"false\"\n                                                                 (selectedItemChanged)=\"onArticuloChanged($event)\">\n                              </inventory-articulo-stock-selector>\n                          </azteca-form-field>\n\n                      </div>\n                  </div>\n        \n                  <div class=\"row\">\n                      <div class=\"col-12\">\n                          <inventory-articulo-stock-entrada [stockConfig]=\"stockConfig\"\n                                                            [unidadesMedida]=\"unidadesMedida\"\n                                                            [idAlmacen]=\"idAlmacen\"\n                                                            [(cantidad)]=\"detailCopy.cantidad\"\n                                                            [(unidades)]=\"detailCopy.unidades\"\n                                                            [(costoUnitario)]=\"detailCopy.costoUnitario\"\n                                                            [(idUnidadMedida)]=\"detailCopy.idUnidadMedida\"\n                                                            [(numeroSerie)]=\"detailCopy.numeroSerie\"\n                                                            [(fechaCaducidad)]=\"detailCopy.fechaCaducidad\"\n                                                            [(idUbicacion)]=\"detailCopy.idUbicacion\"\n                                                            (validChange)=\"onInputValidChange($event)\">\n                          </inventory-articulo-stock-entrada>\n                      </div>\n                  </div>\n          </azteca-basic-editor>\n      </form>\n    "
        }),
        __metadata("design:paramtypes", [core_2.Context, forms_1.FormBuilder, unidad_medida_service_1.UnidadMedidaService, almacen_service_1.AlmacenService])
    ], EntradaDetailEditor);
    return EntradaDetailEditor;
}(editors_1.BasicEditor));
exports.EntradaDetailEditor = EntradaDetailEditor;
