import { FormBuilder } from '@angular/forms';
import { Context } from 'framework3/core';
import { BasicEditor } from 'framework3/editors';
import { SalidaDetail } from '../../models/salida-detail';
import { ArticuloStockInfo } from '../../models/articulo-stock';
import { StockInfo } from '../../models/stock';
import { LoteInfo } from '../../models/lote';
import { SerieInfo } from '../../models/serie';
import { UnidadMedidaItem } from '../../models/unidad-medida';
import { UnidadMedidaService } from '../../services/unidad-medida.service';
import { AlmacenService } from '../../services/almacen.service';
export declare class SalidaDetailEditor extends BasicEditor {
    protected context: Context;
    private builder;
    private unidadService;
    private almacenService;
    unidadesMedida: UnidadMedidaItem[];
    stockConfig: StockInfo;
    validInput: boolean;
    lotes: LoteInfo[];
    series: SerieInfo[];
    detailCopy: SalidaDetail;
    detail: SalidaDetail;
    idAlmacen: number;
    constructor(context: Context, builder: FormBuilder, unidadService: UnidadMedidaService, almacenService: AlmacenService);
    loadUnidadesMedida(idTipoUnidad: number): void;
    loadStock(idArticulo: number): void;
    onCreatingItem(): void;
    onLoadingItem(detail: SalidaDetail): void;
    onUpdatingItem(detail: SalidaDetail): void;
    onArticuloChanged(articulo: ArticuloStockInfo): void;
    onInputValidChange(valid: boolean): void;
    onLotesChange(lotes: LoteInfo[]): void;
    onSeriesChange(series: SerieInfo[]): void;
}
