"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
//////////////////////////// Guards //////////////////////////////////
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
var unidades_medida_editor_1 = require("./catalogs/unidades-medida.editor");
var unidades_medida_tipo_manager_1 = require("./catalogs/unidades-medida-tipo.manager");
var unidades_medida_tipo_editor_1 = require("./catalogs/unidades-medida-tipo.editor");
var areas_manager_1 = require("./catalogs/areas.manager");
var areas_editor_1 = require("./catalogs/areas.editor");
var almacenes_manager_1 = require("./catalogs/almacenes.manager");
var almacenes_editor_1 = require("./catalogs/almacenes.editor");
var articulos_stock_manager_1 = require("./catalogs/articulos-stock.manager");
var articulos_stock_editor_1 = require("./catalogs/articulos-stock.editor");
var almacen_existencias_1 = require("./catalogs/almacen-existencias");
var articulo_existencias_1 = require("./catalogs/articulo-existencias");
var ubicaciones_manager_1 = require("./catalogs/ubicaciones.manager");
var almacen_articulos_stock_1 = require("./catalogs/almacen-articulos-stock");
var articulos_stock_configuracion_1 = require("./catalogs/articulos-stock-configuracion");
var tipos_ubicacion_manager_1 = require("./catalogs/tipos-ubicacion.manager");
var tipos_ubicacion_editor_1 = require("./catalogs/tipos-ubicacion.editor");
var conceptos_manager_1 = require("./catalogs/conceptos.manager");
var conceptos_editor_1 = require("./catalogs/conceptos.editor");
//////////////////////////// Componentes ////////////////////////////////
var area_usuarios_component_1 = require("./components/area-usuarios.component");
var almacen_usuarios_component_1 = require("./components/almacen-usuarios.component");
var articulos_permitidos_component_1 = require("./components/articulos-permitidos.component");
var articulos_fotografias_component_1 = require("./components/articulos-fotografias.component");
var concepto_usuarios_component_1 = require("./components/concepto-usuarios.component");
var corte_component_1 = require("./components/corte.component");
///////////////////////////// Document /////////////////////////////////
var entradas_editor_1 = require("./documents/entradas.editor");
var entradas_manager_1 = require("./documents/entradas.manager");
var salidas_editor_1 = require("./documents/salidas.editor");
var salidas_manager_1 = require("./documents/salidas.manager");
var nueva_entrada_component_1 = require("./documents/parts/nueva-entrada.component");
var nueva_salida_component_1 = require("./documents/parts/nueva-salida.component");
///////////////////////////// Rutas /////////////////////////////////
var routes = [
    {
        path: '',
        canActivateChild: [core_2.AuthGuard],
        children: [
            { path: 'unidades-medida-tipo/:proceso', component: unidades_medida_tipo_manager_1.UnidadesMedidaTipoManager },
            { path: 'unidades-medida-tipo/:proceso/:id', component: unidades_medida_tipo_editor_1.UnidadesMedidaTipoEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'unidades-medida/:proceso/:idTipo/:id', component: unidades_medida_editor_1.UnidadesMedidaEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'articulos-stock/:proceso', component: articulos_stock_manager_1.ArticulosStockManager },
            { path: 'articulos-stock/:proceso/:id', component: articulos_stock_editor_1.ArticulosStockEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'areas/:proceso', component: areas_manager_1.AreasManager },
            { path: 'areas/:proceso/:id', component: areas_editor_1.AreasEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'areas-usuarios/:proceso/:idArea', component: area_usuarios_component_1.AreasUsuariosComponent },
            { path: 'almacenes/:proceso/:idArea', component: almacenes_manager_1.AlmacenesManager },
            { path: 'almacenes/:proceso/:idArea/:id', component: almacenes_editor_1.AlmacenesEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'almacenes-usuarios/:proceso/:idAlmacen', component: almacen_usuarios_component_1.AlmacenUsuariosComponent },
            { path: 'almacenes-clasificaciones-articulos/:proceso/:idAlmacen', component: articulos_permitidos_component_1.ArticulosPermitidosComponent },
            { path: 'almacenes-existencias/:proceso/:idAlmacen', component: almacen_existencias_1.AlmacenExistencias },
            { path: 'articulos-existencias/:proceso/:idArticulo', component: articulo_existencias_1.ArticuloExistencias },
            { path: 'almacenes-stock/:proceso/:idAlmacen', component: almacen_articulos_stock_1.AlmacenArticulosStock },
            { path: 'articulos-stock-configuracion/:proceso/:idArticulo', component: articulos_stock_configuracion_1.ArticulosStockConfiguracion },
            { path: 'ubicaciones/:proceso/:idAlmacen', component: ubicaciones_manager_1.UbicacionesManager },
            { path: 'articulos-fotografias/:proceso/:idArticulo', component: articulos_fotografias_component_1.ArticulosFotografias },
            { path: 'ubicaciones-tipo/:proceso', component: tipos_ubicacion_manager_1.TiposUbicacionManager },
            { path: 'ubicaciones-tipo/:proceso/:id', component: tipos_ubicacion_editor_1.TiposUbicacionEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'conceptos/:proceso', component: conceptos_manager_1.ConceptosManager },
            { path: 'conceptos/:proceso/:id', component: conceptos_editor_1.ConceptosEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'conceptos/:proceso/:id/users', component: concepto_usuarios_component_1.ConceptoUsuariosComponent },
            { path: 'cortes/:proceso', component: corte_component_1.CortesComponent },
            //DOCUMENTS
            { path: 'entradas/:proceso', component: entradas_manager_1.EntradasManager },
            { path: 'entradas/:proceso/new', component: nueva_entrada_component_1.NuevaEntradaComponent },
            { path: 'entradas/:proceso/:id', component: entradas_editor_1.EntradasEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'salidas/:proceso', component: salidas_manager_1.SalidasManager },
            { path: 'salidas/:proceso/new', component: nueva_salida_component_1.NuevaSalidaComponent },
            { path: 'salidas/:proceso/:id', component: salidas_editor_1.SalidasEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
        ]
    },
];
var InventoryRoutingModule = /** @class */ (function () {
    function InventoryRoutingModule() {
    }
    InventoryRoutingModule = __decorate([
        core_1.NgModule({
            imports: [
                router_1.RouterModule.forChild(routes)
            ],
            exports: [
                router_1.RouterModule
            ]
        })
    ], InventoryRoutingModule);
    return InventoryRoutingModule;
}());
exports.InventoryRoutingModule = InventoryRoutingModule;
