import { HttpClient } from '@angular/common/http';
import 'rxjs/add/operator/toPromise';
import { Context, CatalogService } from 'framework3/core';
import { AreaInfo, AreaItem, AreaUsuarioItem, TurnoItem } from '../models/area';
import { AlmacenItem } from '../models/almacen';
export declare class AreaService extends CatalogService<AreaInfo> {
    constructor(http: HttpClient, context: Context);
    create(): Promise<AreaInfo>;
    loadList(idSucursal: number): Promise<AreaItem[]>;
    loadListByUser(idSucursal: number, idUsuario: number): Promise<AreaItem[]>;
    loadAlmacenes(idArea: number): Promise<AlmacenItem[]>;
    loadAlmacenesByUser(idArea: number, idUsuario: number): Promise<AlmacenItem[]>;
    LoadAccessUsersList(idArea: number): Promise<AreaUsuarioItem[]>;
    getMembers(idGrupo: number): Promise<AreaUsuarioItem[]>;
    addMembers(idArea: number, usuarios: AreaUsuarioItem[]): Promise<any>;
    removeMember(idArea: number, idUsuario: number): Promise<any>;
    LoadTurnos(idArea: number): Promise<TurnoItem[]>;
    LoadCorte(idCorte: string): Promise<any[]>;
    LoadCorteActual(idArea: number): Promise<any>;
    AbrirCorte(idArea: number, idTurno: number, idUsuario: number): Promise<any>;
    CerrarCorte(idCorte: string, ajustarInventario: boolean, idUsuario: number): Promise<any>;
}
