import { HttpClient } from '@angular/common/http';
import 'rxjs/add/operator/toPromise';
import { Context, CatalogService } from 'framework3/core';
import { ArticuloStockInfo, ArticulosFotografia } from '../models/articulo-stock';
import { LoteInfo } from '../models/lote';
import { SerieInfo } from '../models/serie';
import { TiposInventarioItem } from '../models/tipo-inventario';
export declare class ArticuloStockService extends CatalogService<ArticuloStockInfo> {
    constructor(http: HttpClient, context: Context);
    create(): Promise<ArticuloStockInfo>;
    loadList(): Promise<TiposInventarioItem[]>;
    loadFotografias(idArticuloStock: number): Promise<ArticulosFotografia[]>;
    agregarFotografia(idArticuloStock: number, articulosFotografia: ArticulosFotografia): Promise<any>;
    eliminarFotografia(idArticuloStock: number, idArchivo: string): Promise<any>;
    loadExistenciasLote(idArticuloStock: number, idAlmacen: number): Promise<LoteInfo[]>;
    loadExistenciasSerie(idArticuloStock: number, idAlmacen: number): Promise<SerieInfo[]>;
    getSerieInfo(idArticuloStock: number, idAlmacen: number, numeroSerie: string): Promise<SerieInfo>;
}
