"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Azteca Kernel
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
var editors_1 = require("framework3/editors");
//Features
var empresa_service_1 = require("../services/empresa.service");
var empresa_1 = require("../models/empresa");
var EmpresasEditor = /** @class */ (function (_super) {
    __extends(EmpresasEditor, _super);
    //
    function EmpresasEditor(router, route, formBuilder, changeDetector, context, location, empresaService) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.router = router;
        _this.route = route;
        _this.formBuilder = formBuilder;
        _this.changeDetector = changeDetector;
        _this.context = context;
        _this.location = location;
        _this.empresaService = empresaService;
        _this.empresa = new empresa_1.EmpresaInfo();
        _this.catalogForm = formBuilder.group({
            'codigo': [''],
            'nombre': [''],
            'idRemitentePortal': [0],
            'idRemitenteOrdenes': [0],
            'correoRecepcionCFD': ['', controls_1.AztecaValidators.email],
            'servidorPopCFD': [''],
            'puertoPopCFD': [0],
            'passwordPopCFD': [''],
        });
        return _this;
    }
    EmpresasEditor_1 = EmpresasEditor;
    ///////////////////////// METODOS ///////////////////////////////////////
    ///////////////////////// HANDLERS ///////////////////////////////////////
    EmpresasEditor.prototype.onConfigureCatalog = function (options) {
        this.autogeneratedCode = options.codigoAutogenerado;
        this.applyPolicies();
    };
    EmpresasEditor.prototype.onCreatingItem = function () {
    };
    EmpresasEditor.prototype.onViewingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.empresaService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.empresa = info;
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    EmpresasEditor.prototype.onCloningItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.empresaService.clone(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.empresa = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    EmpresasEditor.prototype.onLoadingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.empresaService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.empresa = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    EmpresasEditor.prototype.onSavingItem = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.empresaService.update(this.empresa)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.reset();
            //Si es un elemento nuevo y no se cerrará el editor, navegar a nueva ruta
            if (!args.closeEditor && _this.empresa.identity == 0) {
                _this.router.navigate(['../', info.identity], { relativeTo: _this.route });
            }
            else {
                if (args.closeEditor)
                    _this.router.navigate(['../'], { relativeTo: _this.route });
                else
                    _this.showAlert('La información ha sido actualizada con éxito', 'success');
            }
            _this.empresa = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    EmpresasEditor = EmpresasEditor_1 = __decorate([
        core_1.Component({
            selector: 'compras-empresa-editor',
            template: "\n      <form [formGroup]=\"catalogForm\">\n\n          <azteca-catalog-editor #catalogEditor \n                                 [title]=\"'Empresa'\"\n                                 [info]=\"empresa\"\n                                 [valid]=\"valid\"\n                                 (configureCatalog)=\"onConfigureCatalog($event)\"\n                                 (creatingItem)=\"onCreatingItem()\"\n                                 (viewingItem)=\"onViewingItem($event)\"\n                                 (cloningItem)=\"onCloningItem($event)\"\n                                 (savingItem)=\"onSavingItem($event)\"\n                                 (loadingItem)=\"onLoadingItem($event)\">\n\n\n              <!------------------- Menu de acciones adicionales --------------------->\n\n              <!------------------- Controles del editor ----------------------------->\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-lg-10\">\n                      <azteca-form-field [label]=\"'C\u00F3digo:'\">\n                          <catalog-code formControlName=\"codigo\" [(ngModel)]=\"empresa.code\" [automatic]=\"true\"></catalog-code>\n                      </azteca-form-field>\n\n                      <label class=\"control-label\">Nombre:</label>\n                      <az-label [text]=\"empresa.empresaBase.nombre\"></az-label>\n\n                  </div>\n              </div>\n        \n              <div class=\"row\">\n                  <div class=\"col-12 col-lg-10\">\n\n                      <az-panel [header]=\"'Remitentes'\">\n\n                          <azteca-form-field [label]=\"'Remitente del portal de proveedores:'\">\n                              <notification-remitente-mail-selector formControlName=\"idRemitentePortal\" [(ngModel)]=\"empresa.idRemitentePortal\"></notification-remitente-mail-selector>\n                          </azteca-form-field>\n\n                          <azteca-form-field [label]=\"'Remitente de ordenes de compra:'\">\n                              <notification-remitente-mail-selector formControlName=\"idRemitenteOrdenes\" [(ngModel)]=\"empresa.idRemitenteOrdenes\"></notification-remitente-mail-selector>\n                          </azteca-form-field>\n\n                      </az-panel>\n\n                      <az-panel [header]=\"'Buz\u00F3n de comprobantes fiscales'\">\n\n\n                          <div class=\"row\">\n                              <div class=\"col-12 col-lg-6\">\n                                  <azteca-form-field [label]=\"'Correo electr\u00F3nico:'\">\n                                      <az-textbox formControlName=\"correoRecepcionCFD\" [(ngModel)]=\"empresa.correoRecepcionCFD\"></az-textbox>\n                                  </azteca-form-field>\n                              </div>\n                              <div class=\"col-12 col-lg-6\">\n                                  <azteca-form-field [label]=\"'Contrase\u00F1a:'\">\n                                      <az-password formControlName=\"passwordPopCFD\" [(ngModel)]=\"empresa.passwordPopCFD\"></az-password>\n                                  </azteca-form-field>\n                              </div>\n                          </div>\n\n                          <div class=\"row\">\n                              <div class=\"col-12 col-lg-9\">\n                                  <azteca-form-field [label]=\"'Servidor POP3:'\">\n                                      <az-textbox formControlName=\"servidorPopCFD\" [(ngModel)]=\"empresa.servidorPopCFD\"></az-textbox>\n                                  </azteca-form-field>\n                              </div>\n                              <div class=\"col-12 col-lg-3\">\n                                  <azteca-form-field [label]=\"'Puerto:'\">\n                                      <az-input-number formControlName=\"puertoPopCFD\" [(ngModel)]=\"empresa.puertoPopCFD\"></az-input-number>\n                                  </azteca-form-field>\n                              </div>\n                          </div>\n\n                      </az-panel>\n\n                  </div>\n              </div>\n            \n\n          </azteca-catalog-editor>\n      </form>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return EmpresasEditor_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: empresa_service_1.EmpresaService
                }
            ]
        }),
        __metadata("design:paramtypes", [router_1.Router, router_1.ActivatedRoute, forms_1.FormBuilder, core_1.ChangeDetectorRef,
            core_2.Context, common_1.Location, empresa_service_1.EmpresaService])
    ], EmpresasEditor);
    return EmpresasEditor;
    var EmpresasEditor_1;
}(editors_1.CatalogEditor));
exports.EmpresasEditor = EmpresasEditor;
