"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Azteca Kernel
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
var editors_1 = require("framework3/editors");
//Features
var proveedor_service_1 = require("../services/proveedor.service");
var proveedor_1 = require("../models/proveedor");
var ProveedoresEditor = /** @class */ (function (_super) {
    __extends(ProveedoresEditor, _super);
    //
    function ProveedoresEditor(router, route, formBuilder, changeDetector, context, location, proveedorService) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.router = router;
        _this.route = route;
        _this.formBuilder = formBuilder;
        _this.changeDetector = changeDetector;
        _this.context = context;
        _this.location = location;
        _this.proveedorService = proveedorService;
        _this.proveedor = new proveedor_1.ProveedorInfo();
        _this.tiposProveedor = [];
        _this.catalogForm = formBuilder.group({
            'codigo': ['', forms_1.Validators.required],
            'nombre': ['', forms_1.Validators.required],
            //Generales
            'tipo': [0],
            'telefono': [''],
            'celular': [''],
            'correo': ['', controls_1.AztecaValidators.email],
            'paginaWeb': [''],
            'idCuenta': [0],
            //
            'domicilio': [''],
            //Pagos
            'limiteCredito': [''],
            'diasCredito': [''],
            'idBanco': [0],
            'cuentaBancaria': [''],
            'leyenda': [''],
            //Datos Fiscales
            'rfc': [''],
            'razonSocial': [''],
            'domicilioFiscal': [''],
        });
        return _this;
    }
    ProveedoresEditor_1 = ProveedoresEditor;
    ///////////////////////// METODOS ///////////////////////////////////////
    ///////////////////////// HANDLERS ///////////////////////////////////////
    ProveedoresEditor.prototype.onConfigureCatalog = function (options) {
        this.autogeneratedCode = options.codigoAutogenerado;
        this.applyPolicies();
    };
    ProveedoresEditor.prototype.onCreatingItem = function () {
    };
    ProveedoresEditor.prototype.onViewingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.proveedorService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.proveedor = info;
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ProveedoresEditor.prototype.onCloningItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.proveedorService.clone(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.proveedor = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ProveedoresEditor.prototype.onLoadingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.proveedorService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.proveedor = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ProveedoresEditor.prototype.onSavingItem = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.proveedorService.update(this.proveedor)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.reset();
            //Si es un elemento nuevo y no se cerrará el editor, navegar a nueva ruta
            if (!args.closeEditor && _this.proveedor.identity == 0) {
                _this.router.navigate(['../', info.identity], { relativeTo: _this.route });
            }
            else {
                if (args.closeEditor)
                    _this.router.navigate(['../'], { relativeTo: _this.route });
                else
                    _this.showAlert('La información ha sido actualizada con éxito', 'success');
            }
            _this.proveedor = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ProveedoresEditor = ProveedoresEditor_1 = __decorate([
        core_1.Component({
            selector: 'compras-proveedor-editor',
            template: "\n      <form [formGroup]=\"catalogForm\">\n\n          <azteca-catalog-editor #catalogEditor \n                                 [title]=\"'Proveedor'\"\n                                 [info]=\"proveedor\"\n                                 [valid]=\"valid\"\n                                 (configureCatalog)=\"onConfigureCatalog($event)\"\n                                 (creatingItem)=\"onCreatingItem()\"\n                                 (viewingItem)=\"onViewingItem($event)\"\n                                 (cloningItem)=\"onCloningItem($event)\"\n                                 (savingItem)=\"onSavingItem($event)\"\n                                 (loadingItem)=\"onLoadingItem($event)\">\n\n\n              <!------------------- Menu de acciones adicionales --------------------->\n\n              <azteca-menu-item [name]=\"'CONTACTOS'\" [icon]=\"'fa fa-users'\" [text]=\"'Contactos'\" [smallText]=\"'editar contactos'\" [enabled]=\"true\"></azteca-menu-item>\n              <azteca-menu-item [name]=\"'ARTICULOS'\" [icon]=\"'fa fa-cubes'\" [text]=\"'Art\u00EDculos'\" [smallText]=\"'asignar art\u00EDculos'\" [enabled]=\"true\"></azteca-menu-item>\n              <azteca-menu-item [name]=\"'SERVICIOS'\" [icon]=\"'fa fa-wrench'\" [text]=\"'Servicios'\" [smallText]=\"'asignar servicios'\" [enabled]=\"true\"></azteca-menu-item>\n\n              <!------------------- Controles del editor ----------------------------->\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-lg-10\">\n                      <azteca-form-field [label]=\"'C\u00F3digo:'\">\n                          <catalog-code formControlName=\"codigo\" [(ngModel)]=\"proveedor.code\" [automatic]=\"autogeneratedCode\"></catalog-code>\n                      </azteca-form-field>\n\n                      <azteca-form-field [label]=\"'Nombre:'\">\n                          <az-textbox formControlName=\"nombre\" [(ngModel)]=\"proveedor.nombre\"></az-textbox>\n                      </azteca-form-field>\n\n                  </div>\n              </div>\n\n        \n              <div class=\"row\">\n                  <div class=\"col-12 col-lg-10\">\n                      <tabset>\n\n                          <!----------------- DATOS GENERALES ------------------------------------------->\n                          <tab heading=\"Generales\">\n\t\t\t\t\t\t\n                              <div class=\"row\">\n                                  <div class=\"col-12\">\n\n                                      <azteca-form-field [label]=\"'Tipo:'\">\n                                          <az-combobox formControlName=\"tipo\" \n                                                       [(ngModel)]=\"proveedor.tipo\"\n                                                       [items]=\"tiposProveedor\"\n                                                       [valueMember]=\"'id'\"\n                                                       [displayMember]=\"'nombre'\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n\n                                  </div>\n                              </div>\n\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-lg-6\">\n\n                                      <azteca-form-field [label]=\"'Tel\u00E9fono:'\">\n                                          <az-textbox formControlName=\"telefono\" [(ngModel)]=\"proveedor.telefono\"></az-textbox>\n                                      </azteca-form-field>\n\n                                  </div>\n                                  <div class=\"col-12 col-lg-6\">\n\n                                      <azteca-form-field [label]=\"'Celular:'\">\n                                          <az-textbox formControlName=\"celular\" [(ngModel)]=\"celular\"></az-textbox>\n                                      </azteca-form-field>\n\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12\">\n\n                                      <azteca-form-field [label]=\"'Correo:'\">\n                                          <az-textbox formControlName=\"correo\" [(ngModel)]=\"proveedor.correo\" [enabled]=\"proveedor.usuario.identity == 0\"></az-textbox>\n                                      </azteca-form-field>                                \n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12\">\n\n                                      <azteca-form-field [label]=\"'P\u00E1gina web:'\">\n                                          <az-textbox formControlName=\"paginaWeb\" [(ngModel)]=\"proveedor.pagingaWeb\"></az-textbox>\n                                      </azteca-form-field>\n\n                                  </div>\n                              </div>\n\t\t\t\t\t\t\n\n                              <div class=\"row\">\n                                  <div class=\"col-12\">\n\n                                      <azteca-form-field [label]=\"'Cuenta:'\">\n                                          <accounting-cuenta-selector formControlName=\"idCuenta\" [(ngModel)]=\"proveedor.idCuenta\"></accounting-cuenta-selector>\n                                      </azteca-form-field>\n\n                                  </div>\n                              </div>\n\n                          </tab>\n\n                          <!----------------- DOMICILIO -------------------------------------------->\n                          <tab heading=\"Domicilio\">\n\n                              <general-domicilio-editor #domicilioEditor\n                                                        formControlName=\"domicilio\"\n                                                        [(ngModel)]=\"proveedor.domicilio\"\n                                                        [poblacionRequired]=\"false\"\n                                                        [cruceUnoVisible]=\"false\"\n                                                        [cruceDosVisible]=\"false\">\n\n                              </general-domicilio-editor>\n\n                          </tab>\n\n\n                          <!----------------- CONDICIONES DE PAGO -------------------------------------------->\n                          <tab heading=\"Condiciones de pago\">\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-lg-6\">\n\n                                      <azteca-form-field [label]=\"'L\u00EDmite de cr\u00E9dito:'\">\n                                          <az-input-number formControlName=\"limiteCredito\" [(ngModel)]=\"proveedor.beneficiario.limiteCredito\"></az-input-number>\n                                      </azteca-form-field>\n\n                                  </div>\n                                  <div class=\"col-12 col-lg-6\">\n\n                                      <azteca-form-field [label]=\"'D\u00EDas de cr\u00E9dito:'\">\n                                          <az-input-number formControlName=\"diasCredito\" [(ngModel)]=\"proveedor.beneficiario.diasCredito\"></az-input-number>\n                                      </azteca-form-field>\n\n                                  </div>\n\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-lg-6\">\n                                      <!--\n                                      <azteca-form-field [label]=\"'Banco:'\">\n                                    \n                                      </azteca-form-field>\n                                          -->\n                                  </div>\n                                  <div class=\"col-12 col-lg-6\">\n\n                                      <azteca-form-field [label]=\"'Cuenta:'\">\n                                          <az-textbox formControlName=\"cuentaBancaria\" [(ngModel)]=\"proveedor.beneficiario.clabe\"></az-textbox>\n                                      </azteca-form-field>\n\n                                  </div>\n                              </div>\n\n\n                              <div class=\"row\">\n                                  <div class=\"col-12\">\n                                      <az-checkbox formControlName=\"leyenda\" [(ngModel)]=\"proveedor.beneficiario.leyendaCheque\" label=\"Incluir leyenda 'Para abono a cuenta del beneficiario'\"></az-checkbox>\n                                  </div>\n                              </div>\n\n                          </tab>\n\n                          <!----------------- DATOS FISCALES ------------------------------------------------>\n                          <tab heading=\"Datos fiscales\">\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-lg-5\">\n                                      <azteca-form-field [label]=\"'RFC:'\">\n                                          <az-textbox formControlName=\"rfc\" [(ngModel)]=\"proveedor.contribuyente.rfc\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-lg-10\">\n                                      <azteca-form-field [label]=\"'Raz\u00F3n Social:'\">\n                                          <az-textbox formControlName=\"razonSocial\" [(ngModel)]=\"proveedor.contribuyente.razonSocial\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-lg-10\">\n                                      <general-domicilio-editor formControlName=\"domicilioFiscal\"\n                                                                [(ngModel)]=\"proveedor.contribuyente.domicilio\"\n                                                                [cruceUnoVisible]=\"false\"\n                                                                [cruceDosVisible]=\"false\">\n\n                                      </general-domicilio-editor>\n\n                                  </div>\n                              </div>\n\n                          </tab>\n\n                      </tabset>\n                  </div>\n              </div>\n            \n\n          </azteca-catalog-editor>\n      </form>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return ProveedoresEditor_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: proveedor_service_1.ProveedorService
                }
            ]
        }),
        __metadata("design:paramtypes", [router_1.Router, router_1.ActivatedRoute, forms_1.FormBuilder, core_1.ChangeDetectorRef,
            core_2.Context, common_1.Location, proveedor_service_1.ProveedorService])
    ], ProveedoresEditor);
    return ProveedoresEditor;
    var ProveedoresEditor_1;
}(editors_1.CatalogEditor));
exports.ProveedoresEditor = ProveedoresEditor;
