"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var rxjs_1 = require("rxjs");
//
var core_2 = require("framework3/core");
var index_1 = require("framework3/search/index"); //'../../search/index';
//
var categoria_presupuestal_1 = require("../models/categoria-presupuestal");
var categoria_presupuestal_service_1 = require("../services/categoria-presupuestal.service");
var CategoriaPresupuestalSelectorComponent = /** @class */ (function (_super) {
    __extends(CategoriaPresupuestalSelectorComponent, _super);
    function CategoriaPresupuestalSelectorComponent(context, categoriaService) {
        var _this = _super.call(this, context) || this;
        _this.context = context;
        _this.categoriaService = categoriaService;
        _this.selectedItem = new categoria_presupuestal_1.CategoriaPresupuestalInfo();
        _this.categoriaUpdated = new core_1.EventEmitter();
        _this.keywordSearchSource = rxjs_1.Observable.create(function (observer) {
            //observer.next(this.keyword);
        })
            .mergeMap(function (keyword) { return _this.findCategoria(keyword); });
        return _this;
    }
    CategoriaPresupuestalSelectorComponent_1 = CategoriaPresupuestalSelectorComponent;
    CategoriaPresupuestalSelectorComponent.prototype.loadItem = function (itemID) {
        var _this = this;
        if (itemID > 0) {
            this.categoriaService.getDetailByID(itemID)
                .then(function (info) {
                _this.selectedItem = info;
                _this.displayValue = info.code; //+ ", " + info.municipio.estado.nombre;
                _this.categoriaUpdated.emit(info);
            })
                .catch(function (error) { return _this.handleError(error); });
        }
        else {
            this.selectedItem = null;
            this.displayValue = "";
            this.categoriaUpdated.emit(null);
        }
    };
    CategoriaPresupuestalSelectorComponent.prototype.doSearch = function (request) {
        var _this = this;
        this.context.app.showSpinner();
        var existDepartamento = false;
        var existPeriodo = false;
        var existPresupuesto = false;
        request.conditions.forEach(function (r) {
            if (r.field == "IdDepartamento") {
                existDepartamento = true;
                r.value = _this.idDepartamento;
            }
            else if (r.field == "IdPeriodo" && r.operator == "<=") {
                existPeriodo = true;
                r.value = _this.idPeriodo;
            }
            else if (r.field == "IdPresupuesto" && r.operator == "<=") {
                existPeriodo = true;
                r.value = _this.idPresupuesto;
            }
        });
        if (!existDepartamento) {
            var conDepartamento = { field: "IdDepartamento", operator: "=", valueType: "int", value: this.idDepartamento };
            request.conditions.push(conDepartamento);
        }
        if (!existPeriodo) {
            var conDepartamento = { field: "IdPeriodo", operator: "=", valueType: "int", value: this.idPeriodo };
            request.conditions.push(conDepartamento);
        }
        if (!existPresupuesto) {
            var conDepartamento = { field: "IdPresupuesto", operator: "=", valueType: "int", value: this.idPresupuesto };
            request.conditions.push(conDepartamento);
        }
        this.categoriaService.searchByPresupuesto(this.context.app.defaultSite.identity, request)
            .then(function (response) {
            _this.context.app.hideSpinner();
            //
            _this.categorias = response.rows;
            _this.totalRows = response.totalRows;
            _this.pageIndex = request.pageIndex;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CategoriaPresupuestalSelectorComponent.prototype.findCategoria = function (keyword) {
        return this.categoriaService.searchKeyword(this.context.app.defaultSite.identity, keyword);
    };
    CategoriaPresupuestalSelectorComponent.prototype.onKeywordSearch = function (keyword) {
        this.markUnselected();
        //this.keyword = keyword;
    };
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], CategoriaPresupuestalSelectorComponent.prototype, "categoriaUpdated", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], CategoriaPresupuestalSelectorComponent.prototype, "idDepartamento", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], CategoriaPresupuestalSelectorComponent.prototype, "idPeriodo", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], CategoriaPresupuestalSelectorComponent.prototype, "idPresupuesto", void 0);
    CategoriaPresupuestalSelectorComponent = CategoriaPresupuestalSelectorComponent_1 = __decorate([
        core_1.Component({
            selector: 'purchasing-categoria-presupuestal-selector',
            template: "\n      <azteca-catalog-selector [catalogList]=\"categorias\"\n                               [dialogTitle]=\"'Categor&iacute;a presupuestal'\"\n                               [displayValue]=\"displayValue\"\n                               [serverSide]=\"true\"\n                               [selectedItem]=\"selectedItem\"\n                               [pageIndex]=\"pageIndex\"\n                               [pageSize]=\"pageSize\"\n                               [totalRows]=\"totalRows\"\n                               [visible]=\"visible\"\n                               [enabled]=\"enabled\"\n                               [dataSource]=\"keywordSearchSource\"\n                               [showListButton]=\"showListButton\"\n                               (selectedItemChanged)=\"itemChangedHandler($event)\"\n                               (keywordSearch)=\"onKeywordSearch($event)\"\n                               (searchRequested)=\"doSearch($event)\">\n\n          <azteca-grid-column [header]=\"'Codigo'\" [binding]=\"'codigo'\" [width]=\"'2*'\"></azteca-grid-column>\n          <azteca-grid-column [header]=\"'Nombre'\" [binding]=\"'nombre'\" [width]=\"'3*'\"></azteca-grid-column>\n    \n\n      </azteca-catalog-selector>\n    ",
            providers: [{
                    provide: core_2.BaseComponent,
                    useExisting: core_1.forwardRef(function () { return CategoriaPresupuestalSelectorComponent_1; })
                },
                {
                    provide: forms_1.NG_VALUE_ACCESSOR,
                    useExisting: core_1.forwardRef(function () { return CategoriaPresupuestalSelectorComponent_1; }),
                    multi: true
                }]
        }),
        __metadata("design:paramtypes", [core_2.Context, categoria_presupuestal_service_1.CategoriaPresupuestalService])
    ], CategoriaPresupuestalSelectorComponent);
    return CategoriaPresupuestalSelectorComponent;
    var CategoriaPresupuestalSelectorComponent_1;
}(index_1.CatalogSelector));
exports.CategoriaPresupuestalSelectorComponent = CategoriaPresupuestalSelectorComponent;
