import { Router, ActivatedRoute } from '@angular/router';
import { FormGroup, FormBuilder } from '@angular/forms';
import { ModalDirective } from 'ngx-bootstrap';
import { Context, ProcessComponent, PolicyInfo } from 'framework3/core';
import { MenuItem, ToolbarButton } from 'framework3/controls';
import { FilterGroup, DocumentListComponent } from 'framework3/search';
import { ComprobanteFiscalService } from '../services/comprobante-fiscal.service';
import { ComprobanteFiscalInfo, ComprobanteFiscalItem } from '../models/comprobante-fiscal';
export declare class AlmacenDigitalComponent extends ProcessComponent {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    private formBuilder;
    private comprobanteService;
    form: FormGroup;
    menuItems: MenuItem[];
    fechaInicial: Date;
    fechaFinal: Date;
    pageSize: number;
    maxRows: number;
    totalRows: number;
    comprobantes: ComprobanteFiscalItem[];
    selectedGroup: FilterGroup;
    filterGroups: FilterGroup[];
    currentComprobante: ComprobanteFiscalInfo;
    viewDialog: ModalDirective;
    documentList: DocumentListComponent;
    constructor(context: Context, router: Router, route: ActivatedRoute, formBuilder: FormBuilder, comprobanteService: ComprobanteFiscalService);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    refreshList(): void;
    createMenu(): void;
    viewComprobante(): void;
    exportXml(): void;
    onMainToolbar(button: ToolbarButton): void;
    optionClick(option: MenuItem): void;
    onValidateMenu(): void;
    currentItemChangedHandler(): void;
    handleError(error: any): void;
    applyPolicy(policy: PolicyInfo): void;
}
