import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { Context, DocumentItem, DocumentTypeService, DocumentTypeInfo } from 'framework3/core';
import { DocumentEditor, EditableListComponent, EditorEventArgs, WorkflowEventArgs } from 'framework3/editors';
import { PeriodoInfo } from '../models/periodo';
import { PeriodoDetail } from '../models/periodo-detail';
import { PeriodoService } from '../services/periodo.service';
import { PeriodoDetailEditor } from './parts/periodos-detail.editor';
export declare class PeriodosEditor extends DocumentEditor {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    private location;
    private formBuilder;
    protected documentTypeService: DocumentTypeService;
    private periodoService;
    periodo: PeriodoInfo;
    detailsList: EditableListComponent;
    detailsEditor: PeriodoDetailEditor;
    constructor(context: Context, router: Router, route: ActivatedRoute, location: Location, formBuilder: FormBuilder, documentTypeService: DocumentTypeService, periodoService: PeriodoService);
    onConfigureDocument(docType: DocumentTypeInfo): void;
    onCreatingDocument(): void;
    onViewingDocument(id: string): void;
    onCloningDocument(id: string): void;
    onLoadingDocument(id: string): void;
    onSavingDocument(args: EditorEventArgs): void;
    onApplyingNextStep(args: WorkflowEventArgs): void;
    onApplyingPreviousStep(document: DocumentItem): void;
    onTabSelected(args: any): void;
    onAddingDetail(): void;
    onEditingDetail(detail: PeriodoDetail): void;
    onDeletingDetail(detail: PeriodoDetail): void;
    onListItemsUpdated(updatedDetails: PeriodoDetail[]): void;
    onSavingDetail(detail: PeriodoDetail): void;
}
