import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { Context, DocumentItem, DocumentTypeService, DocumentTypeInfo } from 'framework3/core';
import { DocumentEditor, EditableListComponent, EditorEventArgs, WorkflowEventArgs } from 'framework3/editors';
import { PresupuestoInfo } from '../models/presupuesto';
import { PresupuestoDetail } from '../models/presupuesto-detail';
import { PresupuestoService } from '../services/presupuesto.service';
import { PresupuestoDetailEditor } from './parts/presupuestos-detail.editor';
export declare class PresupuestosEditor extends DocumentEditor {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    private location;
    private formBuilder;
    protected documentTypeService: DocumentTypeService;
    private presupuestoService;
    presupuesto: PresupuestoInfo;
    detailsList: EditableListComponent;
    detailsEditor: PresupuestoDetailEditor;
    constructor(context: Context, router: Router, route: ActivatedRoute, location: Location, formBuilder: FormBuilder, documentTypeService: DocumentTypeService, presupuestoService: PresupuestoService);
    onConfigureDocument(docType: DocumentTypeInfo): void;
    onCreatingDocument(): void;
    onViewingDocument(id: string): void;
    onCloningDocument(id: string): void;
    onLoadingDocument(id: string): void;
    onSavingDocument(args: EditorEventArgs): void;
    onApplyingNextStep(args: WorkflowEventArgs): void;
    onApplyingPreviousStep(document: DocumentItem): void;
    onTabSelected(args: any): void;
    onAddingDetail(): void;
    onEditingDetail(detail: PresupuestoDetail): void;
    onDeletingDetail(detail: PresupuestoDetail): void;
    onListItemsUpdated(updatedDetails: PresupuestoDetail[]): void;
    onSavingDetail(detail: PresupuestoDetail): void;
}
