import { Router, ActivatedRoute } from '@angular/router';
import { ModalDirective } from 'ngx-bootstrap';
import { CollectionView } from 'wijmo/wijmo';
import { FlexGrid } from 'wijmo/wijmo.grid';
import { Context, ProcessComponent, PolicyInfo } from 'framework3/core';
import { FileInfo } from 'framework3/general';
import { MenuItem, ToolbarButton, AlertsBarComponent } from 'framework3/controls';
import { CFDValiationResult } from '../models/cfd-validation-result';
import { ComprobanteFiscalService } from '../services/comprobante-fiscal.service';
export declare class ValidacionCFDComponent extends ProcessComponent {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    private comprobanteService;
    selectedFile: FileInfo;
    comprobantesCollection: CollectionView;
    menuItems: MenuItem[];
    validatedFiles: CFDValiationResult[];
    uploadDialog: ModalDirective;
    alertsBar: AlertsBarComponent;
    constructor(context: Context, router: Router, route: ActivatedRoute, comprobanteService: ComprobanteFiscalService);
    validateFile(): void;
    createMenu(): void;
    save(): void;
    onToolbarClick(button: ToolbarButton): void;
    initialized(sender: FlexGrid, args: any): void;
    onFileChanged(file: FileInfo): void;
    onValidateFile(): void;
    handleError(error: any): void;
    applyPolicy(policy: PolicyInfo): void;
}
