"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
//////////////////////////// Guards //////////////////////////////////
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//////////////////////////// Catalogos ////////////////////////////////
var empresas_manager_1 = require("./catalogs/empresas.manager");
var empresas_editor_1 = require("./catalogs/empresas.editor");
var proveedores_manager_1 = require("./catalogs/proveedores.manager");
var proveedores_editor_1 = require("./catalogs/proveedores.editor");
///////////////////////////// Documentos //////////////////////////////
var almacen_digital_component_1 = require("./documents/almacen-digital.component");
///////////////////////////// Parts //////////////////////////////
var validacion_cfd_component_1 = require("./parts/validacion-cfd.component");
///////////////////////////// Rutas /////////////////////////////////
var routes = [
    {
        path: '',
        canActivateChild: [core_2.AuthGuard],
        children: [
            // CATALOGS
            { path: 'empresas-compras/:proceso', component: empresas_manager_1.EmpresasManager },
            { path: 'empresas-compras/:proceso/:id', component: empresas_editor_1.EmpresasEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'proveedores/:proceso', component: proveedores_manager_1.ProveedoresManager },
            { path: 'proveedores/:proceso/:id', component: proveedores_editor_1.ProveedoresEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            //DOCUMENTS
            { path: 'almacen-digital/:proceso', component: almacen_digital_component_1.AlmacenDigitalComponent },
            //PARTS
            { path: 'almacen-digital/:proceso/upload', component: validacion_cfd_component_1.ValidacionCFDComponent },
        ]
    },
];
var PurchasingRoutingModule = /** @class */ (function () {
    function PurchasingRoutingModule() {
    }
    PurchasingRoutingModule = __decorate([
        core_1.NgModule({
            imports: [
                router_1.RouterModule.forChild(routes)
            ],
            exports: [
                router_1.RouterModule
            ]
        })
    ], PurchasingRoutingModule);
    return PurchasingRoutingModule;
}());
exports.PurchasingRoutingModule = PurchasingRoutingModule;
