"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var http_1 = require("@angular/common/http");
require("rxjs/add/operator/toPromise");
var moment = require("moment");
//Azteca Framework
var core_2 = require("framework3/core");
var comprobante_fiscal_1 = require("../models/comprobante-fiscal");
var ComprobanteFiscalService = /** @class */ (function (_super) {
    __extends(ComprobanteFiscalService, _super);
    function ComprobanteFiscalService(http, context) {
        var _this = _super.call(this, http, context, 'api/compras/comprobantes') || this;
        _this.http = http;
        _this.context = context;
        return _this;
    }
    ComprobanteFiscalService.prototype.create = function () {
        var newDoc = new comprobante_fiscal_1.ComprobanteFiscalInfo();
        return Promise.resolve(newDoc);
    };
    ComprobanteFiscalService.prototype.validate = function (idEmpresa, file) {
        var params = new http_1.HttpParams()
            .set('idEmpresa', idEmpresa.toString());
        return this.apiService.post('validate', params, file)
            .map(function (result) {
            result.forEach(function (row) {
                row.fecha = moment(row.fecha).toDate();
            });
            return result;
        })
            .toPromise();
    };
    ComprobanteFiscalService.prototype.save = function (idProveedor, idEmpresa, idSucursal, xml) {
        var params = new http_1.HttpParams()
            .set('idProveedor', idProveedor.toString())
            .set('idEmpresa', idEmpresa.toString())
            .set('idSucursal', idSucursal.toString());
        //
        return this.apiService.post('save', params, JSON.stringify(xml))
            .toPromise();
    };
    ComprobanteFiscalService.prototype.loadListByProveedor = function (idEmpresa, idProveedor, fechaInicial, fechaFinal) {
        var params = new http_1.HttpParams()
            .set('idProveedor', idProveedor.toString())
            .set('idEmpresa', idEmpresa.toString())
            .set('fechaInicial', moment(fechaInicial).format())
            .set('fechaFinal', moment(fechaFinal).format());
        //
        return this.apiService.get('list-proveedor', params)
            .map(function (response) {
            response.forEach(function (c) {
                c.fechaComprobante = moment(c.fechaComprobante).toDate();
                c.fechaCreacion = moment(c.fechaCreacion).toDate();
            });
            return response;
        })
            .toPromise();
    };
    ComprobanteFiscalService.prototype.mapSearchResult = function (row) {
        var comprobante = row;
        comprobante.fechaComprobante = moment(comprobante.fechaComprobante).toDate();
    };
    ComprobanteFiscalService = __decorate([
        core_1.Injectable(),
        __metadata("design:paramtypes", [http_1.HttpClient, core_2.Context])
    ], ComprobanteFiscalService);
    return ComprobanteFiscalService;
}(core_2.DocumentService));
exports.ComprobanteFiscalService = ComprobanteFiscalService;
