"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//Features
var compania_service_1 = require("../services/compania.service");
var compania_1 = require("../models/compania");
var CompaniasEditor = /** @class */ (function (_super) {
    __extends(CompaniasEditor, _super);
    //
    function CompaniasEditor(router, route, formBuilder, changeDetector, context, location, companiaService) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.router = router;
        _this.route = route;
        _this.formBuilder = formBuilder;
        _this.changeDetector = changeDetector;
        _this.context = context;
        _this.location = location;
        _this.companiaService = companiaService;
        _this.compania = new compania_1.CompaniaInfo();
        _this.catalogForm = formBuilder.group({
            'codigo': ['', forms_1.Validators.required],
            'nombre': ['', forms_1.Validators.required],
            'empresaAdam': ['', forms_1.Validators.required],
            'abreviatura': [''],
            'rfc': [''],
            'giro': [''],
            'registroPatronal': [''],
            'calle': [''],
            'numExt': [''],
            'numInt': [''],
            'cruceUno': [''],
            'cruceDos': [''],
            'colonia': [''],
            'cp': ['']
        });
        return _this;
    }
    CompaniasEditor_1 = CompaniasEditor;
    ///////////////////////// METODOS ///////////////////////////////////////
    ///////////////////////// HANDLERS ///////////////////////////////////////
    CompaniasEditor.prototype.onConfigureCatalog = function (options) {
        this.autogeneratedCode = options.codigoAutogenerado;
        this.applyPolicies();
    };
    CompaniasEditor.prototype.onCreatingItem = function () {
    };
    CompaniasEditor.prototype.onViewingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.companiaService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.compania = info;
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CompaniasEditor.prototype.onCloningItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.companiaService.clone(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.compania = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CompaniasEditor.prototype.onLoadingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.companiaService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.compania = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CompaniasEditor.prototype.onSavingItem = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.companiaService.update(this.compania)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.reset();
            //Si es un elemento nuevo y no se cerrará el editor, navegar a nueva ruta
            if (!args.closeEditor && _this.compania.identity == 0) {
                _this.router.navigate(['../', info.identity], { relativeTo: _this.route });
            }
            else {
                if (args.closeEditor)
                    _this.router.navigate(['../'], { relativeTo: _this.route });
                else
                    _this.showAlert('La información ha sido actualizada con éxito', 'success');
            }
            _this.compania = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CompaniasEditor = CompaniasEditor_1 = __decorate([
        core_1.Component({
            selector: 'azteca.rh-compania-editor',
            template: "\n      <form [formGroup]=\"catalogForm\">\n\n          <azteca-catalog-editor #catalogEditor \n                                 [title]=\"'Compania'\"\n                                 [info]=\"compania\"\n                                 [valid]=\"valid\"\n                                 (configureCatalog)=\"onConfigureCatalog($event)\"\n                                 (creatingItem)=\"onCreatingItem()\"\n                                 (viewingItem)=\"onViewingItem($event)\"\n                                 (cloningItem)=\"onCloningItem($event)\"\n                                 (savingItem)=\"onSavingItem($event)\"\n                                 (loadingItem)=\"onLoadingItem($event)\">\n\n\n              <!------------------- Menu de acciones adicionales --------------------->\n\n              <!------------------- Controles del editor ----------------------------->\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <azteca-form-field [label]=\"'C\u00F3digo:'\">\n                          <catalog-code formControlName=\"codigo\" [(ngModel)]=\"compania.code\" [automatic]=\"autogeneratedCode\"></catalog-code>\n                      </azteca-form-field>\n\n                      <azteca-form-field [label]=\"'Nombre:'\">\n                          <az-textbox formControlName=\"nombre\" [(ngModel)]=\"compania.nombre\"></az-textbox>\n                      </azteca-form-field>\n\n                  </div>\n              </div>\n\n        \n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <tabset>\n                          <tab heading=\"General\">\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-10\">\n                                      <azteca-form-field [label]=\"'Empresa adam:'\">\n                                          <rh-empresa-adam-selector formControlName=\"empresaAdam\" [(ngModel)]=\"compania.idEmpresaAdam\"></rh-empresa-adam-selector>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'abreviatura:'\">\n                                          <az-textbox formControlName=\"abreviatura\" [ngModel]=\"compania.abreviatura\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'RFC:'\">\n                                          <az-textbox formControlName=\"rfc\" [ngModel]=\"compania.rFC\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-10\">\n                                      <azteca-form-field [label]=\"'Giro:'\">\n                                          <az-textbox formControlName=\"giro\" [ngModel]=\"compania.giro\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-10\">\n                                      <azteca-form-field [label]=\"'Registro Patronal:'\">\n                                          <az-textbox formControlName=\"rfc\" [ngModel]=\"compania.registroPatronal\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                          </tab>\n\n                          <tab heading=\"Domicilio\">\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-10\">\n                                      <azteca-form-field [label]=\"'Calle:'\">\n                                          <az-textbox formControlName=\"rfc\" [ngModel]=\"compania.calle\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'Num. Exterior:'\">\n                                          <az-textbox formControlName=\"numExt\" [ngModel]=\"compania.numExt\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'Num. Interior:'\">\n                                          <az-textbox formControlName=\"numInt\" [ngModel]=\"compania.numInt\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-10\">\n                                      <azteca-form-field [label]=\"'Primer cruce:'\">\n                                          <az-textbox formControlName=\"cruceUno\" [ngModel]=\"compania.cruce1\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-10\">\n                                      <azteca-form-field [label]=\"'Segundo cruce:'\">\n                                          <az-textbox formControlName=\"cruceDos\" [ngModel]=\"compania.cruce2\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-10\">\n                                      <azteca-form-field [label]=\"'Colonia:'\">\n                                          <az-textbox formControlName=\"colonia\" [ngModel]=\"compania.colonia\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'CP:'\">\n                                          <az-textbox formControlName=\"cp\" [ngModel]=\"compania.cP\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                          </tab>\n                      </tabset>\n                  </div>\n              </div>\n            \n\n          </azteca-catalog-editor>\n      </form>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return CompaniasEditor_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: compania_service_1.CompaniaService
                }
            ]
        }),
        __metadata("design:paramtypes", [router_1.Router, router_1.ActivatedRoute, forms_1.FormBuilder, core_1.ChangeDetectorRef,
            core_2.Context, common_1.Location, compania_service_1.CompaniaService])
    ], CompaniasEditor);
    return CompaniasEditor;
    var CompaniasEditor_1;
}(editors_1.CatalogEditor));
exports.CompaniasEditor = CompaniasEditor;
