"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Azteca Kernel
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
var editors_1 = require("framework3/editors");
//Features
var concepto_adam_service_1 = require("../services/concepto-adam.service");
var concepto_adam_1 = require("../models/concepto-adam");
var ConceptosAdamEditor = /** @class */ (function (_super) {
    __extends(ConceptosAdamEditor, _super);
    function ConceptosAdamEditor(router, route, formBuilder, changeDetector, context, location, conceptoAdamService) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.router = router;
        _this.route = route;
        _this.formBuilder = formBuilder;
        _this.changeDetector = changeDetector;
        _this.context = context;
        _this.location = location;
        _this.conceptoAdamService = conceptoAdamService;
        _this.conceptoAdam = new concepto_adam_1.ConceptoAdamInfo();
        //
        _this.tiposTransaccion = [{ id: 1, nombre: 'Percepción' }, { id: 2, nombre: 'Deducción' }, { id: 3, nombre: 'Otros Pagos' }, { id: 4, nombre: 'Incapacidad' }];
        _this.catalogForm = formBuilder.group({
            'codigo': ['', forms_1.Validators.required],
            'concepto': ['', forms_1.Validators.required],
            'descripcion': ['', forms_1.Validators.required],
            'abreviatura': [''],
            'tipoTransaccion': ['', controls_1.AztecaValidators.selected],
            'tipoPerDed': [''],
            'compania': ['']
        });
        return _this;
    }
    ConceptosAdamEditor_1 = ConceptosAdamEditor;
    ///////////////////////// METODOS ///////////////////////////////////////
    ///////////////////////// HANDLERS ///////////////////////////////////////
    ConceptosAdamEditor.prototype.onConfigureCatalog = function (options) {
        this.autogeneratedCode = options.codigoAutogenerado;
        this.applyPolicies();
    };
    ConceptosAdamEditor.prototype.onCreatingItem = function () {
    };
    ConceptosAdamEditor.prototype.onViewingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.conceptoAdamService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.conceptoAdam = info;
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ConceptosAdamEditor.prototype.onCloningItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.conceptoAdamService.clone(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.conceptoAdam = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ConceptosAdamEditor.prototype.onLoadingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.conceptoAdamService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.conceptoAdam = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ConceptosAdamEditor.prototype.onSavingItem = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.conceptoAdamService.update(this.conceptoAdam)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.reset();
            //Si es un elemento nuevo y no se cerrará el editor, navegar a nueva ruta
            if (!args.closeEditor && _this.conceptoAdam.identity == 0) {
                _this.router.navigate(['../', info.identity], { relativeTo: _this.route });
            }
            else {
                if (args.closeEditor)
                    _this.router.navigate(['../'], { relativeTo: _this.route });
                else
                    _this.showAlert('La información ha sido actualizada con éxito', 'success');
            }
            _this.conceptoAdam = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ConceptosAdamEditor = ConceptosAdamEditor_1 = __decorate([
        core_1.Component({
            selector: 'rh-concepto-adam-editor',
            template: "\n      <form [formGroup]=\"catalogForm\">\n\n          <azteca-catalog-editor #catalogEditor \n                                 [title]=\"'ConceptoAdam'\"\n                                 [info]=\"conceptoAdam\"\n                                 [valid]=\"valid\"\n                                 (configureCatalog)=\"onConfigureCatalog($event)\"\n                                 (creatingItem)=\"onCreatingItem()\"\n                                 (viewingItem)=\"onViewingItem($event)\"\n                                 (cloningItem)=\"onCloningItem($event)\"\n                                 (savingItem)=\"onSavingItem($event)\"\n                                 (loadingItem)=\"onLoadingItem($event)\">\n\n\n              <!------------------- Menu de acciones adicionales --------------------->\n\n              <!------------------- Controles del editor ----------------------------->\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <azteca-form-field [label]=\"'C\u00F3digo:'\">\n                          <catalog-code formControlName=\"codigo\" [(ngModel)]=\"conceptoAdam.code\" [automatic]=\"autogeneratedCode\"></catalog-code>\n                      </azteca-form-field>\n\n                      <azteca-form-field [label]=\"'Concepto:'\">\n                          <az-textbox formControlName=\"concepto\" [(ngModel)]=\"conceptoAdam.concepto\"></az-textbox>\n                      </azteca-form-field>\n\n                  </div>\n              </div>\n\n        \n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <tabset>\n                          <tab heading=\"General\">\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-10\">\n                                      <azteca-form-field [label]=\"'Descripci&oacute;n:'\">\n                                          <az-textbox formControlName=\"descripcion\" [(ngModel)]=\"conceptoAdam.descripcion\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-10\">\n                                      <azteca-form-field [label]=\"'Abreviatura:'\">\n                                          <az-textbox formControlName=\"abreviatura\" [(ngModel)]=\"conceptoAdam.abreviatura\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-10\">\n                                      <azteca-form-field [label]=\"'Tipo transacci&oacute;n:'\">\n                                          <az-combobox formControlName=\"tipoTransaccion\" [(ngModel)]=\"conceptoAdam.tipoTransaccion\" [items]=\"tiposTransaccion\" [valueMember]=\"'id'\" [displayMember]=\"'nombre'\"></az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-10\">\n                                      <azteca-form-field [label]=\"'Tipo transacci&oacute;n:'\">\n                                          <rh-tipo-per-ded-selector formControlName=\"tipoPerDed\" \n                                                                    [(ngModel)]=\"conceptoAdam.idTipoPerDed\"\n                                                                    [enabled]=\"true\"></rh-tipo-per-ded-selector>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-10\">\n                                      <azteca-form-field [label]=\"'Compa&ntilde;&iacute;a:'\">\n                                          <rh-compania-selector formControlName=\"compania\" \n                                                                [(ngModel)]=\"conceptoAdam.idCompania\"\n                                                                [enabled]=\"true\"></rh-compania-selector>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>                        \n\n                          </tab>\n\n                      </tabset>\n                  </div>\n              </div>\n            \n\n          </azteca-catalog-editor>\n      </form>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return ConceptosAdamEditor_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: concepto_adam_service_1.ConceptoAdamService
                }
            ]
        }),
        __metadata("design:paramtypes", [router_1.Router, router_1.ActivatedRoute, forms_1.FormBuilder, core_1.ChangeDetectorRef,
            core_2.Context, common_1.Location, concepto_adam_service_1.ConceptoAdamService])
    ], ConceptosAdamEditor);
    return ConceptosAdamEditor;
    var ConceptosAdamEditor_1;
}(editors_1.CatalogEditor));
exports.ConceptosAdamEditor = ConceptosAdamEditor;
