"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//Features
var turno_service_1 = require("../services/turno.service");
var turno_1 = require("../models/turno");
var TurnosEditor = /** @class */ (function (_super) {
    __extends(TurnosEditor, _super);
    //
    function TurnosEditor(router, route, formBuilder, changeDetector, context, location, empleadoService) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.router = router;
        _this.route = route;
        _this.formBuilder = formBuilder;
        _this.changeDetector = changeDetector;
        _this.context = context;
        _this.location = location;
        _this.empleadoService = empleadoService;
        _this.turno = new turno_1.TurnoInfo();
        _this.catalogForm = formBuilder.group({
            'codigo': ['', forms_1.Validators.required],
            'nombre': ['', forms_1.Validators.required],
            'tipo': [''],
            'ciclo': [''],
            'retardos': [''],
            'periodoDias': [''],
            'accion': [''],
            'cuenta': ['']
        });
        return _this;
    }
    TurnosEditor_1 = TurnosEditor;
    ///////////////////////// METODOS ///////////////////////////////////////
    ///////////////////////// HANDLERS ///////////////////////////////////////
    TurnosEditor.prototype.onConfigureCatalog = function (options) {
        this.autogeneratedCode = options.codigoAutogenerado;
    };
    TurnosEditor.prototype.onCreatingItem = function () {
    };
    TurnosEditor.prototype.onViewingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.empleadoService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.turno = info;
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    TurnosEditor.prototype.onCloningItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.empleadoService.clone(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.turno = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    TurnosEditor.prototype.onLoadingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.empleadoService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.turno = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    TurnosEditor.prototype.onSavingItem = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.empleadoService.update(this.turno)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.turno = info;
            _this.reset();
            if (args.closeEditor)
                _this.location.back();
            else
                _this.showAlert('La información ha sido actualizada con éxito', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    TurnosEditor = TurnosEditor_1 = __decorate([
        core_1.Component({
            selector: 'rh-turno-editor',
            template: "\n      <form [formGroup]=\"catalogForm\">\n\n          <azteca-catalog-editor #catalogEditor\n                                 [title]=\"'Turnos'\"\n                                 [info]=\"turno\"\n                                 [valid]=\"valid\"\n                                 (configureCatalog)=\"onConfigureCatalog($event)\"\n                                 (creatingItem)=\"onCreatingItem()\"\n                                 (viewingItem)=\"onViewingItem($event)\"\n                                 (cloningItem)=\"onCloningItem($event)\"\n                                 (savingItem)=\"onSavingItem($event)\"\n                                 (loadingItem)=\"onLoadingItem($event)\">\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <azteca-form-field [label]=\"'C\u00F3digo:'\">\n                          <catalog-code formControlName=\"codigo\" [(ngModel)]=\"turno.code\" [automatic]=\"autogeneratedCode\"></catalog-code>\n                      </azteca-form-field>\n\n                      <azteca-form-field [label]=\"'Nombre:'\">\n                          <catalog-code formControlName=\"nombre\" [(ngModel)]=\"turno.nombre\"></catalog-code>\n                      </azteca-form-field>\n\n                  </div>\n              </div>\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <tabset>\n                          <tab heading=\"General\">\n                        \n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-4\">\n                                      <azteca-form-field [label]=\"'Tipo:'\">\n                                          <az-textbox formControlName=\"tipo\" [(ngModel)]=\"turno.tipo\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-4\">\n                                      <azteca-form-field [label]=\"'Ciclo:'\">\n                                          <az-input-number formControlName=\"ciclo\" [(ngModel)]=\"turno.ciclo\" [format]=\"'n0'\" [min]=\"0\"></az-input-number>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-4\">\n                                      <azteca-form-field [label]=\"'Retardos:'\">\n                                          <az-input-number formControlName=\"retardos\" [(ngModel)]=\"turno.retardos\" [format]=\"'n0'\" [min]=\"0\"></az-input-number>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n                        \n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-4\">\n                                      <azteca-form-field [label]=\"'Periodo d&iacute;as:'\">\n                                          <az-input-number formControlName=\"periodoDias\" [(ngModel)]=\"turno.periodoDias\" [format]=\"'n0'\" [min]=\"0\"></az-input-number>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-4\">\n                                      <azteca-form-field [label]=\"'Acci&oacute;n:'\">\n                                          <az-textbox formControlName=\"accion\" [(ngModel)]=\"turno.accion\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'Cuenta:'\">\n                                          <accounting-cuenta-selector formControlName=\"cuenta\"\n                                                                      [(ngModel)]=\"turno.idCuenta\">\n                                          </accounting-cuenta-selector>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                          </tab>\n                      </tabset>\n                  </div>\n              </div>\n\n          </azteca-catalog-editor>\n      </form>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return TurnosEditor_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: turno_service_1.TurnoService
                }
            ]
        }),
        __metadata("design:paramtypes", [router_1.Router, router_1.ActivatedRoute, forms_1.FormBuilder, core_1.ChangeDetectorRef,
            core_2.Context, common_1.Location, turno_service_1.TurnoService])
    ], TurnosEditor);
    return TurnosEditor;
    var TurnosEditor_1;
}(editors_1.CatalogEditor));
exports.TurnosEditor = TurnosEditor;
