import { EventEmitter, SimpleChange } from '@angular/core';
import { ControlValueAccessor, FormBuilder } from '@angular/forms';
import { HttpClient } from '@angular/common/http';
import { BaseControl } from 'framework3/controls/index';
import { Context } from 'framework3/core';
import { AdamNominaInfo } from '../models/adamnomina';
export declare class AdamNominaComponent extends BaseControl implements ControlValueAccessor {
    private formBuilder;
    private form;
    private empresaAdamSvc;
    private adamSvc;
    readonly valid: boolean;
    adamNomina: AdamNominaInfo;
    idSucursal: number;
    adamNominaUpdated: EventEmitter<AdamNominaInfo>;
    validChange: EventEmitter<boolean>;
    handleError: EventEmitter<any>;
    companiaRequired: boolean;
    companiaVisible: boolean;
    companiaEnabled: boolean;
    claseNominaRequired: boolean;
    claseNominaVisible: boolean;
    claseNominaEnabled: boolean;
    tipoNominaRequired: boolean;
    tipoNominaVisible: boolean;
    tipoNominaEnabled: boolean;
    anioRequired: boolean;
    anioVisible: boolean;
    anioEnabled: boolean;
    periodoRequired: boolean;
    periodoVisible: boolean;
    periodoEnabled: boolean;
    nominaInfo: AdamNominaInfo;
    empresasAdam: Array<any>;
    companiasAdam: Array<any>;
    clasesNomina: Array<any>;
    tiposNomina: Array<any>;
    anios: Array<any>;
    periodos: Array<any>;
    context: Context;
    constructor(http: HttpClient, context: Context, formBuilder: FormBuilder);
    ngOnChanges(changes: SimpleChange): void;
    ngAfterViewInit(): void;
    loadEmpresasAdam(): void;
    loadCompaniasAdam(): void;
    loadClaseNomina(): void;
    loadTiposNomina(): void;
    loadAnios(): void;
    loadPeriodos(): void;
    updateNominaAdam(): void;
    notifiyChange(): void;
    writeValue(value: any): void;
    propagateChange: (_: any) => void;
    registerOnChange(fn: any): void;
    registerOnTouched(): void;
}
