"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var rxjs_1 = require("rxjs");
//
var core_2 = require("framework3/core");
var index_1 = require("framework3/search/index"); //'../../search/index';
//
var compania_1 = require("../models/compania");
var compania_service_1 = require("../services/compania.service");
var CompaniaSelectorComponent = /** @class */ (function (_super) {
    __extends(CompaniaSelectorComponent, _super);
    function CompaniaSelectorComponent(context, companiaService) {
        var _this = _super.call(this, context) || this;
        _this.context = context;
        _this.companiaService = companiaService;
        _this.selectedItem = new compania_1.CompaniaInfo;
        _this.companiaUpdated = new core_1.EventEmitter();
        _this.companiaSelector = false;
        _this.keywordSearchSource = rxjs_1.Observable.create(function (observer) {
            observer.next(_this.innerSelector.displayValue);
        })
            .mergeMap(function (keyword) { return _this.findCompania(keyword); });
        return _this;
    }
    CompaniaSelectorComponent_1 = CompaniaSelectorComponent;
    CompaniaSelectorComponent.prototype.loadItem = function (itemID) {
        var _this = this;
        if (itemID > 0) {
            this.companiaService.getDetailByID(itemID)
                .then(function (info) {
                _this.selectedItem = info;
                _this.displayValue = info.code; //+ ", " + info.municipio.estado.nombre;
                _this.companiaUpdated.emit(info);
            })
                .catch(function (error) { return _this.handleError(error); });
        }
        else {
            this.selectedItem = null;
            this.displayValue = "";
            this.companiaUpdated.emit(null);
        }
    };
    CompaniaSelectorComponent.prototype.doSearch = function (request) {
        var _this = this;
        this.context.app.showSpinner();
        this.companiaService.search(this.context.app.defaultSite.identity, request)
            .then(function (response) {
            _this.context.app.hideSpinner();
            //
            _this.compania = response.rows;
            _this.totalRows = response.totalRows;
            _this.pageIndex = request.pageIndex;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CompaniaSelectorComponent.prototype.findCompania = function (keyword) {
        return this.companiaService.searchKeyword(this.context.app.defaultSite.identity, keyword);
    };
    CompaniaSelectorComponent.prototype.onKeywordSearch = function (keyword) {
        this.markUnselected();
    };
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], CompaniaSelectorComponent.prototype, "companiaUpdated", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], CompaniaSelectorComponent.prototype, "companiaSelector", void 0);
    CompaniaSelectorComponent = CompaniaSelectorComponent_1 = __decorate([
        core_1.Component({
            selector: 'rh-compania-selector',
            template: "\n      <azteca-catalog-selector [catalogList]=\"compania\"\n                               [dialogTitle]=\"'Compa&ntilde;&iacute;s'\"\n                               [displayValue]=\"displayValue\"\n                               [serverSide]=\"true\"\n                               [selectedItem]=\"selectedItem\"\n                               [pageIndex]=\"pageIndex\"\n                               [pageSize]=\"pageSize\"\n                               [totalRows]=\"totalRows\"\n                               [enabled]=\"enabled\"\n                               [visible]=\"visible\"\n                               [dataSource]=\"keywordSearchSource\"\n                               [showListButton]=\"showListButton\"\n                               (selectedItemChanged)=\"itemChangedHandler($event)\"\n                               (keywordSearch)=\"onKeywordSearch($event)\"\n                               (searchRequested)=\"doSearch($event)\">\n\n          <azteca-grid-column [header]=\"'Codigo'\" [binding]=\"'codigo'\" [width]=\"'2*'\"></azteca-grid-column>\n          <azteca-grid-column [header]=\"'Nombre'\" [binding]=\"'nombre'\" [width]=\"'3*'\"></azteca-grid-column>\n    \n\n      </azteca-catalog-selector>\n    ",
            providers: [{
                    provide: core_2.BaseComponent,
                    useExisting: core_1.forwardRef(function () { return CompaniaSelectorComponent_1; })
                },
                {
                    provide: forms_1.NG_VALUE_ACCESSOR,
                    useExisting: core_1.forwardRef(function () { return CompaniaSelectorComponent_1; }),
                    multi: true
                }]
        }),
        __metadata("design:paramtypes", [core_2.Context, compania_service_1.CompaniaService])
    ], CompaniaSelectorComponent);
    return CompaniaSelectorComponent;
    var CompaniaSelectorComponent_1;
}(index_1.CatalogSelector));
exports.CompaniaSelectorComponent = CompaniaSelectorComponent;
