import { EventEmitter } from '@angular/core';
import { Observable } from 'rxjs';
import { Context, CatalogItem } from 'framework3/core';
import { SearchRequest, HierarchySelector, ITreeHost } from 'framework3/search/index';
import { DepartamentoInfo, DepartamentoItem } from '../models/departamento';
import { DepartamentoService } from '../services/departamento.service';
export declare class DepartamentoSelectorComponent extends HierarchySelector implements ITreeHost {
    protected context: Context;
    private departamentoService;
    departamentos: DepartamentoItem[];
    nodes: DepartamentoInfo[];
    selectedItem: DepartamentoInfo;
    idDocumento: number;
    version: number;
    idPadre: number;
    selectedItemChanged: EventEmitter<DepartamentoInfo>;
    constructor(context: Context, departamentoService: DepartamentoService);
    loadItem(itemID: number): void;
    doSearch(request: SearchRequest): void;
    findKeyword(keyword: string): Observable<CatalogItem[]>;
    onKeywordSearch(keyword: string): void;
    onLoadingHierarchy(): void;
    loadChildren(parent: DepartamentoInfo): Promise<DepartamentoInfo[]>;
}
