"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//Features
var polizas_nomina_service_1 = require("../services/polizas-nomina.service");
var adamnomina_1 = require("../models/adamnomina");
var PolizasNomina = /** @class */ (function () {
    function PolizasNomina(formBuilder, router, polizasNominaService, context) {
        this.formBuilder = formBuilder;
        this.router = router;
        this.polizasNominaService = polizasNominaService;
        this.context = context;
        this.adamNomina = new adamnomina_1.AdamNominaInfo();
        this.cuentasCollection = new editors_1.TrackableCollection();
        this.editorForm = formBuilder.group({
            'adamNomina': ['']
        });
    }
    PolizasNomina.prototype.onInterfasClick = function () {
        var _this = this;
        this.polizasNominaService.importarPolizaAdam(this.adamNomina.idEmpresaAdam, this.adamNomina.compania, this.adamNomina.claseNomina, this.adamNomina.tipoNomina, this.adamNomina.anio, this.adamNomina.periodo)
            .catch(function (error) { return _this.handleError(error); });
    };
    PolizasNomina.prototype.onListarCuentasClick = function () {
        var _this = this;
        this.polizasNominaService.loadCuentasFaltantes(this.adamNomina.idEmpresaAdam, this.adamNomina.compania, this.adamNomina.claseNomina, this.adamNomina.tipoNomina, this.adamNomina.anio, this.adamNomina.periodo)
            .then(function (lista) {
            _this.cuentasCollection.sourceCollection = lista;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    PolizasNomina.prototype.handleError = function (error) {
        console.log(error);
    };
    PolizasNomina = __decorate([
        core_1.Component({
            selector: 'polizas-nomina',
            template: "\n      <div class=\"row justify-content-center\">\n          <div class=\"col-12 col-md-10 col-lg-8\">\n              <form [formGroup]=\"editorForm\">\n\n\n\n                  <alerts-bar></alerts-bar>\n\n                  <az-panel [header]=\"'Interfas de polizas de ADAM'\">\n\n                      <rh-adam-nomina #personaEditor\n                                      formControlName=\"adamNomina\"\n                                      [(ngModel)]=\"adamNomina\"\n                                      [idSucursal]=\"this.context.app.defaultSite.identity\"\n                                      (adamNominaUpdated)=\"onNominaCambia\"></rh-adam-nomina>\n\n                  </az-panel>\n\n                  <div class=\"modal-footer\">\n                      <button type=\"button\" class=\"btn btn-primary\" (click)=\"onListarCuentasClick()\"><span class=\"glyphicon glyphicon-list\"></span> Listar cuentas faltantes</button>\n                      <button type=\"button\" class=\"btn btn-primary\" (click)=\"onInterfasClick()\"><span class=\"glyphicon glyphicon-import\"></span>Importar p\u00F3liza</button>\n                  </div> \n\n                  <div class=\"row\">\n                      <div class=\"col-12\">\n                          <wj-flex-grid #gridInsumos style=\"height:550px\"\n                                        [itemsSource]=\"cuentasCollection\">\n\n                              <wj-flex-grid-column [header]=\"'Cuenta'\" [binding]=\"'cuenta'\" [width]=\"'10*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                              <wj-flex-grid-column [header]=\"'Trabajador'\" [binding]=\"'trabajador'\" [width]=\"'20*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                          </wj-flex-grid>\n                      </div>\n                  </div>\n\n\n              </form>\n          </div>\n      </div>\n    "
        }),
        __metadata("design:paramtypes", [forms_1.FormBuilder, router_1.Router, polizas_nomina_service_1.PolizasNominaService, core_2.Context])
    ], PolizasNomina);
    return PolizasNomina;
}());
exports.PolizasNomina = PolizasNomina;
