"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var router_1 = require("@angular/router");
var common_1 = require("@angular/common");
var ngx_bootstrap_1 = require("ngx-bootstrap");
var moment = require("moment");
//Azteca Kernel
var core_2 = require("framework3/core");
var search_1 = require("framework3/search");
var index_1 = require("framework3/controls/index");
var recibo_nomina_adam_1 = require("../models/recibo-nomina-adam");
var recibo_adam_service_1 = require("../services/recibo-adam.service");
var programacion_recibo_adam_service_1 = require("../services/programacion-recibo-adam.service");
var content_viewer_component_1 = require("framework3/controls/components/content-viewer.component");
var ReciboAdamMaintenance = /** @class */ (function (_super) {
    __extends(ReciboAdamMaintenance, _super);
    function ReciboAdamMaintenance(context, router, route, location, formBuilder, reciboAdamService, programacionReciboSvc) {
        var _this = _super.call(this) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.location = location;
        _this.formBuilder = formBuilder;
        _this.reciboAdamService = reciboAdamService;
        _this.programacionReciboSvc = programacionReciboSvc;
        _this.titleDialog = "Recibo de n&oacute;mina";
        _this.currentRecibos = new Array();
        _this.fechaInicial = new Date();
        _this.fechaFinal = new Date();
        _this.currentProgramacion = new Array();
        _this.fechaInicialProg = new Date();
        _this.fechaFinalProg = new Date();
        _this.errorProgramacion = new Array();
        _this.errorDisplay = "";
        _this.idProgramacion = "";
        _this.timerInterval = null;
        _this.titleContentView = "";
        _this.fileNameContentView = "";
        _this.errorDialog = false;
        _this.errorServer = "";
        _this.menuItems = [];
        _this.menuItemsProg = [];
        _this.totalRows = 0;
        _this.pageIndex = 0;
        _this.totalRowsProg = 0;
        _this.pageIndexProg = 0;
        _this.adamNomina = new recibo_nomina_adam_1.NominaAdamInfo();
        _this.editForm = formBuilder.group({
            'fechaInicial': [''],
            'fechaFinal': [''],
            'adamNomina': [''],
            'presupuesto': [''],
            'concepto': [''],
            'empleado': [''],
            'fechaInicialProg': [''],
            'fechaFinalProg': [''],
            'fechaLiquidacion': [''],
            'numLiquidacion': [''],
            'proCancelar': [''],
            'proGenerar': [''],
            'proTimbrar': [''],
            'proEnviar': [''],
            'errorDisplay': ['']
        });
        _this.adamNomina.idSucursal = _this.context.app.defaultSite.identity;
        return _this;
    }
    ReciboAdamMaintenance.prototype.ngAfterViewInit = function () {
        var _this = this;
        setTimeout(function (_) {
            _this.refreshList();
            _this.refreshListProg();
        });
        this.createMenu();
        this.createMenuProg();
        this.refreshList();
        this.refreshListProg();
    };
    ReciboAdamMaintenance.prototype.applyPolicy = function (policy) {
    };
    ReciboAdamMaintenance.prototype.handleError = function (error) {
        this.context.app.hideSpinner();
        var message = this.context.getExceptionMessage(error);
        this.errorDialog = true;
        this.errorServer = message;
        this.alerts.showAlert(message, 'danger');
    };
    ReciboAdamMaintenance.prototype.onRemoveBranch = function () {
    };
    ReciboAdamMaintenance.prototype.onCurrentItemChanged = function (item) {
        this.currentItem = item;
    };
    ReciboAdamMaintenance.prototype.onCurrentItemProgChanged = function (item) {
        this.currentItemProg = item;
    };
    ReciboAdamMaintenance.prototype.refreshList = function () {
        var _this = this;
        this.context.app.showSpinner();
        if (this.request == null) {
            this.request = new search_1.SearchRequest();
            this.request.pageIndex = 0;
            this.request.pageSize = 20;
            this.request.paged = false;
        }
        var exist = false;
        this.request.conditions.forEach(function (r) {
            if (r.field == "fechaCreacion" && r.operator == ">=") {
                exist = true;
                r.value = moment(_this.fechaInicial).format("YYYY-MM-DD") + "T00:00:00-00:00";
            }
            else if (r.field == "fechaCreacion" && r.operator == "<=") {
                exist = true;
                r.value = moment(_this.fechaFinal).format("YYYY-MM-DD") + "T00:00:00-00:00";
            }
        });
        if (!exist) {
            var conFechaIni = { field: "fechaCreacion", operator: ">=", valueType: "datetime", value: moment(this.fechaInicial).format("YYYY-MM-DD") + "T00:00:00-00:00" };
            var conFechaFin = { field: "fechaCreacion", operator: "<=", valueType: "datetime", value: moment(this.fechaFinal).format("YYYY-MM-DD") + "T00:00:00-00:00" };
            this.request.conditions.push(conFechaIni);
            this.request.conditions.push(conFechaFin);
        }
        this.reciboAdamService.search(this.context.app.defaultSite.identity, this.request)
            .then(function (response) {
            response.rows.forEach(function (r) {
                r['fechaCreacion'] = moment(r['fechaCreacion']).toDate();
            });
            _this.currentRecibos = response.rows;
            _this.totalRows = response.totalRows;
            _this.pageIndex = _this.request.pageIndex;
            _this.context.app.hideSpinner();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ReciboAdamMaintenance.prototype.searchRequested = function (request) {
        this.request = request;
        this.refreshList();
    };
    ReciboAdamMaintenance.prototype.createMenu = function () {
        var mnuImprimir = { icon: "glyphicon glyphicon-print", text: "Imprimir", name: "IMPRIMIR", smallText: "Imprimir recibo de n&oacute;mina" };
        var mnuDescargar = { icon: "glyphicon glyphicon-download-alt", text: "Descargar", name: "DESCARGAR", smallText: "Descargar XML" };
        var mnuEnviar = { icon: "glyphicon glyphicon-envelope", text: "Enviar correo", name: "ENVIAR", smallText: "Enviar correo recibo" };
        var mnuTimbrar = { icon: "glyphicon glyphicon-qrcode", text: "Timbrar", name: "TIMBRAR", smallText: "Timbrar recibo" };
        var mnuCancelar = { icon: "glyphicon glyphicon-remove", text: "Cancelar", name: "CENCELAR", smallText: "Cancelar recibo" };
        var mnuError = { icon: "glyphicon glyphicon-warning-sign", text: "Error", name: "ERROR", smallText: "Ver error" };
        this.menuItems.push(mnuImprimir, mnuDescargar, mnuEnviar, mnuTimbrar, mnuCancelar, mnuError);
        this.menuItems.forEach(function (item) {
            if (item.enabled == undefined)
                item.enabled = true;
        });
    };
    ReciboAdamMaintenance.prototype.createMenuProg = function () {
        var mnuCancelar = { icon: "glyphicon glyphicon-remove", text: "Cancelar", name: "CANCELAR", smallText: "Cancelar Programaci&oacute;n" };
        var mnuComparativo = { icon: "glyphicon glyphicon-search", text: "Comparativo", name: "COMPARATIVO", smallText: "Comparativo Adam" };
        var mnuDescargar = { icon: "glyphicon glyphicon-download-alt", text: "Descargar", name: "DESCARGAR", smallText: "Descargar recibos" };
        var mnuError = { icon: "glyphicon glyphicon-warning-sign", text: "Error", name: "ERROR", smallText: "Ver error" };
        this.menuItemsProg.push(mnuCancelar, mnuComparativo, mnuDescargar, mnuError);
        this.menuItemsProg.forEach(function (item) {
            if (item.enabled == undefined)
                item.enabled = true;
        });
    };
    ReciboAdamMaintenance.prototype.optionClick = function (option) {
        var _this = this;
        if (option.name == "IMPRIMIR") {
            this.context.app.showSpinner();
            this.reciboAdamService.printReciboPdf(this.currentItem.data.id)
                .then(function (report) {
                _this.context.app.hideSpinner();
                _this.titleContentView = "Recibo " + _this.currentItem.data.numTrabajador;
                _this.fileNameContentView = _this.currentItem.data.numTrabajador + ".pdf";
                _this.reportViewer.show("data:application/pdf; base64, " + report);
            })
                .catch(function (error) { return _this.handleError(error); });
        }
        else if (option.name == "DESCARGAR") {
            this.context.app.showSpinner();
            this.reciboAdamService.loadReciboXml(this.currentItem.data.id)
                .then(function (response) {
                _this.titleContentView = "Recibo " + _this.currentItem.data.numTrabajador;
                _this.fileNameContentView = _this.currentItem.data.numTrabajador + ".xml";
                _this.reportViewer.show("data:text/xml, " + response._body);
                _this.context.app.hideSpinner();
            })
                .catch(function (error) { return _this.handleError(error); });
        }
        else if (option.name == "ENVIAR") {
            this.context.app.showSpinner();
            this.reciboAdamService.enviarRecibo(this.currentItem.data.id, this.context.app.defaultSite.identity)
                .then(function (report) {
                _this.context.app.hideSpinner();
                _this.refreshList();
            })
                .catch(function (error) { return _this.handleError(error); });
        }
        else if (option.name == "TIMBRAR") {
            this.context.app.showSpinner();
            this.reciboAdamService.timbrarRecibo(this.currentItem.data.id)
                .then(function (response) {
                _this.context.app.hideSpinner();
                _this.refreshList();
            })
                .catch(function (error) { return _this.handleError(error); });
        }
        else if (option.name == "ERROR") {
            this.errorDisplay = this.currentItem.data.errorTimbrado;
            this.dlgErrorComprobante.config.backdrop = false;
            this.dlgErrorComprobante.show();
        }
        else if (option.name == "CENCELAR") {
            this.context.app.showSpinner();
            this.reciboAdamService.cancelarRecibo(this.currentItem.data.id)
                .then(function (response) {
                _this.context.app.hideSpinner();
                _this.refreshList();
            })
                .catch(function (error) { return _this.handleError(error); });
        }
    };
    ReciboAdamMaintenance.prototype.generarComprobante = function () {
        var _this = this;
        if (this.adamNomina.concepto.length == 0) {
            this.errorServer = "Concepto requerido";
            this.errorDialog = true;
        }
        else if ((this.adamNomina.tipo == "R" || this.adamNomina.tipo == "F") && (this.adamNomina.empleado == undefined || this.adamNomina.empleado.length == 0)) {
            this.errorServer = "Num. Empleado requerido";
            this.errorDialog = true;
        }
        else if (this.adamNomina.tipo == "F" && (this.adamNomina.noLiquidacion == undefined || !(this.adamNomina.noLiquidacion > 0))) {
            this.errorServer = "Num. liquidación requerido";
            this.errorDialog = true;
        }
        else if (this.adamNomina.nomina.compania == undefined || this.adamNomina.nomina.compania == null || this.adamNomina.nomina.compania.length == 0) {
            this.errorServer = "Seleccione la compañía";
            this.errorDialog = true;
        }
        else if (this.adamNomina.nomina.claseNomina == undefined || this.adamNomina.nomina.claseNomina == null || this.adamNomina.nomina.claseNomina.length == 0) {
            this.errorServer = "Seleccione la clase de nómina";
            this.errorDialog = true;
        }
        else if (this.adamNomina.nomina.tipoNomina == undefined || this.adamNomina.nomina.tipoNomina == null || this.adamNomina.nomina.tipoNomina.length == 0) {
            this.errorServer = "Seleccione la compañía";
            this.errorDialog = true;
        }
        else if (this.adamNomina.tipo != "F" && (this.adamNomina.nomina.anio == undefined || this.adamNomina.nomina.anio == null || !(this.adamNomina.nomina.anio > 0))) {
            this.errorServer = "Seleccione el año";
            this.errorDialog = true;
        }
        else if (this.adamNomina.tipo != "F" && (this.adamNomina.nomina.periodo == undefined || this.adamNomina.nomina.periodo == null || !(this.adamNomina.nomina.periodo > 0))) {
            this.errorServer = "Seleccione el periodo";
            this.errorDialog = true;
        }
        else if (this.adamNomina.tipo == "F" && (this.adamNomina.noLiquidacion == undefined || this.adamNomina.noLiquidacion == null || !(this.adamNomina.noLiquidacion > 0))) {
            this.errorServer = "Ingrese el número de liquidación";
            this.errorDialog = true;
        }
        else if ((this.adamNomina.tipo == "R" || this.adamNomina.tipo == "F") && (this.adamNomina.empleado == undefined || this.adamNomina.empleado == null || this.adamNomina.empleado.length == 0)) {
            this.errorServer = "Ingrese el número de empleado";
            this.errorDialog = true;
        }
        else {
            if (this.adamNomina.tipo == "R" || this.adamNomina.tipo == "F") {
                this.context.app.showSpinner();
                this.reciboAdamService.generarRecibo(this.context.app.defaultSite.identity, this.adamNomina)
                    .then(function (response) {
                    _this.context.app.hideSpinner();
                    _this.dlgComprobante.hide();
                    _this.refreshList();
                    _this.refreshListProg();
                })
                    .catch(function (error) { return _this.handleError(error); });
            }
            else {
                this.context.app.showSpinner();
                this.programacionReciboSvc.generarProgramacion(this.context.app.defaultSite.identity, this.adamNomina)
                    .then(function (response) {
                    _this.context.app.hideSpinner();
                    _this.dlgComprobante.hide();
                    _this.refreshList();
                    _this.refreshListProg();
                })
                    .catch(function (error) { return _this.handleError(error); });
            }
        }
    };
    ReciboAdamMaintenance.prototype.cancelarComprobante = function () {
        this.dlgComprobante.hide();
    };
    // Eventos cliente
    ReciboAdamMaintenance.prototype.agregarComprobante = function () {
        this.dlgTipoComprobante.config.backdrop = false;
        this.dlgTipoComprobante.show();
    };
    ReciboAdamMaintenance.prototype.onPresupuestoSelected = function (args) {
        this.dlgTipoComprobante.config.backdrop = false;
        this.dlgTipoComprobante.show();
        this.dlgTipoComprobante.hide();
    };
    ReciboAdamMaintenance.prototype.onCancelar = function () {
        this.dlgTipoComprobante.config.backdrop = false;
        this.dlgTipoComprobante.hide();
        this.dlgTipoComprobante.hide();
    };
    ReciboAdamMaintenance.prototype.onGenerarFiniquito = function (tipo) {
        this.adamNomina.tipo = "F";
        this.titleDialog = "Recibo Finiquito";
        this.errorDialog = false;
        this.errorServer = "";
        this.dlgComprobante.config.backdrop = false;
        this.dlgComprobante.show();
        this.dlgTipoComprobante.hide();
    };
    ReciboAdamMaintenance.prototype.onGenerarRecibo = function (tipo) {
        this.adamNomina.tipo = "R";
        this.titleDialog = "Recibo N&oacute;mina";
        this.errorDialog = false;
        this.errorServer = "";
        this.dlgComprobante.config.backdrop = false;
        this.dlgComprobante.show();
        this.dlgTipoComprobante.hide();
    };
    // Programación de la nómina
    ReciboAdamMaintenance.prototype.searchRequestedProg = function (request) {
        this.requestProg = request;
        this.refreshListProg();
    };
    ReciboAdamMaintenance.prototype.refreshListProg = function () {
        var _this = this;
        this.context.app.showSpinner();
        if (this.requestProg == null) {
            this.requestProg = new search_1.SearchRequest();
            this.requestProg.pageIndex = 0;
            this.requestProg.pageSize = 20;
            this.requestProg.paged = false;
        }
        var exist = false;
        this.requestProg.conditions.forEach(function (r) {
            if (r.field == "fechaSys" && r.operator == ">=") {
                exist = true;
                r.value = moment(_this.fechaInicialProg).format("YYYY-MM-DD") + "T00:00:00-00:00";
            }
            else if (r.field == "fechaSys" && r.operator == "<=") {
                exist = true;
                r.value = moment(_this.fechaFinalProg).format("YYYY-MM-DD") + "T00:00:00-00:00";
            }
        });
        if (!exist) {
            var conFechaIni = { field: "fechaSys", operator: ">=", valueType: "datetime", value: moment(this.fechaInicialProg).format("YYYY-MM-DD") + "T00:00:00-00:00" };
            var conFechaFin = { field: "fechaSys", operator: "<=", valueType: "datetime", value: moment(this.fechaFinalProg).format("YYYY-MM-DD") + "T00:00:00-00:00" };
            this.requestProg.conditions.push(conFechaIni);
            this.requestProg.conditions.push(conFechaFin);
        }
        this.programacionReciboSvc.search(this.context.app.defaultSite.identity, this.requestProg)
            .then(function (response) {
            response.rows.forEach(function (r) {
                r['fechaSys'] = moment(r['fechaSys']).toDate();
            });
            _this.currentProgramacion = response.rows;
            _this.totalRowsProg = response.totalRows;
            _this.pageIndexProg = _this.requestProg.pageIndex;
            _this.context.app.hideSpinner();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ReciboAdamMaintenance.prototype.optionClickProg = function (option) {
        var _this = this;
        if (option.name == "CANCELAR") {
            this.context.app.showSpinner();
            this.programacionReciboSvc.cancelarProgramacion(this.currentItemProg.data.id)
                .then(function (report) {
                _this.refreshListProg();
                _this.context.app.hideSpinner();
            })
                .catch(function (error) { return _this.handleError(error); });
        }
        else if (option.name == "COMPARATIVO") {
            this.context.app.showSpinner();
            this.programacionReciboSvc.generarComparativoPDF(this.currentItemProg.data.id)
                .then(function (report) {
                _this.context.app.hideSpinner();
                _this.titleContentView = "Comparativo";
                _this.fileNameContentView = _this.currentItemProg.data.id + ".pdf";
                _this.reportViewer.show("data:application/pdf; base64, " + report);
            })
                .catch(function (error) { return _this.handleError(error); });
        }
        else if (option.name == "DESCARGAR") {
            this.context.app.showSpinner();
            this.programacionReciboSvc.generarDescargaComprobante(this.currentItemProg.data.id)
                .then(function (result) {
                _this.idProgramacion = result._body;
                _this.timerInterval = setInterval(function () {
                    _this.verificarTaskDownload();
                }, 60000);
            })
                .catch(function (error) { return _this.handleError(error); });
        }
        else if (option.name == "ERROR") {
            this.errorDisplay = this.currentItemProg.data.errorTimbrado;
            this.dlgErrorComprobante.config.backdrop = false;
            this.dlgErrorComprobante.show();
        }
    };
    // Eventos cliente
    ReciboAdamMaintenance.prototype.agregarProgramacion = function () {
        this.titleDialog = "Programaci&oacute;n de N&oacute;mina";
        this.adamNomina.tipo = "P";
        this.errorDialog = false;
        this.errorServer = "";
        this.dlgComprobante.config.backdrop = false;
        this.dlgComprobante.show();
    };
    ReciboAdamMaintenance.prototype.onProcesoCancelar = function (args) {
        if (args) {
            this.adamNomina.proGenerar = false;
            this.adamNomina.proTimbrar = false;
            this.adamNomina.proEnviar = false;
        }
    };
    // Eventos html
    ReciboAdamMaintenance.prototype.onCloseDialogComprobante = function () {
        this.dlgComprobante.hide();
    };
    ReciboAdamMaintenance.prototype.onCloseDialogErrorComprobante = function () {
        this.dlgErrorComprobante.hide();
    };
    // Task
    ReciboAdamMaintenance.prototype.verificarTaskDownload = function () {
        var _this = this;
        var self = this;
        this.programacionReciboSvc.getJobDescargaComprobante(this.idProgramacion)
            .then(function (response) {
            if (response.completed) {
                clearInterval(_this.timerInterval);
                _this.programacionReciboSvc.getReciboToDownloadPath(_this.idProgramacion)
                    .then(function (result) {
                    _this.alerts.showAlert("Descarga completa, verifica su carpeta de descarga", 'danger');
                    _this.context.app.hideSpinner();
                    window.open(result._body.toString());
                })
                    .catch(function (error) { return _this.handleError(error); });
            }
            else if (response.errorCount > 0) {
                clearInterval(_this.timerInterval);
                _this.context.app.hideSpinner();
                _this.errorDisplay = response.errorMessage;
                _this.dlgErrorComprobante.config.backdrop = false;
                _this.dlgErrorComprobante.show();
            }
        })
            .catch(function (error) {
            clearInterval(_this.timerInterval);
            _this.handleError(error);
        });
    };
    __decorate([
        core_1.ViewChild(index_1.AlertsBarComponent),
        __metadata("design:type", index_1.AlertsBarComponent)
    ], ReciboAdamMaintenance.prototype, "alerts", void 0);
    __decorate([
        core_1.ViewChild(content_viewer_component_1.ContentViewerComponent),
        __metadata("design:type", content_viewer_component_1.ContentViewerComponent)
    ], ReciboAdamMaintenance.prototype, "reportViewer", void 0);
    __decorate([
        core_1.ViewChild('dlgComprobante'),
        __metadata("design:type", ngx_bootstrap_1.ModalDirective)
    ], ReciboAdamMaintenance.prototype, "dlgComprobante", void 0);
    __decorate([
        core_1.ViewChild('dlgTipoComprobante'),
        __metadata("design:type", ngx_bootstrap_1.ModalDirective)
    ], ReciboAdamMaintenance.prototype, "dlgTipoComprobante", void 0);
    __decorate([
        core_1.ViewChild('dlgErrorComprobante'),
        __metadata("design:type", ngx_bootstrap_1.ModalDirective)
    ], ReciboAdamMaintenance.prototype, "dlgErrorComprobante", void 0);
    ReciboAdamMaintenance = __decorate([
        core_1.Component({
            selector: 'recibos-adam-maintenance',
            template: "\n      <form [formGroup]=\"editForm\">\n          <div class=\"row\">\n              <div class=\"col-12 col-md-10\">\n\n                  <!--Barra de alertas-->\n                  <alerts-bar></alerts-bar>\n\n                  <tabset style=\"padding: .5rem .75rem;\">\n                      <tab heading=\"Generar Recibo\">\n\n                          <div class=\"form-inline\">\n                              <div class=\"form-group\">\n                                  <div class=\"btn-group\" style=\"padding: .5rem .75rem;\">\n                                      <button type=\"button\" class=\"btn btn-primary\" (click)=\"refreshList()\">Actualizar</button>\n                                      <button type=\"button\" class=\"btn btn-default\" (click)=\"agregarComprobante()\">Agregar</button>\n                                  </div>\n\n                                  <div class=\"form-group\">\n                                      <label for=\"fechaInicial\">Fecha Ini</label>\n                                      <az-input-date id=\"fechaInicial\" style=\"padding: .5rem .75rem;\" formControlName=\"fechaInicial\" [(ngModel)]=\"fechaInicial\"></az-input-date>\n                                  </div>\n\n                                  <div class=\"form-group\">\n                                      <label for=\"fechaFinal\">Fecha Fin</label>\n                                      <az-input-date id=\"fechaFinal\" style=\"padding: .5rem .75rem;\" formControlName=\"fechaFinal\" [(ngModel)]=\"fechaFinal\"></az-input-date>\n                                  </div>\n\n                              </div>\n                          </div>\n\n                          <!-- Recibos generados dentro del periodo -->\n                          <azteca-catalog-list [catalogList]=\"currentRecibos\"\n                                                  [showRowButton]=\"false\"\n                                                  [rowButtonIcon]=\"'glyphicon glyphicon-trash'\"\n                                                  (rowButtonClick)=\"onRemoveBranch()\"\n                                                  (currentItemChanged)=\"onCurrentItemChanged($event)\"\n                                                  (searchRequested)=\"searchRequested($event)\"\n                                                  (contextMenuClick)=\"optionClick($event)\"\n                                                  [enabled]=\"true\"\n                                                  [pageSize]=\"100\"\n                                                  [serverSide]=\"false\"\n                                                  [totalRows]=\"totalRows\"\n                                                  [pageIndex]=\"pageIndex\">\n\n                              <!-- Mapear opciones de men\u00FA de componente padre-->\n                              <azteca-menu-item *ngFor=\"let item of menuItems\" [name]=\"item.name\" [icon]=\"item.icon\" [text]=\"item.text\" [smallText]=\"item.smallText\" [enabled]=\"item.enabled\"></azteca-menu-item>\n                              <azteca-grid-column [header]=\"'Serie'\" [binding]=\"'serie'\" [width]=\"60\"></azteca-grid-column>\n                              <azteca-grid-column [header]=\"'Folio'\" [binding]=\"'folio'\" [width]=\"70\"></azteca-grid-column>\n                              <azteca-grid-column [header]=\"'Fecha'\" [binding]=\"'fechaSys'\" [format]=\"'dd-MM-yyyy'\"></azteca-grid-column>\n                              <azteca-grid-column [header]=\"'C&oacute;digo'\" [binding]=\"'numTrabajador'\"></azteca-grid-column>\n                              <azteca-grid-column [header]=\"'Trabajador'\" [binding]=\"'trabajador'\" [width]=\"300\"></azteca-grid-column>\n                              <azteca-grid-column [header]=\"'Total'\" [binding]=\"'total'\"></azteca-grid-column>\n                              <azteca-grid-column [header]=\"'Liquidaci&oacute;n'\" [binding]=\"'numeroLiquidacion'\"></azteca-grid-column>\n                              <azteca-grid-column [header]=\"'Clase'\" [binding]=\"'claseNomina'\" [width]=\"70\"></azteca-grid-column>\n                              <azteca-grid-column [header]=\"'Tipo'\" [binding]=\"'tipoNomina'\" [width]=\"70\"></azteca-grid-column>\n                              <azteca-grid-column [header]=\"'A&ntilde;o'\" [binding]=\"'anio'\" [width]=\"70\"></azteca-grid-column>\n                              <azteca-grid-column [header]=\"'Periodo'\" [binding]=\"'periodo'\" [width]=\"70\"></azteca-grid-column>\n                              <azteca-grid-column [header]=\"'Compa&ntilde;&iacute;a'\" [binding]=\"'compania'\" [width]=\"70\"></azteca-grid-column>\n                              <azteca-grid-column [header]=\"'Estado'\" [binding]=\"'status'\"></azteca-grid-column>\n                          </azteca-catalog-list>\n\n                      </tab>\n                      <tab heading=\"Programaci&oacute; de N&oacute;mina\">\n\n                          <div class=\"form-inline\">\n                              <div class=\"form-group\">\n                                  <div class=\"btn-group\" style=\"padding: .5rem .75rem;\">\n                                      <button type=\"button\" class=\"btn btn-primary\" (click)=\"refreshListProg()\">Actualizar</button>\n                                      <button type=\"button\" class=\"btn btn-default\" (click)=\"agregarProgramacion()\">Agregar</button>\n                                  </div>\n\n                                  <div class=\"form-group\">\n                                      <label for=\"fechaInicialProg\">Fecha Ini</label>\n                                      <az-input-date id=\"fechaInicialProg\" style=\"padding: .5rem .75rem;\" formControlName=\"fechaInicialProg\" [(ngModel)]=\"fechaInicialProg\"></az-input-date>\n                                  </div>\n\n                                  <div class=\"form-group\">\n                                      <label for=\"fechaFinalProg\">Fecha Fin</label>\n                                      <az-input-date id=\"fechaFinalProg\" style=\"padding: .5rem .75rem;\" formControlName=\"fechaFinalProg\" [(ngModel)]=\"fechaFinalProg\"></az-input-date>\n                                  </div>\n\n                              </div>\n                          </div>\n\n                          <!-- Recibos generados dentro del periodo -->\n                          <azteca-catalog-list [catalogList]=\"currentProgramacion\"\n                                               [showRowButton]=\"false\"\n                                               [rowButtonIcon]=\"'glyphicon glyphicon-trash'\"\n                                               (currentItemChanged)=\"onCurrentItemProgChanged($event)\"\n                                               (searchRequested)=\"searchRequestedProg($event)\"\n                                               (contextMenuClick)=\"optionClickProg($event)\"\n                                               [enabled]=\"true\"\n                                               [pageSize]=\"100\"\n                                               [serverSide]=\"false\"\n                                               [totalRows]=\"totalRowsProg\"\n                                               [pageIndex]=\"pageIndexProg\">\n                              <!-- Mapear opciones de men\u00FA de componente padre-->\n                              <azteca-menu-item *ngFor=\"let item of menuItemsProg\" [name]=\"item.name\" [icon]=\"item.icon\" [text]=\"item.text\" [smallText]=\"item.smallText\" [enabled]=\"item.enabled\"></azteca-menu-item>\n                              <azteca-grid-column [header]=\"'Fecha'\" [binding]=\"'fechaSys'\" [format]=\"'dd-MM-yyyy'\"></azteca-grid-column>\n                              <azteca-grid-column [header]=\"'Clase'\" [binding]=\"'claseNomina'\" [width]=\"70\"></azteca-grid-column>\n                              <azteca-grid-column [header]=\"'Tipo'\" [binding]=\"'tipoNomina'\" [width]=\"70\"></azteca-grid-column>\n                              <azteca-grid-column [header]=\"'A&ntilde;o'\" [binding]=\"'anio'\" [width]=\"70\"></azteca-grid-column>\n                              <azteca-grid-column [header]=\"'Periodo'\" [binding]=\"'periodo'\" [width]=\"70\"></azteca-grid-column>\n                              <azteca-grid-column [header]=\"'Compa&ntilde;&iacute;a'\" [binding]=\"'compania'\" [width]=\"70\"></azteca-grid-column>\n                              <azteca-grid-column [header]=\"'Errores'\" [binding]=\"'errores'\"></azteca-grid-column>\n                              <azteca-grid-column [header]=\"'Adam'\" [binding]=\"'recibos'\"></azteca-grid-column>\n                              <azteca-grid-column [header]=\"'Gen'\" [binding]=\"'generado'\"></azteca-grid-column>\n                              <azteca-grid-column [header]=\"'Por Tim'\" [binding]=\"'porTimbrar'\"></azteca-grid-column>\n                              <azteca-grid-column [header]=\"'Tim'\" [binding]=\"'timbrado'\"></azteca-grid-column>\n                              <azteca-grid-column [header]=\"'Cero'\" [binding]=\"'importeCero'\"></azteca-grid-column>\n                              <azteca-grid-column [header]=\"'Estado'\" [binding]=\"'status'\"></azteca-grid-column>\n                          </azteca-catalog-list>\n\n                      </tab>\n                  </tabset>\n              </div>\n          </div>\n\n          <azteca-content-viewer [title]=\"titleContentView\" [fileName]=\"fileNameContentView\"></azteca-content-viewer>\n\n          <!--DIALOGO DE CARGA DE COMPROBANTES-->\n          <div bsModal #dlgComprobante=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-hidden=\"true\">\n              <div class=\"modal-dialog\">\n                  <div class=\"modal-content\">\n                      <div class=\"modal-header\">\n                          <h5 class=\"modal-title\" [innerHTML]=\"titleDialog\"></h5>\n                          <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\" (click)=\"onCloseDialogComprobante()\">\n                              <span aria-hidden=\"true\">&times;</span>\n                          </button>\n                      </div>\n                      <div class=\"modal-body\">\n\n                          <div *ngIf=\"errorDialog\" class=\"alert alert-danger\" role=\"alert\">\n                              {{errorServer}}\n                          </div>\n\n                          <div class=\"row\">\n                              <div class=\"col-12\">\n                                  <azteca-form-field [label]=\"'Concepto:'\">\n                                      <az-textbox formControlName=\"concepto\" [(ngModel)]=\"adamNomina.concepto\"></az-textbox>\n                                  </azteca-form-field>\n                              </div>\n                          </div>\n                    \n                          <rh-adam-nomina #personaEditor\n                                          formControlName=\"adamNomina\"\n                                          [anioVisible]=\"adamNomina.tipo != 'F'\"\n                                          [periodoVisible]=\"adamNomina.tipo != 'F'\"\n                                          [(ngModel)]=\"adamNomina.nomina\"\n                                          [idSucursal]=\"this.context.app.defaultSite.identity\"></rh-adam-nomina>\n\n                          <div *ngIf=\"adamNomina.tipo == 'F'\" class=\"row\">\n                              <div class=\"col-12\">\n                                  <azteca-form-field [label]=\"'Fecha Liquidaci&oacute;n:'\">\n                                      <az-input-date formControlName=\"fechaLiquidacion\" [(ngModel)]=\"adamNomina.fecha\"></az-input-date>\n                                  </azteca-form-field>\n\n                              </div>\n                          </div>\n\n                          <div *ngIf=\"adamNomina.tipo == 'P'\" class=\"row\">\n                              <div class=\"col-12\">\n                                  <azteca-form-field [label]=\"'Fecha Programaci&oacute;n:'\">\n                                      <az-input-date-time formControlName=\"fechaLiquidacion\" [(ngModel)]=\"adamNomina.fecha\"></az-input-date-time>\n                                  </azteca-form-field>\n                              </div>\n                          </div>\n\n                          <div *ngIf=\"adamNomina.tipo == 'F'\" class=\"row\">\n                              <div class=\"col-12 col-md-6\">\n                                  <azteca-form-field [label]=\"'Num. Liquidaci&oacute;n:'\">\n                                      <az-input-number formControlName=\"numLiquidacion\" [(ngModel)]=\"adamNomina.noLiquidacion\" [format]=\"'n0'\" [min]=\"0\" ></az-input-number>\n                                  </azteca-form-field>\n                              </div>\n                          </div>\n                          <div *ngIf=\"adamNomina.tipo != 'P'\" class=\"row\">\n                              <div class=\"col-12 col-md-6\">\n                                  <azteca-form-field [label]=\"'Empleado:'\">\n                                      <az-textbox formControlName=\"empleado\" [(ngModel)]=\"adamNomina.empleado\"></az-textbox>\n                                  </azteca-form-field>\n                              </div>\n                          </div>\n\n                          <div *ngIf=\"adamNomina.tipo == 'P'\" class=\"row\">\n                              <div class=\"col-12 col-md-6\">\n                                  <az-checkbox [label]=\"'Cancelar'\" formControlName=\"proCancelar\" [(ngModel)]=\"adamNomina.proCancelar\" (checkedChanged)=\"onProcesoCancelar($event)\"></az-checkbox>\n                              </div>\n                          </div>\n\n                          <div *ngIf=\"adamNomina.tipo == 'P'\" class=\"row\">\n                              <div class=\"col-12 col-md-6\">\n                                  <az-checkbox [label]=\"'Generar'\" formControlName=\"proGenerar\" [(ngModel)]=\"adamNomina.proGenerar\" [enabled]=\"adamNomina.proCancelar == false\"></az-checkbox>\n                              </div>\n                          </div>\n                          <div *ngIf=\"adamNomina.tipo == 'P'\" class=\"row\">\n                              <div class=\"col-12 col-md-6\">\n                                  <az-checkbox [label]=\"'Timbrar'\" formControlName=\"proTimbrar\" [(ngModel)]=\"adamNomina.proTimbrar\" [enabled]=\"adamNomina.proCancelar == false\"></az-checkbox>\n                              </div>\n                          </div>\n\n                          <div *ngIf=\"adamNomina.tipo == 'P'\" class=\"row\">\n                              <div class=\"col-12 col-md-6\">\n                                  <az-checkbox [label]=\"'Enviar'\" formControlName=\"proEnviar\" [(ngModel)]=\"adamNomina.proEnviar\" [enabled]=\"adamNomina.proCancelar == false\"></az-checkbox>\n                              </div>\n                          </div>\n\n                      </div>\n                      <div class=\"modal-footer\">\n                          <button type=\"button\" class=\"btn btn-primary\" (click)=\"generarComprobante()\">Agregar</button>\n                          <button type=\"button\" class=\"btn btn-secondary\" (click)=\"cancelarComprobante()\">Cancelar</button>\n                      </div>\n                  </div>\n              </div>\n          </div>\n\n          <!--DIALOGO DE CARGA DE COMPROBANTES-->\n          <div bsModal #dlgTipoComprobante=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-hidden=\"true\">\n              <div class=\"modal-dialog\">\n                  <div class=\"modal-content\">\n                      <div class=\"modal-body\">\n                          <div>Generar comprobante</div>\n                      </div>\n                      <div class=\"modal-footer\">\n                          <button type=\"button\" class=\"btn btn-primary\" (click)=\"onCancelar()\">Cancelar</button>\n                          <button type=\"button\" class=\"btn btn-primary\" (click)=\"onGenerarFiniquito()\">Finiquito</button>\n                          <button type=\"button\" class=\"btn btn-default\" (click)=\"onGenerarRecibo()\">Recibo</button>\n                      </div>\n                  </div>\n              </div>\n          </div>\n\n          <!--DIALOGO DETALLE DE ERROR-->\n          <div bsModal #dlgErrorComprobante=\"bs-modal\" class=\"modal fade\"  tabindex=\"-1\" role=\"dialog\" aria-hidden=\"true\">\n              <div class=\"modal-dialog modal-lg\" role=\"document\">\n                  <div class=\"modal-content\">\n                      <div class=\"modal-header\">\n                          <h5 class=\"modal-title\" id=\"exampleModalLabel\">Error Recibo</h5>\n                          <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\" (click)=\"onCloseDialogErrorComprobante()\">\n                              <span aria-hidden=\"true\">&times;</span>\n                          </button>\n                      </div>\n                      <div class=\"modal-body\">\n                          <az-textarea formControlName=\"errorDisplay\" [(text)]=\"errorDisplay\"></az-textarea>\n                      </div>\n                      <div class=\"modal-footer\">\n                          <button type=\"button\" class=\"btn btn-primary\" (click)=\"onCloseDialogErrorComprobante()\">Aceptar</button>\n                      </div>\n                  </div>\n              </div>\n          </div>\n\n          <!-- DIALOGO LISTADO ERRORES -->\n          <div bsModal #dlgErrorComprobante=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-hidden=\"true\">\n              <div class=\"modal-dialog modal-lg\" role=\"document\">\n                  <div class=\"modal-content\">\n                      <div class=\"modal-header\">\n                          <h5 class=\"modal-title\" id=\"exampleModalLabel\">Error Recibos</h5>\n                          <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\" (click)=\"onCloseDialogErrorComprobante()\">\n                              <span aria-hidden=\"true\">&times;</span>\n                          </button>\n                      </div>\n                      <div class=\"modal-body\">\n                          <wj-flex-grid #grdCedulaApoyo [(itemsSource)]=\"conceptosApoyo\" [showGroups]=\"true\">\n                              <wj-flex-grid-column [header]=\"'C&oacute;digo'\" [visible]=\"false\" [binding]=\"'clasificacionConcepto.descripcion'\"></wj-flex-grid-column>\n                              <wj-flex-grid-column [header]=\"'Empleado'\" [binding]=\"'concepto'\" [isReadOnly]=\"true\" [width]=\"'*'\"></wj-flex-grid-column>\n                              <wj-flex-grid-column [header]=\"'Error'\" [binding]=\"'cantidad'\" [format]=\"'n2'\" [aggregate]=\"'Sum'\"></wj-flex-grid-column>\n                          </wj-flex-grid>\n\n                      </div>\n                      <div class=\"modal-footer\">\n                          <button type=\"button\" class=\"btn btn-primary\">Aceptar</button>\n                      </div>\n                  </div>\n              </div>\n          </div>\n\n\n      </form>\n    "
        }),
        __metadata("design:paramtypes", [core_2.Context, router_1.Router, router_1.ActivatedRoute, common_1.Location,
            forms_1.FormBuilder, recibo_adam_service_1.ReciboAdamService, programacion_recibo_adam_service_1.ProgramacionReciboAdamService])
    ], ReciboAdamMaintenance);
    return ReciboAdamMaintenance;
}(core_2.BaseComponent));
exports.ReciboAdamMaintenance = ReciboAdamMaintenance;
