"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
//////////////////////////// Guards //////////////////////////////////
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//////////////////////////// Catalogos ////////////////////////////////
var empresasadam_manager_1 = require("./catalogs/empresasadam.manager");
var empresasadam_editor_1 = require("./catalogs/empresasadam.editor");
var empleados_manager_1 = require("./catalogs/empleados.manager");
var empleados_editor_1 = require("./catalogs/empleados.editor");
var cedulasfiniquitos_manager_1 = require("./catalogs/cedulasfiniquitos.manager");
var cedulasfiniquitos_editor_1 = require("./catalogs/cedulasfiniquitos.editor");
var turnos_manager_1 = require("./catalogs/turnos.manager");
var turnos_editor_1 = require("./catalogs/turnos.editor");
var departamentos_manager_1 = require("./catalogs/departamentos.manager");
var companias_manager_1 = require("./catalogs/companias.manager");
var companias_editor_1 = require("./catalogs/companias.editor");
var tipos_per_ded_manager_1 = require("./catalogs/tipos-per-ded.manager");
var tipos_per_ded_editor_1 = require("./catalogs/tipos-per-ded.editor");
var puestos_manager_1 = require("./catalogs/puestos.manager");
var dispositivos_nixtla_manager_1 = require("./catalogs/dispositivos-nixtla.manager");
var dispositivos_nixtla_editor_1 = require("./catalogs/dispositivos-nixtla.editor");
var conceptos_adam_manager_1 = require("./catalogs/conceptos-adam.manager");
var conceptos_adam_editor_1 = require("./catalogs/conceptos-adam.editor");
///////////////////////////// Interfases /////////////////////////////////
var polizas_nomina_1 = require("./interfases/polizas-nomina");
///////////////////////////// Document /////////////////////////////////
///////////////////////////// Rutas /////////////////////////////////
///////////////////////////// Mantenimientos /////////////////////////////////
var recibos_adam_maintenance_1 = require("./maintenances/recibos-adam.maintenance");
var routes = [
    {
        path: '',
        canActivateChild: [core_2.AuthGuard],
        children: [
            { path: 'empresa-adam/:proceso', component: empresasadam_manager_1.EmpresasAdamManager },
            { path: 'empresa-adam/:proceso/:id', component: empresasadam_editor_1.EmpresasAdamEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'empleados/:proceso', component: empleados_manager_1.EmpleadosManager },
            { path: 'empleados/:proceso/:id', component: empleados_editor_1.EmpleadosEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'cedulas-finiquitos/:proceso', component: cedulasfiniquitos_manager_1.CedulasFiniquitosManager },
            { path: 'cedulas-finiquitos/:proceso/:id', component: cedulasfiniquitos_editor_1.CedulasFiniquitosEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'polizas-nomina/:proceso', component: polizas_nomina_1.PolizasNomina, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'recibos-adam/:proceso', component: recibos_adam_maintenance_1.ReciboAdamMaintenance, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'turnos/:proceso', component: turnos_manager_1.TurnosManager, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'turnos/:proceso/:id', component: turnos_editor_1.TurnosEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'departamentos/:proceso', component: departamentos_manager_1.DepartamentosManager },
            { path: 'companias/:proceso', component: companias_manager_1.CompaniasManager, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'companias/:proceso/:id', component: companias_editor_1.CompaniasEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'tipos-per-ded/:proceso', component: tipos_per_ded_manager_1.TiposPerDedManager, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'tipos-per-ded/:proceso/:id', component: tipos_per_ded_editor_1.TiposPerDedEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'departamentos/:proceso', component: departamentos_manager_1.DepartamentosManager },
            { path: 'puestos/:proceso', component: puestos_manager_1.PuestosManager },
            { path: 'conceptos-adam/:proceso', component: conceptos_adam_manager_1.ConceptosAdamManager, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'conceptos-adam/:proceso/:id', component: conceptos_adam_editor_1.ConceptosAdamEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'dispositivos-nixtla/:proceso', component: dispositivos_nixtla_manager_1.DispositivosNixtlaManager, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'dispositivos-nixtla/:proceso/:id', component: dispositivos_nixtla_editor_1.DispositivosNixtlaEditor, canDeactivate: [editors_1.EditorDeactivateGuard] }
        ]
    },
];
var RhRoutingModule = /** @class */ (function () {
    function RhRoutingModule() {
    }
    RhRoutingModule = __decorate([
        core_1.NgModule({
            imports: [
                router_1.RouterModule.forChild(routes)
            ],
            exports: [
                router_1.RouterModule
            ]
        })
    ], RhRoutingModule);
    return RhRoutingModule;
}());
exports.RhRoutingModule = RhRoutingModule;
