import { HttpClient } from '@angular/common/http';
import 'rxjs/add/operator/toPromise';
import { Context, CatalogService } from 'framework3/core';
import { CedulaFiniquitoInfo, RescisionLaboral, TarifaPagoProvicional, SubsidioEmpleo, AsyncTaskInfo } from '../models/cedulafiniquito';
export declare class CedulaFiniquitoService extends CatalogService<CedulaFiniquitoInfo> {
    constructor(http: HttpClient, context: Context);
    create(): Promise<CedulaFiniquitoInfo>;
    loadIngresoInformacion(idEmpleado: number, calcular: boolean): Promise<CedulaFiniquitoInfo>;
    loadRescisionesLaborales(): Promise<Array<RescisionLaboral>>;
    getTarifaPagoProvicional(idCompania: number, importe: number): Promise<TarifaPagoProvicional>;
    getSubsidioEmpleo(idCompania: number, importe: number): Promise<SubsidioEmpleo>;
    generarCedulaFiniquito(idCedulaFiniquito: number): Promise<string>;
    generarCedulaFiniquitoAdeudo(idEmpleado: number): Promise<string>;
    generarKardexAsistencia(empleado: string, fechaIni: string, fechaFin: string): Promise<string>;
    getTaskComision(idTask: any): Promise<AsyncTaskInfo>;
}
