"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var http_1 = require("@angular/common/http");
require("rxjs/add/operator/toPromise");
//Azteca Kernel
var core_2 = require("framework3/core");
//Locales
var cedulafiniquito_1 = require("../models/cedulafiniquito");
var CedulaFiniquitoService = /** @class */ (function (_super) {
    __extends(CedulaFiniquitoService, _super);
    function CedulaFiniquitoService(http, context) {
        return _super.call(this, http, context, "api/rh/cedulasfiniquitos") || this;
    }
    CedulaFiniquitoService.prototype.create = function () {
        return Promise.resolve(new cedulafiniquito_1.CedulaFiniquitoInfo());
    };
    CedulaFiniquitoService.prototype.loadIngresoInformacion = function (idEmpleado, calcular) {
        var params = new http_1.HttpParams()
            .set('idEmpleado', idEmpleado.toString())
            .set('calcualr', calcular.toString());
        return this.apiService.get('load-ingreso-informacion', params)
            .toPromise();
    };
    CedulaFiniquitoService.prototype.loadRescisionesLaborales = function () {
        var params = new http_1.HttpParams();
        return this.apiService.get('load-rescisiones', params)
            .toPromise();
    };
    CedulaFiniquitoService.prototype.getTarifaPagoProvicional = function (idCompania, importe) {
        var params = new http_1.HttpParams()
            .set('idCompania', idCompania.toString())
            .set('importe', importe.toString());
        return this.apiService.get('get-tarifa-provicional', params)
            .toPromise();
    };
    CedulaFiniquitoService.prototype.getSubsidioEmpleo = function (idCompania, importe) {
        var params = new http_1.HttpParams()
            .set('idCompania', idCompania.toString())
            .set('importe', importe.toString());
        return this.apiService.get('get-subsidio-empleo', params)
            .toPromise();
    };
    CedulaFiniquitoService.prototype.generarCedulaFiniquito = function (idCedulaFiniquito) {
        var params = new http_1.HttpParams()
            .set('idCedulaFiniquito', idCedulaFiniquito.toString());
        return this.apiService.get('generar-cedula-finiquito', params)
            .toPromise();
    };
    CedulaFiniquitoService.prototype.generarCedulaFiniquitoAdeudo = function (idEmpleado) {
        var params = new http_1.HttpParams()
            .set('idEmpleado', idEmpleado.toString());
        return this.apiService.get('load-cedula-finiquito-adeudo', params)
            .toPromise();
    };
    CedulaFiniquitoService.prototype.generarKardexAsistencia = function (empleado, fechaIni, fechaFin) {
        var params = new http_1.HttpParams()
            .set("empleado", empleado)
            .set("fechaIni", fechaIni)
            .set("fechaFin", fechaFin);
        return this.apiService.get('load-kardex-asistencia', params)
            .toPromise();
    };
    CedulaFiniquitoService.prototype.getTaskComision = function (idTask) {
        var params = new http_1.HttpParams()
            .set('idTask', idTask.toString());
        return this.apiService.get('get-task-comision', params)
            .toPromise();
    };
    CedulaFiniquitoService = __decorate([
        core_1.Injectable(),
        __metadata("design:paramtypes", [http_1.HttpClient, core_2.Context])
    ], CedulaFiniquitoService);
    return CedulaFiniquitoService;
}(core_2.CatalogService));
exports.CedulaFiniquitoService = CedulaFiniquitoService;
