import { ChangeDetectorRef } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { Context } from 'framework3/core';
import { CatalogOptions } from 'framework3/custom';
import { ToolbarButton, MenuItem } from 'framework3/controls';
import { CatalogEditor, EditorEventArgs, TrackableCollection } from 'framework3/editors';
import { Clasificacion } from 'framework3/general';
import { UnidadMedidaTipoService } from '../../inventory/services/unidad-medida-tipo.service';
import { ArticuloService } from '../services/articulo.service';
import { ArticuloInfo } from '../models/articulo';
import { ImpuestoAsignacionInfo } from '../../accounting/models/impuesto-asignacion';
import { EstComSelectorComponent } from '../controls/est-com-selector.component';
import { CuentaSelectorComponent } from '../../accounting/components/cuenta-selector.component';
import { FlujoSelectorComponent } from '../../accounting/components/flujo-selector.component';
import { MarcasSelectorComponent } from '../controls/marcas-selector.component';
import { ArticuloCategoriaFiscalComponent } from '../../accounting/controls/articulo-categoria-fiscal-selector.component';
import { UnidadMedidaTipoItem } from '../../inventory/models/unidad-medida-tipo';
import { UnidadMedidaService } from '../../inventory/services/unidad-medida.service';
import { UnidadMedidaItem } from '../../inventory/models/unidad-medida';
import { ArticuloStockService } from '../../inventory/services/articulo-stock.service';
import { ImpuestosAsignacionEditor } from '../../accounting/components/impuesto-asignacion.editor';
export declare class ArticulosEditor extends CatalogEditor {
    protected router: Router;
    protected route: ActivatedRoute;
    private formBuilder;
    protected changeDetector: ChangeDetectorRef;
    protected context: Context;
    private location;
    private articulosService;
    private tipoUnidadService;
    private unidadMedidaService;
    private articuloStockService;
    idArticulo: number;
    idArticuloStock: number;
    codigoNuevo: string;
    articulosVentas: ArticuloInfo;
    tiposUnidad: UnidadMedidaTipoItem[];
    unidadesMedida: UnidadMedidaItem[];
    metodosValuacion: {
        id: string;
        nombre: string;
    }[];
    clasificadores: Clasificacion[];
    articuloImpuestos: ImpuestoAsignacionInfo[];
    artImpCollection: TrackableCollection;
    selectorEstCom: EstComSelectorComponent;
    selectorCuenta: CuentaSelectorComponent;
    selectorCatFlujo: FlujoSelectorComponent;
    selectorMarca: MarcasSelectorComponent;
    selectorCategoriaFiscal: ArticuloCategoriaFiscalComponent;
    articuloImpuestosDialog: ImpuestosAsignacionEditor;
    constructor(router: Router, route: ActivatedRoute, formBuilder: FormBuilder, changeDetector: ChangeDetectorRef, context: Context, location: Location, articulosService: ArticuloService, tipoUnidadService: UnidadMedidaTipoService, unidadMedidaService: UnidadMedidaService, articuloStockService: ArticuloStockService);
    onConfigureCatalog(options: CatalogOptions): void;
    ngAfterViewChecked(): void;
    ngOnInit(): void;
    loadClasificadores(): void;
    loadTiposUnidad(): void;
    onTipoUnidadChanged(idTipoUnidad: any): void;
    loadUnidadesMedida(idTipoUnidad: number): void;
    onSerieCheckChange(): void;
    onCreatingItem(): void;
    onViewingItem(id: number): void;
    onCloningItem(id: number): void;
    onLoadingItem(id: number): void;
    onSavingItem(args: EditorEventArgs): void;
    onSelectTab(args: any): void;
    onToolbarButtonClick(button: ToolbarButton): void;
    onMenuItemClick(item: MenuItem): void;
    onAgregarImpuesto(args: ImpuestoAsignacionInfo): void;
    onRemoveItem(item: any): void;
}
