"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Wijmo
var wijmo_1 = require("wijmo/wijmo");
//Azteca Kernel
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
var editors_1 = require("framework3/editors");
//Features
var unidad_medida_tipo_service_1 = require("../../inventory/services/unidad-medida-tipo.service");
var articulo_service_1 = require("../services/articulo.service");
var articulo_1 = require("../models/articulo");
var est_com_selector_component_1 = require("../controls/est-com-selector.component");
var cuenta_selector_component_1 = require("../../accounting/components/cuenta-selector.component");
var flujo_selector_component_1 = require("../../accounting/components/flujo-selector.component");
var marcas_selector_component_1 = require("../controls/marcas-selector.component");
var articulo_categoria_fiscal_selector_component_1 = require("../../accounting/controls/articulo-categoria-fiscal-selector.component");
var unidad_medida_service_1 = require("../../inventory/services/unidad-medida.service");
var metodo_valuacion_1 = require("../../inventory/models/metodo-valuacion");
var articulo_stock_service_1 = require("../../inventory/services/articulo-stock.service");
var impuesto_asignacion_editor_1 = require("../../accounting/components/impuesto-asignacion.editor");
var ArticulosEditor = /** @class */ (function (_super) {
    __extends(ArticulosEditor, _super);
    function ArticulosEditor(router, route, formBuilder, changeDetector, context, location, articulosService, tipoUnidadService, unidadMedidaService, articuloStockService) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.router = router;
        _this.route = route;
        _this.formBuilder = formBuilder;
        _this.changeDetector = changeDetector;
        _this.context = context;
        _this.location = location;
        _this.articulosService = articulosService;
        _this.tipoUnidadService = tipoUnidadService;
        _this.unidadMedidaService = unidadMedidaService;
        _this.articuloStockService = articuloStockService;
        _this.articulosVentas = new articulo_1.ArticuloInfo();
        _this.tiposUnidad = [];
        _this.unidadesMedida = [];
        _this.metodosValuacion = metodo_valuacion_1.MetodoValuacion.list;
        _this.clasificadores = [];
        _this.articuloImpuestos = [];
        _this.artImpCollection = new editors_1.TrackableCollection();
        _this.catalogForm = formBuilder.group({
            //general
            'codigo': ['', forms_1.Validators.required],
            'nombre': ['', forms_1.Validators.required],
            'cuenta': [''],
            'gtin': [''],
            'tipoUnidad': ['', controls_1.AztecaValidators.selected],
            'unidadAlmacenamiento': ['', controls_1.AztecaValidators.selected],
            'categoriaFiscal': ['', controls_1.AztecaValidators.selected],
            'descripcion': [''],
            //controls
            'manejaSeries': [false],
            'manejaLotes': [false],
            'manejaCaducidad': [false],
            'metodoValuacion': [''],
            //clasificaciones
            'clasificaciones': [[], controls_1.AztecaValidators.validClasifications],
            //Comercial
            'impuestoIncluido': [false],
            'estCom': [''],
            'catFlujo': [''],
            'marcas': [''],
            'modelo': [''],
            'unidadVenta': ['', controls_1.AztecaValidators.selected]
        });
        return _this;
    }
    ArticulosEditor_1 = ArticulosEditor;
    ///////////////////////// METODOS ///////////////////////////////////////
    ///////////////////////// HANDLERS ///////////////////////////////////////
    ArticulosEditor.prototype.onConfigureCatalog = function (options) {
        this.autogeneratedCode = options.codigoAutogenerado;
        this.applyPolicies();
        this.loadClasificadores();
        this.loadTiposUnidad();
    };
    ArticulosEditor.prototype.ngAfterViewChecked = function () {
        this.artImpCollection.sourceCollection = this.articulosVentas.impuestos;
    };
    ArticulosEditor.prototype.ngOnInit = function () {
        var _this = this;
        this.route.params.forEach(function (param) {
            _this.idArticulo = +param['id'];
        });
        this.route.queryParams.forEach(function (params) {
            _this.idArticuloStock = +params['idArticuloStock'] || 0;
        });
        this.route.queryParams.forEach(function (params) {
            _this.codigoNuevo = params['codigoNuevo'];
        });
    };
    ArticulosEditor.prototype.loadClasificadores = function () {
        var _this = this;
        this.articuloStockService.loadClassifiers(this.context.app.defaultSite.identity)
            .then(function (clasificadores) { return _this.clasificadores = clasificadores; })
            .catch(function (error) { return _this.handleError(error); });
    };
    ArticulosEditor.prototype.loadTiposUnidad = function () {
        var _this = this;
        this.tipoUnidadService.loadList()
            .then(function (tipos) { return _this.tiposUnidad = tipos; })
            .catch(function (error) { return _this.handleError(error); });
    };
    ArticulosEditor.prototype.onTipoUnidadChanged = function (idTipoUnidad) {
        this.loadUnidadesMedida(idTipoUnidad);
    };
    ArticulosEditor.prototype.loadUnidadesMedida = function (idTipoUnidad) {
        var _this = this;
        this.unidadMedidaService.loadList(idTipoUnidad)
            .then(function (unidades) { return _this.unidadesMedida = unidades; })
            .catch(function (error) { return _this.handleError(error); });
    };
    ArticulosEditor.prototype.onSerieCheckChange = function () {
        if (this.catalogForm.controls.manejaSeries.value) {
            this.catalogForm.controls.unidadAlmacenamiento.clearValidators();
            this.catalogForm.controls.unidadAlmacenamiento.updateValueAndValidity();
            this.catalogForm.controls.tipoUnidad.clearValidators();
            this.catalogForm.controls.tipoUnidad.updateValueAndValidity();
            this.catalogForm.controls.unidadVenta.clearValidators();
            this.catalogForm.controls.unidadVenta.updateValueAndValidity();
        }
        else {
            this.catalogForm.controls.unidadAlmacenamiento.setValidators(controls_1.AztecaValidators.selected);
            this.catalogForm.controls.unidadAlmacenamiento.updateValueAndValidity();
            this.catalogForm.controls.tipoUnidad.setValidators(controls_1.AztecaValidators.selected);
            this.catalogForm.controls.tipoUnidad.updateValueAndValidity();
            this.catalogForm.controls.unidadVenta.setValidators(controls_1.AztecaValidators.selected);
            this.catalogForm.controls.unidadVenta.updateValueAndValidity();
        }
    };
    ArticulosEditor.prototype.onCreatingItem = function () {
        var _this = this;
        this.context.app.showSpinner();
        this.articulosService.create()
            .then(function (articulo) {
            _this.context.app.hideSpinner();
            _this.articulosVentas = articulo;
            if (_this.idArticuloStock > 0) {
                _this.articuloStockService.getDetailByID(_this.idArticuloStock)
                    .then(function (articuloStock) {
                    _this.context.app.hideSpinner();
                    _this.articulosVentas.articuloStock = articuloStock;
                    _this.loadUnidadesMedida(articuloStock.unidadMedida.idUnidadMedidaTipo);
                })
                    .catch(function (error) { return _this.handleError(error); });
            }
            if (_this.codigoNuevo)
                _this.catalogForm.controls.codigo.patchValue(_this.codigoNuevo);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ArticulosEditor.prototype.onViewingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.articulosService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.articulosVentas = info;
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ArticulosEditor.prototype.onCloningItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.articulosService.clone(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.articulosVentas = info;
            _this.loadUnidadesMedida(info.articuloStock.unidadMedida.idUnidadMedidaTipo);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ArticulosEditor.prototype.onLoadingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.articulosService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.articulosVentas = info;
            _this.loadUnidadesMedida(info.articuloStock.unidadMedida.idUnidadMedidaTipo);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ArticulosEditor.prototype.onSavingItem = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.articulosService.update(this.articulosVentas)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.reset();
            //Si es un elemento nuevo y no se cerrará el editor, navegar a nueva ruta
            if (!args.closeEditor && _this.articulosVentas.identity == 0) {
                _this.router.navigate(['../', info.identity], { relativeTo: _this.route });
            }
            else {
                if (args.closeEditor)
                    _this.router.navigate(['../'], { relativeTo: _this.route });
                else
                    _this.showAlert('La información ha sido actualizada con éxito', 'success');
            }
            _this.articulosVentas = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ArticulosEditor.prototype.onSelectTab = function (args) {
        if (args.heading) {
            wijmo_1.Control.invalidateAll();
        }
    };
    ArticulosEditor.prototype.onToolbarButtonClick = function (button) {
        if (button.name == 'ADD') {
            this.articuloImpuestosDialog.show();
        }
    };
    ArticulosEditor.prototype.onMenuItemClick = function (item) {
        if (item.name == 'LP') {
            this.router.navigate(['sales/articulo-listas-precio/' + this.process.id + '/' + this.articulosVentas.identity.toString()]);
        }
        else if (item.name == 'GD') {
            this.router.navigate(['sales/articulo-grupo-descuento/' + this.process.id + '/' + this.articulosVentas.identity.toString()]);
        }
    };
    ArticulosEditor.prototype.onAgregarImpuesto = function (args) {
        var _this = this;
        var impuestoExists = false;
        this.articulosVentas.impuestos.forEach(function (articuloImp) {
            if (articuloImp.idImpuesto == args.idImpuesto && articuloImp.state != 'DELETED') {
                _this.showAlert("El impuesto ya fue agregado", "información");
                impuestoExists = true;
            }
        });
        if (!impuestoExists) {
            this.articulosVentas.impuestos.push(args);
            this.artImpCollection.refresh();
        }
    };
    ArticulosEditor.prototype.onRemoveItem = function (item) {
        this.articulosVentas.impuestos.forEach(function (x) {
            if (x.idImpuesto == item.idImpuesto)
                x.state = 'DELETED';
        });
        this.artImpCollection.remove(item);
        this.artImpCollection.refresh();
    };
    __decorate([
        core_1.ViewChild('selectorEstCom'),
        __metadata("design:type", est_com_selector_component_1.EstComSelectorComponent)
    ], ArticulosEditor.prototype, "selectorEstCom", void 0);
    __decorate([
        core_1.ViewChild('selectorCuenta'),
        __metadata("design:type", cuenta_selector_component_1.CuentaSelectorComponent)
    ], ArticulosEditor.prototype, "selectorCuenta", void 0);
    __decorate([
        core_1.ViewChild('selectorCatFlujo'),
        __metadata("design:type", flujo_selector_component_1.FlujoSelectorComponent)
    ], ArticulosEditor.prototype, "selectorCatFlujo", void 0);
    __decorate([
        core_1.ViewChild('selectorMarca'),
        __metadata("design:type", marcas_selector_component_1.MarcasSelectorComponent)
    ], ArticulosEditor.prototype, "selectorMarca", void 0);
    __decorate([
        core_1.ViewChild('selectorCategoriaFiscal'),
        __metadata("design:type", articulo_categoria_fiscal_selector_component_1.ArticuloCategoriaFiscalComponent)
    ], ArticulosEditor.prototype, "selectorCategoriaFiscal", void 0);
    __decorate([
        core_1.ViewChild(impuesto_asignacion_editor_1.ImpuestosAsignacionEditor),
        __metadata("design:type", impuesto_asignacion_editor_1.ImpuestosAsignacionEditor)
    ], ArticulosEditor.prototype, "articuloImpuestosDialog", void 0);
    ArticulosEditor = ArticulosEditor_1 = __decorate([
        core_1.Component({
            selector: 'ventas-articulos-ventas-editor',
            template: "\n      <form [formGroup]=\"catalogForm\">\n\n          <azteca-catalog-editor #catalogEditor\n                                 [title]=\"'Edici\u00F3n de Art\u00EDculos'\"\n                                 [info]=\"articulosVentas\"\n                                 [valid]=\"valid\"\n                                 (configureCatalog)=\"onConfigureCatalog($event)\"\n                                 (creatingItem)=\"onCreatingItem()\"\n                                 (viewingItem)=\"onViewingItem($event)\"\n                                 (cloningItem)=\"onCloningItem($event)\"\n                                 (savingItem)=\"onSavingItem($event)\"\n                                 (loadingItem)=\"onLoadingItem($event)\"\n                                 (menuItemClick)=\"onMenuItemClick($event)\">\n\n\n              <!--Toolbar Principal-->\n              <azteca-menu-item [name]=\"'LP'\" [icon]=\"'glyphicon glyphicon-usd'\" [text]=\"'Listas de Precios'\" [smallText]=\"'configuraci\u00F3n de listas de precios'\"></azteca-menu-item>\n              <azteca-menu-item [name]=\"'GD'\" [icon]=\"'glyphicon glyphicon-gift'\" [text]=\"'Grupos de Descuentos'\" [smallText]=\"'configuraci\u00F3n de grupos de gescuentos'\"></azteca-menu-item>\n\n              <!------------------- Controles del editor ----------------------------->\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-lg-5\">\n                      <azteca-form-field [label]=\"'C\u00F3digo:'\">\n                          <catalog-code formControlName=\"codigo\" [(ngModel)]=\"articulosVentas.articuloStock.code\" [automatic]=\"autogeneratedCode\"></catalog-code>\n                      </azteca-form-field>\n                  </div>\n                  <div class=\"col-12 col-lg-5\">\n                      <azteca-form-field [label]=\"'Nombre:'\">\n                          <az-textbox formControlName=\"nombre\" [(ngModel)]=\"articulosVentas.articuloStock.nombre\"></az-textbox>\n                      </azteca-form-field>\n                  </div>\n              </div>\n\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-lg-10\">\n                      <tabset>\n                          <!------------------------------------------ GENERALES ----------------------------------->\n                          <tab heading=\"Datos Generales\" (select)=\"onSelectTab($event)\">\n\n                              <div>\n                                  <div class=\"col-12\">\n                                      <azteca-form-field [label]=\"'Categoria Fiscal'\">\n                                          <accounting-articulo-categoria-fiscal-selector formControlName=\"categoriaFiscal\" [(ngModel)]=\"articulosVentas.articuloStock.idCategoriaFiscal\" #selectorCategoriaFiscal></accounting-articulo-categoria-fiscal-selector>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div>\n                                  <div class=\"col-12\">\n                                      <azteca-form-field [label]=\"'GTIN:'\">\n                                          <az-textbox formControlName=\"gtin\" [(ngModel)]=\"articulosVentas.articuloStock.gtin\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <!--Mostrar s\u00F3lo si se manejan series-->\n                              <label *ngIf=\"articulosVentas.articuloStock.manejaSeries\" class=\"control-label\">Unidad de medida:</label>\n                              <az-label *ngIf=\"articulosVentas.articuloStock.manejaSeries\" [text]=\"'Piezas'\"></az-label>\n\n                              <div>\n                                  <div class=\"col-12\">\n                                      <azteca-form-field [label]=\"'Descripci\u00F3n'\">\n                                          <az-textarea formControlName=\"descripcion\" [(ngModel)]=\"articulosVentas.articuloStock.descripcion\"></az-textarea>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                          </tab>\n                          <!------------------------------------------ CONTROLES ----------------------------------->\n                          <tab heading=\"Controles\" (select)=\"onSelectTab($event)\">\n                              <az-checkbox [label]=\"'Requiere control por n\u00FAmero de serie'\" formControlName=\"manejaSeries\" [(ngModel)]=\"articulosVentas.articuloStock.manejaSeries\" (change)=\"onSerieCheckChange()\"></az-checkbox>\n                              <az-checkbox [label]=\"'Requiere control por lotes'\" formControlName=\"manejaLotes\" [(ngModel)]=\"articulosVentas.articuloStock.manejaLotes\"></az-checkbox>\n                              <az-checkbox [label]=\"'Requiere control de fechas de caducidad'\" formControlName=\"manejaCaducidad\" [(ngModel)]=\"articulosVentas.articuloStock.manejaCaducidad\"></az-checkbox>\n\n                              <azteca-form-field *ngIf=\"articulosVentas.articuloStock.manejaLotes\" [label]=\"'M\u00E9todo de valuaci\u00F3n de inventario:'\">\n                                  <az-combobox formControlName=\"metodoValuacion\" [(ngModel)]=\"articulosVentas.articuloStock.metodoValuacion\" [items]=\"metodosValuacion\" [valueMember]=\"'id'\" [displayMember]=\"'nombre'\"></az-combobox>\n                              </azteca-form-field>\n                          </tab>\n\n                          <!------------------------------------------ UNIDADES DE MEDIDA ----------------------------------->\n                          <tab heading=\"Unidades de Medida\" (select)=\"onSelectTab($event)\">\n                              <div class=\"row\">\n                                  <div class=\"col-12\">\n                                      <azteca-form-field *ngIf=\"!articulosVentas.articuloStock.manejaSeries\" [label]=\"'Tipo de Unidad:'\">\n                                          <az-combobox formControlName=\"tipoUnidad\"\n                                                       [(ngModel)]=\"articulosVentas.articuloStock.unidadMedida.idUnidadMedidaTipo\"\n                                                       [items]=\"tiposUnidad\"\n                                                       [valueMember]=\"'id'\"\n                                                       [displayMember]=\"'nombre'\"\n                                                       (selectedItemChanged)=\"onTipoUnidadChanged($event)\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12\">\n                                      <azteca-form-field *ngIf=\"!articulosVentas.articuloStock.manejaSeries\" [label]=\"'Unidad de Almacenamiento:'\">\n                                          <az-combobox formControlName=\"unidadAlmacenamiento\"\n                                                       [(ngModel)]=\"articulosVentas.articuloStock.idUnidadMedida\"\n                                                       [items]=\"unidadesMedida\"\n                                                       [valueMember]=\"'id'\"\n                                                       [displayMember]=\"'nombre'\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12\">\n                                      <azteca-form-field *ngIf=\"!articulosVentas.articuloStock.manejaSeries\" [label]=\"'Unidad de Venta:'\">\n                                          <az-combobox formControlName=\"unidadVenta\"\n                                                       [(ngModel)]=\"articulosVentas.idUnidadMedida\"\n                                                       [items]=\"unidadesMedida\"\n                                                       [valueMember]=\"'id'\"\n                                                       [displayMember]=\"'nombre'\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n                              <div>\n                                  <label *ngIf=\"articulosVentas.articuloStock.manejaSeries\" class=\"control-label\">Unidad de medida:</label>\n                                  <az-label *ngIf=\"articulosVentas.articuloStock.manejaSeries\" [text]=\"'Piezas'\"></az-label>\n                              </div>\n                          </tab>\n                          <!------------------------------------------ CLASIFICACIONES ----------------------------------->\n                          <tab heading=\"Clasificaciones\" (select)=\"onSelectTab($event)\">\n                              <az-clasificaciones-editor formControlName=\"clasificaciones\" [(ngModel)]=\"articulosVentas.articuloStock.clasificaciones\" [clasificadores]=\"clasificadores\">\n\n                              </az-clasificaciones-editor>\n                          </tab>\n\n                          <!------------------------------------------ COMERCIALES ----------------------------------->\n                          <tab heading=\"Comercial\" (select)=\"onSelectTab($event)\">\n                              <div class=\"row\">\n                                  <div class=\"col-12\">\n                                      <azteca-form-field [label]=\"'Cuenta:'\">\n                                          <accounting-cuenta-selector formControlName=\"cuenta\" [(ngModel)]=\"articulosVentas.idCuenta\" [showListButton]=\"true\" #selectorCuenta></accounting-cuenta-selector>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12\">\n                                      <azteca-form-field [label]=\"'Estructura Comercial:'\">\n                                          <sales-est-com-selector formControlName=\"estCom\" [(ngModel)]=\"articulosVentas.idEstCom\" [showListButton]=\"true\" #selectorEstCom></sales-est-com-selector>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n                              <div class=\"row\">\n                                  <div class=\"col-12\">\n                                      <azteca-form-field [label]=\"'Cat. Flujo:'\">\n                                          <accounting-flujo-selector formControlName=\"catFlujo\" [(ngModel)]=\"articulosVentas.idFlujo\" [showListButton]=\"true\" #selectorCatFlujo></accounting-flujo-selector>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n                              <div class=\"row\">\n                                  <div class=\"col-12\">\n                                      <azteca-form-field [label]=\"'Marcas:'\">\n                                          <sales-marcas-selector formControlName=\"marcas\" [(ngModel)]=\"articulosVentas.idMarca\" [showListButton]=\"true\" #selectorMarca></sales-marcas-selector>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n                              <div class=\"row\">\n                                  <div class=\"col-12\">\n                                      <azteca-form-field [label]=\"'Modelo:'\">\n                                          <az-textbox formControlName=\"modelo\" [(ngModel)]=\"articulosVentas.modelo\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n                              <div>\n                                  <azteca-form-field [label]=\"''\">\n                                      <az-checkbox formControlName=\"impuestoIncluido\" [(ngModel)]=\"articulosVentas.impuestoIncluido\" [label]=\"'Impuesto Incluido'\"></az-checkbox>\n                                  </azteca-form-field>\n                              </div>\n\n                          </tab>\n                          <!------------------------------------------ IMPUESTOS ----------------------------------->\n                          <tab heading=\"Impuestos\" (select)=\"onSelectTab($event)\">                          \n                              <!--Toolbar Principal-->\n                              <az-toolbar (buttonClick)=\"onToolbarButtonClick($event)\">\n                                  <az-toolbar-button [name]=\"'ADD'\" [type]=\"'primary'\" [text]=\"'Agregar Impuesto'\" [icon]=\"'glyphicon glyphicon-plus'\"></az-toolbar-button>\n                              </az-toolbar>\n\n                              <wj-flex-grid #gridArticuloImpuestos style=\"height:550px\"\n                                              [itemsSource]=\"artImpCollection\">\n\n                                  <wj-flex-grid-column [width]=\"55\" [isReadOnly]=\"true\">\n                                      <ng-template wjFlexGridCellTemplate [cellType]=\"'Cell'\" let-cell=\"cell\">\n                                          <button type=\"button\" class=\"btn btn-default\" (click)=\"onRemoveItem(cell.item)\">\n                                              <span class=\"glyphicon glyphicon-trash\"></span>\n                                          </button>\n                                      </ng-template>\n                                  </wj-flex-grid-column>\n\n                                  <wj-flex-grid-column [header]=\"'C\u00F3digo'\" [binding]=\"'impuesto.code'\" [width]=\"'20*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'Impuesto'\" [binding]=\"'impuesto.nombre'\" [width]=\"'30*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'Tasa \u00F3 cuota'\" [binding]=\"'tasaOCuota'\" [width]=\"'30*'\" [isReadOnly]=\"true\" format=\"n2\"></wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'Orden calculo'\" [binding]=\"'ordenCalculo'\" [width]=\"'25*'\" [isReadOnly]=\"true\" format=\"n0\"></wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'Tipo calculo'\" [binding]=\"'tipoCalculo'\" [width]=\"'25*'\" [isReadOnly]=\"true\" format=\"n0\"></wj-flex-grid-column>\n                              </wj-flex-grid>\n                          </tab>\n                      </tabset>\n                  </div>\n              </div>\n\n          </azteca-catalog-editor>\n\n          <accounting-impuesto-asignacion (dataUpdater)=\"onAgregarImpuesto($event)\">\n\n          </accounting-impuesto-asignacion>\n      </form>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return ArticulosEditor_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: articulo_service_1.ArticuloService
                }
            ]
        }),
        __metadata("design:paramtypes", [router_1.Router, router_1.ActivatedRoute, forms_1.FormBuilder, core_1.ChangeDetectorRef,
            core_2.Context, common_1.Location, articulo_service_1.ArticuloService, unidad_medida_tipo_service_1.UnidadMedidaTipoService,
            unidad_medida_service_1.UnidadMedidaService, articulo_stock_service_1.ArticuloStockService])
    ], ArticulosEditor);
    return ArticulosEditor;
    var ArticulosEditor_1;
}(editors_1.CatalogEditor));
exports.ArticulosEditor = ArticulosEditor;
