import { Router, ActivatedRoute } from '@angular/router';
import { Context, CatalogItem } from 'framework3/core';
import { CatalogOptions } from 'framework3/custom';
import { CatalogManager } from 'framework3/editors';
import { SearchRequest } from 'framework3/search';
import { MenuItem } from 'framework3/controls';
import { ArticuloService } from '../services/articulo.service';
import { ArticuloItem } from '../models/articulo';
import { ArticuloNuevoComponent } from '../components/nuevo-articulo.component';
export declare class ArticulosManager extends CatalogManager {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    private articulosService;
    articulos: ArticuloItem[];
    options: CatalogOptions;
    currentItem: CatalogItem;
    articulosDialog: ArticuloNuevoComponent;
    constructor(context: Context, router: Router, route: ActivatedRoute, articulosService: ArticuloService);
    onConfigureCatalog(options: CatalogOptions): void;
    doSearch(request: SearchRequest): void;
    onAddingItem(): void;
    onViewingItem(item: CatalogItem): void;
    onEditingItem(item: CatalogItem): void;
    onDeletingItem(item: CatalogItem): void;
    onCloningItem(item: CatalogItem): void;
    onChangingItemState(item: CatalogItem): void;
    onCurrentItemChanged(item: CatalogItem): void;
    onMenuItemClick(item: MenuItem): void;
}
