"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//Features
var cliente_service_1 = require("../services/cliente.service");
var ClientesManager = /** @class */ (function (_super) {
    __extends(ClientesManager, _super);
    //    
    function ClientesManager(router, route, context, clienteService) {
        var _this = _super.call(this, context, router, route) || this;
        _this.router = router;
        _this.route = route;
        _this.context = context;
        _this.clienteService = clienteService;
        _this.clientes = [];
        return _this;
    }
    ClientesManager_1 = ClientesManager;
    ///////////////////////// METODOS ///////////////////////////////////////
    ClientesManager.prototype.enviarRegistro = function () {
        var _this = this;
        this.clienteService.enviarRegistro(this.manager.currentItem.id)
            .then(function (_) {
            _this.showAlert('Se ha enviado un correo electrónico con la invitaicón de registro', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ///////////////////////// HANDLERS ///////////////////////////////////////
    ClientesManager.prototype.onConfigureCatalog = function (options) {
        this.manager.serverSide = options.busquedasServidor;
        this.manager.pageSize = options.tamanioPagina;
        this.refreshList();
    };
    ClientesManager.prototype.doSearch = function (request) {
        var _this = this;
        this.context.app.showSpinner();
        this.clienteService.search(this.context.app.defaultSite.identity, request)
            .then(function (response) {
            _this.context.app.hideSpinner();
            //
            _this.clientes = response.rows;
            _this.totalRows = response.totalRows;
            _this.pageIndex = request.pageIndex;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ClientesManager.prototype.onAddingItem = function () {
        this.router.navigate([0], { relativeTo: this.route });
    };
    ClientesManager.prototype.onViewingItem = function (item) {
        this.router.navigate([item.id, { readonly: true }], { relativeTo: this.route });
    };
    ClientesManager.prototype.onEditingItem = function (item) {
        this.router.navigate([item.id], { relativeTo: this.route });
    };
    ClientesManager.prototype.onDeletingItem = function (item) {
        var _this = this;
        this.clienteService.delete(item.id)
            .then(function (success) {
            _this.refreshList();
            _this.showAlert('El registro ha sido eliminado con éxito.', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ClientesManager.prototype.onCloningItem = function (item) {
        this.router.navigate([0, { cloneId: item.id }], { relativeTo: this.route });
    };
    ClientesManager.prototype.onChangingItemState = function (item) {
        var _this = this;
        this.clienteService.changeStatus(item.id, !item.activo)
            .then(function (success) {
            _this.refreshList();
            _this.showAlert('El estatus del registro ha sido actualizado con éxito.', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ClientesManager.prototype.onMenuItemClick = function (option) {
        if (option.name == 'REGISTRO') {
            this.enviarRegistro();
        }
    };
    ClientesManager = ClientesManager_1 = __decorate([
        core_1.Component({
            selector: 'ventas-clientes-manager',
            template: "\n      <azteca-catalog-manager (searchRequested)=\"doSearch($event)\"\n                              (addingItem)=\"onAddingItem()\"\n                              (viewingItem)=\"onViewingItem($event)\"\n                              (editingItem)=\"onEditingItem($event)\"\n                              (deletingItem)=\"onDeletingItem($event)\"\n                              (cloningItem)=\"onCloningItem($event)\"\n                              (changingItemState)=\"onChangingItemState($event)\"\n      \t\t\t\t\t\t(configureCatalog)=\"onConfigureCatalog($event)\"\n                              (menuItemClick)=\"onMenuItemClick($event)\"\n                              [enabled]=\"enabled\"\n                              [allowNew]=\"allowNew\"\n                              [allowView]=\"allowView\"\n                              [allowEdit]=\"allowEdit\"\n                              [allowDelete]=\"allowDelete\"\n                              [allowClone]=\"allowClone\"\n                              [allowChangeState]=\"allowChangeState\"\n                              [catalogList]=\"clientes\"\n                              [totalRows]=\"totalRows\"\n                              [pageIndex]=\"pageIndex\">\n\n          <!------------------- Menu de acciones adicionales --------------------->\n\n          <azteca-menu-item [name]=\"'REGISTRO'\" [icon]=\"'glyphicon glyphicon-send'\" [text]=\"'Enviar invitaci\u00F3n'\" [smallText]=\"'enviar correo de registro al portal'\" [enabled]=\"true\"></azteca-menu-item>\n\n          <!------------------- Columnas del listado ----------------------------->\n    \n          <azteca-grid-column [header]=\"'C\u00F3digo'\" [binding]=\"'codigo'\" [width]=\"'10*'\"></azteca-grid-column>\n          <azteca-grid-column [header]=\"'Nombre'\" [binding]=\"'nombre'\" [width]=\"'40*'\"></azteca-grid-column>\n          <azteca-grid-column [header]=\"'RFC'\" [binding]=\"'rfc'\" [width]=\"'20*'\"></azteca-grid-column>\n          <azteca-grid-column [header]=\"'Raz\u00F3n social'\" [binding]=\"'razonSocial'\" [width]=\"'40*'\"></azteca-grid-column>\n          <azteca-grid-column [header]=\"'Cond. Pago'\" [binding]=\"'condicionesPago'\" [width]=\"'10*'\"></azteca-grid-column>\n\n      </azteca-catalog-manager>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return ClientesManager_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: cliente_service_1.ClienteService
                }
            ]
        }),
        __metadata("design:paramtypes", [router_1.Router, router_1.ActivatedRoute, core_2.Context, cliente_service_1.ClienteService])
    ], ClientesManager);
    return ClientesManager;
    var ClientesManager_1;
}(editors_1.CatalogManager));
exports.ClientesManager = ClientesManager;
