import { ChangeDetectorRef } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { Context, SucursalService as SucursalKernelService } from 'framework3/core';
import { CatalogOptions } from 'framework3/custom';
import { CatalogEditor, EditorEventArgs } from 'framework3/editors';
import { EmpresaService } from '../services/empresa.service';
import { EmpresaInfo } from '../models/empresa';
import { SucursalItem } from '../models/sucursal';
import { SucursalService } from '../services/sucursal.service';
export declare class EmpresasEditor extends CatalogEditor {
    protected router: Router;
    protected route: ActivatedRoute;
    private formBuilder;
    protected changeDetector: ChangeDetectorRef;
    protected context: Context;
    private location;
    private empresaService;
    private sucursalService;
    private sucursalKernelService;
    empresa: EmpresaInfo;
    sucursales: SucursalItem[];
    solicitarMetodosPagoCredito: {
        id: boolean;
        nombre: string;
    }[];
    modalidadCobroContado: {
        id: string;
        nombre: string;
    }[];
    modalidadesPrecio: {
        id: string;
        nombre: string;
    }[];
    politicasDescuento: {
        id: string;
        nombre: string;
    }[];
    constructor(router: Router, route: ActivatedRoute, formBuilder: FormBuilder, changeDetector: ChangeDetectorRef, context: Context, location: Location, empresaService: EmpresaService, sucursalService: SucursalService, sucursalKernelService: SucursalKernelService);
    onConfigureCatalog(options: CatalogOptions): void;
    onCreatingItem(): void;
    onViewingItem(id: number): void;
    onCloningItem(id: number): void;
    onLoadingItem(id: number): void;
    onSavingItem(args: EditorEventArgs): void;
    selectSucursalesTab(arg: any): void;
    loadSucursales(): void;
}
