import { ChangeDetectorRef } from '@angular/core';
import { FormBuilder } from '@angular/forms';
import { Router, ActivatedRoute } from '@angular/router';
import { TreeNode } from 'angular-tree-component';
import { Context, HierarchyChanges } from 'framework3/core';
import { CatalogOptions } from 'framework3/custom';
import { HierarchyManager } from 'framework3/editors';
import { EstructuraComercialInfo } from '../models/estructura-comercial';
import { EstructuraComercialService } from '../services/estructura-comercial.service';
export declare class EstComManager extends HierarchyManager {
    protected context: Context;
    protected changeDetector: ChangeDetectorRef;
    private formBuilder;
    private estructuraComercialService;
    protected router: Router;
    protected route: ActivatedRoute;
    estCom: EstructuraComercialInfo[];
    estructuraComercialEdicion: EstructuraComercialInfo;
    currentNode: TreeNode;
    currentParent: TreeNode;
    constructor(context: Context, changeDetector: ChangeDetectorRef, formBuilder: FormBuilder, estructuraComercialService: EstructuraComercialService, router: Router, route: ActivatedRoute);
    loadHierarchy(): void;
    onConfigureCatalog(options: CatalogOptions): void;
    onNodesChanged(estCom: EstructuraComercialInfo[]): void;
    onCurrentNodeChanged(node: TreeNode): void;
    onCreatingNode(parentNode: TreeNode): void;
    onEditingNode(node: TreeNode): void;
    onSavingNode(): void;
    onDeletingNode(node: TreeNode): void;
    onSavingHierarchy(changes: HierarchyChanges<EstructuraComercialInfo>): void;
}
