import { ChangeDetectorRef } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { Context } from 'framework3/core';
import { CatalogOptions } from 'framework3/custom';
import { ToolbarButton, MenuItem } from 'framework3/controls';
import { CatalogEditor, EditorEventArgs, EditableListComponent, TrackableCollection } from 'framework3/editors';
import { ImpuestoAsignacionInfo, ImpuestosAsignacionEditor } from '../../accounting';
import { ServicioService } from '../services/servicio.service';
import { ServicioInfo } from '../models/servicio';
import { UnidadMedidaService } from '../../inventory/services/unidad-medida.service';
import { UnidadMedidaItem } from '../../inventory/models/unidad-medida';
import { UnidadMedidaTipoItem, UnidadMedidaTipoInfo } from '../../inventory/models/unidad-medida-tipo';
import { UnidadMedidaTipoService } from '../../inventory/services/unidad-medida-tipo.service';
export declare class ServiciosEditor extends CatalogEditor {
    protected router: Router;
    protected route: ActivatedRoute;
    private formBuilder;
    protected changeDetector: ChangeDetectorRef;
    protected context: Context;
    private location;
    private servicioService;
    private unidadMedidaService;
    private tipoUnidadService;
    servicio: ServicioInfo;
    impuestosCollection: TrackableCollection;
    tiposUnidad: UnidadMedidaTipoItem[];
    unidadesMedida: UnidadMedidaItem[];
    unidadMedidaTipo: UnidadMedidaTipoInfo;
    constructor(router: Router, route: ActivatedRoute, formBuilder: FormBuilder, changeDetector: ChangeDetectorRef, context: Context, location: Location, servicioService: ServicioService, unidadMedidaService: UnidadMedidaService, tipoUnidadService: UnidadMedidaTipoService);
    impuestosList: EditableListComponent;
    impuestoEditor: ImpuestosAsignacionEditor;
    loadTiposUnidad(): void;
    loadUnidadesMedida(idTipoUnidad: number): void;
    onConfigureCatalog(options: CatalogOptions): void;
    onCreatingItem(): void;
    onViewingItem(id: number): void;
    onCloningItem(id: number): void;
    onLoadingItem(id: number): void;
    onSavingItem(args: EditorEventArgs): void;
    onTabSelected(): void;
    onImpuestosToolbar(button: ToolbarButton): void;
    onMenuItemClick(item: MenuItem): void;
    onRemoveItem(impuesto: ImpuestoAsignacionInfo): void;
    onImpuestoUpdated(impuesto: ImpuestoAsignacionInfo): void;
}
