import { ChangeDetectorRef } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { Context } from 'framework3/core';
import { CatalogOptions } from 'framework3/custom';
import { CatalogEditor, EditorEventArgs } from 'framework3/editors';
import { FormatoItem, FormatoTipoService } from 'framework3/general';
import { SucursalService } from '../services/sucursal.service';
import { SucursalInfo } from '../models/sucursal';
import { UnidadNegocioItem } from '../models/unidad-negocio';
import { UnidadNegocioService } from '../services/unidad-negocio.service';
import { DivisaItem } from '../../accounting/models/divisa';
import { DivisaService } from '../../accounting/services/divisa.service';
import { ListaPreciosService } from '../services/lista-precios.service';
import { GrupoDescuentoService } from '../services/grupo-descuento.service';
import { RegionItem } from '../models/region';
import { RegionService } from '../services/region.service';
import { ZonaVentaItem } from '../models/zona-venta';
import { ZonaVentaService } from '../services/zona-venta.service';
export declare class SucursalesEditor extends CatalogEditor {
    protected router: Router;
    protected route: ActivatedRoute;
    private formBuilder;
    protected changeDetector: ChangeDetectorRef;
    protected context: Context;
    private location;
    private sucursalService;
    private divisaService;
    private formatoTipoService;
    private listaPreciosService;
    private grupoDescuentoService;
    private unidadNegocioService;
    private regionService;
    private zonaVentaService;
    sucursal: SucursalInfo;
    unidadesNegocio: UnidadNegocioItem[];
    divisas: DivisaItem[];
    listasPrecio: FormatoItem[];
    gruposDescuento: FormatoItem[];
    regiones: RegionItem[];
    zonasVenta: ZonaVentaItem[];
    constructor(router: Router, route: ActivatedRoute, formBuilder: FormBuilder, changeDetector: ChangeDetectorRef, context: Context, location: Location, sucursalService: SucursalService, divisaService: DivisaService, formatoTipoService: FormatoTipoService, listaPreciosService: ListaPreciosService, grupoDescuentoService: GrupoDescuentoService, unidadNegocioService: UnidadNegocioService, regionService: RegionService, zonaVentaService: ZonaVentaService);
    onConfigureCatalog(options: CatalogOptions): void;
    onCreatingItem(): void;
    onViewingItem(id: number): void;
    onCloningItem(id: number): void;
    onLoadingItem(id: number): void;
    onSavingItem(args: EditorEventArgs): void;
    loadDivisas(): void;
    selectUnidadesNegocioTab(arg: any): void;
    loadUnidadesNegocio(): void;
    loadRegiones(): void;
    loadZonasVenta(): void;
    loadListasPrecio(): void;
    loadGruposDescuento(): void;
    onCancelingEdit(): void;
}
