"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Azteca Kernel
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
var editors_1 = require("framework3/editors");
var search_1 = require("framework3/search");
var general_1 = require("framework3/general");
//Features
var sucursal_service_1 = require("../services/sucursal.service");
var sucursal_1 = require("../models/sucursal");
var unidad_negocio_service_1 = require("../services/unidad-negocio.service");
var divisa_service_1 = require("../../accounting/services/divisa.service");
var lista_precios_service_1 = require("../services/lista-precios.service");
var grupo_descuento_service_1 = require("../services/grupo-descuento.service");
var wijmo_1 = require("wijmo/wijmo");
var region_service_1 = require("../services/region.service");
var zona_venta_service_1 = require("../services/zona-venta.service");
var SucursalesEditor = /** @class */ (function (_super) {
    __extends(SucursalesEditor, _super);
    //
    function SucursalesEditor(router, route, formBuilder, changeDetector, context, location, sucursalService, divisaService, formatoTipoService, listaPreciosService, grupoDescuentoService, unidadNegocioService, regionService, zonaVentaService) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.router = router;
        _this.route = route;
        _this.formBuilder = formBuilder;
        _this.changeDetector = changeDetector;
        _this.context = context;
        _this.location = location;
        _this.sucursalService = sucursalService;
        _this.divisaService = divisaService;
        _this.formatoTipoService = formatoTipoService;
        _this.listaPreciosService = listaPreciosService;
        _this.grupoDescuentoService = grupoDescuentoService;
        _this.unidadNegocioService = unidadNegocioService;
        _this.regionService = regionService;
        _this.zonaVentaService = zonaVentaService;
        _this.sucursal = new sucursal_1.SucursalInfo();
        _this.unidadesNegocio = [];
        _this.divisas = [];
        _this.listasPrecio = [];
        _this.gruposDescuento = [];
        _this.regiones = [];
        _this.zonasVenta = [];
        _this.catalogForm = formBuilder.group({
            'codigo': [''],
            'idDivisaBase': ['', controls_1.AztecaValidators.selected],
            'idListaPrecio': ['', controls_1.AztecaValidators.selected],
            'idGrupoDescuento': ['', controls_1.AztecaValidators.selected],
            'idRegion': ['', forms_1.Validators.required],
            'idZonaVenta': ['', forms_1.Validators.required],
            'idCuenta': ['']
        });
        return _this;
    }
    SucursalesEditor_1 = SucursalesEditor;
    ///////////////////////// METODOS ///////////////////////////////////////
    ///////////////////////// HANDLERS ///////////////////////////////////////
    SucursalesEditor.prototype.onConfigureCatalog = function (options) {
        this.autogeneratedCode = options.codigoAutogenerado;
        this.applyPolicies();
        this.loadRegiones();
        this.loadZonasVenta();
    };
    SucursalesEditor.prototype.onCreatingItem = function () {
    };
    SucursalesEditor.prototype.onViewingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.sucursalService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.sucursal = info;
            _this.setReadonlyMode();
            _this.loadUnidadesNegocio();
            _this.loadDivisas();
            _this.loadListasPrecio();
            _this.loadGruposDescuento();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    SucursalesEditor.prototype.onCloningItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.sucursalService.clone(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.sucursal = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    SucursalesEditor.prototype.onLoadingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.sucursalService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.sucursal = info;
            _this.sucursal.identity = info.sucursalBase.identity;
            _this.loadUnidadesNegocio();
            _this.loadDivisas();
            _this.loadListasPrecio();
            _this.loadGruposDescuento();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    SucursalesEditor.prototype.onSavingItem = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.sucursalService.update(this.sucursal)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.reset();
            //Si es un elemento nuevo y no se cerrará el editor, navegar a nueva ruta
            if (!args.closeEditor && _this.sucursal.identity == 0) {
                _this.router.navigate(['../', _this.process.id, info.identity]);
            }
            else {
                if (args.closeEditor)
                    _this.location.back();
                else
                    _this.showAlert('La información ha sido actualizada con éxito', 'success');
            }
            _this.sucursal = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    SucursalesEditor.prototype.loadDivisas = function () {
        var _this = this;
        this.divisaService.loadList(this.sucursal.idCompany)
            .then(function (divisas) { return _this.divisas = divisas; })
            .catch(function (error) { return _this.handleError(error); });
    };
    //Manejo de Estados
    SucursalesEditor.prototype.selectUnidadesNegocioTab = function (arg) {
        wijmo_1.Control.invalidateAll();
    };
    SucursalesEditor.prototype.loadUnidadesNegocio = function () {
        var _this = this;
        var request = new search_1.SearchRequest();
        request.paged = false;
        //Agregar condición de empresa actual
        var condicionServidorSMTP = { field: "idSucursal", operator: "=", valueType: "int", value: this.sucursal.identity.toString() };
        request.conditions.push(condicionServidorSMTP);
        //
        this.context.app.showSpinner();
        this.unidadNegocioService.search(this.sucursal.identity, request)
            .then(function (response) {
            _this.context.app.hideSpinner();
            //
            _this.unidadesNegocio = response.rows;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    SucursalesEditor.prototype.loadRegiones = function () {
        var _this = this;
        this.regionService.loadList(this.context.app.defaultCompany.identity)
            .then(function (regiones) { return _this.regiones = regiones; })
            .catch(function (error) { return _this.handleError(error); });
    };
    SucursalesEditor.prototype.loadZonasVenta = function () {
        var _this = this;
        this.zonaVentaService.loadList(this.context.app.defaultCompany.identity.toString())
            .then(function (zonasVenta) { return _this.zonasVenta = zonasVenta; })
            .catch(function (error) { return _this.handleError(error); });
    };
    SucursalesEditor.prototype.loadListasPrecio = function () {
        var _this = this;
        this.listaPreciosService.loadList(this.sucursal.identity)
            .then(function (listas) { return _this.listasPrecio = listas; })
            .catch(function (error) { return _this.handleError(error); });
    };
    SucursalesEditor.prototype.loadGruposDescuento = function () {
        var _this = this;
        this.grupoDescuentoService.loadList(this.sucursal.identity)
            .then(function (grupos) { return _this.gruposDescuento = grupos; })
            .catch(function (error) { return _this.handleError(error); });
    };
    SucursalesEditor.prototype.onCancelingEdit = function () {
        this.location.back();
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", Array)
    ], SucursalesEditor.prototype, "unidadesNegocio", void 0);
    SucursalesEditor = SucursalesEditor_1 = __decorate([
        core_1.Component({
            selector: 'ventas-sucursales-editor',
            template: "\n      <form [formGroup]=\"catalogForm\">\n\n          <azteca-catalog-editor #catalogEditor \n                                 [title]=\"'Configuraci\u00F3n de la sucursal'\"\n                                 [info]=\"sucursal\"\n                                 [valid]=\"valid\"\n                                 (configureCatalog)=\"onConfigureCatalog($event)\"\n                                 (creatingItem)=\"onCreatingItem()\"\n                                 (viewingItem)=\"onViewingItem($event)\"\n                                 (cloningItem)=\"onCloningItem($event)\"\n                                 (savingItem)=\"onSavingItem($event)\"\n                                 (loadingItem)=\"onLoadingItem($event)\">\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-lg-10\">\n                      <azteca-form-field [label]=\"'C\u00F3digo:'\">\n                          <catalog-code formControlName=\"codigo\" [(ngModel)]=\"sucursal.code\" [automatic]=\"true\"></catalog-code>\n                      </azteca-form-field>\n\n                      <label class=\"control-label\">Nombre:</label>\n                      <az-label [text]=\"sucursal.sucursalBase.nombre\"></az-label>\n\n                  </div>\n              </div>\n\n        \n              <div class=\"row\">\n                  <div class=\"col-12 col-lg-10\">\n                      <tabset>\n                          <tab heading=\"General\" (select)=\"selectUnidadesNegocioTab($event)\">\n\n                              <azteca-form-field [label]=\"'Divisa base:'\">\n                                  <accounting-divisas-selector formControlName=\"idDivisaBase\" [(ngModel)]=\"sucursal.idDivisaBase\"></accounting-divisas-selector>\n                              </azteca-form-field>\n\n                              <azteca-form-field [label]=\"'Lista de precios default:'\">\n                                  <az-combobox formControlName=\"idListaPrecio\"\n                                               [(ngModel)]=\"sucursal.idListaPrecioDefault\"\n                                               [items]=\"listasPrecio\"\n                                               [displayMember]=\"'nombre'\"\n                                               [valueMember]=\"'id'\">\n                                  </az-combobox>\n                              </azteca-form-field>\n\n                              <azteca-form-field [label]=\"'Grupo de descuento default:'\">\n                                  <az-combobox formControlName=\"idGrupoDescuento\"\n                                               [(ngModel)]=\"sucursal.idGrupoDescuentoDefault\"\n                                               [items]=\"gruposDescuento\"\n                                               [displayMember]=\"'nombre'\"\n                                               [valueMember]=\"'id'\">\n                                  </az-combobox>\n                              </azteca-form-field>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-lg-6\">\n                                      <azteca-form-field [label]=\"'Regi\u00F3n:'\">\n                                          <az-combobox formControlName=\"idRegion\"\n                                                       [(ngModel)]=\"sucursal.idRegion\"\n                                                       [items]=\"regiones\"\n                                                       [displayMember]=\"'nombre'\"\n                                                       [valueMember]=\"'id'\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n                                  <div class=\"col-12 col-lg-6\">\n                                      <azteca-form-field [label]=\"'Zona de Venta:'\">\n                                          <az-combobox formControlName=\"idZonaVenta\"\n                                                       [(ngModel)]=\"sucursal.idZonaVenta\"\n                                                       [items]=\"zonasVenta\"\n                                                       [displayMember]=\"'nombre'\"\n                                                       [valueMember]=\"'id'\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n\n                              <azteca-form-field [label]=\"'Cuenta Contable:'\">\n                                  <accounting-cuenta-selector formControlName=\"idCuenta\" [(ngModel)]=\"sucursal.idCuenta\"></accounting-cuenta-selector>\n                              </azteca-form-field>\n\n                          </tab>\n                                      \n\n                          <tab heading=\"Unidades de Negocio\" [disabled]=\"sucursal.identity == 0\" (select)=\"selectUnidadesNegocioTab($event)\">\n                              <ventas-unidades-negocio-manager [name]=\"'Unidades de Negocio'\"\n                                                                  [unidadesNegocio]=\"unidadesNegocio\"\n                                                                  [idSucursal]=\"sucursal.identity\"\n                                                                  (refreshListParent)=\"loadUnidadesNegocio()\">\n                              </ventas-unidades-negocio-manager>\n                          </tab>\n                      </tabset>\n                  </div>\n              </div>\n            \n          </azteca-catalog-editor>\n      </form>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return SucursalesEditor_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: sucursal_service_1.SucursalService
                }
            ]
        }),
        __metadata("design:paramtypes", [router_1.Router, router_1.ActivatedRoute, forms_1.FormBuilder, core_1.ChangeDetectorRef,
            core_2.Context, common_1.Location, sucursal_service_1.SucursalService,
            divisa_service_1.DivisaService, general_1.FormatoTipoService, lista_precios_service_1.ListaPreciosService, grupo_descuento_service_1.GrupoDescuentoService,
            unidad_negocio_service_1.UnidadNegocioService, region_service_1.RegionService, zona_venta_service_1.ZonaVentaService])
    ], SucursalesEditor);
    return SucursalesEditor;
    var SucursalesEditor_1;
}(editors_1.CatalogEditor));
exports.SucursalesEditor = SucursalesEditor;
