"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//Features
var unidad_negocio_service_1 = require("../services/unidad-negocio.service");
var unidad_negocio_1 = require("../models/unidad-negocio");
var wijmo_1 = require("wijmo/wijmo");
var serie_fiscal_service_1 = require("../../accounting/services/serie-fiscal.service");
var divisa_service_1 = require("../../accounting/services/divisa.service");
var area_service_1 = require("../../inventory/services/area.service");
var UnidadesNegocioEditor = /** @class */ (function (_super) {
    __extends(UnidadesNegocioEditor, _super);
    //
    function UnidadesNegocioEditor(router, route, formBuilder, changeDetector, context, location, unidadNegocioService, serieFiscalService, divisaService, areaService) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.router = router;
        _this.route = route;
        _this.formBuilder = formBuilder;
        _this.changeDetector = changeDetector;
        _this.context = context;
        _this.location = location;
        _this.unidadNegocioService = unidadNegocioService;
        _this.serieFiscalService = serieFiscalService;
        _this.divisaService = divisaService;
        _this.areaService = areaService;
        _this.unidadNegocio = new unidad_negocio_1.UnidadNegocioInfo();
        _this.series = [];
        _this.areas = [];
        _this.almacenes = [];
        _this.modalidadesAfectacion = [];
        _this.catalogForm = formBuilder.group({
            'codigo': ['', forms_1.Validators.required],
            'nombre': ['', forms_1.Validators.required],
            'cuenta': [''],
            'idCFDSerie': [''],
            'idCFDSerieDev': [''],
            'gln': [''],
            'descontarExistencias': [''],
            'modalidadAfectacion': [''],
            'area': [],
            'almacen': [],
            'editarAlmacen': [],
            'remitente': [],
            'enviarFacturas': [],
            'operador': [],
            'notificarFacturas': [],
            'notificarFoliosTerminar': [],
            'porcentajeFolios': []
        });
        _this.modalidadesAfectacion =
            [
                { "id": true, "nombre": "En Linea" },
                { "id": false, "nombre": "Por Lote" }
            ];
        return _this;
    }
    UnidadesNegocioEditor_1 = UnidadesNegocioEditor;
    ///////////////////////// METODOS ///////////////////////////////////////
    ///////////////////////// HANDLERS ///////////////////////////////////////
    UnidadesNegocioEditor.prototype.onConfigureCatalog = function (options) {
        this.autogeneratedCode = options.codigoAutogenerado;
        this.applyPolicies();
        this.loadSeries();
        this.loadAreas();
    };
    UnidadesNegocioEditor.prototype.onCreatingItem = function () {
    };
    UnidadesNegocioEditor.prototype.onViewingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.unidadNegocioService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.unidadNegocio = info;
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    UnidadesNegocioEditor.prototype.onCloningItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.unidadNegocioService.clone(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.unidadNegocio = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    UnidadesNegocioEditor.prototype.onLoadingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.unidadNegocioService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.selectArea(info.idArea);
            _this.unidadNegocio = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    UnidadesNegocioEditor.prototype.onSavingItem = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.unidadNegocioService.update(this.unidadNegocio)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.reset();
            //Si es un elemento nuevo y no se cerrará el editor, navegar a nueva ruta
            if (!args.closeEditor && _this.unidadNegocio.identity == 0) {
                _this.router.navigate(['ventas/unidadesNegocio', _this.process.id, info.identity]);
            }
            else {
                if (args.closeEditor)
                    _this.router.navigate(['../'], { relativeTo: _this.route });
                else
                    _this.showAlert('La información ha sido actualizada con éxito', 'success');
            }
            _this.unidadNegocio = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    UnidadesNegocioEditor.prototype.loadSeries = function () {
        var _this = this;
        this.serieFiscalService.loadList(this.context.app.defaultCompany.identity.toString())
            .then(function (series) { return _this.series = series; })
            .catch(function (error) { return _this.handleError(error); });
    };
    UnidadesNegocioEditor.prototype.loadAreas = function () {
        var _this = this;
        this.areaService.loadList(this.context.app.defaultCompany.identity)
            .then(function (areas) { return _this.areas = areas; })
            .catch(function (error) { return _this.handleError(error); });
    };
    UnidadesNegocioEditor.prototype.selectTab = function () {
        //refresca los controles de wijmo
        wijmo_1.Control.invalidateAll();
    };
    UnidadesNegocioEditor.prototype.selectArea = function (idArea) {
        var _this = this;
        this.areaService.loadAlmacenes(idArea)
            .then(function (almacenes) { return _this.almacenes = almacenes; })
            .catch(function (error) { return _this.handleError(error); });
    };
    UnidadesNegocioEditor.prototype.onMenuItemClick = function (option) {
        if (option.name == 'USERS') {
            this.router.navigate(['members'], { relativeTo: this.route });
        }
    };
    UnidadesNegocioEditor.prototype.onCancelingEdit = function () {
        this.location.back();
    };
    UnidadesNegocioEditor = UnidadesNegocioEditor_1 = __decorate([
        core_1.Component({
            selector: 'ventas-unidades-negocio-editor',
            template: "\n      <form [formGroup]=\"catalogForm\">\n\n          <azteca-catalog-editor #catalogEditor \n                                 [title]=\"'Unidades de Negocio'\"\n                                 [info]=\"unidadnegocio\"\n                                 [valid]=\"valid\"\n                                 (configureCatalog)=\"onConfigureCatalog($event)\"\n                                 (creatingItem)=\"onCreatingItem()\"\n                                 (viewingItem)=\"onViewingItem($event)\"\n                                 (cloningItem)=\"onCloningItem($event)\"\n                                 (savingItem)=\"onSavingItem($event)\"\n                                 (loadingItem)=\"onLoadingItem($event)\"\n                                 (menuItemClick)=\"onMenuItemClick($event)\">\n\n              <!------------------- Menu de acciones adicionales --------------------->\n              <azteca-menu-item [name]=\"'USERS'\" [icon]=\"'glyphicon glyphicon-user'\" [text]=\"'Miembros'\" [smallText]=\"'editar usuarios miembro'\"></azteca-menu-item>\n        \n              <div class=\"row\">\n                  <div class=\"col-12 col-lg-10\">\n                      <azteca-form-field [label]=\"'C\u00F3digo:'\">\n                          <catalog-code formControlName=\"codigo\" [(ngModel)]=\"unidadNegocio.code\" [automatic]=\"autogeneratedCode\"></catalog-code>\n                      </azteca-form-field>\n\n                      <azteca-form-field [label]=\"'Nombre:'\">\n                          <az-textbox formControlName=\"nombre\" [(ngModel)]=\"unidadNegocio.nombre\"></az-textbox>\n                      </azteca-form-field>\n\n                  </div>\n              </div>\n\n        \n              <div class=\"row\">\n                  <div class=\"col-12 col-lg-10\">\n                      <tabset>\n                          <tab heading=\"Configuraci\u00F3n\">\n                                               \n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-lg-6\">\n                                      <azteca-form-field [label]=\"'GLN:'\">\n                                          <az-textbox formControlName=\"gln\" [(ngModel)]=\"unidadNegocio.gln\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12\">\n                                      <azteca-form-field [label]=\"'Cuenta Contable:'\">\n                                          <accounting-cuenta-selector formControlName=\"cuenta\" [(ngModel)]=\"unidadNegocio.idCuenta\"></accounting-cuenta-selector>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                          </tab>\n                    \n                          <tab heading=\"Facturaci\u00F3n\">\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-lg-6\">\n                                      <azteca-form-field [label]=\"'Serie Fiscal para ventas:'\">\n                                          <az-combobox formControlName=\"idCFDSerie\"\n                                                       [(ngModel)]=\"unidadNegocio.idCFDSerie\"\n                                                       [items]=\"series\"\n                                                       [displayMember]=\"'nombre'\"\n                                                       [valueMember]=\"'id'\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n\n                                  <div class=\"col-12 col-lg-6\">\n                                      <azteca-form-field [label]=\"'Serie Fiscal para devoluciones:'\">\n                                          <az-combobox formControlName=\"idCFDSerieDev\"\n                                                       [(ngModel)]=\"unidadNegocio.idSerieDevoluciones\"\n                                                       [items]=\"series\"\n                                                       [displayMember]=\"'nombre'\"\n                                                       [valueMember]=\"'id'\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                          </tab>\n\n                          <tab heading=\"Inventario\">                        \n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-lg-6\">\n                                      <az-checkbox formControlName=\"descontarExistencias\" [label]=\"'Descontar existencias del alm\u00E1cen'\" [(ngModel)]=\"unidadNegocio.afectarInventario\"></az-checkbox>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">                            \n                                  <div class=\"col-12 col-lg-6\">\n                                      <azteca-form-field [label]=\"'Area:'\" *ngIf=\"unidadNegocio.afectarInventario\">\n                                          <az-combobox formControlName=\"area\"\n                                                          [(ngModel)]=\"unidadNegocio.idArea\"\n                                                          [items]=\"areas\"\n                                                          [displayMember]=\"'nombre'\"\n                                                          [valueMember]=\"'id'\"\n                                                          (selectedItemChanged)=\"selectArea($event)\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n                                  <div class=\"col-12 col-lg-6\">\n                                      <azteca-form-field [label]=\"'Almacen:'\" *ngIf=\"unidadNegocio.afectarInventario\">\n                                          <az-combobox formControlName=\"almacen\"\n                                                       [(ngModel)]=\"unidadNegocio.idAlmacen\"\n                                                       [items]=\"almacenes\"\n                                                       [displayMember]=\"'nombre'\"\n                                                       [valueMember]=\"'id'\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n                                               \n                              <div class=\"row\">\n                                  <div class=\"col-12 col-lg-6\">\n                                      <azteca-form-field [label]=\"'Modalidad de afectaci\u00F3n:'\" *ngIf=\"unidadNegocio.afectarInventario\">\n                                          <az-combobox formControlName=\"modalidadAfectacion\"\n                                                          [(ngModel)]=\"unidadNegocio.afectarInvLinea\"\n                                                          [items]=\"modalidadesAfectacion\"\n                                                          [displayMember]=\"'nombre'\"\n                                                          [valueMember]=\"'id'\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n                                  <div class=\"col-12 col-lg-6\">\n                                      <az-checkbox formControlName=\"editarAlmacen\" [label]=\"'Editar el almacen en la venta'\" [(ngModel)]=\"unidadNegocio.editarAlmacen\" *ngIf=\"unidadNegocio.afectarInventario\"></az-checkbox>\n                                  </div>                            \n                              </div>\n\n                          </tab>\n\n                          <tab heading=\"Punto de Venta\">\n\n                          </tab>\n                   \n                      </tabset>\n                  </div>\n              </div>\n            \n\n          </azteca-catalog-editor>\n      </form>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return UnidadesNegocioEditor_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: unidad_negocio_service_1.UnidadNegocioService
                }
            ]
        }),
        __metadata("design:paramtypes", [router_1.Router, router_1.ActivatedRoute, forms_1.FormBuilder, core_1.ChangeDetectorRef,
            core_2.Context, common_1.Location, unidad_negocio_service_1.UnidadNegocioService,
            serie_fiscal_service_1.SerieFiscalService, divisa_service_1.DivisaService,
            area_service_1.AreaService])
    ], UnidadesNegocioEditor);
    return UnidadesNegocioEditor;
    var UnidadesNegocioEditor_1;
}(editors_1.CatalogEditor));
exports.UnidadesNegocioEditor = UnidadesNegocioEditor;
