import { EventEmitter } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { Context, CatalogItem } from 'framework3/core';
import { CatalogOptions } from 'framework3/custom';
import { CatalogManager } from 'framework3/editors';
import { SearchRequest } from 'framework3/search';
import { MenuItem } from 'framework3/controls';
import { UnidadNegocioService } from '../services/unidad-negocio.service';
import { UnidadNegocioItem } from '../models/unidad-negocio';
export declare class UnidadesNegocioManager extends CatalogManager {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    private unidadNegocioService;
    unidadesNegocio: UnidadNegocioItem[];
    idSucursal: number;
    refreshListParent: EventEmitter<void>;
    constructor(context: Context, router: Router, route: ActivatedRoute, unidadNegocioService: UnidadNegocioService);
    onConfigureCatalog(options: CatalogOptions): void;
    doSearch(request: SearchRequest): void;
    onAddingItem(): void;
    onViewingItem(item: CatalogItem): void;
    onEditingItem(item: CatalogItem): void;
    onDeletingItem(item: CatalogItem): void;
    onCloningItem(item: CatalogItem): void;
    onChangingItemState(item: CatalogItem): void;
    onMenuItemClick(option: MenuItem): void;
}
