"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//Features
var unidad_negocio_service_1 = require("../services/unidad-negocio.service");
var UnidadesNegocioManager = /** @class */ (function (_super) {
    __extends(UnidadesNegocioManager, _super);
    //    
    function UnidadesNegocioManager(context, router, route, unidadNegocioService) {
        var _this = _super.call(this, context, router, route) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.unidadNegocioService = unidadNegocioService;
        _this.unidadesNegocio = [];
        _this.refreshListParent = new core_1.EventEmitter();
        return _this;
    }
    UnidadesNegocioManager_1 = UnidadesNegocioManager;
    ///////////////////////// METODOS ///////////////////////////////////////
    ///////////////////////// HANDLERS ///////////////////////////////////////
    UnidadesNegocioManager.prototype.onConfigureCatalog = function (options) {
        this.manager.serverSide = options.busquedasServidor;
        this.manager.pageSize = options.tamanioPagina;
        this.refreshList();
        this.applyPolicies();
    };
    UnidadesNegocioManager.prototype.doSearch = function (request) {
        var _this = this;
        this.context.app.showSpinner();
        this.unidadNegocioService.search(this.context.app.defaultSite.identity, request)
            .then(function (response) {
            _this.context.app.hideSpinner();
            //
            _this.unidadesNegocio = response.rows;
            _this.totalRows = response.totalRows;
            _this.pageIndex = request.pageIndex;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    UnidadesNegocioManager.prototype.onAddingItem = function () {
        this.router.navigate(['sales/unidades-negocio', this.idSucursal, this.process.id, 0]);
    };
    UnidadesNegocioManager.prototype.onViewingItem = function (item) {
        this.router.navigate(['sales/unidades-negocio', this.idSucursal, this.process.id, item.id, { readonly: true }]);
    };
    UnidadesNegocioManager.prototype.onEditingItem = function (item) {
        this.router.navigate(['sales/unidades-negocio', this.idSucursal, this.process.id, item.id]);
    };
    UnidadesNegocioManager.prototype.onDeletingItem = function (item) {
        var _this = this;
        this.unidadNegocioService.delete(item.id)
            .then(function (success) {
            _this.refreshList();
            _this.refreshListParent.emit();
            _this.showAlert('El registro ha sido eliminado con éxito.', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    UnidadesNegocioManager.prototype.onCloningItem = function (item) {
        this.router.navigate(['sales/unidades-negocio', this.idSucursal, this.process.id, item.id, { cloneId: item.id }]);
    };
    UnidadesNegocioManager.prototype.onChangingItemState = function (item) {
        var _this = this;
        this.unidadNegocioService.changeStatus(item.id, !item.activo)
            .then(function (success) {
            _this.refreshList();
            _this.refreshListParent.emit();
            _this.showAlert('El estatus del registro ha sido actualizado con éxito.', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    UnidadesNegocioManager.prototype.onMenuItemClick = function (option) {
        if (option.name == 'USERS') {
            this.router.navigate(['sales/unidades-negocio', this.idSucursal, this.process.id, this.manager.currentItem.id, 'members']);
        }
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", Array)
    ], UnidadesNegocioManager.prototype, "unidadesNegocio", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], UnidadesNegocioManager.prototype, "idSucursal", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", core_1.EventEmitter)
    ], UnidadesNegocioManager.prototype, "refreshListParent", void 0);
    UnidadesNegocioManager = UnidadesNegocioManager_1 = __decorate([
        core_1.Component({
            selector: 'ventas-unidades-negocio-manager',
            template: "\n      <div class=\"card\">\n          <div class=\"card-header\">Ventas - UnidadesNegocio</div>\n          <div class=\"card-body\">\n\n      \t\t<azteca-catalog-manager (searchRequested)=\"doSearch($event)\"\n      \t\t\t\t\t\t\t\t(addingItem)=\"onAddingItem()\"\n      \t\t\t\t\t\t\t\t(viewingItem)=\"onViewingItem($event)\"\n      \t\t\t\t\t\t\t\t(editingItem)=\"onEditingItem($event)\"\n      \t\t\t\t\t\t\t\t(deletingItem)=\"onDeletingItem($event)\"\n      \t\t\t\t\t\t\t\t(cloningItem)=\"onCloningItem($event)\"\n      \t\t\t\t\t\t\t\t(changingItemState)=\"onChangingItemState($event)\"\n                                      (menuItemClick)=\"onMenuItemClick($event)\"\n      \t\t\t\t\t\t\t\t(configureCatalog)=\"onConfigureCatalog($event)\"\n      \t\t\t\t\t\t\t\t[enabled]=\"enabled\"\n                                      [allowNew]=\"allowNew\"\n                                      [allowView]=\"allowView\"\n                                      [allowEdit]=\"allowEdit\"\n                                      [allowDelete]=\"allowDelete\"\n                                      [allowClone]=\"allowClone\"\n                                      [allowChangeState]=\"allowChangeState\"\n                                      [catalogList]=\"unidadesNegocio\"\n                                      [totalRows]=\"totalRows\"\n                                      [pageIndex]=\"pageIndex\"\n                                      [standAlone]=\"false\">\n\n                  <azteca-menu-item [name]=\"'USERS'\" [icon]=\"'glyphicon glyphicon-user'\" [text]=\"'Miembros'\" [smallText]=\"'editar usuarios miembro'\"></azteca-menu-item>\n   \n      \t\t\t<azteca-grid-column [header]=\"'C\u00F3digo'\" [binding]=\"'codigo'\" [width]=\"'10*'\"></azteca-grid-column>\n      \t\t\t<azteca-grid-column [header]=\"'Nombre'\" [binding]=\"'nombre'\" [width]=\"'60*'\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Regi\u00F3n'\" [binding]=\"'region'\" [width]=\"'20*'\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Zona venta'\" [binding]=\"'zonaVenta'\" [width]=\"'20*'\"></azteca-grid-column>\n\t\t\t\n\n      \t\t</azteca-catalog-manager>\n\n          </div>\n      </div>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return UnidadesNegocioManager_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: unidad_negocio_service_1.UnidadNegocioService
                }
            ]
        }),
        __metadata("design:paramtypes", [core_2.Context, router_1.Router, router_1.ActivatedRoute, unidad_negocio_service_1.UnidadNegocioService])
    ], UnidadesNegocioManager);
    return UnidadesNegocioManager;
    var UnidadesNegocioManager_1;
}(editors_1.CatalogManager));
exports.UnidadesNegocioManager = UnidadesNegocioManager;
