import { EventEmitter, ChangeDetectorRef } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder, FormGroup } from '@angular/forms';
import { ModalDirective } from 'ngx-bootstrap';
import { Context, PolicyInfo } from 'framework3/core';
import { AlertsBarComponent } from 'framework3/controls';
import { CatalogEditor } from 'framework3/editors';
import { ArticuloGrupoDescuentoItem } from '../models/articulo-grupo-descuento';
import { ArticuloService } from '../services/articulo.service';
export declare class ArticuloGrupoDescuentoEditorComponent extends CatalogEditor {
    private articuloService;
    protected context: Context;
    private formBuilder;
    protected router: Router;
    protected route: ActivatedRoute;
    protected changeDetector: ChangeDetectorRef;
    editorForm: FormGroup;
    info: ArticuloGrupoDescuentoItem;
    data: ArticuloGrupoDescuentoItem;
    dataUpdated: EventEmitter<ArticuloGrupoDescuentoItem>;
    dialog: ModalDirective;
    alerts: AlertsBarComponent;
    constructor(articuloService: ArticuloService, context: Context, formBuilder: FormBuilder, router: Router, route: ActivatedRoute, changeDetector: ChangeDetectorRef);
    show(): void;
    onUpdate(): void;
    applyPolicy(policy: PolicyInfo): void;
    handleError(error: any): void;
}
