"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
//Wijmo
var wijmo_1 = require("wijmo/wijmo");
//Bootstrap
var ngx_bootstrap_1 = require("ngx-bootstrap");
//Azteca Kernel
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
var editors_1 = require("framework3/editors");
//Features
var articulo_grupo_descuento_1 = require("../models/articulo-grupo-descuento");
var articulo_service_1 = require("../services/articulo.service");
var ArticuloGrupoDescuentoEditorComponent = /** @class */ (function (_super) {
    __extends(ArticuloGrupoDescuentoEditorComponent, _super);
    function ArticuloGrupoDescuentoEditorComponent(articuloService, context, formBuilder, router, route, changeDetector) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.articuloService = articuloService;
        _this.context = context;
        _this.formBuilder = formBuilder;
        _this.router = router;
        _this.route = route;
        _this.changeDetector = changeDetector;
        _this.info = new articulo_grupo_descuento_1.ArticuloGrupoDescuentoItem();
        //Inputs
        _this.data = new articulo_grupo_descuento_1.ArticuloGrupoDescuentoItem();
        //outputs
        _this.dataUpdated = new core_1.EventEmitter();
        _this.editorForm = formBuilder.group({
            'porcentajeDescuento1': [0],
            'porcentajeDescuento2': [0],
            'porcentajeDescuento3': [0],
            'porcentajeDescuento4': [0],
            'porcentajeDescuento5': [0]
        });
        return _this;
    }
    ArticuloGrupoDescuentoEditorComponent_1 = ArticuloGrupoDescuentoEditorComponent;
    ArticuloGrupoDescuentoEditorComponent.prototype.show = function () {
        var _this = this;
        this.info = new articulo_grupo_descuento_1.ArticuloGrupoDescuentoItem();
        this.dialog.config.backdrop = false;
        this.dialog.show();
        setTimeout(function (_) {
            _this.editorForm.reset();
            _this.info = _this.data;
            _this.data = new articulo_grupo_descuento_1.ArticuloGrupoDescuentoItem();
        });
        wijmo_1.Control.invalidateAll();
    };
    ArticuloGrupoDescuentoEditorComponent.prototype.onUpdate = function () {
        this.dataUpdated.emit(this.info);
        this.dialog.hide();
    };
    ArticuloGrupoDescuentoEditorComponent.prototype.applyPolicy = function (policy) {
    };
    ArticuloGrupoDescuentoEditorComponent.prototype.handleError = function (error) {
        this.context.app.hideSpinner();
        var message = this.getErrorMessage(error);
        this.alerts.showAlert(message, 'danger');
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", articulo_grupo_descuento_1.ArticuloGrupoDescuentoItem)
    ], ArticuloGrupoDescuentoEditorComponent.prototype, "data", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", core_1.EventEmitter)
    ], ArticuloGrupoDescuentoEditorComponent.prototype, "dataUpdated", void 0);
    __decorate([
        core_1.ViewChild('dialog'),
        __metadata("design:type", ngx_bootstrap_1.ModalDirective)
    ], ArticuloGrupoDescuentoEditorComponent.prototype, "dialog", void 0);
    __decorate([
        core_1.ViewChild(controls_1.AlertsBarComponent),
        __metadata("design:type", controls_1.AlertsBarComponent)
    ], ArticuloGrupoDescuentoEditorComponent.prototype, "alerts", void 0);
    ArticuloGrupoDescuentoEditorComponent = ArticuloGrupoDescuentoEditorComponent_1 = __decorate([
        core_1.Component({
            selector: 'ventas-articulo-grupo-descuento-editor',
            template: "\n      <form [formGroup]=\"editorForm\">\n\n          <div bsModal #dialog=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"myLargeModalLabel\" aria-hidden=\"true\">\n              <div class=\"modal-dialog modal-lg\">\n                  <div class=\"modal-content\">\n                      <div class=\"modal-header\">\n                          <h4 class=\"modal-title\">Asignar Grupo de Descuentos</h4>\n                      </div>\n\n                      <div class=\"modal-body\">\n\n                          <div class=\"row\">\n                              <div class=\"col-12\">\n                                  <azteca-form-field [label]=\"'Porcentaje Descuento 1:'\">\n                                      <az-input-number formControlName=\"porcentajeDescuento1\" decimal=\"True\" [(ngModel)]=\"info.porcentajeDescuento1\" [min]=\"0\" [max]=\"100\" [format]=\"n2\"></az-input-number>\n                                  </azteca-form-field>\n                              </div>\n                          </div>\n\n                          <div class=\"row\">\n                              <div class=\"col-12\">\n                                  <azteca-form-field [label]=\"'Porcentaje Descuento 2:'\">\n                                      <az-input-number formControlName=\"porcentajeDescuento2\" decimal=\"True\" [(ngModel)]=\"info.porcentajeDescuento2\" [min]=\"0\" [max]=\"100\" [format]=\"n2\"></az-input-number>\n                                  </azteca-form-field>\n                              </div>\n                          </div>\n\n                          <div class=\"row\">\n                              <div class=\"col-12\">\n                                  <azteca-form-field [label]=\"'Porcentaje Descuento 3:'\">\n                                      <az-input-number formControlName=\"porcentajeDescuento3\" decimal=\"True\" [(ngModel)]=\"info.porcentajeDescuento3\" [min]=\"0\" [max]=\"100\" [format]=\"n2\"></az-input-number>\n                                  </azteca-form-field>\n                              </div>\n                          </div>\n\n                          <div class=\"row\">\n                              <div class=\"col-12\">\n                                  <azteca-form-field [label]=\"'Porcentaje Descuento 4:'\">\n                                      <az-input-number formControlName=\"porcentajeDescuento4\" decimal=\"True\" [(ngModel)]=\"info.porcentajeDescuento4\" [min]=\"0\" [max]=\"100\" [format]=\"n2\"></az-input-number>\n                                  </azteca-form-field>\n                              </div>\n                          </div>\n\n                          <div class=\"row\">\n                              <div class=\"col-12\">\n                                  <azteca-form-field [label]=\"'Porcentaje Descuento 5:'\">\n                                      <az-input-number formControlName=\"porcentajeDescuento5\" decimal=\"True\" [(ngModel)]=\"info.porcentajeDescuento5\" [min]=\"0\" [max]=\"100\" [format]=\"n2\"></az-input-number>\n                                  </azteca-form-field>\n                              </div>\n                          </div>\n\n                      </div> <!--Modal Body-->\n                      <div class=\"modal-footer\">\n                          <button type=\"button\" class=\"btn btn-primary\" (click)=\"onUpdate()\" [disabled]=\"!editorForm.valid\">Aceptar</button>\n                          <button type=\"button\" class=\"btn btn-danger\" (click)=\"dialog.hide()\">Atr\u00E1s</button>\n                      </div> <!--Modal Footer-->\n\n                  </div> <!-- Modal Content-->\n              </div> <!--Modal-->\n          </div><!--Modal directive-->\n\n      </form>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return ArticuloGrupoDescuentoEditorComponent_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: articulo_service_1.ArticuloService
                }
            ]
        }),
        __metadata("design:paramtypes", [articulo_service_1.ArticuloService, core_2.Context, forms_1.FormBuilder, router_1.Router, router_1.ActivatedRoute,
            core_1.ChangeDetectorRef])
    ], ArticuloGrupoDescuentoEditorComponent);
    return ArticuloGrupoDescuentoEditorComponent;
    var ArticuloGrupoDescuentoEditorComponent_1;
}(editors_1.CatalogEditor));
exports.ArticuloGrupoDescuentoEditorComponent = ArticuloGrupoDescuentoEditorComponent;
