import { EventEmitter, ChangeDetectorRef } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder, FormGroup } from '@angular/forms';
import { ModalDirective } from 'ngx-bootstrap';
import { Context, PolicyInfo } from 'framework3/core';
import { AlertsBarComponent } from 'framework3/controls';
import { CatalogEditor } from 'framework3/editors';
import { ArticuloStockItem } from '../../inventory/models/articulo-stock';
import { ArticuloService } from '../services/articulo.service';
import { ArticuloStockSelectorComponent } from '../../inventory/controls/articulo-stock-selector.component';
export declare class ArticuloNuevoComponent extends CatalogEditor {
    private articulosService;
    protected context: Context;
    private formBuilder;
    protected router: Router;
    protected route: ActivatedRoute;
    protected changeDetector: ChangeDetectorRef;
    editorForm: FormGroup;
    articulosStock: ArticuloStockItem;
    opcionesAutogenerar: {
        id: number;
        name: string;
    }[];
    codigoValidador: string;
    data: ArticuloStockItem;
    autogenerado: boolean;
    dataUpdated: EventEmitter<ArticuloStockItem>;
    articuloNuevoDialog: ModalDirective;
    alerts: AlertsBarComponent;
    selectorArticulo: ArticuloStockSelectorComponent;
    constructor(articulosService: ArticuloService, context: Context, formBuilder: FormBuilder, router: Router, route: ActivatedRoute, changeDetector: ChangeDetectorRef);
    show(): void;
    onTextChange(text: string): void;
    onUpdate(): void;
    applyPolicy(policy: PolicyInfo): void;
    handleError(error: any): void;
    onSelectedItemChanged(args: any): void;
    itemchanged(args: any): void;
}
