"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
//Wijmo
var wijmo_1 = require("wijmo/wijmo");
//Bootstrap
var ngx_bootstrap_1 = require("ngx-bootstrap");
//Azteca Kernel
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
var editors_1 = require("framework3/editors");
//Features
var articulo_stock_1 = require("../../inventory/models/articulo-stock");
var articulo_service_1 = require("../services/articulo.service");
var articulo_stock_selector_component_1 = require("../../inventory/controls/articulo-stock-selector.component");
var ArticuloNuevoComponent = /** @class */ (function (_super) {
    __extends(ArticuloNuevoComponent, _super);
    function ArticuloNuevoComponent(articulosService, context, formBuilder, router, route, changeDetector) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.articulosService = articulosService;
        _this.context = context;
        _this.formBuilder = formBuilder;
        _this.router = router;
        _this.route = route;
        _this.changeDetector = changeDetector;
        _this.articulosStock = new articulo_stock_1.ArticuloStockItem();
        _this.opcionesAutogenerar = [
            { "id": 1, "name": "Crear articulo nuevo en inventario y ventas" },
            { "id": 2, "name": "Ligar a articulo existente en inventario" }
        ];
        _this.codigoValidador = '';
        //Inputs
        _this.data = new articulo_stock_1.ArticuloStockItem();
        _this.autogenerado = false;
        //outputs
        _this.dataUpdated = new core_1.EventEmitter();
        _this.editorForm = formBuilder.group({
            'codigo': [''],
            'nombre': [''],
            'unidadMedida': [''],
            'codigoValidador': [''],
            'opcionesAutogenerar': [0],
            'articulo': [''],
            'codigoLigado': [true]
        });
        return _this;
    }
    ArticuloNuevoComponent_1 = ArticuloNuevoComponent;
    ArticuloNuevoComponent.prototype.show = function () {
        var _this = this;
        if (this.autogenerado) {
            this.editorForm.controls['opcionesAutogenerar'].setValidators(controls_1.AztecaValidators.selected);
        }
        else {
            this.editorForm.controls['codigo'].setValidators(forms_1.Validators.required);
        }
        this.articuloNuevoDialog.config.backdrop = false;
        this.articuloNuevoDialog.show();
        setTimeout(function (_) { return _this.editorForm.reset(); });
        wijmo_1.Control.invalidateAll();
    };
    ArticuloNuevoComponent.prototype.onTextChange = function (text) {
        var _this = this;
        this.articulosService.GetArticuloStock(this.context.app.defaultSite.identity, text)
            .then(function (articulo) {
            _this.data = articulo;
            _this.articulosService.articuloAsignadoCheck(articulo.id).then(function (x) {
                if (articulo.nombre.length == 0) {
                    _this.codigoValidador = 'Código Nuevo';
                    // Nota: si es código es nuevo, habilita el boton de aceptar
                    _this.editorForm.controls['codigoLigado'].clearValidators();
                    _this.editorForm.controls['codigoLigado'].updateValueAndValidity();
                }
                else if (x) {
                    //Nota: si el código ya fue ligado a un articulo, inhabilita el boton de aceptar
                    _this.codigoValidador = 'El Código ya esta ligado a un articulo';
                    _this.editorForm.controls['codigoLigado'].setValidators(forms_1.Validators.requiredTrue);
                    _this.editorForm.controls['codigoLigado'].updateValueAndValidity();
                }
                else {
                    //Nota: si el codigo ya existe pero no esta ligado a un articulo, habilita el boton de aceptar
                    _this.codigoValidador = 'El Código se asignara al articulo';
                    _this.editorForm.controls['codigoLigado'].clearValidators();
                    _this.editorForm.controls['codigoLigado'].updateValueAndValidity();
                }
            }).catch(function (Er) { return _this.handleError(Er); });
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ArticuloNuevoComponent.prototype.onUpdate = function () {
        if (this.autogenerado) {
            if (this.editorForm.controls.opcionesAutogenerar.value === 1) {
                this.router.navigate(['sales/articulos-ventas/' + this.process.id + '/0']);
            }
            else {
                this.router.navigate(['sales/articulos-ventas/' + this.process.id + '/0'], { queryParams: { idArticuloStock: this.editorForm.controls.articulo.value } });
            }
        }
        else {
            if (this.data.id > 0) {
                this.router.navigate(['sales/articulos-ventas/' + this.process.id + '/0'], { queryParams: { idArticuloStock: this.data.id } });
            }
            else {
                this.router.navigate(['sales/articulos-ventas/' + this.process.id + '/0'], { queryParams: { codigoNuevo: this.editorForm.controls.codigo.value } });
            }
        }
    };
    ArticuloNuevoComponent.prototype.applyPolicy = function (policy) {
    };
    ArticuloNuevoComponent.prototype.handleError = function (error) {
        this.context.app.hideSpinner();
        var message = this.getErrorMessage(error);
        this.alerts.showAlert(message, 'danger');
    };
    ArticuloNuevoComponent.prototype.onSelectedItemChanged = function (args) {
        if (args == 2) {
            this.editorForm.controls['articulo'].setValidators(controls_1.AztecaValidators.selected);
        }
        else {
            this.editorForm.controls['articulo'].setValidators(forms_1.Validators.nullValidator);
            this.codigoValidador = '';
            this.editorForm.controls['codigoLigado'].clearValidators();
            this.editorForm.controls['codigoLigado'].updateValueAndValidity();
        }
        //Nota: updateValueAndValidity() no actualiza el validador de todos los controles. Por eso se usa disable() y enable().
        this.editorForm.disable();
        this.editorForm.enable();
    };
    ArticuloNuevoComponent.prototype.itemchanged = function (args) {
        var _this = this;
        this.articulosService.articuloAsignadoCheck(args.identity).then(function (x) {
            if (x) {
                //Nota: si el código ya fue ligado a un articulo, inhabilita el boton de aceptar
                _this.codigoValidador = 'El Código ya esta ligado a un articulo';
                _this.editorForm.controls['codigoLigado'].setValidators(forms_1.Validators.requiredTrue);
                _this.editorForm.controls['codigoLigado'].updateValueAndValidity();
            }
            else {
                //Nota: si el codigo ya existe pero no esta ligado a un articulo, habilita el boton de aceptar
                _this.codigoValidador = 'El Código se asignara al articulo';
                _this.editorForm.controls['codigoLigado'].clearValidators();
                _this.editorForm.controls['codigoLigado'].updateValueAndValidity();
            }
        });
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", articulo_stock_1.ArticuloStockItem)
    ], ArticuloNuevoComponent.prototype, "data", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], ArticuloNuevoComponent.prototype, "autogenerado", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", core_1.EventEmitter)
    ], ArticuloNuevoComponent.prototype, "dataUpdated", void 0);
    __decorate([
        core_1.ViewChild('dialog'),
        __metadata("design:type", ngx_bootstrap_1.ModalDirective)
    ], ArticuloNuevoComponent.prototype, "articuloNuevoDialog", void 0);
    __decorate([
        core_1.ViewChild(controls_1.AlertsBarComponent),
        __metadata("design:type", controls_1.AlertsBarComponent)
    ], ArticuloNuevoComponent.prototype, "alerts", void 0);
    __decorate([
        core_1.ViewChild('selectorArticulo'),
        __metadata("design:type", articulo_stock_selector_component_1.ArticuloStockSelectorComponent)
    ], ArticuloNuevoComponent.prototype, "selectorArticulo", void 0);
    ArticuloNuevoComponent = ArticuloNuevoComponent_1 = __decorate([
        core_1.Component({
            selector: 'sales-nuevo-articulo',
            template: "\n      <form [formGroup]=\"editorForm\">\n\n          <div bsModal #dialog=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"myLargeModalLabel\" aria-hidden=\"true\">\n              <div class=\"modal-dialog modal-lg\">\n                  <div class=\"modal-content\">\n                      <div class=\"modal-header\">\n                          <h4 class=\"modal-title\">Nuevo Articulo</h4>\n                      </div>\n                      <div class=\"modal-body\">\n\n                          <azteca-form-field [label]=\"'C\u00F3digo:'\" [hidden]=\"autogenerado\">\n                              <az-textbox formControlName=\"codigo\" (textChange)=\"onTextChange($event)\"></az-textbox>\n                          </azteca-form-field>\n                          <azteca-form-field [label]=\"'Nombre:'\" [hidden]=\"autogenerado\">\n                              <az-textbox formControlName=\"nombre\" [(ngModel)]=\"data.nombre\" [enabled]=\"false\"></az-textbox>\n                          </azteca-form-field>\n                          <azteca-form-field [label]=\"'Unidad de Medida:'\" [hidden]=\"autogenerado\">\n                              <az-textbox formControlName=\"unidadMedida\" [(ngModel)]=\"data.unidadMedida\" [enabled]=\"false\"></az-textbox>\n                          </azteca-form-field>\n\n                          <azteca-form-field [label]=\"'M\u00E9todo Creaci\u00F3n Art\u00EDculo:'\" [hidden]=\"!autogenerado\">\n                              <az-combobox formControlName=\"opcionesAutogenerar\"\n                                           [items]=\"opcionesAutogenerar\"\n                                           [displayMember]=\"'name'\"\n                                           [valueMember]=\"'id'\"\n                                           (selectedItemChanged)=\"onSelectedItemChanged($event)\">\n                              </az-combobox>\n                          </azteca-form-field>\n\n                          <azteca-form-field [label]=\"'Articulo:'\" [hidden]=\"!autogenerado\" *ngIf=\"editorForm.controls.opcionesAutogenerar._value===2\">\n                              <azteca-form-field [label]=\"Articulo\">\n                                  <inventory-articulo-stock-selector \n                                           formControlName=\"articulo\" \n                                           [(ngModel)]=\"data.idArticuloStock\" \n                                           [showListButton]=\"false\" \n                                           (selectedItemChanged)=\"itemchanged($event)\"\n                                           #selectorArticulo></inventory-articulo-stock-selector>\n                              </azteca-form-field>\n                          </azteca-form-field>\n\n                          <azteca-form-field [label]=\"''\">\n                              <az-textbox formControlName=\"codigoValidador\" [enabled]=\"false\" [(ngModel)]=\"codigoValidador\"></az-textbox>\n                          </azteca-form-field>\n\n                      </div> <!--Modal Body-->\n                      <div class=\"modal-footer\">\n                          <button type=\"button\" class=\"btn btn-primary\" (click)=\"onUpdate()\" [disabled]=\"!editorForm.valid\">Aceptar</button>\n                          <button type=\"button\" class=\"btn btn-danger\" (click)=\"dialog.hide()\">Cancelar</button>\n                      </div> <!--Modal Footer-->\n\n                  </div> <!-- Modal Content-->\n              </div> <!--Modal-->\n          </div> <!--Modal directive-->\n\n      </form>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return ArticuloNuevoComponent_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: articulo_service_1.ArticuloService
                }
            ]
        }),
        __metadata("design:paramtypes", [articulo_service_1.ArticuloService, core_2.Context, forms_1.FormBuilder, router_1.Router, router_1.ActivatedRoute,
            core_1.ChangeDetectorRef])
    ], ArticuloNuevoComponent);
    return ArticuloNuevoComponent;
    var ArticuloNuevoComponent_1;
}(editors_1.CatalogEditor));
exports.ArticuloNuevoComponent = ArticuloNuevoComponent;
