import { EventEmitter, ChangeDetectorRef } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder, FormGroup } from '@angular/forms';
import { ModalDirective } from 'ngx-bootstrap';
import { Context, PolicyInfo } from 'framework3/core';
import { AlertsBarComponent } from 'framework3/controls';
import { CatalogEditor } from 'framework3/editors';
import { ServicioListaPreciosItem } from '../models/servicio-lista-precios';
import { ServicioService } from '../services/servicio.service';
import { DivisasSelectorComponent } from '../../accounting/controls/divisas-selector.component';
export declare class ServicioListaPreciosEditorComponent extends CatalogEditor {
    private servicioService;
    protected context: Context;
    private formBuilder;
    protected router: Router;
    protected route: ActivatedRoute;
    protected changeDetector: ChangeDetectorRef;
    editorForm: FormGroup;
    info: ServicioListaPreciosItem;
    formato: String;
    data: ServicioListaPreciosItem;
    dataUpdated: EventEmitter<ServicioListaPreciosItem>;
    dialog: ModalDirective;
    alerts: AlertsBarComponent;
    selectorDivisas: DivisasSelectorComponent;
    constructor(servicioService: ServicioService, context: Context, formBuilder: FormBuilder, router: Router, route: ActivatedRoute, changeDetector: ChangeDetectorRef);
    show(): void;
    onSelectedItemChanged(args: any): void;
    onUpdate(): void;
    applyPolicy(policy: PolicyInfo): void;
    handleError(error: any): void;
}
