"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var rxjs_1 = require("rxjs");
//
var core_2 = require("framework3/core");
var search_1 = require("framework3/search");
var articulo_service_1 = require("../services/articulo.service");
var ArticulosSelectorComponent = /** @class */ (function (_super) {
    __extends(ArticulosSelectorComponent, _super);
    function ArticulosSelectorComponent(context, service) {
        var _this = _super.call(this, context) || this;
        _this.context = context;
        _this.service = service;
        _this.selectedItem = null;
        //Outputs
        _this.selectedItemChanged = new core_1.EventEmitter();
        _this.keywordSearchSource = rxjs_1.Observable.create(function (observer) {
            observer.next(_this.innerSelector.displayValue);
        })
            .mergeMap(function (keyword) { return _this.findKeyword(keyword); });
        return _this;
    }
    ArticulosSelectorComponent_1 = ArticulosSelectorComponent;
    ArticulosSelectorComponent.prototype.loadItem = function (itemID) {
        var _this = this;
        if (itemID > 0) {
            this.service.getDetailByID(itemID)
                .then(function (info) {
                _this.selectedItem = info;
                _this.displayValue = info.nombre;
                _this.selectedItemChanged.emit(_this.selectedItem);
            })
                .catch(function (error) { return _this.handleError(error); });
        }
        else {
            this.selectedItem = null;
            this.displayValue = "";
            this.selectedItemChanged.emit(this.selectedItem);
        }
    };
    ArticulosSelectorComponent.prototype.doSearch = function (request) {
        var _this = this;
        this.context.app.showSpinner();
        //Agregar aqui filtros
        //let condicion: SearchCondition = { field: "campo", operator: "=", valueType: "int", value: this.inputMember.toString() };
        //request.conditions.push(condicion);
        //
        this.service.search(this.context.app.defaultSite.identity, request)
            .then(function (response) {
            _this.context.app.hideSpinner();
            //
            _this.articulos = response.rows;
            _this.totalRows = response.totalRows;
            _this.pageIndex = request.pageIndex;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ArticulosSelectorComponent.prototype.findKeyword = function (keyword) {
        return this.service.searchKeyword(this.context.app.defaultSite.identity, keyword);
    };
    ArticulosSelectorComponent.prototype.onKeywordSearch = function (keyword) {
        this.markUnselected();
    };
    __decorate([
        core_1.Output(),
        __metadata("design:type", core_1.EventEmitter)
    ], ArticulosSelectorComponent.prototype, "selectedItemChanged", void 0);
    ArticulosSelectorComponent = ArticulosSelectorComponent_1 = __decorate([
        core_1.Component({
            selector: 'sales-articulos-selector',
            template: "\n\n      <azteca-catalog-selector [catalogList]=\"articulos\"\n                               [dialogTitle]=\"'Lista de art\u00EDculos'\"\n                               [displayValue]=\"displayValue\"\n                               [serverSide]=\"true\"\n                               [selectedItem]=\"selectedItem\"\n                               [pageIndex]=\"pageIndex\"\n                               [pageSize]=\"pageSize\"\n                               [totalRows]=\"totalRows\"\n                               [enabled]=\"enabled\"\n                               [visible]=\"visible\"\n                               [dataSource]=\"keywordSearchSource\"\n                               [showListButton]=\"showListButton\"\n                               (selectedItemChanged)=\"itemChangedHandler($event)\"\n                               (keywordSearch)=\"onKeywordSearch($event)\"\n                               (searchRequested)=\"doSearch($event)\">\n\n          <azteca-grid-column [header]=\"'Codigo'\" [binding]=\"'codigo'\" [width]=\"100\"></azteca-grid-column>\n          <azteca-grid-column [header]=\"'Nombre'\" [binding]=\"'nombre'\" [width]=\"'3*'\"></azteca-grid-column>\n          <azteca-grid-column [header]=\"'U.M.'\" [binding]=\"'unidadMedida'\" [width]=\"'2*'\"></azteca-grid-column>\n    \n\n      </azteca-catalog-selector>        \n    ",
            providers: [{
                    provide: core_2.BaseComponent,
                    useExisting: core_1.forwardRef(function () { return ArticulosSelectorComponent_1; })
                },
                {
                    provide: forms_1.NG_VALUE_ACCESSOR,
                    useExisting: core_1.forwardRef(function () { return ArticulosSelectorComponent_1; }),
                    multi: true
                }]
        }),
        __metadata("design:paramtypes", [core_2.Context, articulo_service_1.ArticuloService])
    ], ArticulosSelectorComponent);
    return ArticulosSelectorComponent;
    var ArticulosSelectorComponent_1;
}(search_1.CatalogSelector));
exports.ArticulosSelectorComponent = ArticulosSelectorComponent;
