import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { Context, DocumentItem, DocumentTypeService, DocumentTypeInfo } from 'framework3/core';
import { DocumentEditor, EditableListComponent, EditorEventArgs, WorkflowEventArgs } from 'framework3/editors';
import { DevolucionInfo } from '../models/devolucion';
import { DevolucionDetail } from '../models/devolucion-detail';
import { DevolucionService } from '../services/devolucion.service';
import { DevolucionDetailEditor } from './parts/devoluciones-detail.editor';
import { DevolucionArticuloDetail } from '../models/devolucion-articulo-detail';
import { DevolucionServicioDetail } from '../models/devolucion-servicio-detail';
import { VentaInfo } from '../models/venta';
import { DivisaService } from '../../accounting';
import { ClienteService } from '../services/cliente.service';
import { UnidadNegocioService } from '../services/unidad-negocio.service';
import { AlmacenService } from '../../inventory';
import { VentasSelectorComponent } from '../controls/ventas-selector.component';
export declare class DevolucionesEditor extends DocumentEditor {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    private location;
    private formBuilder;
    protected documentTypeService: DocumentTypeService;
    private devolucionService;
    private almacenService;
    private divisaService;
    private unidadNegocioService;
    private clienteService;
    devolucion: DevolucionInfo;
    venta: VentaInfo;
    articulos: DevolucionArticuloDetail[];
    servicios: DevolucionServicioDetail[];
    detailsList: EditableListComponent;
    detailsEditor: DevolucionDetailEditor;
    selectorVentas: VentasSelectorComponent;
    constructor(context: Context, router: Router, route: ActivatedRoute, location: Location, formBuilder: FormBuilder, documentTypeService: DocumentTypeService, devolucionService: DevolucionService, almacenService: AlmacenService, divisaService: DivisaService, unidadNegocioService: UnidadNegocioService, clienteService: ClienteService);
    onConfigureDocument(docType: DocumentTypeInfo): void;
    onCreatingDocument(): void;
    onViewingDocument(id: string): void;
    onCloningDocument(id: string): void;
    onLoadingDocument(id: string): void;
    combineDetail(): DevolucionDetail[];
    onSavingDocument(args: EditorEventArgs): void;
    onApplyingNextStep(args: WorkflowEventArgs): void;
    onApplyingPreviousStep(document: DocumentItem): void;
    onTabSelected(args: any): void;
    onAddingDetail(): void;
    onEditingDetail(detail: DevolucionDetail): void;
    onDeletingDetail(detail: DevolucionDetail): void;
    onListItemsUpdated(updatedDetails: DevolucionDetail[]): void;
    onSavingDetail(detail: DevolucionDetail): void;
    onSelectedItemChanged(venta: VentaInfo): void;
    cargarInfAdicional(): void;
}
