"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Wijmo
var wijmo_1 = require("wijmo/wijmo");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//Locales
var devolucion_1 = require("../models/devolucion");
var devolucion_detail_1 = require("../models/devolucion-detail");
var devolucion_service_1 = require("../services/devolucion.service");
var devoluciones_detail_editor_1 = require("./parts/devoluciones-detail.editor");
var devolucion_articulo_detail_1 = require("../models/devolucion-articulo-detail");
var devolucion_servicio_detail_1 = require("../models/devolucion-servicio-detail");
var venta_1 = require("../models/venta");
var accounting_1 = require("../../accounting");
var cliente_service_1 = require("../services/cliente.service");
var unidad_negocio_service_1 = require("../services/unidad-negocio.service");
var inventory_1 = require("../../inventory");
var ventas_selector_component_1 = require("../controls/ventas-selector.component");
var DevolucionesEditor = /** @class */ (function (_super) {
    __extends(DevolucionesEditor, _super);
    function DevolucionesEditor(context, router, route, location, formBuilder, documentTypeService, devolucionService, almacenService, divisaService, unidadNegocioService, clienteService) {
        var _this = _super.call(this, context, router, route, documentTypeService) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.location = location;
        _this.formBuilder = formBuilder;
        _this.documentTypeService = documentTypeService;
        _this.devolucionService = devolucionService;
        _this.almacenService = almacenService;
        _this.divisaService = divisaService;
        _this.unidadNegocioService = unidadNegocioService;
        _this.clienteService = clienteService;
        _this.devolucion = new devolucion_1.DevolucionInfo();
        _this.venta = new venta_1.VentaInfo();
        _this.articulos = [];
        _this.servicios = [];
        _this.documentForm = formBuilder.group({
            'idVenta': [''],
        });
        return _this;
    }
    DevolucionesEditor_1 = DevolucionesEditor;
    DevolucionesEditor.prototype.onConfigureDocument = function (docType) {
        this.applyPolicies();
    };
    DevolucionesEditor.prototype.onCreatingDocument = function () {
    };
    DevolucionesEditor.prototype.onViewingDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.devolucionService.getDetail(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.devolucion = doc;
            _this.setReadonlyMode();
            _this.articulos = _this.devolucion.details.map(function (d) { return d; }).filter(function (d) { return d.idArticulo && d.idArticulo > 0; });
            _this.servicios = _this.devolucion.details.map(function (d) { return d; }).filter(function (d) { return d.idServicio && d.idServicio > 0; });
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    DevolucionesEditor.prototype.onCloningDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.devolucionService.clone(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.devolucion = doc;
            //
            _this.articulos = _this.devolucion.details.map(function (d) { return d; }).filter(function (d) { return d.idArticulo && d.idArticulo > 0; });
            _this.servicios = _this.devolucion.details.map(function (d) { return d; }).filter(function (d) { return d.idServicio && d.idServicio > 0; });
            //
            _this.detailsEditor.clientIndexStart = _this.devolucion.details.length;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    DevolucionesEditor.prototype.onLoadingDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.devolucionService.getDetail(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.devolucion = doc;
            //                this.selectorVentas.selectedID = this.devolucion.idVenta;
            _this.selectorVentas.displayValue = _this.devolucion.idVenta;
            _this.selectorVentas.enabled = false;
            //
            _this.articulos = _this.devolucion.details.map(function (d) { return d; }).filter(function (d) { return d.idArticulo && d.idArticulo > 0; });
            _this.servicios = _this.devolucion.details.map(function (d) { return d; }).filter(function (d) { return d.idServicio && d.idServicio > 0; });
            //
            _this.detailsEditor.clientIndexStart = _this.devolucion.details.length;
            if (_this.devolucion.status != core_2.DocumentStatus.DRAFT)
                _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    DevolucionesEditor.prototype.combineDetail = function () {
        var newDetail = [];
        this.servicios.forEach(function (s) { return newDetail.push(s); });
        this.articulos.forEach(function (a) { return newDetail.push(a); });
        return newDetail;
    };
    DevolucionesEditor.prototype.onSavingDocument = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.devolucion.details = this.combineDetail();
        this.devolucionService.update(this.devolucion)
            .then(function (updatedDoc) {
            _this.context.app.hideSpinner();
            //Si es un elemento nuevo y no se cerrará el editor, navegar a nueva ruta
            _this.reset();
            if (!args.closeEditor && _this.devolucion.identity == '') {
                _this.router.navigate(['../', updatedDoc.identity], { relativeTo: _this.route });
            }
            else {
                if (args.closeEditor)
                    _this.router.navigate(['../'], { relativeTo: _this.route });
                else
                    _this.showAlert('La información ha sido actualizada con éxito', 'success');
            }
            _this.devolucion = updatedDoc;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    DevolucionesEditor.prototype.onApplyingNextStep = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.devolucionService.nextStep(args.document.id, args.step.idWorkflowStep, null)
            .then(function (_) {
            //Volver a cargar documento
            _this.onViewingDocument(args.document.id);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    DevolucionesEditor.prototype.onApplyingPreviousStep = function (document) {
        var _this = this;
        this.context.app.showSpinner();
        this.devolucionService.previousStep(document.id, null)
            .then(function (_) {
            //Volver a cargar documento
            _this.onViewingDocument(document.id);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    DevolucionesEditor.prototype.onTabSelected = function (args) {
        if (args.heading) {
            //Al seleccionar la pestaña de historial, realizar carga de información
            if (args.heading == 'Historial') {
                this.loadHistory(this.devolucion.identity);
            }
            //Actualizar controles de wijmo
            wijmo_1.Control.invalidateAll();
        }
    };
    ///////////// DETALLE DEL DOCUMENTO /////////////////////////
    DevolucionesEditor.prototype.onAddingDetail = function () {
        this.detailsEditor.detail = new devolucion_detail_1.DevolucionDetail();
        this.detailsEditor.show();
    };
    DevolucionesEditor.prototype.onEditingDetail = function (detail) {
        this.detailsEditor.detail = detail;
        this.detailsEditor.show();
    };
    DevolucionesEditor.prototype.onDeletingDetail = function (detail) {
        this.detailsList.deleteItem(detail);
    };
    DevolucionesEditor.prototype.onListItemsUpdated = function (updatedDetails) {
        this.devolucion.details = updatedDetails;
    };
    DevolucionesEditor.prototype.onSavingDetail = function (detail) {
        this.detailsList.updateItem(detail);
    };
    DevolucionesEditor.prototype.onSelectedItemChanged = function (venta) {
        var _this = this;
        this.venta = venta;
        this.devolucion.idVenta = venta.identity;
        this.devolucion.fechaVenta = venta.fechaSys;
        this.devolucion.idAlmacen = venta.idAlmacen;
        this.devolucion.idCliente = venta.idCliente;
        this.devolucion.idDivisa = venta.idDivisa;
        this.devolucion.idUnidadNegocio = venta.idUnidadNegocio;
        //this.devolucion.idReferencia = 
        this.devolucion.idSucursal = this.context.app.defaultSite.idBranch;
        this.devolucion.ordenCompra = venta.ordenCompra;
        this.devolucion.tipoCambio = venta.tipoCambio;
        this.cargarInfAdicional();
        venta.details.filter(function (d) { return d.idArticulo > 0; }).map(function (d) { return d; }).forEach(function (det) {
            var newDetArt = new devolucion_articulo_detail_1.DevolucionArticuloDetail;
            newDetArt.articulo = det.articulo;
            newDetArt.unidadMedida = det.unidadMedida;
            newDetArt.stock = det.stock;
            newDetArt.codigo = det.codigo;
            newDetArt.cantidad = det.cantidad;
            newDetArt.cantidadRef = det.cantidad;
            newDetArt.idUnidadMedida = det.idUnidadMedida;
            newDetArt.unidades = det.unidades;
            newDetArt.descripcion = det.descripcion;
            newDetArt.flete = 0;
            newDetArt.idArticulo = det.idArticulo;
            newDetArt.idServicio = det.idServicio;
            newDetArt.descuentos.descuento1 = det.descuentos.descuento1;
            newDetArt.descuentos.descuento2 = det.descuentos.descuento2;
            newDetArt.descuentos.descuento3 = det.descuentos.descuento3;
            newDetArt.descuentos.descuento4 = det.descuentos.descuento4;
            newDetArt.descuentos.descuento5 = det.descuentos.descuento5;
            newDetArt.descuentos.porcentajeDescuento1 = det.descuentos.porcentajeDescuento1;
            newDetArt.descuentos.porcentajeDescuento2 = det.descuentos.porcentajeDescuento2;
            newDetArt.descuentos.porcentajeDescuento3 = det.descuentos.porcentajeDescuento3;
            newDetArt.descuentos.porcentajeDescuento4 = det.descuentos.porcentajeDescuento4;
            newDetArt.descuentos.porcentajeDescuento5 = det.descuentos.porcentajeDescuento5;
            newDetArt.precioUnitario = det.precioUnitario;
            //Llenando los impuestos
            det.impuestos.forEach(function (imp) {
                var newImp = new accounting_1.ImpuestoDetailInfo;
                newImp.base = imp.base;
                newImp.importe = imp.importe;
                newImp.impuesto = imp.impuesto;
                newImp.tasaOCuota = imp.tasaOCuota;
                newImp.tipoAplicacion = imp.tipoAplicacion;
                newImp.tipoFactor = imp.tipoFactor;
                newDetArt.impuestos.push(newImp);
            });
            _this.devolucion.details.push(newDetArt);
        });
        venta.details.filter(function (d) { return d.idServicio > 0; }).map(function (d) { return d; }).forEach(function (det) {
            var newDetSer = new devolucion_servicio_detail_1.DevolucionServicioDetail;
            newDetSer.codigo = det.codigo;
            newDetSer.cantidad = det.cantidad;
            newDetSer.cantidadRef = det.cantidad;
            newDetSer.descripcion = det.descripcion;
            newDetSer.flete = 0;
            newDetSer.idArticulo = det.idArticulo;
            newDetSer.idServicio = det.idServicio;
            newDetSer.descuentos.descuento1 = det.descuentos.descuento1;
            newDetSer.descuentos.descuento2 = det.descuentos.descuento2;
            newDetSer.descuentos.descuento3 = det.descuentos.descuento3;
            newDetSer.descuentos.descuento4 = det.descuentos.descuento4;
            newDetSer.descuentos.descuento5 = det.descuentos.descuento5;
            newDetSer.descuentos.porcentajeDescuento1 = det.descuentos.porcentajeDescuento1;
            newDetSer.descuentos.porcentajeDescuento2 = det.descuentos.porcentajeDescuento2;
            newDetSer.descuentos.porcentajeDescuento3 = det.descuentos.porcentajeDescuento3;
            newDetSer.descuentos.porcentajeDescuento4 = det.descuentos.porcentajeDescuento4;
            newDetSer.descuentos.porcentajeDescuento5 = det.descuentos.porcentajeDescuento5;
            newDetSer.precioUnitario = det.precioUnitario;
            //Llenando los impuestos
            det.impuestos.forEach(function (imp) {
                var newImp = new accounting_1.ImpuestoDetailInfo;
                newImp.base = imp.base;
                newImp.importe = imp.importe;
                newImp.impuesto = imp.impuesto;
                newImp.tasaOCuota = imp.tasaOCuota;
                newImp.tipoAplicacion = imp.tipoAplicacion;
                newImp.tipoFactor = imp.tipoFactor;
                newDetSer.impuestos.push(newImp);
            });
            _this.devolucion.details.push(newDetSer);
        });
        this.articulos = this.devolucion.details.map(function (d) { return d; }).filter(function (d) { return d.idArticulo && d.idArticulo > 0; });
        this.servicios = this.devolucion.details.map(function (d) { return d; }).filter(function (d) { return d.idServicio && d.idServicio > 0; });
    };
    DevolucionesEditor.prototype.cargarInfAdicional = function () {
        var _this = this;
        //Cargar información del almacén origen
        this.almacenService.getDetailByID(this.devolucion.idAlmacen)
            .then(function (almacen) { return _this.devolucion.almacen = almacen; })
            .catch(function (error) { return _this.handleError(error); });
        //Cargar información de la unidad de negocio
        this.unidadNegocioService.getDetailByID(this.devolucion.idUnidadNegocio)
            .then(function (unidadNegocio) { return _this.devolucion.unidadNegocio = unidadNegocio; })
            .catch(function (error) { return _this.handleError(error); });
        this.divisaService.getDetailByID(this.devolucion.idDivisa)
            .then(function (divisa) {
            _this.devolucion.divisa = divisa;
        })
            .catch(function (error) { return _this.handleError(error); });
        this.clienteService.getDetailByID(this.devolucion.idCliente)
            .then(function (cliente) { return _this.devolucion.cliente = cliente; })
            .catch(function (error) { return _this.handleError(error); });
    };
    __decorate([
        core_1.ViewChild('detailsList'),
        __metadata("design:type", editors_1.EditableListComponent)
    ], DevolucionesEditor.prototype, "detailsList", void 0);
    __decorate([
        core_1.ViewChild('detailsEditor'),
        __metadata("design:type", devoluciones_detail_editor_1.DevolucionDetailEditor)
    ], DevolucionesEditor.prototype, "detailsEditor", void 0);
    __decorate([
        core_1.ViewChild('selectorVentas'),
        __metadata("design:type", ventas_selector_component_1.VentasSelectorComponent)
    ], DevolucionesEditor.prototype, "selectorVentas", void 0);
    DevolucionesEditor = DevolucionesEditor_1 = __decorate([
        core_1.Component({
            selector: 'ventas-devoluciones-editor',
            template: "\n      <form [formGroup]=\"documentForm\">\n          <azteca-document-editor #documentEditor\n                                         [title]=\"'Devoluciones'\"\n                                         [document]=\"devolucion\"\n                                         [valid]=\"valid\"\n                                         (configureDocument)=\"onConfigureDocument($event)\"\n                                         (creatingDocument)=\"onCreatingDocument()\"\n                                         (viewingDocument)=\"onViewingDocument($event)\"\n                                         (cloningDocument)=\"onCloningDocument($event)\"\n                                         (savingDocument)=\"onSavingDocument($event)\"\n                                         (loadingDocument)=\"onLoadingDocument($event)\"\n                                         (applyingNextStep)=\"onApplyingNextStep($event)\"\n                                         (menuItemClick)=\"onMenuItemClick($event)\">\n\n              <!------------------- Menu de acciones adicionales --------------------->\n\n              <!------------------- Controles del editor ----------------------------->\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <tabset>\n                          <tab heading=\"Generales\" (select)=\"onTabSelected($event)\">\n\n                              <azteca-form-field [label]=\"'Seleccionar venta:'\">\n                                  <azteca-form-field [label]=\"Venta\">\n                                      <sales-ventas-selector formControlName=\"idVenta\" [enabled]=\"selectorVentas.selectedID==''\" #selectorVentas (selectedItemChanged)=\"onSelectedItemChanged($event)\"> </sales-ventas-selector>\n                                  </azteca-form-field>\n                              </azteca-form-field>\n                        \n                              <label class=\"control-label\">Unidad de negocio:</label>\n                              <az-label [text]=\"devolucion.unidadNegocio.nombre ? devolucion.unidadNegocio.nombre: ''\"></az-label>\n\n                              <label class=\"control-label\">Almac\u00E9n origen:</label>\n                              <az-label [text]=\"devolucion.almacen.nombre ? devolucion.almacen.nombre: ''\"></az-label>\n\n                              <label class=\"control-label\">Cliente:</label>\n                              <az-label [text]=\"devolucion.cliente.code ? devolucion.cliente.code + '-' + devolucion.cliente.nombre : ''\"></az-label>\n\n                              <label class=\"control-label\">Divisa:</label>\n                              <az-label [text]=\"devolucion.divisa.code ? devolucion.divisa.code + ' - ' + devolucion.divisa.nombre : ''\"></az-label>\n\n\n\n                          </tab>\n                          <!--ARTICULOS -->\n                          <tab heading=\"Art\u00EDculos\" (select)=\"onTabSelected($event)\">\n                              <azteca-editable-list   #detailsList\n                                                      (addingItem)=\"onAddingDetail()\"\n                                                      (editingItem)=\"onEditingDetail($event)\"\n                                                      (deletingItem)=\"onDeletingDetail($event)\"\n                                                      (listItemsUpdated)=\"onListItemsUpdated($event)\"\n                                                      [allowNew]=\"false\"\n                                                      [listItems]=\"articulos\">\n\n                                  <!-- OPCIONES DEL MENU-->\n                                  <!--<azteca-menu-item [name]=\"'EDIT'\" [icon]=\"'glyphicon glyphicon-pencil'\" [text]=\"'Editar'\" [smallText]=\"'editar registro'\"></azteca-menu-item>\n                                  <azteca-menu-item [name]=\"'DELETE'\" [icon]=\"'glyphicon glyphicon-trash'\" [text]=\"'Eliminar'\" [smallText]=\"'eliminar registro'\"></azteca-menu-item>-->\n\n                                  <!-- COLUMNAS DEL GRID-->\n                                  <azteca-grid-column [header]=\"'C\u00F3digo'\" [binding]=\"'codigo'\" [width]=\"'10*'\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Descripci\u00F3n'\" [binding]=\"'articulo.articuloStock.nombre'\" [width]=\"'60*'\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'U.M.'\" [binding]=\"'unidadMedida.nombre'\" [width]=\"'30*'\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Cantidad'\" [binding]=\"'cantidad'\" [width]=\"'20*'\" [isReadOnly] =\"false\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Unidades'\" [binding]=\"'unidades'\" [width]=\"'20*'\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Lote'\" [binding]=\"'idLote'\" [width]=\"80\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Num. Serie'\" [binding]=\"'numeroSerie'\" [width]=\"'40*'\"></azteca-grid-column>\n\n                              </azteca-editable-list>\n                          </tab>\n                          <!--SERVICIOS -->\n                          <tab heading=\"Servicios\" (select)=\"onTabSelected($event)\">\n                              <azteca-editable-list #serviciosList\n                                                    (addingItem)=\"onAddingServicio()\"\n                                                    (editingItem)=\"onEditingServicio($event)\"\n                                                    (deletingItem)=\"onDeletingServicio($event)\"\n                                                    (listItemsUpdated)=\"onServiciosUpdated($event)\"\n                                                    [allowNew]=\"false\"\n                                                    [listItems]=\"servicios\">\n\n                                  <!-- OPCIONES DEL MENU-->\n                                  <!--<azteca-menu-item [name]=\"'EDIT'\" [icon]=\"'glyphicon glyphicon-pencil'\" [text]=\"'Editar'\" [smallText]=\"'editar servicio'\"></azteca-menu-item>\n                                  <azteca-menu-item [name]=\"'DELETE'\" [icon]=\"'glyphicon glyphicon-trash'\" [text]=\"'Eliminar'\" [smallText]=\"'eliminar servicio'\"></azteca-menu-item>-->\n\n                                  <!-- COLUMNAS DEL GRID-->\n                                  <azteca-grid-column [header]=\"'C\u00F3digo'\" [binding]=\"'servicio.code'\" [width]=\"100\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Descripci\u00F3n'\" [binding]=\"'descripcion'\" [width]=\"'5*'\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Cantidad'\" [binding]=\"'cantidad'\" [width]=\"'1*'\" [isReadOnly] =\"false\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Precio'\" [binding]=\"'precioNeto'\" [width]=\"'1*'\" format=\"C\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Importe'\" [binding]=\"'importe'\" [width]=\"'1*'\" format=\"C\"></azteca-grid-column>\n\n                              </azteca-editable-list>\n                          </tab>\n                          <tab heading=\"Historial\" (select)=\"onTabSelected($event)\">\n                              <document-history [history]=\"history\"></document-history>\n                          </tab>\n                      </tabset>\n\n                  </div>\n              </div>\n          </azteca-document-editor>\n      </form>\n\n      <ventas-devoluciones-detail-editor #detailsEditor                                     \n                                           (savingItem)=\"onSavingDetail($event)\">\n\n      </ventas-devoluciones-detail-editor>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return DevolucionesEditor_1; })
                },
                {
                    provide: core_2.DocumentService, useExisting: devolucion_service_1.DevolucionService
                }
            ]
        }),
        __metadata("design:paramtypes", [core_2.Context,
            router_1.Router,
            router_1.ActivatedRoute,
            common_1.Location,
            forms_1.FormBuilder,
            core_2.DocumentTypeService,
            devolucion_service_1.DevolucionService,
            inventory_1.AlmacenService,
            accounting_1.DivisaService,
            unidad_negocio_service_1.UnidadNegocioService,
            cliente_service_1.ClienteService])
    ], DevolucionesEditor);
    return DevolucionesEditor;
    var DevolucionesEditor_1;
}(editors_1.DocumentEditor));
exports.DevolucionesEditor = DevolucionesEditor;
