import { FormGroup, FormBuilder } from '@angular/forms';
import { Router, ActivatedRoute } from '@angular/router';
import { Context } from 'framework3/core';
import { ToolbarButton, AlertsBarComponent } from 'framework3/controls';
import { AreaItem, AlmacenItem, AreaService, AlmacenService } from '../../../inventory';
import { DivisaService } from '../../../accounting';
import { UnidadNegocioItem } from '../../models/unidad-negocio';
import { UnidadNegocioService } from '../../services/unidad-negocio.service';
import { ClienteInfo } from '../../models/cliente';
export declare class NuevaVentaComponent {
    private formBuilder;
    private router;
    private route;
    private context;
    private areaService;
    private almacenService;
    private unidadNegocioService;
    private divisaService;
    valid: boolean;
    form: FormGroup;
    idUnidadNegocio: number;
    idArea: number;
    idAlmacen: number;
    idDivisa: number;
    idCliente: number;
    idOrigen: number;
    cliente: ClienteInfo;
    unidadesNegocio: UnidadNegocioItem[];
    areas: AreaItem[];
    almacenes: AlmacenItem[];
    selectedUnidad: UnidadNegocioItem;
    alertsBar: AlertsBarComponent;
    constructor(formBuilder: FormBuilder, router: Router, route: ActivatedRoute, context: Context, areaService: AreaService, almacenService: AlmacenService, unidadNegocioService: UnidadNegocioService, divisaService: DivisaService);
    ngAfterViewInit(): void;
    private loadUnidadesNegocio();
    private loadAreas();
    private loadAlmacenes(idArea);
    cargarDivisaDefault(): void;
    onToolbarClick(button: ToolbarButton): void;
    onClienteChanged(cliente: ClienteInfo): void;
    handleError(error: any): void;
}
