"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
//Wijmo
var wijmo_1 = require("wijmo/wijmo");
//Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
var controls_1 = require("framework3/controls");
//Inventario
var inventory_1 = require("../../../inventory");
var venta_articulo_detail_1 = require("../../models/venta-articulo-detail");
var articulo_service_1 = require("../../services/articulo.service");
var VentaArticulosDetailEditor = /** @class */ (function (_super) {
    __extends(VentaArticulosDetailEditor, _super);
    function VentaArticulosDetailEditor(context, builder, unidadService, almacenService, articuloService) {
        var _this = _super.call(this, context) || this;
        _this.context = context;
        _this.builder = builder;
        _this.unidadService = unidadService;
        _this.almacenService = almacenService;
        _this.articuloService = articuloService;
        _this.unidadesMedida = [];
        _this.validInput = false;
        _this.lotes = [];
        _this.series = [];
        _this.precioUnitario = '$0.0';
        //Copia temporal que se utilizará para edición y no afecte al objeto original por si el usuario decide cancelar la edición
        _this.detailCopy = new venta_articulo_detail_1.VentaArticuloDetail();
        //Objeto original que se editará
        _this.detail = new venta_articulo_detail_1.VentaArticuloDetail();
        _this.idCliente = 0;
        _this.idAlmacen = 0;
        _this.form = builder.group({
            'idArticulo': [0, controls_1.AztecaValidators.selected],
            'precio': [0]
        });
        return _this;
    }
    /////////////////// METODOS ///////////////////////////////
    VentaArticulosDetailEditor.prototype.loadStock = function (idArticulo) {
        var _this = this;
        this.almacenService.loadStock(this.idAlmacen, idArticulo)
            .then(function (stock) {
            _this.stockConfig = stock;
            _this.loadUnidadesMedida(_this.detailCopy.articulo.unidadMedida.idUnidadMedidaTipo);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    VentaArticulosDetailEditor.prototype.loadUnidadesMedida = function (idTipoUnidad) {
        var _this = this;
        //Si el articulo esta controlado por series, no se puede cambiar la unidad de medida, por lo tanto solo se debe utilizar la unidad de medida el articulo,
        //en caso contrario, cargar lista de unidades de medida del mismo tipo
        if (this.stockConfig.manejaSeries) {
            var unidadArticulo = this.detailCopy.articulo.unidadMedida;
            var newUnidad = {
                id: unidadArticulo.identity, codigo: unidadArticulo.code, idUnidadMedidaTipo: unidadArticulo.idUnidadMedidaTipo, base: unidadArticulo.base,
                factor: unidadArticulo.factor, fraccionable: unidadArticulo.fraccionable, paquete: unidadArticulo.paquete, activo: true
            };
            var newUnidades = [];
            newUnidades.push(newUnidad);
            this.unidadesMedida = newUnidades;
            this.detailCopy.idUnidadMedida = unidadArticulo.identity;
        }
        else {
            this.unidadService.loadList(idTipoUnidad)
                .then(function (unidadesMedida) {
                _this.unidadesMedida = unidadesMedida;
                _this.detailCopy.idUnidadMedida = _this.detailCopy.articulo.idUnidadMedida;
            })
                .catch(function (error) { return _this.handleError(error); });
        }
    };
    /////////////////// HANDLERS //////////////////////////////
    VentaArticulosDetailEditor.prototype.onCreatingItem = function () {
        this.detailCopy = this.detail;
        this.form.reset({ sample: '' });
        this.form.markAsPristine();
    };
    VentaArticulosDetailEditor.prototype.onLoadingItem = function (detail) {
        this.detailCopy = this.copyItem(this.detail);
    };
    VentaArticulosDetailEditor.prototype.onUpdatingItem = function (detail) {
        var _this = this;
        this.unidadService.getDetailFromCache(this.detailCopy.idUnidadMedida)
            .then(function (unidad) {
            //Si el artículo maneja lotes y ningún método de valuación, el usuario podrá especificar indicar manualmente los lotes y por lo cual generar más de un detalle
            if (!_this.stockConfig.manejaSeries && _this.stockConfig.manejaLotes && (_this.stockConfig.metodoValuacion == inventory_1.MetodoValuacion.NINGUNO || _this.stockConfig.metodoValuacion == '')) {
                var details_1 = [];
                //Crear una partida por cada lote que el usuario haya seleccionado
                _this.lotes.filter(function (lote) { return lote.cantidad > 0 || lote.unidades > 0; }).forEach(function (lote) {
                    var detail = new venta_articulo_detail_1.VentaArticuloDetail();
                    detail._clientID = _this.createClientID();
                    detail.idArticulo = _this.detailCopy.idArticulo;
                    detail.codigo = _this.detailCopy.codigo;
                    detail.descripcion = _this.detailCopy.descripcion;
                    detail.cantidad = lote.cantidad;
                    detail.unidades = lote.unidades;
                    //detail.costo = lote.costo;
                    detail.idLote = lote.id;
                    detail.idUnidadMedida = _this.detailCopy.idUnidadMedida;
                    //
                    detail.articulo = _this.detailCopy.articulo;
                    detail.stock = _this.stockConfig;
                    detail.unidadMedida = unidad;
                    //Asignacion de importes
                    detail.precioUnitario = _this.detailCopy.precioUnitario;
                    detail.precioNeto = _this.detailCopy.precioNeto;
                    detail.descuentos = _this.detailCopy.descuentos;
                    detail.impuestos = _this.detailCopy.impuestos;
                    detail.importe = detail.precioNeto * detail.cantidad;
                    //
                    details_1.push(detail);
                });
                _this.savingItems.emit(details_1);
            }
            else if (_this.stockConfig.manejaSeries && (_this.stockConfig.metodoValuacion == inventory_1.MetodoValuacion.NINGUNO || _this.stockConfig.metodoValuacion == '')) {
                var details_2 = [];
                //Crear una partida por cada lote que el usuario haya seleccionado
                _this.series.forEach(function (item) {
                    var detail = new venta_articulo_detail_1.VentaArticuloDetail();
                    detail._clientID = _this.createClientID();
                    detail.idArticulo = _this.detailCopy.idArticulo;
                    detail.numeroSerie = item.numeroSerie;
                    detail.codigo = _this.detailCopy.codigo;
                    detail.descripcion = _this.detailCopy.descripcion;
                    detail.cantidad = 1;
                    detail.unidades = 0;
                    //detail.costoUnitario = item.costo;
                    detail.idLote = item.idLote;
                    detail.idUnidadMedida = _this.detailCopy.idUnidadMedida;
                    //
                    detail.articulo = _this.detailCopy.articulo;
                    detail.stock = _this.stockConfig;
                    detail.unidadMedida = unidad;
                    //
                    details_2.push(detail);
                });
                _this.savingItems.emit(details_2);
            }
            else {
                _this.detailCopy.stock = _this.stockConfig;
                _this.detailCopy.unidadMedida = unidad;
                _this.detailCopy._clientID = _this.createClientID();
                _this.detailCopy.importe = _this.detailCopy.precioNeto * _this.detailCopy.cantidad;
                _this.savingItem.emit(_this.detailCopy);
            }
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    VentaArticulosDetailEditor.prototype.onArticuloChanged = function (articulo) {
        var _this = this;
        if (articulo) {
            this.detailCopy.codigo = articulo.code;
            this.detailCopy.descripcion = articulo.nombre;
            this.detailCopy.articulo = articulo;
            this.detailCopy.idEstructuraComercial = articulo.idEstCom;
            this.loadStock(articulo.articuloStock.identity);
            this.articuloService.calcularPrecioCliente(this.detailCopy.idArticulo, this.idCliente, this.context.app.defaultCompany.identity)
                .then(function (precio) {
                _this.detailCopy.precioUnitario = precio.precioBase;
                _this.detailCopy.precioNeto = precio.precioNeto;
                _this.detailCopy.descuentos = precio.descuentos;
                _this.detailCopy.impuestos = precio.impuestos;
                _this.precioUnitario = wijmo_1.Globalize.formatNumber(_this.detailCopy.precioUnitario, 'c');
            })
                .catch(function (error) { return _this.handleError(error); });
        }
        else {
            this.unidadesMedida = [];
            this.stockConfig = new inventory_1.StockInfo();
        }
    };
    VentaArticulosDetailEditor.prototype.onInputValidChange = function (valid) {
        this.validInput = valid;
    };
    VentaArticulosDetailEditor.prototype.onLotesChange = function (lotes) {
        this.lotes = lotes;
    };
    VentaArticulosDetailEditor.prototype.onSeriesChange = function (series) {
        this.series = series;
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", venta_articulo_detail_1.VentaArticuloDetail)
    ], VentaArticulosDetailEditor.prototype, "detail", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], VentaArticulosDetailEditor.prototype, "idCliente", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], VentaArticulosDetailEditor.prototype, "idAlmacen", void 0);
    VentaArticulosDetailEditor = __decorate([
        core_1.Component({
            selector: 'venta-articulos-detail-editor',
            template: "\n      <form [formGroup]=\"form\">\n          <azteca-basic-editor [item]=\"detail\"\n                               [dirty]=\"dirty\"\n                               [valid]=\"valid && validInput\"\n                               [title]=\"'Editar art\u00EDculos de la venta'\"\n                               (creatingItem)=\"onCreatingItem()\"\n                               (loadingItem)=\"onLoadingItem($event)\"\n                               (updatingItem)=\"onUpdatingItem($event)\">\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-9\">\n                      <azteca-form-field [label]=\"'Art\u00EDculo:'\">\n                          <sales-articulos-selector formControlName=\"idArticulo\"\n                                                    [(ngModel)]=\"detailCopy.idArticulo\"\n                                                    [showListButton]=\"false\"\n                                                    (selectedItemChanged)=\"onArticuloChanged($event)\">\n                          </sales-articulos-selector>                    \n                      </azteca-form-field>\n\n                  </div>\n                  <div class=\"col-12 col-md-3\">\n                      <label class=\"control-label\">Precio unitario:</label>\n                      <az-label [text]=\"precioUnitario\"></az-label>\n                  </div>\n              </div>\n\n              <div class=\"row\">\n                  <div class=\"col-12\">\n                      <inventory-articulo-stock-salida [stockConfig]=\"stockConfig\"\n                                                       [unidadesMedida]=\"unidadesMedida\"\n                                                       [idAlmacen]=\"idAlmacen\"\n                                                       [idArticuloStock]=\"detailCopy.articulo.idArticuloStock\"\n                                                       [(cantidad)]=\"detailCopy.cantidad\"\n                                                       [(unidades)]=\"detailCopy.unidades\"\n                                                       [(idUnidadMedida)]=\"detailCopy.idUnidadMedida\"\n                                                       (lotesChange)=\"onLotesChange($event)\"\n                                                       (seriesChange)=\"onSeriesChange($event)\"\n                                                       (validChange)=\"onInputValidChange($event)\">\n                      </inventory-articulo-stock-salida>\n                  </div>            \n\n              </div>\n\n          </azteca-basic-editor>\n      </form>\n    "
        }),
        __metadata("design:paramtypes", [core_2.Context, forms_1.FormBuilder, inventory_1.UnidadMedidaService,
            inventory_1.AlmacenService, articulo_service_1.ArticuloService])
    ], VentaArticulosDetailEditor);
    return VentaArticulosDetailEditor;
}(editors_1.BasicEditor));
exports.VentaArticulosDetailEditor = VentaArticulosDetailEditor;
