"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var wijmo_1 = require("wijmo/wijmo");
var wijmo_grid_1 = require("wijmo/wijmo.grid");
//Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
var controls_1 = require("framework3/controls");
//Modulos pixkua
var accounting_1 = require("../../../accounting");
var inventory_1 = require("../../../inventory");
var venta_servicio_detail_1 = require("../../models/venta-servicio-detail");
var servicio_1 = require("../../models/servicio");
var servicio_service_1 = require("../../services/servicio.service");
var VentaServiciosDetailEditor = /** @class */ (function (_super) {
    __extends(VentaServiciosDetailEditor, _super);
    function VentaServiciosDetailEditor(context, builder, servicioService, unidadService, unidadTipoService) {
        var _this = _super.call(this, context) || this;
        _this.context = context;
        _this.builder = builder;
        _this.servicioService = servicioService;
        _this.unidadService = unidadService;
        _this.unidadTipoService = unidadTipoService;
        //Copia temporal que se utilizará para edición y no afecte al objeto original por si el usuario decide cancelar la edición
        _this.detailCopy = new venta_servicio_detail_1.VentaServicioDetail();
        //
        _this.trasladosCollection = new wijmo_1.CollectionView();
        _this.retencionesCollection = new wijmo_1.CollectionView();
        _this.unidadesMedida = [];
        //Objeto original que se editará
        _this.detail = new venta_servicio_detail_1.VentaServicioDetail();
        _this.idCliente = 0;
        _this.form = builder.group({
            'idServicio': [0, controls_1.AztecaValidators.selected],
            'cantidad': [0],
            'descripcion': [''],
            'precio': [0]
        });
        _this.trasladosCollection.filter = function (item) {
            return item.tipoAplicacion == accounting_1.TipoAplicacion.TRASLADO;
        };
        _this.retencionesCollection.filter = function (item) {
            return item.tipoAplicacion == accounting_1.TipoAplicacion.RETENCION;
        };
        _this.form.controls.precio.valueChanges.subscribe(function (value) {
            _this.onPrecioChanged(value);
        });
        return _this;
    }
    /////////////////// METODOS ///////////////////////////////
    VentaServiciosDetailEditor.prototype.loadUnidadMedida = function () {
        var _this = this;
        this.unidadTipoService.getDetailByCode(0, 'SVC')
            .then(function (tipo) {
            _this.unidadService.loadList(tipo.identity)
                .then(function (unidades) {
                _this.unidadesMedida = unidades;
            })
                .catch(function (error) { return _this.handleError(error); });
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    /////////////////// HANDLERS //////////////////////////////
    VentaServiciosDetailEditor.prototype.onPrecioChanged = function (precio) {
        if (precio > 0 && this.detailCopy && this.detailCopy.servicio.libre) {
            this.detailCopy.impuestos.forEach(function (impuesto) {
                impuesto.base = precio;
            });
            this.trasladosCollection.refresh();
            this.retencionesCollection.refresh();
        }
    };
    VentaServiciosDetailEditor.prototype.onCreatingItem = function () {
        //this.loadUnidadMedida();
        this.detailCopy = this.detail;
        this.form.reset({ idServicio: 0 });
        this.form.markAsPristine();
        wijmo_1.Control.invalidateAll();
    };
    VentaServiciosDetailEditor.prototype.onLoadingItem = function (detail) {
        //this.loadUnidadMedida();
        this.detailCopy = this.copyItem(this.detail);
        wijmo_1.Control.invalidateAll();
    };
    VentaServiciosDetailEditor.prototype.onUpdatingItem = function (detail) {
        if (this.detailCopy._clientID == 0) {
            this.detailCopy._clientID = this.createClientID();
        }
        else {
            this.detailCopy.state = editors_1.ChangeState.MODIFIED;
        }
        //Si NO es un servicio libre, asignar descripcion del servicio
        if (!this.detailCopy.servicio.libre) {
            this.detailCopy.descripcion = this.detailCopy.servicio.nombre;
        }
        else {
            var precio = this.servicioService.calcularPrecioLibre(this.detailCopy.precioUnitario, this.detailCopy.servicio.impuestoIncluido, this.detailCopy.impuestos);
            this.detailCopy.precioNeto = precio.precioNeto;
            this.detailCopy.impuestos = precio.impuestos;
            this.detailCopy.descuentos = precio.descuentos;
        }
        this.detailCopy.importe = this.detailCopy.precioNeto * this.detailCopy.cantidad;
        this.savingItem.emit(this.detailCopy);
    };
    VentaServiciosDetailEditor.prototype.onServicioChanged = function (servicio) {
        var _this = this;
        if (servicio) {
            this.detailCopy.codigo = servicio.code;
            this.detailCopy.servicio = servicio;
            this.detailCopy.idEstructuraComercial = servicio.idEstCom;
            this.detailCopy.idUnidadMedida = servicio.idUnidadMedida;
            this.detailCopy.descripcion = servicio.nombre;
            //Hacer requerido el campo de descripción cuando el servicio sea de concepto libre
            if (this.detailCopy.servicio.libre) {
                this.form.controls.descripcion.setValidators(forms_1.Validators.required);
            }
            else {
                this.form.controls.descripcion.setValidators(null);
            }
            this.form.controls.descripcion.updateValueAndValidity();
            //Cargar información de precios del servicio
            this.servicioService.calcularPrecioCliente(this.detailCopy.idServicio, this.idCliente, this.context.app.defaultCompany.identity, 0)
                .then(function (precio) {
                _this.detailCopy.precioUnitario = precio.precioBase;
                _this.detailCopy.precioNeto = precio.precioNeto;
                _this.detailCopy.impuestos = precio.impuestos;
                _this.detailCopy.descuentos = precio.descuentos;
                //
                _this.trasladosCollection.sourceCollection = precio.impuestos;
                _this.retencionesCollection.sourceCollection = precio.impuestos;
            })
                .catch(function (error) { return _this.handleError(error); });
        }
        else {
            this.detailCopy.servicio = new servicio_1.ServicioInfo();
        }
    };
    VentaServiciosDetailEditor.prototype.onEditCell = function (grid, args) {
        if (!grid.rows[args.row].dataItem.impuesto.rango && grid.columns[args.col].binding == 'tasaOCuota') {
            args.cancel = true;
        }
    };
    VentaServiciosDetailEditor.prototype.onFormatCell = function (grid, args) {
        if (args.panel.cellType == wijmo_grid_1.CellType.Cell && !grid.rows[args.row].dataItem.impuesto.rango && grid.columns[args.col].binding == 'tasaOCuota') {
            args.cell.style.backgroundColor = '#C0C0C0';
        }
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", venta_servicio_detail_1.VentaServicioDetail)
    ], VentaServiciosDetailEditor.prototype, "detail", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], VentaServiciosDetailEditor.prototype, "idCliente", void 0);
    VentaServiciosDetailEditor = __decorate([
        core_1.Component({
            selector: 'venta-servicios-detail-editor',
            template: "\n      <form [formGroup]=\"form\">\n          <azteca-basic-editor [item]=\"detail\"\n                               [dirty]=\"dirty\"\n                               [valid]=\"valid && detailCopy.cantidad > 0\"\n                               [title]=\"'Editar servicios de la venta'\"\n                               (creatingItem)=\"onCreatingItem()\"\n                               (loadingItem)=\"onLoadingItem($event)\"\n                               (updatingItem)=\"onUpdatingItem($event)\">\n        \n\n              <div class=\"row\">\n                  <div class=\"col-12\">\n                      <azteca-form-field [label]=\"'Servicio:'\">\n                          <sales-servicios-selector formControlName=\"idServicio\"\n                                                    [(ngModel)]=\"detailCopy.idServicio\"\n                                                    [showListButton]=\"true\"\n                                                    (selectedItemChanged)=\"onServicioChanged($event)\">\n\n                          </sales-servicios-selector>\n\n                      </azteca-form-field>\n\n                  </div>\n              </div>\n\n\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-lg-6\">\n                      <azteca-form-field [label]=\"'Cantidad:'\">\n                          <az-input-number formControlName=\"cantidad\" [(ngModel)]=\"detailCopy.cantidad\" format=\"n0\"></az-input-number>\n                      </azteca-form-field>\n                  </div>\n\n                  <div class=\"col-12 col-lg-6\">\n                      <azteca-form-field [label]=\"'Precio:'\">\n                          <az-input-number formControlName=\"precio\" [(ngModel)]=\"detailCopy.precioUnitario\" format=\"C\" [enabled]=\"detailCopy.servicio.libre\"></az-input-number>\n                      </azteca-form-field>\n                  </div>\n              </div>\n\n              <div class=\"row\">\n                  <div class=\"col-12\" *ngIf=\"detailCopy.servicio.libre\">\n                      <azteca-form-field [label]=\"'Descripci\u00F3n:'\">\n                          <az-textarea formControlName=\"descripcion\" [(ngModel)]=\"detailCopy.descripcion\"></az-textarea>\n                      </azteca-form-field>\n                  </div>\n              </div>\n\n              <!--GRID DE TRASLADOS-->\n              <div class=\"row\" *ngIf=\"detailCopy.servicio.libre\">\n                  <div class=\"col-12\">\n                      <label class=\"control-label\">Traslados:</label>\n                      <wj-flex-grid #gridTraslados style=\"height:120px\" [itemsSource]=\"trasladosCollection\"\n                                    (beginningEdit)=\"onEditCell(gridTraslados, $event)\" (formatItem)=\"onFormatCell(gridTraslados, $event)\">\n                          <wj-flex-grid-column [header]=\"'Impuesto'\" [binding]=\"'impuesto.nombre'\" [width]=\"'30*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                          <wj-flex-grid-column [header]=\"'Factor'\" [binding]=\"'tipoFactor'\" [width]=\"'20*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                          <wj-flex-grid-column [header]=\"'Base'\" [binding]=\"'base'\" [width]=\"'20*'\"></wj-flex-grid-column>\n                          <wj-flex-grid-column [header]=\"'Tasa \u00F3 cuota'\" [binding]=\"'tasaOCuota'\" [width]=\"'20*'\"></wj-flex-grid-column>\n                      </wj-flex-grid>\n\n                  </div>\n              </div>\n\n              <!--GRID DE RETENCIONES-->\n              <div class=\"row\" *ngIf=\"detailCopy.servicio.libre\">\n                  <div class=\"col-12\">\n\n                      <label class=\"control-label\">Retenciones:</label>\n                      <wj-flex-grid #gridRetenciones style=\"height:120px\" [itemsSource]=\"retencionesCollection\"\n                                    (beginningEdit)=\"onEditCell(gridRetenciones, $event)\" (formatItem)=\"onFormatCell(gridRetenciones, $event)\">\n                          <wj-flex-grid-column [header]=\"'Impuesto'\" [binding]=\"'impuesto.nombre'\" [width]=\"'30*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                          <wj-flex-grid-column [header]=\"'Factor'\" [binding]=\"'tipoFactor'\" [width]=\"'20*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                          <wj-flex-grid-column [header]=\"'Base'\" [binding]=\"'base'\" [width]=\"'20*'\"></wj-flex-grid-column>\n                          <wj-flex-grid-column [header]=\"'Tasa \u00F3 cuota'\" [binding]=\"'tasaOCuota'\" [width]=\"'20*'\"></wj-flex-grid-column>\n                      </wj-flex-grid>\n\n                  </div>\n              </div>\n\n          </azteca-basic-editor>\n      </form>\n    "
        }),
        __metadata("design:paramtypes", [core_2.Context, forms_1.FormBuilder, servicio_service_1.ServicioService,
            inventory_1.UnidadMedidaService, inventory_1.UnidadMedidaTipoService])
    ], VentaServiciosDetailEditor);
    return VentaServiciosDetailEditor;
}(editors_1.BasicEditor));
exports.VentaServiciosDetailEditor = VentaServiciosDetailEditor;
