import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { Context, DocumentItem, DocumentTypeService, DocumentTypeInfo } from 'framework3/core';
import { MenuItem, DownloadPopupComponent } from 'framework3/controls';
import { DocumentEditor, EditableListComponent, EditorEventArgs, WorkflowEventArgs } from 'framework3/editors';
import { DivisaService } from '../../accounting';
import { AlmacenService, DetailQuantityEditor } from '../../inventory';
import { CobranzaComponent, CobranzaFormaPagoDetail } from '../../credit';
import { VentaInfo } from '../models/venta';
import { VentaDetail } from '../models/venta-detail';
import { VentaService } from '../services/venta.service';
import { VentaArticulosDetailEditor } from './parts/venta-articulos-detail.editor';
import { VentaServiciosDetailEditor } from './parts/venta-servicios-detail.editor';
import { VentaArticuloDetail } from '../models/venta-articulo-detail';
import { VentaServicioDetail } from '../models/venta-servicio-detail';
import { ClienteService } from '../services/cliente.service';
import { UnidadNegocioService } from '../services/unidad-negocio.service';
import { EmpresaService } from '../services/empresa.service';
export declare class VentasEditor extends DocumentEditor {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    private location;
    private formBuilder;
    protected documentTypeService: DocumentTypeService;
    private ventaService;
    private divisaService;
    private almacenService;
    private unidadNegocioService;
    private clienteService;
    private empresaService;
    venta: VentaInfo;
    articulos: VentaArticuloDetail[];
    servicios: VentaServicioDetail[];
    condicionesPagoItems: {
        id: string;
        nombre: string;
    }[];
    metodoCobranzaEfectivo: string;
    argsEditorEvent: EditorEventArgs;
    argsCurrentDocument: WorkflowEventArgs;
    articulosList: EditableListComponent;
    serviciosList: EditableListComponent;
    articulosEditor: VentaArticulosDetailEditor;
    serviciosEditor: VentaServiciosDetailEditor;
    dlgCobranza: CobranzaComponent;
    downloadPopup: DownloadPopupComponent;
    quantityEditor: DetailQuantityEditor;
    constructor(context: Context, router: Router, route: ActivatedRoute, location: Location, formBuilder: FormBuilder, documentTypeService: DocumentTypeService, ventaService: VentaService, divisaService: DivisaService, almacenService: AlmacenService, unidadNegocioService: UnidadNegocioService, clienteService: ClienteService, empresaService: EmpresaService);
    onConfigureDocument(docType: DocumentTypeInfo): void;
    onCreatingDocument(): void;
    onViewingDocument(id: string): void;
    onCloningDocument(id: string): void;
    onLoadingDocument(id: string): void;
    combineDetail(): VentaDetail[];
    onSavingDocument(args: EditorEventArgs): void;
    onApplyingNextStep(args: WorkflowEventArgs): void;
    onApplyingPreviousStep(document: DocumentItem): void;
    onTabSelected(args: any): void;
    onMenuItemClick(option: MenuItem): void;
    onAddingArticulo(): void;
    onEditingArticulo(detail: VentaArticuloDetail): void;
    onDeletingArticulo(detail: VentaArticuloDetail): void;
    onArticulosUpdated(updatedItems: VentaArticuloDetail[]): void;
    onSavingArticulo(detail: VentaArticuloDetail): void;
    onSavingArticulos(details: VentaArticuloDetail[]): void;
    onUpdateQuantity(value: any): void;
    onAddingServicio(): void;
    onEditingServicio(detail: VentaServicioDetail): void;
    onDeletingServicio(detail: VentaServicioDetail): void;
    onServiciosUpdated(updatedServices: VentaServicioDetail[]): void;
    onSavingServicio(detail: VentaServicioDetail): void;
    onSavingServicios(details: VentaServicioDetail[]): void;
    cobroAceptado(formasPagoCobro: CobranzaFormaPagoDetail): void;
    cargarInfomacionEntidades(): void;
    private refreshValidity();
}
