"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Wijmo
var wijmo_1 = require("wijmo/wijmo");
//Azteca Kernel
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
var editors_1 = require("framework3/editors");
//Pixkua
var accounting_1 = require("../../accounting");
var inventory_1 = require("../../inventory");
var credit_1 = require("../../credit");
//Ventas
var venta_1 = require("../models/venta");
var venta_service_1 = require("../services/venta.service");
var venta_articulos_detail_editor_1 = require("./parts/venta-articulos-detail.editor");
var venta_servicios_detail_editor_1 = require("./parts/venta-servicios-detail.editor");
var venta_articulo_detail_1 = require("../models/venta-articulo-detail");
var venta_servicio_detail_1 = require("../models/venta-servicio-detail");
var cliente_service_1 = require("../services/cliente.service");
var unidad_negocio_service_1 = require("../services/unidad-negocio.service");
var empresa_service_1 = require("../services/empresa.service");
var VentasEditor = /** @class */ (function (_super) {
    __extends(VentasEditor, _super);
    function VentasEditor(context, router, route, location, formBuilder, documentTypeService, ventaService, divisaService, almacenService, unidadNegocioService, clienteService, empresaService) {
        var _this = _super.call(this, context, router, route, documentTypeService) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.location = location;
        _this.formBuilder = formBuilder;
        _this.documentTypeService = documentTypeService;
        _this.ventaService = ventaService;
        _this.divisaService = divisaService;
        _this.almacenService = almacenService;
        _this.unidadNegocioService = unidadNegocioService;
        _this.clienteService = clienteService;
        _this.empresaService = empresaService;
        _this.venta = new venta_1.VentaInfo();
        _this.articulos = [];
        _this.servicios = [];
        _this.condicionesPagoItems = [];
        _this.metodoCobranzaEfectivo = "";
        _this.documentForm = formBuilder.group({
            'idVendedor': [0],
            'condicionesPago': ['E']
        });
        _this.condicionesPagoItems.push({ id: 'E', nombre: 'Contado' });
        _this.condicionesPagoItems.push({ id: 'C', nombre: 'Parcialidades o diferido' });
        return _this;
    }
    VentasEditor_1 = VentasEditor;
    VentasEditor.prototype.onConfigureDocument = function (docType) {
        var _this = this;
        this.applyPolicies();
        this.empresaService.getDetailFromCache(this.context.app.defaultCompany.identity)
            .then(function (empresa) {
            _this.metodoCobranzaEfectivo = empresa.efectivoMetodoCobranza;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    VentasEditor.prototype.onCreatingDocument = function () {
        var _this = this;
        this.articulos = [];
        this.servicios = [];
        //Cargar parámetros que se proporcionan cuando es un nuevo documento
        this.route.params.forEach(function (params) {
            _this.venta.idUnidadNegocio = +params['idUnidadNegocio'];
            _this.venta.idAlmacen = +params['idAlmacen'];
            _this.venta.idCliente = +params['idCliente'];
            _this.venta.idDivisa = +params['idDivisa'];
            if (params['idOrigen']) {
                _this.venta.idOrigen = +params['idOrigen'];
            }
        });
        setTimeout(function (_) { return _this.cargarInfomacionEntidades(); });
    };
    VentasEditor.prototype.onViewingDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.ventaService.getDetail(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.venta = doc;
            _this.setReadonlyMode();
            _this.articulos = _this.venta.details.map(function (d) { return d; }).filter(function (d) { return d.idArticulo && d.idArticulo > 0; });
            _this.servicios = _this.venta.details.map(function (d) { return d; }).filter(function (d) { return d.idServicio && d.idServicio > 0; });
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    VentasEditor.prototype.onCloningDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.ventaService.clone(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.venta = doc;
            //
            _this.articulos = _this.venta.details.map(function (d) { return d; }).filter(function (d) { return d.idArticulo && d.idArticulo > 0; });
            _this.servicios = _this.venta.details.map(function (d) { return d; }).filter(function (d) { return d.idServicio && d.idServicio > 0; });
            //
            _this.articulosEditor.clientIndexStart = _this.articulos.length;
            _this.serviciosEditor.clientIndexStart = _this.servicios.length;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    VentasEditor.prototype.onLoadingDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.ventaService.getDetail(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.venta = doc;
            //
            _this.articulos = _this.venta.details.map(function (d) { return d; }).filter(function (d) { return d.idArticulo && d.idArticulo > 0; });
            _this.servicios = _this.venta.details.map(function (d) { return d; }).filter(function (d) { return d.idServicio && d.idServicio > 0; });
            //
            _this.articulosEditor.clientIndexStart = _this.articulos.length;
            _this.serviciosEditor.clientIndexStart = _this.servicios.length;
            if (_this.venta.status != core_2.DocumentStatus.DRAFT)
                _this.setReadonlyMode();
            setTimeout(function (_) { return _this.refreshValidity(); });
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    VentasEditor.prototype.combineDetail = function () {
        var newDetail = [];
        this.servicios.forEach(function (s) { return newDetail.push(s); });
        this.articulos.forEach(function (a) { return newDetail.push(a); });
        return newDetail;
    };
    VentasEditor.prototype.onSavingDocument = function (args) {
        var _this = this;
        this.argsEditorEvent = args;
        this.context.app.showSpinner();
        this.venta.details = this.combineDetail();
        this.ventaService.update(this.venta)
            .then(function (updatedDoc) {
            _this.context.app.hideSpinner();
            //Si es un elemento nuevo y no se cerrará el editor, navegar a nueva ruta
            _this.reset();
            if (!args.closeEditor && _this.venta.identity == '') {
                _this.router.navigate(['../', updatedDoc.identity], { relativeTo: _this.route });
            }
            else {
                if (args.closeEditor)
                    _this.router.navigate(['../'], { relativeTo: _this.route });
                else
                    _this.showAlert('La información ha sido actualizada con éxito', 'success');
            }
            _this.venta = updatedDoc;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    VentasEditor.prototype.onApplyingNextStep = function (args) {
        var _this = this;
        this.argsCurrentDocument = args;
        if (args.step.activities.find(function (a) { return a.tag == 'CREDIT'; }) && this.venta.condicionesPago == "E" && this.metodoCobranzaEfectivo == "A") {
            this.dlgCobranza.show(this.venta.total, this.venta.cliente.deudor.identity);
        }
        else {
            this.context.app.showSpinner();
            this.ventaService.nextStep(args.document.id, args.step.idWorkflowStep, null)
                .then(function (_) {
                _this.context.app.hideSpinner();
                //Volver a cargar documento
                _this.onViewingDocument(args.document.id);
            })
                .catch(function (error) { return _this.handleError(error); });
        }
    };
    VentasEditor.prototype.onApplyingPreviousStep = function (document) {
        var _this = this;
        this.context.app.showSpinner();
        this.ventaService.previousStep(document.id, null)
            .then(function (_) {
            //Volver a cargar documento
            _this.onViewingDocument(document.id);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    VentasEditor.prototype.onTabSelected = function (args) {
        if (args.heading) {
            //Al seleccionar la pestaña de historial, realizar carga de información
            if (args.heading == 'Historial') {
                this.loadHistory(this.venta.identity);
            }
            //Actualizar controles de wijmo
            wijmo_1.Control.invalidateAll();
        }
    };
    VentasEditor.prototype.onMenuItemClick = function (option) {
        var _this = this;
        if (option.name == 'PDF') {
            this.context.app.showSpinner();
            this.ventaService.generarPdfFactura(this.venta.identity)
                .then(function (uri) {
                _this.context.app.hideSpinner();
                window.open('/file-server/' + uri, '_blank');
            })
                .catch(function (error) { return _this.handleError(error); });
        }
        if (option.name == "DOWNLOAD") {
            this.context.app.showSpinner();
            //Generar PDF
            this.ventaService.generarPdfFactura(this.venta.identity)
                .then(function (pdf) {
                //Descargar xml
                _this.ventaService.getXmlFactura(_this.venta.identity)
                    .then(function (xml) {
                    _this.context.app.hideSpinner();
                    var links = [];
                    links.push(pdf);
                    links.push(xml);
                    _this.downloadPopup.show(links);
                })
                    .catch(function (error) { return _this.handleError(error); });
            })
                .catch(function (error) { return _this.handleError(error); });
        }
    };
    ///////////// ARTICULOS /////////////////////////
    VentasEditor.prototype.onAddingArticulo = function () {
        this.articulosEditor.detail = new venta_articulo_detail_1.VentaArticuloDetail();
        this.articulosEditor.show();
    };
    VentasEditor.prototype.onEditingArticulo = function (detail) {
        this.quantityEditor.unidadMedida = detail.unidadMedida;
        this.quantityEditor.cantidad = detail.cantidad;
        this.quantityEditor.unidades = detail.unidades;
        this.quantityEditor.show();
    };
    VentasEditor.prototype.onDeletingArticulo = function (detail) {
        this.articulosList.deleteItem(detail);
    };
    VentasEditor.prototype.onArticulosUpdated = function (updatedItems) {
        this.articulos = updatedItems;
    };
    VentasEditor.prototype.onSavingArticulo = function (detail) {
        this.articulosList.updateItem(detail);
    };
    VentasEditor.prototype.onSavingArticulos = function (details) {
        this.articulosList.updateItems(details);
    };
    VentasEditor.prototype.onUpdateQuantity = function (value) {
        var detail = this.articulosList.currentItem;
        if (detail.unidadMedida.paquete) {
            var cantidad = value;
            detail.cantidad = cantidad.paquetes;
            detail.unidades = cantidad.unidades;
        }
        else {
            detail.cantidad = value;
        }
        this.articulosList.updateItem(detail);
    };
    ///////////// SERVICIOS /////////////////////////
    VentasEditor.prototype.onAddingServicio = function () {
        this.serviciosEditor.detail = new venta_servicio_detail_1.VentaServicioDetail();
        this.serviciosEditor.show();
    };
    VentasEditor.prototype.onEditingServicio = function (detail) {
        this.serviciosEditor.detail = detail;
        this.serviciosEditor.show();
    };
    VentasEditor.prototype.onDeletingServicio = function (detail) {
        this.serviciosList.deleteItem(detail);
    };
    VentasEditor.prototype.onServiciosUpdated = function (updatedServices) {
        this.servicios = updatedServices;
    };
    VentasEditor.prototype.onSavingServicio = function (detail) {
        this.serviciosList.updateItem(detail);
    };
    VentasEditor.prototype.onSavingServicios = function (details) {
        this.serviciosList.updateItems(details);
    };
    ////////////  METODOS ///////////////////////////////////////
    VentasEditor.prototype.cobroAceptado = function (formasPagoCobro) {
        var _this = this;
        var pago = { formasPago: formasPagoCobro };
        this.context.app.showSpinner();
        this.ventaService.nextStep(this.editor.document.identity, this.argsCurrentDocument.step.idWorkflowStep, pago)
            .then(function (_) {
            _this.context.app.hideSpinner();
            //this.refreshList();
            _this.dlgCobranza.clear();
            _this.onViewingDocument(_this.editor.document.identity);
            if (!_this.argsEditorEvent.closeEditor && _this.venta.identity == '') {
                _this.router.navigate(['../', _this.editor.document.identity], { relativeTo: _this.route });
            }
            else {
                if (_this.argsEditorEvent.closeEditor)
                    _this.router.navigate(['../'], { relativeTo: _this.route });
                else
                    _this.showAlert('La información ha sido actualizada con éxito', 'success');
            }
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    VentasEditor.prototype.cargarInfomacionEntidades = function () {
        var _this = this;
        //Cargar información del almacén origen
        if (this.venta.idAlmacen > 0) {
            this.almacenService.getDetailByID(this.venta.idAlmacen)
                .then(function (almacen) { return _this.venta.almacen = almacen; })
                .catch(function (error) { return _this.handleError(error); });
        }
        else {
            this.venta.almacen.nombre = 'N/A';
        }
        //Cargar información de la unidad de negocio
        this.unidadNegocioService.getDetailByID(this.venta.idUnidadNegocio)
            .then(function (unidadNegocio) { return _this.venta.unidadNegocio = unidadNegocio; })
            .catch(function (error) { return _this.handleError(error); });
        this.divisaService.getDetailByID(this.venta.idDivisa)
            .then(function (divisa) {
            _this.venta.divisa = divisa;
        })
            .catch(function (error) { return _this.handleError(error); });
        this.clienteService.getDetailByID(this.venta.idCliente)
            .then(function (cliente) {
            _this.venta.cliente = cliente;
            _this.venta.condicionesPago = _this.venta.cliente.deudor.condicionesPago;
            setTimeout(function (_) { return _this.refreshValidity(); });
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    VentasEditor.prototype.refreshValidity = function () {
        this.editor.valid = this.documentForm.valid;
    };
    __decorate([
        core_1.ViewChild('articulosList'),
        __metadata("design:type", editors_1.EditableListComponent)
    ], VentasEditor.prototype, "articulosList", void 0);
    __decorate([
        core_1.ViewChild('serviciosList'),
        __metadata("design:type", editors_1.EditableListComponent)
    ], VentasEditor.prototype, "serviciosList", void 0);
    __decorate([
        core_1.ViewChild('articulosEditor'),
        __metadata("design:type", venta_articulos_detail_editor_1.VentaArticulosDetailEditor)
    ], VentasEditor.prototype, "articulosEditor", void 0);
    __decorate([
        core_1.ViewChild('serviciosEditor'),
        __metadata("design:type", venta_servicios_detail_editor_1.VentaServiciosDetailEditor)
    ], VentasEditor.prototype, "serviciosEditor", void 0);
    __decorate([
        core_1.ViewChild('dlgCobranza'),
        __metadata("design:type", credit_1.CobranzaComponent)
    ], VentasEditor.prototype, "dlgCobranza", void 0);
    __decorate([
        core_1.ViewChild(controls_1.DownloadPopupComponent),
        __metadata("design:type", controls_1.DownloadPopupComponent)
    ], VentasEditor.prototype, "downloadPopup", void 0);
    __decorate([
        core_1.ViewChild(inventory_1.DetailQuantityEditor),
        __metadata("design:type", inventory_1.DetailQuantityEditor)
    ], VentasEditor.prototype, "quantityEditor", void 0);
    VentasEditor = VentasEditor_1 = __decorate([
        core_1.Component({
            selector: 'sales-ventas-editor',
            template: "\n      <form [formGroup]=\"documentForm\">\n          <azteca-document-editor #documentEditor\n                                         [title]=\"'Ventas'\"\n                                         [document]=\"venta\"\n                                         [valid]=\"valid\"\n                                         (configureDocument)=\"onConfigureDocument($event)\"\n                                         (creatingDocument)=\"onCreatingDocument()\"\n                                         (viewingDocument)=\"onViewingDocument($event)\"\n                                         (cloningDocument)=\"onCloningDocument($event)\"\n                                         (savingDocument)=\"onSavingDocument($event)\"\n                                         (loadingDocument)=\"onLoadingDocument($event)\"\n                                         (applyingNextStep)=\"onApplyingNextStep($event)\"\n                                         (menuItemClick)=\"onMenuItemClick($event)\">\n\n              <!------------------- Menu de acciones adicionales --------------------->\n              <azteca-menu-item [name]=\"'PDF'\" [icon]=\"'glyphicon glyphicon-print'\" [text]=\"'Imprimir factura'\" [smallText]=\"'generar pdf de factura'\"></azteca-menu-item>\n              <azteca-menu-item [name]=\"'DOWNLOAD'\" [icon]=\"'glyphicon glyphicon-save'\" [text]=\"'Descargar factura'\" [smallText]=\"'descargar xml y pdf'\"></azteca-menu-item>\n              <!------------------- Controles del editor ----------------------------->\n              <div class=\"row\">\n                  <div class=\"col-12 col-lg-10\">\n                      <tabset>\n                          <!--GENERALES -->\n                          <tab heading=\"Generales\" (select)=\"onTabSelected($event)\">\n\n                              <label class=\"control-label\">Unidad de negocio:</label>\n                              <az-label [text]=\"venta.unidadNegocio.nombre\"></az-label>\n\n                              <label class=\"control-label\">Almac\u00E9n origen:</label>\n                              <az-label [text]=\"venta.almacen.nombre\"></az-label>\n\n                              <label class=\"control-label\">Cliente:</label>\n                              <az-label [text]=\"venta.cliente ? venta.cliente.code + '-' + venta.cliente.nombre : ''\"></az-label>\n\n                              <label class=\"control-label\">Divisa:</label>\n                              <az-label [text]=\"venta.divisa ? venta.divisa.code + ' - ' + venta.divisa.nombre : ''\"></az-label>\n\n\n                              <azteca-form-field [label]=\"'Condiciones de pago:'\">\n                                  <az-combobox formControlName=\"condicionesPago\" \n                                               [(ngModel)]=\"venta.condicionesPago\"\n                                               [items]=\"condicionesPagoItems\"\n                                               [valueMember]=\"'id'\"\n                                               [displayMember]=\"'nombre'\">\n                                  </az-combobox>\n                              </azteca-form-field>\n\n\n                              <azteca-form-field [label]=\"'Vendedor:'\">\n                                  <sales-vendedores-selector formControlName=\"idVendedor\" [(ngModel)]=\"venta.idVendedor\"></sales-vendedores-selector>\n                              </azteca-form-field>\n\n                          </tab>\n                          <!--ARTICULOS -->\n                          <tab heading=\"Art\u00EDculos\" (select)=\"onTabSelected($event)\">\n                              <azteca-editable-list   #articulosList\n                                                      (addingItem)=\"onAddingArticulo()\"\n                                                      (editingItem)=\"onEditingArticulo($event)\"\n                                                      (deletingItem)=\"onDeletingArticulo($event)\"\n                                                      (listItemsUpdated)=\"onArticulosUpdated($event)\"\n                                                      [listItems]=\"articulos\">\n\n                                  <!-- OPCIONES DEL MENU-->\n                                  <azteca-menu-item [name]=\"'EDIT'\" [icon]=\"'glyphicon glyphicon-pencil'\" [text]=\"'Editar'\" [smallText]=\"'editar art\u00EDculo'\"></azteca-menu-item>\n                                  <azteca-menu-item [name]=\"'DELETE'\" [icon]=\"'glyphicon glyphicon-trash'\" [text]=\"'Eliminar'\" [smallText]=\"'eliminar art\u00EDculo'\"></azteca-menu-item>\n\n                                  <!-- COLUMNAS DEL GRID-->\t\t\t\t\t\t\t\n                                  <azteca-grid-column [header]=\"'Descripci\u00F3n'\" [binding]=\"'articulo.articuloStock.nombre'\" [width]=\"'50*'\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'U.M.'\" [binding]=\"'unidadMedida.nombre'\" [width]=\"'20*'\"></azteca-grid-column>                                                        \n                                  <azteca-grid-column [header]=\"'Lote'\" [binding]=\"'idLote'\" [width]=\"80\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Num. Serie'\" [binding]=\"'numeroSerie'\" [width]=\"'30*'\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Cantidad'\" [binding]=\"'cantidad'\" [width]=\"'10*'\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Unidades'\" [binding]=\"'unidades'\" [width]=\"'10*'\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Precio'\" [binding]=\"'precioNeto'\" [width]=\"'10*'\" format=\"C\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Importe'\" [binding]=\"'importe'\" [width]=\"'20*'\" format=\"C\"></azteca-grid-column>\n                              </azteca-editable-list>\n                          </tab>\n                          <!--SERVICIOS -->\n                          <tab heading=\"Servicios\" (select)=\"onTabSelected($event)\">\n                              <azteca-editable-list #serviciosList\n                                                    (addingItem)=\"onAddingServicio()\"\n                                                    (editingItem)=\"onEditingServicio($event)\"\n                                                    (deletingItem)=\"onDeletingServicio($event)\"\n                                                    (listItemsUpdated)=\"onServiciosUpdated($event)\"\n                                                    [listItems]=\"servicios\">\n\n                                  <!-- OPCIONES DEL MENU-->\n                                  <azteca-menu-item [name]=\"'EDIT'\" [icon]=\"'glyphicon glyphicon-pencil'\" [text]=\"'Editar'\" [smallText]=\"'editar servicio'\"></azteca-menu-item>\n                                  <azteca-menu-item [name]=\"'DELETE'\" [icon]=\"'glyphicon glyphicon-trash'\" [text]=\"'Eliminar'\" [smallText]=\"'eliminar servicio'\"></azteca-menu-item>\n\n                                  <!-- COLUMNAS DEL GRID-->                            \n                                  <azteca-grid-column [header]=\"'C\u00F3digo'\" [binding]=\"'servicio.code'\" [width]=\"100\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Descripci\u00F3n'\" [binding]=\"'descripcion'\" [width]=\"'5*'\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Cantidad'\" [binding]=\"'cantidad'\" [width]=\"'1*'\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Precio'\" [binding]=\"'precioNeto'\" [width]=\"'1*'\" format=\"C\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Importe'\" [binding]=\"'importe'\" [width]=\"'1*'\" format=\"C\"></azteca-grid-column>\n\n                              </azteca-editable-list>\n                          </tab>\n\n                          <!--HISTORIAL -->\n                          <tab heading=\"Historial\" (select)=\"onTabSelected($event)\" [disabled]=\"venta.identity == ''\">\n                              <document-history [history]=\"history\"></document-history>\n                          </tab>\n                      </tabset>\n\n                  </div>\n              </div>\n          </azteca-document-editor>\n      </form>\n\n      <venta-articulos-detail-editor #articulosEditor       \n                                       [idCliente]=\"venta.idCliente\"\n                                       [idAlmacen]=\"venta.idAlmacen\"\n                                       (savingItem)=\"onSavingArticulo($event)\"\n                                       (savingItems)=\"onSavingArticulos($event)\">\n\n      </venta-articulos-detail-editor>\n\n      <venta-servicios-detail-editor #serviciosEditor\n                                     [idCliente]=\"venta.idCliente\"\n                                     (savingItem)=\"onSavingServicio($event)\"\n                                     (savingItems)=\"onSavingServicios($event)\">\n\n      </venta-servicios-detail-editor>\n\n\n      <credit-cobranza #dlgCobranza (cobroAcceptado)=\"cobroAceptado($event)\">\n\n      </credit-cobranza>\n\n      <download-popup></download-popup>\n\n      <inventario-detail-quantity (updateQuantity)=\"onUpdateQuantity($event)\">\n\n      </inventario-detail-quantity>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return VentasEditor_1; })
                },
                {
                    provide: core_2.DocumentService, useExisting: venta_service_1.VentaService
                }
            ]
        }),
        __metadata("design:paramtypes", [core_2.Context,
            router_1.Router,
            router_1.ActivatedRoute,
            common_1.Location,
            forms_1.FormBuilder,
            core_2.DocumentTypeService,
            venta_service_1.VentaService,
            accounting_1.DivisaService,
            inventory_1.AlmacenService,
            unidad_negocio_service_1.UnidadNegocioService,
            cliente_service_1.ClienteService,
            empresa_service_1.EmpresaService])
    ], VentasEditor);
    return VentasEditor;
    var VentasEditor_1;
}(editors_1.DocumentEditor));
exports.VentasEditor = VentasEditor;
