import { Router, ActivatedRoute } from '@angular/router';
import { Context, DocumentItem } from 'framework3/core';
import { DocumentManager, WorkflowEventArgs } from 'framework3/editors';
import { SearchRequest } from 'framework3/search';
import { MenuItem, DownloadPopupComponent } from 'framework3/controls';
import { CobranzaComponent, CobranzaFormaPagoDetail } from '../../credit';
import { VentaItem } from '../models/venta';
import { VentaService } from '../services/venta.service';
import { EmpresaService } from '../services/empresa.service';
export declare class VentasManager extends DocumentManager {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    private ventaService;
    private empresaService;
    ventas: VentaItem[];
    metodoCobranzaEfectivo: string;
    argsCurrentDocument: WorkflowEventArgs;
    idOrigen: number;
    dlgCobranza: CobranzaComponent;
    downloadPopup: DownloadPopupComponent;
    constructor(context: Context, router: Router, route: ActivatedRoute, ventaService: VentaService, empresaService: EmpresaService);
    onConfigureDocument(): void;
    onSearchRequested(request: SearchRequest): void;
    onAddingItem(): void;
    onViewingItem(document: DocumentItem): void;
    onEditingItem(document: DocumentItem): void;
    onDeletingItem(document: DocumentItem): void;
    onCloningItem(document: DocumentItem): void;
    onApplyingNextStep(args: WorkflowEventArgs): void;
    onApplyingPreviousStep(document: DocumentItem): void;
    onMenuItemClick(option: MenuItem): void;
    cobroAceptado(formasPagoCobro: CobranzaFormaPagoDetail[]): void;
}
