"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
var search_1 = require("framework3/search");
var controls_1 = require("framework3/controls");
var credit_1 = require("../../credit");
var venta_service_1 = require("../services/venta.service");
var empresa_service_1 = require("../services/empresa.service");
var VentasManager = /** @class */ (function (_super) {
    __extends(VentasManager, _super);
    function VentasManager(context, router, route, ventaService, empresaService) {
        var _this = _super.call(this, context, router, route) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.ventaService = ventaService;
        _this.empresaService = empresaService;
        _this.metodoCobranzaEfectivo = "";
        _this.idOrigen = 0;
        _this.route.params.forEach(function (params) {
            _this.idOrigen = params['idOrigen'] ? +params['idOrigen'] : 0;
        });
        return _this;
    }
    VentasManager_1 = VentasManager;
    VentasManager.prototype.onConfigureDocument = function () {
        var _this = this;
        this.refreshList();
        this.applyPolicies();
        this.empresaService.getDetailFromCache(this.context.app.defaultCompany.identity)
            .then(function (empresa) {
            _this.metodoCobranzaEfectivo = empresa.efectivoMetodoCobranza;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    VentasManager.prototype.onSearchRequested = function (request) {
        var _this = this;
        this.context.app.showSpinner();
        //Si se especificó un origen, agregarlo como condición
        if (this.idOrigen > 0) {
            var conditionOrigen = { field: 'IdOrigen', operator: '=', valueType: search_1.ConditionValueType.INT, value: this.idOrigen };
            request.conditions.push(conditionOrigen);
        }
        //
        this.ventaService.search(this.context.app.defaultSite.identity, request)
            .then(function (response) {
            _this.context.app.hideSpinner();
            //
            _this.ventas = response.rows;
            _this.totalRows = response.totalRows;
            _this.filterGroups = response.filterGroups;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    VentasManager.prototype.onAddingItem = function () {
        this.router.navigate(['new', { idOrigen: this.idOrigen }], { relativeTo: this.route });
    };
    VentasManager.prototype.onViewingItem = function (document) {
        this.router.navigate([document.id, { readonly: true }], { relativeTo: this.route });
    };
    VentasManager.prototype.onEditingItem = function (document) {
        this.router.navigate([document.id], { relativeTo: this.route });
    };
    VentasManager.prototype.onDeletingItem = function (document) {
        var _this = this;
        this.ventaService.delete(document.id)
            .then(function (success) {
            _this.refreshList();
            _this.showAlert('El documento ha sido eliminado con éxito.', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    VentasManager.prototype.onCloningItem = function (document) {
        this.router.navigate([0, { cloneId: document.id }], { relativeTo: this.route });
    };
    VentasManager.prototype.onApplyingNextStep = function (args) {
        var _this = this;
        this.argsCurrentDocument = args;
        var venta = this.ventas.find(function (doc) { return doc.id == args.document.id; });
        if (args.step.tag == 'APPLY' && venta.condicionesPago == "E" && this.metodoCobranzaEfectivo == "A") {
            this.dlgCobranza.show(venta.total, venta.idDeudor);
        }
        else {
            this.context.app.showSpinner();
            this.ventaService.nextStep(args.document.id, args.step.idWorkflowStep, null)
                .then(function (_) {
                _this.context.app.hideSpinner();
                _this.refreshList();
            })
                .catch(function (error) { return _this.handleError(error); });
        }
    };
    VentasManager.prototype.onApplyingPreviousStep = function (document) {
        var _this = this;
        this.context.app.showSpinner();
        this.ventaService.previousStep(document.id, null)
            .then(function (_) {
            _this.context.app.hideSpinner();
            _this.refreshList();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    VentasManager.prototype.onMenuItemClick = function (option) {
        var _this = this;
        if (option.name == 'PDF') {
            this.context.app.showSpinner();
            this.ventaService.generarPdfFactura(this.manager.currentDocument.id)
                .then(function (file) {
                _this.context.app.hideSpinner();
                window.open('/file-server/' + file.uri, '_blank');
            })
                .catch(function (error) { return _this.handleError(error); });
        }
        if (option.name == "DOWNLOAD") {
            this.context.app.showSpinner();
            //Generar PDF
            this.ventaService.generarPdfFactura(this.manager.currentDocument.id)
                .then(function (pdf) {
                //Descargar xml
                _this.ventaService.getXmlFactura(_this.manager.currentDocument.id)
                    .then(function (xml) {
                    _this.context.app.hideSpinner();
                    var links = [];
                    links.push(pdf);
                    links.push(xml);
                    _this.downloadPopup.show(links);
                })
                    .catch(function (error) { return _this.handleError(error); });
            })
                .catch(function (error) { return _this.handleError(error); });
        }
    };
    VentasManager.prototype.cobroAceptado = function (formasPagoCobro) {
        var _this = this;
        var cobro = { formasPago: formasPagoCobro };
        this.context.app.showSpinner();
        this.ventaService.nextStep(this.argsCurrentDocument.document.id, this.argsCurrentDocument.step.idWorkflowStep, cobro)
            .then(function (_) {
            _this.context.app.hideSpinner();
            _this.refreshList();
            _this.dlgCobranza.clear();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    __decorate([
        core_1.ViewChild('dlgCobranza'),
        __metadata("design:type", credit_1.CobranzaComponent)
    ], VentasManager.prototype, "dlgCobranza", void 0);
    __decorate([
        core_1.ViewChild(controls_1.DownloadPopupComponent),
        __metadata("design:type", controls_1.DownloadPopupComponent)
    ], VentasManager.prototype, "downloadPopup", void 0);
    VentasManager = VentasManager_1 = __decorate([
        core_1.Component({
            selector: 'sales-ventas-manager',
            template: "\n      <div class=\"card\">\n          <div class=\"card-header\">Ventas</div>\n          <div class=\"card-body\">\n              <azteca-document-manager    (searchRequested)=\"onSearchRequested($event)\"\n                                          (addingItem)=\"onAddingItem()\"\n                                          (viewingItem)=\"onViewingItem($event)\"\n                                          (editingItem)=\"onEditingItem($event)\"\n                                          (deletingItem)=\"onDeletingItem($event)\"\n                                          (cloningItem)=\"onCloningItem($event)\"\n                                          (applyingNextStep)=\"onApplyingNextStep($event)\"\n                                          (applyingPreviousStep)=\"onApplyingPreviousStep($event)\"\n                                          (configureDocument)=\"onConfigureDocument($event)\"\n                                          (menuItemClick)=\"onMenuItemClick($event)\"\n                                          [enabled]=\"enabled\"\n                                          [allowNew]=\"allowNew\"\n                                          [allowView]=\"allowView\"\n                                          [allowEdit]=\"allowEdit\"\n                                          [allowDelete]=\"allowDelete\"\n                                          [allowClone]=\"allowClone\"\n                                          [allowNext]=\"allowNext\"\n                                          [allowPrevious]=\"allowPrevious\"\n                                          [allowAudit]=\"allowAudit\"\n                                          [filterGroups]=\"filterGroups\"\n                                          [pageSize]=\"20\"\n                                          [documentList]=\"ventas\">\n\n\n              <!------------------- Menu de acciones adicionales --------------------->\n                  <azteca-menu-item [name]=\"'PDF'\" [icon]=\"'glyphicon glyphicon-print'\" [text]=\"'Imprimir factura'\" [smallText]=\"'generar pdf de factura'\"></azteca-menu-item>\n                  <azteca-menu-item [name]=\"'DOWNLOAD'\" [icon]=\"'glyphicon glyphicon-save'\" [text]=\"'Descargar factura'\" [smallText]=\"'descargar xml y pdf'\"></azteca-menu-item>\n              <!------------------- Columnas del listado ----------------------------->\n\n                  <azteca-grid-column [header]=\"'Folio'\" [binding]=\"'id'\" [width]=\"180\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Fecha'\" [binding]=\"'fechaCreacion'\" [width]=\"160\" dataType=\"Date\" format=\"dd-MM-yyyy HH:mm\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'C\u00F3digo cliente'\" [binding]=\"'codigoCliente'\" [width]=\"'7*'\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Nombre cliente'\" [binding]=\"'nombreCliente'\" [width]=\"'20*'\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Condiciones'\" [binding]=\"'condicionesPagoText'\" [width]=\"'8*'\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Total'\" [binding]=\"'total'\" [width]=\"'10*'\" format=\"C\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Serie'\" [binding]=\"'serie'\" [width]=\"'3*'\"></azteca-grid-column>\n                  <azteca-grid-column [header]=\"'Folio'\" [binding]=\"'factura'\" [width]=\"'4*'\"></azteca-grid-column>\n            \n                  <azteca-grid-column [header]=\"'Paso'\" [binding]=\"'workflowStep'\" [width]=\"'10*'\"></azteca-grid-column>\n\n              </azteca-document-manager>\n          </div>\n      </div>\n\n\n      <credit-cobranza #dlgCobranza (cobroAcceptado)=\"cobroAceptado($event)\">\n\n      </credit-cobranza>\n\n      <download-popup></download-popup>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return VentasManager_1; })
                },
                {
                    provide: core_2.DocumentService, useExisting: venta_service_1.VentaService
                }
            ]
        }),
        __metadata("design:paramtypes", [core_2.Context, router_1.Router, router_1.ActivatedRoute, venta_service_1.VentaService, empresa_service_1.EmpresaService])
    ], VentasManager);
    return VentasManager;
    var VentasManager_1;
}(editors_1.DocumentManager));
exports.VentasManager = VentasManager;
