import { CatalogInfo, CatalogItem } from 'framework3/core';
import { ArticuloStockInfo, UnidadMedidaInfo } from '../../inventory';
import { ImpuestoAsignacionInfo } from '../../accounting/models/impuesto-asignacion';
export declare class ArticuloInfo extends CatalogInfo {
    nombre: string;
    idArticuloStock: number;
    idUnidadMedida: number;
    idMarca: number;
    modelo: string;
    idEstCom: number;
    idFlujo: number;
    idCuenta: number;
    impuestoIncluido: boolean;
    articuloStock: ArticuloStockInfo;
    impuestos: ImpuestoAsignacionInfo[];
    unidadMedida: UnidadMedidaInfo;
    constructor();
}
export declare class ArticuloItem implements CatalogItem {
    id: number;
    codigo: string;
    nombre: string;
    activo: boolean;
    estatus?: string;
    selected?: boolean;
}
export declare class ArticuloImpuestoItem {
    id: number;
    idImpuesto: number;
    codigo: string;
    impuesto: string;
    idArticulo: number;
    tasa: number;
    cuota: number;
    ordenCalculo: number;
    tipoCalculo: string;
    constructor();
}
