"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
//
var core_2 = require("framework3/core");
var base_control_1 = require("framework3/controls/models/base-control");
//Features
var articulo_1 = require("../../sales/models/articulo");
var cuenta_selector_component_1 = require("../../accounting/components/cuenta-selector.component");
var est_com_selector_component_1 = require("../controls/est-com-selector.component");
var flujo_selector_component_1 = require("../../accounting/components/flujo-selector.component");
var marcas_selector_component_1 = require("../controls/marcas-selector.component");
var ArticuloComercialComponent = /** @class */ (function (_super) {
    __extends(ArticuloComercialComponent, _super);
    //Campos privados para enlazar a UI
    //
    function ArticuloComercialComponent(formBuilder) {
        var _this = _super.call(this) || this;
        _this.formBuilder = formBuilder;
        //Inputs
        _this.articulo = new articulo_1.ArticuloInfo();
        //Outputs
        _this.articuloChange = new core_1.EventEmitter();
        _this.validChange = new core_1.EventEmitter();
        _this.propagateChange = function (_) { };
        _this.form = formBuilder.group({
            'cuenta': [''],
            'estCom': [''],
            'catFlujo': [''],
            'marcas': [''],
            'modelo': ['', forms_1.Validators.required],
            'impuestoIncluido': [false]
        });
        return _this;
    }
    ArticuloComercialComponent_1 = ArticuloComercialComponent;
    Object.defineProperty(ArticuloComercialComponent.prototype, "valid", {
        //Indica si la información de la forma es válida
        get: function () {
            return this.form.valid;
        },
        enumerable: true,
        configurable: true
    });
    ArticuloComercialComponent.prototype.ngOnChanges = function (changes) {
    };
    ArticuloComercialComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        this.form.statusChanges.subscribe(function (_) {
            _this.validChange.emit(_this.form.valid);
        });
    };
    //////////////////////////////// METODOS ////////////////////////////////////////
    ArticuloComercialComponent.prototype.notifiyChange = function () {
        var newArticulo = JSON.parse(JSON.stringify(this.articulo));
        newArticulo.idCuenta = this.articulo.idCuenta;
        newArticulo.idEstCom = this.articulo.idEstCom;
        newArticulo.idFlujo = this.articulo.idFlujo;
        newArticulo.idMarca = this.articulo.idMarca;
        newArticulo.modelo = this.articulo.modelo;
        newArticulo.impuestoIncluido = this.articulo.impuestoIncluido;
        //
        this.articuloChange.emit(newArticulo);
        this.propagateChange(newArticulo);
    };
    //////////////////////////////// HANDLERS ////////////////////////////////////////
    ArticuloComercialComponent.prototype.onCuentaChange = function (args) {
        this.notifiyChange();
    };
    ArticuloComercialComponent.prototype.onEstComChange = function (args) {
        this.notifiyChange();
    };
    ArticuloComercialComponent.prototype.onCatFlujoChange = function (args) {
        this.notifiyChange();
    };
    ArticuloComercialComponent.prototype.onMarcasChange = function (args) {
        this.notifiyChange();
    };
    ArticuloComercialComponent.prototype.onModeloChange = function (args) {
        this.notifiyChange();
    };
    ArticuloComercialComponent.prototype.onImpuestoIncluidoChange = function (args) {
        this.notifiyChange();
    };
    //////////////////////////////// CONTROL VALUE ACCESOR ////////////////////////////////////////
    ArticuloComercialComponent.prototype.writeValue = function (value) {
    };
    ArticuloComercialComponent.prototype.registerOnChange = function (fn) {
        this.propagateChange = fn;
    };
    ArticuloComercialComponent.prototype.registerOnTouched = function () {
    };
    __decorate([
        core_1.ViewChild('selectorCuenta'),
        __metadata("design:type", cuenta_selector_component_1.CuentaSelectorComponent)
    ], ArticuloComercialComponent.prototype, "selectorCuenta", void 0);
    __decorate([
        core_1.ViewChild('selectorEstCom'),
        __metadata("design:type", est_com_selector_component_1.EstComSelectorComponent)
    ], ArticuloComercialComponent.prototype, "selectorEstCom", void 0);
    __decorate([
        core_1.ViewChild('selectorCatFlujo'),
        __metadata("design:type", flujo_selector_component_1.FlujoSelectorComponent)
    ], ArticuloComercialComponent.prototype, "selectorCatFlujo", void 0);
    __decorate([
        core_1.ViewChild('selectorMarca'),
        __metadata("design:type", marcas_selector_component_1.MarcasSelectorComponent)
    ], ArticuloComercialComponent.prototype, "selectorMarca", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", articulo_1.ArticuloInfo)
    ], ArticuloComercialComponent.prototype, "articulo", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], ArticuloComercialComponent.prototype, "articuloChange", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], ArticuloComercialComponent.prototype, "validChange", void 0);
    ArticuloComercialComponent = ArticuloComercialComponent_1 = __decorate([
        core_1.Component({
            selector: 'articulos-comercial',
            template: "\n      <form [formGroup]=\"form\">\n          <div class=\"row\">\n              <div class=\"col-12\">\n                  <azteca-form-field [label]=\"'Cuenta:'\">\n                      <accounting-cuenta-selector #selectorCuenta\n                                                  formControlName=\"cuenta\" \n                                                  [(ngModel)]=\"articulo.idCuenta\" \n                                                  [showListButton]=\"true\" \n                                                  (change)=\"onCuentaChange($event)\">\n                      </accounting-cuenta-selector>\n                  </azteca-form-field>\n              </div>\n          </div>\n\n          <div class=\"row\">\n              <div class=\"col-12\">\n                  <azteca-form-field [label]=\"'Estructura Comercial:'\">\n                      <sales-est-com-selector #selectorEstCom\n                                              formControlName=\"estCom\" \n                                              [(ngModel)]=\"articulo.idEstCom\" \n                                              [showListButton]=\"true\" \n                                              (change)=\"onEstComChange($event)\">\n                      </sales-est-com-selector>\n                  </azteca-form-field>\n              </div>\n          </div>\n\n          <div class=\"row\">\n              <div class=\"col-12\">\n                  <azteca-form-field [label]=\"'Cat. Flujo:'\">\n                      <accounting-flujo-selector #selectorCatFlujo\n                                                 formControlName=\"catFlujo\" \n                                                 [(ngModel)]=\"articulo.idFlujo\" \n                                                 [showListButton]=\"true\" \n                                                 (change)=\"onCatFlujoChange($event)\">\n                      </accounting-flujo-selector>\n                  </azteca-form-field>\n              </div>\n          </div>\n\n          <div class=\"row\">\n              <div class=\"col-12\">\n                  <azteca-form-field [label]=\"'Marcas:'\">\n                      <sales-marcas-selector #selectorMarca\n                                             formControlName=\"marcas\" \n                                             [(ngModel)]=\"articulo.idMarca\" \n                                             [showListButton]=\"true\" \n                                             (change)=\"onMarcasChange($event)\">\n                      </sales-marcas-selector>\n                  </azteca-form-field>\n              </div>\n          </div>\n\n          <div class=\"row\">\n              <div class=\"col-12\">\n                  <azteca-form-field [label]=\"'Modelo:'\">\n                      <az-textbox formControlName=\"modelo\" [(ngModel)]=\"articulo.modelo\" (change)=\"onModeloChange($event)\"></az-textbox>\n                  </azteca-form-field>\n              </div>\n          </div>\n\n          <div>\n              <azteca-form-field [label]=\"''\">\n                  <az-checkbox formControlName=\"impuestoIncluido\" [(ngModel)]=\"articulo.impuestoIncluido\" [label]=\"'Impuesto Incluido'\" (change)=\"onImpuestoIncluidoChange($event)\"></az-checkbox>\n              </azteca-form-field>\n          </div>\n\n      </form>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return ArticuloComercialComponent_1; })
                },
                {
                    provide: forms_1.NG_VALUE_ACCESSOR, useExisting: core_1.forwardRef(function () { return ArticuloComercialComponent_1; }), multi: true
                }
            ],
            styles: [
                '.ng-valid-component { border-left: 1px solid #ccc!important;}'
            ]
        }),
        __metadata("design:paramtypes", [forms_1.FormBuilder])
    ], ArticuloComercialComponent);
    return ArticuloComercialComponent;
    var ArticuloComercialComponent_1;
}(base_control_1.BaseControl));
exports.ArticuloComercialComponent = ArticuloComercialComponent;
