"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var common_1 = require("@angular/common");
//
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
//
var general_1 = require("framework3/general");
var cliente_service_1 = require("../services/cliente.service");
var ClientesContactosComponent = /** @class */ (function (_super) {
    __extends(ClientesContactosComponent, _super);
    function ClientesContactosComponent(context, clienteService, router, route, location) {
        var _this = _super.call(this) || this;
        _this.context = context;
        _this.clienteService = clienteService;
        _this.router = router;
        _this.route = route;
        _this.location = location;
        _this.title = '';
        _this.personas = [];
        return _this;
    }
    ClientesContactosComponent.prototype.ngOnInit = function () {
        var _this = this;
        this.route.params.forEach(function (param) {
            _this.proceso = +param['proceso'];
            _this.idCliente = +param['id'];
        });
    };
    ClientesContactosComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        setTimeout(function (_) { return _this.loadContactos(); });
    };
    ClientesContactosComponent.prototype.applyPolicy = function (policy) {
    };
    ClientesContactosComponent.prototype.loadContactos = function () {
        var _this = this;
        this.context.app.showSpinner();
        this.clienteService.loadContactos(this.idCliente)
            .then(function (contactos) {
            _this.personas = contactos;
            _this.context.app.hideSpinner();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ClientesContactosComponent.prototype.onAddPersona = function () {
        //this.router.navigate(['contacts'], { relativeTo: this.route });
        this.router.navigate(['sales/clientes/contacts', this.proceso, this.idCliente, 0, 0]);
    };
    ClientesContactosComponent.prototype.onEditPersona = function (item) {
        //this.router.navigate(['contacts'], { relativeTo: this.route });
        this.router.navigate(['sales/clientes/contacts', this.proceso, this.idCliente, 0, item.data.identity]);
    };
    ClientesContactosComponent.prototype.onRemovePersonas = function (item) {
        var _this = this;
        this.clienteService.removeContacto(this.idCliente, item.data.identity)
            .then(function (_) {
            _this.context.app.hideSpinner();
            _this.alerts.showAlert('El contacto han sido agregado con éxito.', 'success');
            _this.loadContactos;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ClientesContactosComponent.prototype.onCancel = function () {
        this.location.back();
    };
    ClientesContactosComponent.prototype.handleError = function (error) {
        this.context.app.hideSpinner();
        var message = this.getErrorMessage(error);
        this.alerts.showAlert(message, 'danger');
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", Array)
    ], ClientesContactosComponent.prototype, "personas", void 0);
    __decorate([
        core_1.ViewChild(controls_1.AlertsBarComponent),
        __metadata("design:type", controls_1.AlertsBarComponent)
    ], ClientesContactosComponent.prototype, "alerts", void 0);
    ClientesContactosComponent = __decorate([
        core_1.Component({
            selector: 'sales-clientes-contactos',
            template: "\n      <div class=\"row\">\n          <div class=\"col-12 col-md-10\">\n              <az-panel [header]=\"title\">\n                  <alerts-bar></alerts-bar>\n                  <div class=\"row\">\n                      <div class=\"col-12\">\n\n                          <azteca-catalog-manager \n                                                  [standAlone]=\"false\"\n                                                  [catalogList]=\"personas\"\n                                                  (addingItem)=\"onAddPersona($event)\"\n                                                  (editingItem)=\"onEditPersona($event)\"\n                                                  (deletingItem)=\"onRemovePersonas($event)\">\n\n                              <azteca-grid-column [header]=\"'C\u00F3digo'\" [binding]=\"'code'\" [width]=\"'10*'\"></azteca-grid-column>\n                              <azteca-grid-column [header]=\"'Nombre'\" [binding]=\"'nombre'\" [width]=\"'40*'\"></azteca-grid-column>\n                              <azteca-grid-column [header]=\"'Apellido Paterno'\" [binding]=\"'apellidoPaterno'\" [width]=\"'40*'\"></azteca-grid-column>\n                              <azteca-grid-column [header]=\"'Apellido Materno'\" [binding]=\"'apellidoMaterno'\" [width]=\"'40*'\"></azteca-grid-column>\n                              <azteca-grid-column [header]=\"'Tel.Oficina'\" [binding]=\"'telefonoOficina'\" [width]=\"'20*'\"></azteca-grid-column>\n\n                          </azteca-catalog-manager>\n\n                      </div>\n                  </div>\n\n                  <div class=\"modal-footer\">\n                      <button type=\"button\" class=\"btn btn-danger\" (click)=\"onCancel()\">Cerrar</button>\n                \n                  </div> <!--Modal Footer-->\n\n              </az-panel>\n          </div>\n      </div>\n    ",
            providers: [
                {
                    provide: core_2.CatalogService, useExisting: general_1.PersonaService
                }
            ]
        }),
        __metadata("design:paramtypes", [core_2.Context, cliente_service_1.ClienteService, router_1.Router, router_1.ActivatedRoute,
            common_1.Location])
    ], ClientesContactosComponent);
    return ClientesContactosComponent;
}(core_2.BaseComponent));
exports.ClientesContactosComponent = ClientesContactosComponent;
