import { EventEmitter, ChangeDetectorRef } from '@angular/core';
import { ActivatedRoute } from '@angular/router';
import { Location } from '@angular/common';
import { FormBuilder, FormGroup } from '@angular/forms';
import { ModalDirective } from 'ngx-bootstrap';
import { BaseComponent, Context, PolicyInfo } from 'framework3/core';
import { AlertsBarComponent } from 'framework3/controls';
import { PersonaInfo, PersonaService } from 'framework3/general';
import { ClienteService } from '../services/cliente.service';
export declare class ClientesContactosEditor extends BaseComponent {
    private context;
    private route;
    private formBuilder;
    private location;
    protected changeDetector: ChangeDetectorRef;
    private personaService;
    private clienteService;
    editorForm: FormGroup;
    title: string;
    idCliente: number;
    idContacto: number;
    idPersona: number;
    persona: PersonaInfo;
    alerts: AlertsBarComponent;
    dataUpdated: EventEmitter<number>;
    dialog: ModalDirective;
    constructor(context: Context, route: ActivatedRoute, formBuilder: FormBuilder, location: Location, changeDetector: ChangeDetectorRef, personaService: PersonaService, clienteService: ClienteService);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    loadContacto(): void;
    loadPersona(): void;
    onUpdate(): void;
    onCancel(): void;
    applyPolicy(policy: PolicyInfo): void;
    onPersonValidChange(): void;
    handleError(error: any): void;
}
