import { Router, ActivatedRoute } from '@angular/router';
import { Location } from '@angular/common';
import { BaseComponent, Context } from 'framework3/core';
import { SearchRequest } from 'framework3/search';
import { ToolbarButton, AlertsBarComponent } from 'framework3/controls';
import { ClientesListComponent } from '../controls/clientes-list.component';
import { PolicyInfo } from 'framework3/core';
import { ListaPreciosService } from '../services/lista-precios.service';
import { ListaPreciosInfo } from '../models/lista-precios';
import { ClienteItem } from '../models/cliente';
export declare class ListaPreciosClientesComponent extends BaseComponent {
    private context;
    private listaPreciosService;
    private router;
    private route;
    private location;
    title: string;
    clientes: ClienteItem[];
    idListaPrecios: number;
    listaPrecios: ListaPreciosInfo;
    currentItem: ClienteItem;
    pageSize: number;
    pageIndex: number;
    totalRows: number;
    clientesDialog: ClientesListComponent;
    alerts: AlertsBarComponent;
    constructor(context: Context, listaPreciosService: ListaPreciosService, router: Router, route: ActivatedRoute, location: Location);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    loadInitialData(): void;
    loadListaPrecios(): void;
    triggerSearch(): void;
    onCurrentItemChanged(item: ClienteItem): void;
    onToolbarButtonClick(button: ToolbarButton): void;
    onSearchRequested(request: SearchRequest): void;
    onSelectedChanged(newClientes: ClienteItem[]): void;
    applyPolicy(policy: PolicyInfo): void;
    handleError(error: any): void;
}
