"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var common_1 = require("@angular/common");
//
var core_2 = require("framework3/core");
var search_1 = require("framework3/search");
var controls_1 = require("framework3/controls");
//
var clientes_list_component_1 = require("../controls/clientes-list.component");
//
var lista_precios_service_1 = require("../services/lista-precios.service");
var cliente_1 = require("../models/cliente");
var ListaPreciosClientesComponent = /** @class */ (function (_super) {
    __extends(ListaPreciosClientesComponent, _super);
    //
    function ListaPreciosClientesComponent(context, listaPreciosService, router, route, location) {
        var _this = _super.call(this) || this;
        _this.context = context;
        _this.listaPreciosService = listaPreciosService;
        _this.router = router;
        _this.route = route;
        _this.location = location;
        _this.title = 'Clientes asignados a la lista de precios';
        _this.clientes = [];
        _this.currentItem = new cliente_1.ClienteItem();
        _this.pageSize = 25;
        _this.pageIndex = 0;
        _this.totalRows = 0;
        return _this;
    }
    ListaPreciosClientesComponent.prototype.ngOnInit = function () {
        var _this = this;
        this.route.params.forEach(function (param) {
            _this.idListaPrecios = +param['id'];
        });
    };
    ListaPreciosClientesComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        setTimeout(function (_) { return _this.loadInitialData(); });
    };
    ///////////////// METODOS ///////////////////////////////
    ListaPreciosClientesComponent.prototype.loadInitialData = function () {
        this.loadListaPrecios();
        this.triggerSearch();
    };
    ListaPreciosClientesComponent.prototype.loadListaPrecios = function () {
        var _this = this;
        this.listaPreciosService.getDetailByID(this.idListaPrecios)
            .then(function (info) {
            _this.listaPrecios = info;
            _this.title = 'Miembros de la lista de precios - ' + _this.listaPrecios.nombre;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ListaPreciosClientesComponent.prototype.triggerSearch = function () {
        //Disparar búsqueda inicial. Si el manejo se realiza del lado del servidor, obtener sólo la primer página, si es local obtener toda la información disponible
        var request = new search_1.SearchRequest();
        request.pageIndex = 0;
        request.pageSize = this.pageSize;
        request.paged = true;
        //
        this.onSearchRequested(request);
    };
    ///////////////// HANDLERS ///////////////////////////////
    ListaPreciosClientesComponent.prototype.onCurrentItemChanged = function (item) {
        this.currentItem = item;
    };
    ListaPreciosClientesComponent.prototype.onToolbarButtonClick = function (button) {
        if (button.name == 'ADD') {
            this.clientesDialog.show();
        }
        if (button.name == 'CLOSE') {
            this.location.back();
        }
    };
    ListaPreciosClientesComponent.prototype.onSearchRequested = function (request) {
        var _this = this;
        this.context.app.showSpinner();
        this.listaPreciosService.loadClientes(this.idListaPrecios, this.context.app.defaultCompany.identity, this.context.session.user.identity, request)
            .then(function (result) {
            _this.clientes = result.rows;
            _this.totalRows = result.totalRows;
            _this.context.app.hideSpinner();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ListaPreciosClientesComponent.prototype.onSelectedChanged = function (newClientes) {
        var _this = this;
        this.listaPreciosService.addClientes(this.idListaPrecios, newClientes)
            .then(function (_) {
            _this.context.app.hideSpinner();
            _this.alerts.showAlert('Los clientes han sido agregados con éxito.', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ListaPreciosClientesComponent.prototype.applyPolicy = function (policy) {
    };
    ListaPreciosClientesComponent.prototype.handleError = function (error) {
        this.context.app.hideSpinner();
        var message = this.getErrorMessage(error);
        this.alerts.showAlert(message, 'danger');
    };
    __decorate([
        core_1.ViewChild(clientes_list_component_1.ClientesListComponent),
        __metadata("design:type", clientes_list_component_1.ClientesListComponent)
    ], ListaPreciosClientesComponent.prototype, "clientesDialog", void 0);
    __decorate([
        core_1.ViewChild(controls_1.AlertsBarComponent),
        __metadata("design:type", controls_1.AlertsBarComponent)
    ], ListaPreciosClientesComponent.prototype, "alerts", void 0);
    ListaPreciosClientesComponent = __decorate([
        core_1.Component({
            selector: 'sales-listas-precios-clientes',
            template: "\n      <div class=\"row\">\n          <div class=\"col-12 col-lg-10\">\n              <az-panel [header]=\"title\">\n                  <alerts-bar></alerts-bar>\n                  <!--Toolbar Principal-->\n                  <az-toolbar (buttonClick)=\"onToolbarButtonClick($event)\">\n                      <az-toolbar-button [name]=\"'ADD'\" [type]=\"'primary'\" [text]=\"'Agregar clientes'\" [icon]=\"'glyphicon glyphicon-plus'\"></az-toolbar-button>\n                      <az-toolbar-button [name]=\"'CLOSE'\" [text]=\"'Regresar'\" [icon]=\"'glyphicon glyphicon-circle-arrow-left'\"></az-toolbar-button>\n                  </az-toolbar>\n\n                  <!-- Lista de usuarios-->\n                  <azteca-catalog-list [catalogList]=\"clientes\"                                                                                                   \n                                       (currentItemChanged)=\"onCurrentItemChanged($event)\"\n                                       [enabled]=\"enabled\"\n                                       [pageSize]=\"pageSize\"\n                                       [pageIndex]=\"pageIndex\"\n                                       [totalRows]=\"totalRows\"\n                                       [serverSide]=\"true\">\n                \n                      <azteca-grid-column [header]=\"'Codigo'\" [binding]=\"'codigo'\" [width]=\"100\"></azteca-grid-column>\n                      <azteca-grid-column [header]=\"'Nombre'\" [binding]=\"'nombre'\" [width]=\"'40*'\"></azteca-grid-column>\n                      <azteca-grid-column [header]=\"'Sucursal'\" [binding]=\"'sucursal'\" [width]=\"'20*'\"></azteca-grid-column>\n                      <azteca-grid-column [header]=\"'Estatus'\" [binding]=\"'estatus'\" [width]=\"'10*'\"></azteca-grid-column>\n\n                  </azteca-catalog-list>\n\n\n              </az-panel>\n          </div>\n      </div>\n\n      <sales-clientes-list (selectedItemsChanged)=\"onSelectedChanged($event)\"\n                              [excludedItems]=\"clientes\"\n                              [multiSelect]=\"true\">\n\n      </sales-clientes-list>\n    "
        }),
        __metadata("design:paramtypes", [core_2.Context, lista_precios_service_1.ListaPreciosService, router_1.Router, router_1.ActivatedRoute,
            common_1.Location])
    ], ListaPreciosClientesComponent);
    return ListaPreciosClientesComponent;
}(core_2.BaseComponent));
exports.ListaPreciosClientesComponent = ListaPreciosClientesComponent;
