"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var common_1 = require("@angular/common");
var forms_1 = require("@angular/forms");
//
var ngx_bootstrap_1 = require("ngx-bootstrap");
//
var core_2 = require("framework3/core");
var search_1 = require("framework3/search");
var controls_1 = require("framework3/controls");
//
var accounting_1 = require("../../accounting");
//
var lista_precios_service_1 = require("../services/lista-precios.service");
var servicio_lista_precios_1 = require("../models/servicio-lista-precios");
var ListasPreciosServiciosComponent = /** @class */ (function (_super) {
    __extends(ListasPreciosServiciosComponent, _super);
    //
    function ListasPreciosServiciosComponent(context, router, route, location, formBuilder, listaPreciosService, divisaService) {
        var _this = _super.call(this) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.location = location;
        _this.formBuilder = formBuilder;
        _this.listaPreciosService = listaPreciosService;
        _this.divisaService = divisaService;
        _this.title = 'Servicios de la lista de precios';
        _this.currentItem = new servicio_lista_precios_1.ServicioListaPreciosItem();
        _this.pageSize = 25;
        _this.pageIndex = 0;
        _this.totalRows = 0;
        _this.form = _this.formBuilder.group({
            'idDivisa': [0, controls_1.AztecaValidators.selected],
            'precio': [0]
        });
        return _this;
    }
    ListasPreciosServiciosComponent.prototype.ngOnInit = function () {
        var _this = this;
        this.route.params.forEach(function (param) {
            _this.idListaPrecios = +param['id'];
        });
    };
    ListasPreciosServiciosComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        setTimeout(function (_) { return _this.loadInitialData(); });
    };
    ///////////////// METODOS ///////////////////////////////
    ListasPreciosServiciosComponent.prototype.loadInitialData = function () {
        this.loadDivisaDefault();
        this.loadListaPrecios();
        this.triggerSearch();
    };
    ListasPreciosServiciosComponent.prototype.loadListaPrecios = function () {
        var _this = this;
        this.listaPreciosService.getDetailByID(this.idListaPrecios)
            .then(function (lista) {
            _this.listaPrecios = lista;
            _this.title = 'Servicios de la lista de precios: ' + _this.listaPrecios.nombre;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ListasPreciosServiciosComponent.prototype.loadDivisaDefault = function () {
        var _this = this;
        this.divisaService.getDetailByEmpresa(this.context.app.defaultCompany.identity)
            .then(function (divisa) { return _this.divisaDefault = divisa; })
            .catch(function (error) { return _this.handleError(error); });
    };
    ListasPreciosServiciosComponent.prototype.triggerSearch = function () {
        //Disparar búsqueda inicial. Si el manejo se realiza del lado del servidor, obtener sólo la primer página, si es local obtener toda la información disponible
        var request = new search_1.SearchRequest();
        request.pageIndex = 0;
        request.pageSize = this.pageSize;
        request.paged = true;
        //
        this.onSearchRequested(request);
    };
    ///////////////// HANDLERS ///////////////////////////////
    ListasPreciosServiciosComponent.prototype.onSearchRequested = function (request) {
        var _this = this;
        this.context.app.showSpinner();
        this.listaPreciosService.loadServicios(this.context.app.defaultSite.identity, this.idListaPrecios, request)
            .then(function (result) {
            _this.servicios = result.rows;
            _this.totalRows = result.totalRows;
            _this.context.app.hideSpinner();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ListasPreciosServiciosComponent.prototype.onCurrentItemChanged = function (item) {
        this.currentItem = item;
    };
    ListasPreciosServiciosComponent.prototype.onToolbarButtonClick = function (button) {
        if (button.name == 'CLOSE') {
            this.location.back();
        }
    };
    ListasPreciosServiciosComponent.prototype.applyPolicy = function (policy) {
    };
    ListasPreciosServiciosComponent.prototype.onEditServicio = function (articulo) {
        this.currentItem = JSON.parse(JSON.stringify(articulo));
        //Si no se ha definido aún la divisa, establecer por default la de la empresa
        if (this.currentItem.idDivisa == 0)
            this.currentItem.idDivisa = this.divisaDefault.identity;
        this.editDialog.config.backdrop = false;
        this.editDialog.show();
    };
    ListasPreciosServiciosComponent.prototype.onUpdateItem = function () {
        var _this = this;
        this.context.app.showSpinner();
        this.listaPreciosService.updateServicio(this.idListaPrecios, this.currentItem)
            .then(function (_) {
            var newServicios = _this.servicios.slice();
            var index = newServicios.findIndex(function (articulo) { return articulo.id == _this.currentItem.id; });
            newServicios[index] = _this.currentItem;
            _this.servicios = newServicios;
            _this.editDialog.hide();
            _this.context.app.hideSpinner();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ListasPreciosServiciosComponent.prototype.handleError = function (error) {
        this.context.app.hideSpinner();
        var message = this.getErrorMessage(error);
        this.alerts.showAlert(message, 'danger');
    };
    __decorate([
        core_1.ViewChild(controls_1.AlertsBarComponent),
        __metadata("design:type", controls_1.AlertsBarComponent)
    ], ListasPreciosServiciosComponent.prototype, "alerts", void 0);
    __decorate([
        core_1.ViewChild(search_1.CatalogListComponent),
        __metadata("design:type", search_1.CatalogListComponent)
    ], ListasPreciosServiciosComponent.prototype, "catalogList", void 0);
    __decorate([
        core_1.ViewChild(ngx_bootstrap_1.ModalDirective),
        __metadata("design:type", ngx_bootstrap_1.ModalDirective)
    ], ListasPreciosServiciosComponent.prototype, "editDialog", void 0);
    ListasPreciosServiciosComponent = __decorate([
        core_1.Component({
            selector: 'sales-lista-precios-servicios',
            template: "\n      <div class=\"row\">\n          <div class=\"col-12 col-lg-10\">\n              <az-panel [header]=\"title\">\n                  <alerts-bar></alerts-bar>\n\n                  <!--Toolbar Principal-->\n                  <az-toolbar (buttonClick)=\"onToolbarButtonClick($event)\">\n                      <az-toolbar-button [name]=\"'CLOSE'\" [text]=\"'Regresar'\" [icon]=\"'glyphicon glyphicon-circle-arrow-left'\"></az-toolbar-button>\n                  </az-toolbar>\n\n                  <!-- Lista de usuarios-->\n                  <azteca-catalog-list [catalogList]=\"servicios\"\n                                       [showRowButton]=\"true\"\n                                       [rowButtonIcon]=\"'glyphicon glyphicon-pencil'\"\n                                       (rowButtonClick)=\"onEditServicio($event)\"\n                                       (currentItemChanged)=\"onCurrentItemChanged($event)\"\n                                       [enabled]=\"enabled\"\n                                       [pageSize]=\"pageSize\"\n                                       [pageIndex]=\"pageIndex\"\n                                       [totalRows]=\"totalRows\"\n                                       [serverSide]=\"true\"\n                                       (searchRequested)=\"onSearchRequested($event)\">\n\n                      <azteca-grid-column [header]=\"'Codigo'\" [binding]=\"'codigo'\" [width]=\"100\"></azteca-grid-column>\n                      <azteca-grid-column [header]=\"'Nombre'\" [binding]=\"'nombre'\" [width]=\"'40*'\"></azteca-grid-column>\n                      <azteca-grid-column [header]=\"'Precio'\" [binding]=\"'precio'\" [width]=\"'10*'\" format=\"c\"></azteca-grid-column>\n                      <azteca-grid-column [header]=\"'Divisa'\" [binding]=\"'divisa'\" [width]=\"'20*'\"></azteca-grid-column>\n                      <azteca-grid-column [header]=\"'Marca'\" [binding]=\"'marca'\" [width]=\"'20*'\"></azteca-grid-column>\n\n                  </azteca-catalog-list>\n\n              </az-panel>\n          </div>\n      </div>\n\n      <!------------------- DIALOGO PARA EDICI\u00D3N DE DETALLES -------------------------->\n\n      <div bsModal #editDialog=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"myLargeModalLabel\" aria-hidden=\"true\">\n          <div class=\"modal-dialog modal-lg\">\n              <div class=\"modal-content\">\n                  <div class=\"modal-header\">\n                      <h4 class=\"modal-title\">Editar precio</h4>\n                  </div>\n                  <div class=\"modal-body\">\n                      <form [formGroup]=\"form\">\n\n                          <div class=\"row\">\n                              <div class=\"col-12 col-lg-6\">\n                                  <azteca-form-field [label]=\"'Divisa:'\">\n                                      <accounting-divisas-selector formControlName=\"idDivisa\"\n                                                                   [(ngModel)]=\"currentItem.idDivisa\"\n                                                                   [showListButton]=\"false\"\n                                                                   (selectedItemChanged)=\"onDivisaChanged($event)\">\n                                      </accounting-divisas-selector>\n                                  </azteca-form-field>\n                              </div>\n                              <div class=\"col-12 col-lg-3\">\n                                  <azteca-form-field [label]=\"'Precio:'\">\n                                      <az-input-number formControlName=\"precio\"\n                                                       [(ngModel)]=\"currentItem.precio\"\n                                                       format=\"c\"></az-input-number>\n                                  </azteca-form-field>\n                              </div>\n                          </div>\n                      </form>\n\n                  </div> <!--Modal Body-->\n                  <div class=\"modal-footer\">\n                      <button type=\"button\" class=\"btn btn-primary\" (click)=\"onUpdateItem()\" [disabled]=\"!form.valid || !this.currentItem || this.currentItem.precio < 0\">Aceptar</button>\n                      <button type=\"button\" class=\"btn btn-danger\" (click)=\"editDialog.hide()\">Cancelar</button>\n                  </div> <!--Modal Footer-->\n\n              </div> <!-- Modal Content-->\n          </div> <!--Modal-->\n      </div> <!--Modal directive-->\n    "
        }),
        __metadata("design:paramtypes", [core_2.Context, router_1.Router, router_1.ActivatedRoute, common_1.Location, forms_1.FormBuilder,
            lista_precios_service_1.ListaPreciosService, accounting_1.DivisaService])
    ], ListasPreciosServiciosComponent);
    return ListasPreciosServiciosComponent;
}(core_2.BaseComponent));
exports.ListasPreciosServiciosComponent = ListasPreciosServiciosComponent;
