import { HttpClient } from '@angular/common/http';
import 'rxjs/add/operator/toPromise';
import { Context, CatalogService } from 'framework3/core';
import { ArticuloInfo } from '../models/articulo';
import { ArticuloStockItem } from '../../inventory/models/articulo-stock';
import { ArticuloListaPreciosItem } from '../models/articulo-lista-precios';
import { ArticuloGrupoDescuentoItem } from '../models/articulo-grupo-descuento';
import { PrecioInfo } from '../models/precio';
export declare class ArticuloService extends CatalogService<ArticuloInfo> {
    constructor(http: HttpClient, context: Context);
    create(): Promise<ArticuloInfo>;
    GetArticuloStock(idSucursal: number, codigo: string): Promise<ArticuloStockItem>;
    articuloAsignadoCheck(idArticuloStock: number): Promise<boolean>;
    getArticuloByArticuloStock(idArticuloStock: number): Promise<number>;
    loadArticuloListaPrecios(idEmpresa: number, idArticulo: number): Promise<ArticuloListaPreciosItem[]>;
    updateArticuloListaPrecios(data: ArticuloListaPreciosItem[], idArticulo: number): Promise<any>;
    loadArticuloGrupoDescuento(idEmpresa: number, idArticulo: number): Promise<ArticuloGrupoDescuentoItem[]>;
    updateArticuloGrupoDescuento(data: ArticuloGrupoDescuentoItem[], idArticulo: number): Promise<any>;
    calcularPrecio(idArticulo: number, idListaPrecios: number, idGrupoDescuentos: number, idEmpresa: number): Promise<PrecioInfo>;
    calcularPrecioCliente(idArticulo: number, idCliente: number, idEmpresa: number): Promise<PrecioInfo>;
}
