import { HttpClient } from '@angular/common/http';
import 'rxjs/add/operator/toPromise';
import { Context, CatalogService, EmpresaItem } from 'framework3/core';
import { ClienteInfo } from '../models/cliente';
import { PersonaInfo } from 'framework3/general';
export declare class ClienteService extends CatalogService<ClienteInfo> {
    constructor(http: HttpClient, context: Context);
    create(): Promise<ClienteInfo>;
    loadContactos(idCliente: number): Promise<PersonaInfo[]>;
    addContacto(idCliente: number, contacto: PersonaInfo): Promise<any>;
    removeContacto(idCliente: number, idPersona: number): Promise<any>;
    enviarRegistro(idCliente: number): Promise<any>;
    registrar(idCliente: number, password: string): Promise<any>;
    getDetailByUser(idUsuario: number, idEmpresa: number): Promise<ClienteInfo>;
    loadEmpresas(idUsuario: number): Promise<EmpresaItem[]>;
}
