"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var http_1 = require("@angular/common/http");
require("rxjs/add/operator/toPromise");
//Azteca Kernel
var core_2 = require("framework3/core");
var ClienteService = /** @class */ (function (_super) {
    __extends(ClienteService, _super);
    function ClienteService(http, context) {
        return _super.call(this, http, context, "api/ventas/clientes") || this;
    }
    ClienteService.prototype.create = function () {
        return this.apiService.get('create', null)
            .toPromise();
    };
    ClienteService.prototype.loadContactos = function (idCliente) {
        var params = new http_1.HttpParams()
            .append("idCliente", idCliente.toString());
        return this.apiService.get("load-contactos", params)
            .toPromise();
    };
    ClienteService.prototype.addContacto = function (idCliente, contacto) {
        var params = new http_1.HttpParams()
            .set('idCliente', idCliente.toString());
        return this.apiService.post('add-contacto', params, contacto)
            .toPromise();
    };
    ClienteService.prototype.removeContacto = function (idCliente, idPersona) {
        var params = new http_1.HttpParams()
            .set('idCliente', idCliente.toString())
            .set('idPersona', idPersona.toString());
        return this.apiService.delete('remove-contacto', params)
            .toPromise();
    };
    ClienteService.prototype.enviarRegistro = function (idCliente) {
        var params = new http_1.HttpParams()
            .set('idCliente', idCliente.toString());
        return this.apiService.get('enviar-registro', params)
            .toPromise();
    };
    ClienteService.prototype.registrar = function (idCliente, password) {
        var params = new http_1.HttpParams()
            .set('idCliente', idCliente.toString())
            .set('password', password);
        return this.apiService.get('registrar', params)
            .toPromise();
    };
    ClienteService.prototype.getDetailByUser = function (idUsuario, idEmpresa) {
        var params = new http_1.HttpParams()
            .set('idUsuario', idUsuario.toString())
            .set('idEmpresa', idEmpresa.toString());
        return this.apiService.get('detail-by-user', params)
            .toPromise();
    };
    ClienteService.prototype.loadEmpresas = function (idUsuario) {
        var params = new http_1.HttpParams()
            .set('idUsuario', idUsuario.toString());
        return this.apiService.get('empresas', params)
            .toPromise();
    };
    ClienteService = __decorate([
        core_1.Injectable(),
        __metadata("design:paramtypes", [http_1.HttpClient, core_2.Context])
    ], ClienteService);
    return ClienteService;
}(core_2.CatalogService));
exports.ClienteService = ClienteService;
