import { HttpClient } from '@angular/common/http';
import 'rxjs/add/operator/toPromise';
import { Context, CatalogService } from 'framework3/core';
import { SearchRequest, SearchResult } from 'framework3/search';
import { ListaPreciosInfo, ListaPreciosItem } from '../models/lista-precios';
import { ClienteItem } from '../models/cliente';
import { ArticuloListaPreciosItem } from '../models/articulo-lista-precios';
import { ServicioListaPreciosItem } from '../models/servicio-lista-precios';
export declare class ListaPreciosService extends CatalogService<ListaPreciosInfo> {
    constructor(http: HttpClient, context: Context);
    create(): Promise<ListaPreciosInfo>;
    loadList(idSucursal: number): Promise<ListaPreciosItem[]>;
    loadClientes(idListaPrecios: number, idEmpresa: number, idUsuario: number, request: SearchRequest): Promise<SearchResult>;
    addClientes(idListaPrecios: number, clientes: ClienteItem[]): Promise<any>;
    loadArticulos(idSucursal: number, idListaPrecios: number, request: SearchRequest): Promise<SearchResult>;
    updateArticulo(idListaPrecios: number, articulo: ArticuloListaPreciosItem): Promise<any>;
    loadServicios(idSucursal: number, idListaPrecios: number, request: SearchRequest): Promise<SearchResult>;
    updateServicio(idListaPrecios: number, servicio: ServicioListaPreciosItem): Promise<any>;
}
