"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var http_1 = require("@angular/common/http");
require("rxjs/add/operator/toPromise");
//Azteca Kernel
var core_2 = require("framework3/core");
//Locales
var lista_precios_1 = require("../models/lista-precios");
var ListaPreciosService = /** @class */ (function (_super) {
    __extends(ListaPreciosService, _super);
    function ListaPreciosService(http, context) {
        return _super.call(this, http, context, "api/ventas/listas-precios") || this;
    }
    ListaPreciosService.prototype.create = function () {
        return Promise.resolve(new lista_precios_1.ListaPreciosInfo());
    };
    ListaPreciosService.prototype.loadList = function (idSucursal) {
        var params = new http_1.HttpParams()
            .set("idSucursal", idSucursal.toString());
        return this.apiService.get("load-list", params)
            .toPromise();
    };
    ListaPreciosService.prototype.loadClientes = function (idListaPrecios, idEmpresa, idUsuario, request) {
        var params = new http_1.HttpParams()
            .set('idListaPrecios', idListaPrecios.toString())
            .set('idEmpresa', idEmpresa.toString())
            .set('idUsuario', idUsuario.toString());
        //
        return this.apiService.post('clientes', params, request)
            .toPromise();
    };
    ListaPreciosService.prototype.addClientes = function (idListaPrecios, clientes) {
        var params = new http_1.HttpParams()
            .set('idListaPrecios', idListaPrecios.toString());
        return this.apiService.post('add-clientes', params, clientes)
            .toPromise();
    };
    ListaPreciosService.prototype.loadArticulos = function (idSucursal, idListaPrecios, request) {
        var params = new http_1.HttpParams()
            .set('idListaPrecios', idListaPrecios.toString())
            .set('idSucursal', idSucursal.toString());
        //
        return this.apiService.post('articulos', params, request)
            .toPromise();
    };
    ListaPreciosService.prototype.updateArticulo = function (idListaPrecios, articulo) {
        var params = new http_1.HttpParams()
            .set('idListaPrecios', idListaPrecios.toString());
        return this.apiService.post('update-articulo', params, articulo)
            .toPromise();
    };
    ListaPreciosService.prototype.loadServicios = function (idSucursal, idListaPrecios, request) {
        var params = new http_1.HttpParams()
            .set('idListaPrecios', idListaPrecios.toString())
            .set('idSucursal', idSucursal.toString());
        //
        return this.apiService.post('servicios', params, request)
            .toPromise();
    };
    ListaPreciosService.prototype.updateServicio = function (idListaPrecios, servicio) {
        var params = new http_1.HttpParams()
            .set('idListaPrecios', idListaPrecios.toString());
        return this.apiService.post('update-servicio', params, servicio)
            .toPromise();
    };
    ListaPreciosService = __decorate([
        core_1.Injectable(),
        __metadata("design:paramtypes", [http_1.HttpClient, core_2.Context])
    ], ListaPreciosService);
    return ListaPreciosService;
}(core_2.CatalogService));
exports.ListaPreciosService = ListaPreciosService;
