import { HttpClient } from '@angular/common/http';
import 'rxjs/add/operator/toPromise';
import { Context, CatalogService } from 'framework3/core';
import { ImpuestoDetailInfo } from '../../accounting';
import { ServicioInfo } from '../models/servicio';
import { ServicioListaPreciosItem } from '../models/servicio-lista-precios';
import { ServicioGrupoDescuentoItem } from '../models/servicio-grupo-descuento';
import { PrecioInfo } from '../models/precio';
export declare class ServicioService extends CatalogService<ServicioInfo> {
    constructor(http: HttpClient, context: Context);
    create(): Promise<ServicioInfo>;
    loadServicioListaPrecios(idEmpresa: number, idServicio: number): Promise<ServicioListaPreciosItem[]>;
    updateServicioListaPrecios(data: ServicioListaPreciosItem[], idServicio: number): Promise<any>;
    loadServicioGrupoDescuento(idEmpresa: number, idServicio: number): Promise<ServicioGrupoDescuentoItem[]>;
    updateServicioGrupoDescuento(data: ServicioGrupoDescuentoItem[], idServicio: number): Promise<any>;
    calcularPrecio(idServicio: number, idListaPrecios: number, idGrupoDescuentos: number, idEmpresa: number, precioBruto: number): Promise<PrecioInfo>;
    calcularPrecioCliente(idServicio: number, idCliente: number, idEmpresa: number, precioBruto: number): Promise<PrecioInfo>;
    calcularPrecioLibre(precioBase: number, impuestosIncluidos: boolean, impuestos: ImpuestoDetailInfo[]): PrecioInfo;
    calcularPrecioBase(precioNeto: number, impuestos: ImpuestoDetailInfo[]): number;
}
