"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var http_1 = require("@angular/common/http");
require("rxjs/add/operator/toPromise");
//Azteca Kernel
var core_2 = require("framework3/core");
var accounting_1 = require("../../accounting");
//Locales
var servicio_1 = require("../models/servicio");
var precio_1 = require("../models/precio");
var ServicioService = /** @class */ (function (_super) {
    __extends(ServicioService, _super);
    function ServicioService(http, context) {
        return _super.call(this, http, context, 'api/ventas/servicios') || this;
    }
    ServicioService.prototype.create = function () {
        return Promise.resolve(new servicio_1.ServicioInfo());
    };
    //Lista de Precios
    ServicioService.prototype.loadServicioListaPrecios = function (idEmpresa, idServicio) {
        var params = new http_1.HttpParams();
        params.append("idEmpresa", idEmpresa.toString());
        params.append("idServicio", idServicio.toString());
        return this.apiService.get("load-servicio-lista-precios", params)
            .toPromise();
    };
    ServicioService.prototype.updateServicioListaPrecios = function (data, idServicio) {
        var params = new http_1.HttpParams();
        params.append("idServicio", idServicio.toString());
        return this.apiService.post('update-servicio-lista-precios', params, data)
            .toPromise();
    };
    //Grupo de Descuentos
    ServicioService.prototype.loadServicioGrupoDescuento = function (idEmpresa, idServicio) {
        var params = new http_1.HttpParams();
        params.append("idEmpresa", idEmpresa.toString());
        params.append("idServicio", idServicio.toString());
        return this.apiService.get("load-servicio-grupo-descuento", params)
            .toPromise();
    };
    ServicioService.prototype.updateServicioGrupoDescuento = function (data, idServicio) {
        var params = new http_1.HttpParams();
        params.append("idServicio", idServicio.toString());
        return this.apiService.post('update-servicio-grupo-descuento', params, data)
            .toPromise();
    };
    ServicioService.prototype.calcularPrecio = function (idServicio, idListaPrecios, idGrupoDescuentos, idEmpresa, precioBruto) {
        var params = new http_1.HttpParams()
            .set("idServicio", idServicio.toString())
            .set("idListaPrecios", idListaPrecios.toString())
            .set("idGrupoDescuentos", idGrupoDescuentos.toString())
            .set("idEmpresa", idEmpresa.toString())
            .set("precioBruto", precioBruto.toString());
        return this.apiService.get('precio', params)
            .toPromise();
    };
    ServicioService.prototype.calcularPrecioCliente = function (idServicio, idCliente, idEmpresa, precioBruto) {
        var params = new http_1.HttpParams()
            .set("idServicio", idServicio.toString())
            .set("idCliente", idCliente.toString())
            .set("idEmpresa", idEmpresa.toString())
            .set("precioBruto", precioBruto.toString());
        return this.apiService.get('precio-cliente', params)
            .toPromise();
    };
    ServicioService.prototype.calcularPrecioLibre = function (precioBase, impuestosIncluidos, impuestos) {
        var precio = new precio_1.PrecioInfo();
        if (impuestosIncluidos) {
            precio.precioBase = this.calcularPrecioBase(precioBase, impuestos);
        }
        else {
            precio.precioBase = precioBase;
        }
        //Recalcular importes de impuestos
        impuestos.forEach(function (impuesto) {
            impuesto.importe = impuesto.base * impuesto.tasaOCuota;
        });
        precio.impuestos = impuestos;
        //
        var totalTraslados = 0;
        impuestos.filter(function (i) { return i.tipoAplicacion == accounting_1.TipoAplicacion.TRASLADO; }).forEach(function (i) { return totalTraslados += i.importe; });
        //
        var totalRetenciones = 0;
        impuestos.filter(function (i) { return i.tipoAplicacion == accounting_1.TipoAplicacion.RETENCION; }).forEach(function (i) { return totalRetenciones += i.importe; });
        //
        precio.precioNeto = precio.precioBase + totalTraslados - totalRetenciones;
        return precio;
    };
    ServicioService.prototype.calcularPrecioBase = function (precioNeto, impuestos) {
        //Sumar las tasas de traslado
        var tasasTraslados = 0;
        impuestos.filter(function (i) { return i.tipoAplicacion == accounting_1.TipoAplicacion.TRASLADO && i.tipoFactor == accounting_1.TipoFactor.TASA; }).forEach(function (i) { return tasasTraslados += i.tasaOCuota; });
        //Sumar las cuotas de traslado
        var cuotasTraslados = 0;
        impuestos.filter(function (i) { return i.tipoAplicacion == accounting_1.TipoAplicacion.TRASLADO && i.tipoFactor == accounting_1.TipoFactor.CUOTA; }).forEach(function (i) { return cuotasTraslados += i.tasaOCuota * i.base; });
        //Sumar las tasas de las retenciones
        var tasasRetenciones = 0;
        impuestos.filter(function (i) { return i.tipoAplicacion == accounting_1.TipoAplicacion.RETENCION && i.tipoFactor == accounting_1.TipoFactor.TASA; }).forEach(function (i) { return tasasRetenciones += i.tasaOCuota; });
        //Sumar las cuotas de las retenciones
        var cuotasRetenciones = 0;
        impuestos.filter(function (i) { return i.tipoAplicacion == accounting_1.TipoAplicacion.RETENCION && i.tipoFactor == accounting_1.TipoFactor.CUOTA; }).forEach(function (i) { return cuotasRetenciones += i.tasaOCuota * i.base; });
        var precioBase = (precioNeto - cuotasTraslados + cuotasRetenciones) / (1 + (tasasTraslados - tasasRetenciones));
        return Math.round(precioBase * 100) / 100;
    };
    ServicioService = __decorate([
        core_1.Injectable(),
        __metadata("design:paramtypes", [http_1.HttpClient, core_2.Context])
    ], ServicioService);
    return ServicioService;
}(core_2.CatalogService));
exports.ServicioService = ServicioService;
